/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

if (typeof(IlvConstants) == "undefined" || typeof(IlvConstants.ChartsBundleDefined) == "undefined") {
IlvConstants.ChartsBundleDefined=true;
IlvChartComponentView=function(_1,_2,_3,_4,_5,_6){
if(!window.IlvAbstractView){
alert(jviews.messages.IlvChartComponentView.requiresIlvAbstractView);
}
this.superConstructor(_1,_2,_3,_4,_6);
this.reload=_5||false;
this.imageFormat="JPEG";
this.imageMap=false;
this.imageMapVisible=false;
this.servletURL=null;
this.component="";
this.imagePanel=new IlvImageView(_1,_2,_3,_4);
this.imagePanel.setImageSize(20,20);
this.imagePanel.addImageLoadingListener(IlvChartComponentView.onImageLoading);
this.imagePanel.addImagePreloadListener(IlvChartComponentView.onImagePreloaded);
this.imagePanel.addImageLoadListener(IlvChartComponentView.onImageLoaded);
this.imagePanel.addErrorListener(IlvChartComponentView.onImageError);
this.imagePanel.addTimeoutErrorListener(IlvChartComponentView.onImageTimeoutError);
this.imagePanel.compView=this;
this.errorTimerID=null;
this.error=false;
this.errorMessage=jviews.messages.IlvChartComponentView.serviceNotAvailable;
this.errorListeners=new IlvListenerList();
this.timeoutListeners=new IlvListenerList();
this.capabilitiesListeners=new IlvListenerList();
this.interactorListeners=new IlvListenerList();
this.imageLoadingListeners=new IlvListenerList();
this.imagePreloadListeners=new IlvListenerList();
this.imageLoadListeners=new IlvListenerList();
this.initialized=false;
this.waitingImage=IlvConstants.ilvImagePath+jviews.messages.IlvUtil.waitIcon;
this.emptyImage=IlvConstants.ilvImagePath+jviews.messages.IlvUtil.emptyIcon;
this.imgbgcolor=null;
this.setMinimumSize(10,10);
this.updateOnResizeLock=false;
this.hitmap=null;
this.drawPanel=null;
this.registerDispose();
};
IlvChartComponentView.prototype=new IlvAbstractView();
IlvChartComponentView.prototype.setClassName("IlvChartComponentView");
IlvChartComponentView.basePath="script/images/";
IlvChartComponentView.prototype.dispose=function(){
this.superInvoke("dispose");
this.errorListeners.dispose();
this.timeoutListeners.dispose();
this.capabilitiesListeners.dispose();
this.interactorListeners.dispose();
this.imageLoadingListeners.dispose();
this.imagePreloadListeners.dispose();
this.imageLoadListeners.dispose();
if(this.imagePanel){
this.imagePanel.compView=null;
this.imagePanel.dispose();
}
if(this.waitPanel){
this.waitPanel.dispose();
}
if(this.imageMapPanel){
this.imageMapPanel.dispose();
}
if(this.rectPanel){
this.rectPanel.dispose();
}
if(this.imageMapRequest){
this.imageMapRequest=null;
}
};
IlvChartComponentView.prototype.initFromCookie=function(){
if(this.isStateInCookie()){
this.initSizeFromCookie();
}
};
IlvChartComponentView.prototype.initSizeFromCookie=function(){
var _7=this.readSizeFromCookie();
if(_7.width!=this.getWidth()||_7.height!=this.getHeight()){
this.setSize(_7.width,_7.height);
}
};
IlvChartComponentView.prototype.setComponent=function(_8){
this.component=_8;
};
IlvChartComponentView.prototype.getComponent=function(){
return this.component;
};
IlvChartComponentView.prototype.getTimeoutErrorInterval=function(){
return this.imagePanel.getTimeoutInterval();
};
IlvChartComponentView.prototype.setTimeoutErrorInterval=function(_9){
this.imagePanel.setTimeoutInterval(_9);
};
IlvChartComponentView.prototype.startErrorTimer=function(){
this.stopErrorTimer();
if(!this.onTimeoutErrorFunction){
var _a=this;
this.onTimeoutErrorFunction=function(){
_a.timeoutError();
};
}
this.errorTimerID=window.setTimeout(this.onTimeoutErrorFunction,this.getTimeoutErrorInterval()*1000);
};
IlvChartComponentView.prototype.stopErrorTimer=function(){
var _b=this.errorTimerID;
this.errorTimerID=null;
if(_b){
window.clearTimeout(_b);
}
};
IlvChartComponentView.onImageTimeoutError=function(_c){
var _d=_c.compView;
if(_d){
_d.timeoutError();
}
};
IlvChartComponentView.prototype.timeoutError=function(){
this.error=true;
this.waitPanel.setContent(this.getErrorHTML());
this.waitPanel.setVisible(true);
this.timeoutListeners.notify(this);
};
IlvChartComponentView.prototype.addTimeoutErrorListener=function(_e){
this.timeoutListeners.addListener(_e);
};
IlvChartComponentView.prototype.removeTimeoutErrorListener=function(_f){
this.timeoutListeners.removeListener(_f);
};
IlvChartComponentView.prototype.addErrorListener=function(_10){
this.errorListeners.addListener(_10);
};
IlvChartComponentView.prototype.removeErrorListener=function(_11){
this.errorListeners.removeListener(_11);
};
IlvChartComponentView.prototype.resetErrorHandler=function(){
this.error=false;
this.waitPanel.setContent(this.getWaitPanelHTML());
this.waitPanel.setVisible(false);
};
IlvChartComponentView.prototype.setMessagePanel=function(_12){
this.infoPanel=_12;
};
IlvChartComponentView.prototype.getMessagePanel=function(){
return this.infoPanel;
};
IlvChartComponentView.prototype.setImageBackgroundColor=function(_13){
this.imgbgcolor=_13;
};
IlvChartComponentView.prototype.getImageBackgroundColor=function(){
return this.imgbgcolor;
};
IlvChartComponentView.prototype.setImageFormat=function(_14){
this.imageFormat=_14;
};
IlvChartComponentView.prototype.getImageFormat=function(){
return this.imageFormat;
};
IlvChartComponentView.prototype.setWaitingImage=function(_15){
this.waitingImage=_15;
if(this.waitPanel){
this.waitPanel.setContent(this.getWaitPanelHTML());
}
};
IlvChartComponentView.prototype.getWaitingImage=function(){
return this.waitingImage;
};
IlvChartComponentView.prototype.getImageScrollPosition=function(){
return this.imagePanel.getScrollPosition();
};
IlvChartComponentView.prototype.setImageScrollPosition=function(x,y){
this.imagePanel.setScrollPosition(x,y);
};
IlvChartComponentView.prototype.setBlendTransform=function(set){
this.imagePanel.setBlendTransform(set);
};
IlvChartComponentView.prototype.getBlendTransform=function(){
return this.imagePanel.getBlendTransform();
};
IlvChartComponentView.prototype.getImageWidth=function(){
return this.getWidth();
};
IlvChartComponentView.prototype.getImageHeight=function(){
return this.getHeight();
};
IlvChartComponentView.prototype.createImageRequestURL=function(_19,_1a){
var _1b=[this.getServletURL(),"?request=image","&format=",this.imageFormat,"&comp=",this.component,"&width=",_19,"&height=",_1a,this.getAdditionalParameters(),this.getAgainParam()];
if(this.imgbgcolor){
_1b.push("&bgcolor=0x");
_1b.push(this.imgbgcolor);
}
return _1b.join("");
};
IlvChartComponentView.prototype.updateImage=function(){
this.waitPanel.setVisible(true);
var _1c=this.imagePanel.getImageSize();
var _1d=this.getImageWidth();
var _1e=this.getImageHeight();
var _1f=(_1c.width!=_1d||_1c.height!=_1e);
var _20=this.createImageRequestURL(_1d,_1e);
if(_1f){
this.imagePanel.setImage(_20,_1d,_1e);
}else{
this.imagePanel.setImage(_20);
}
};
IlvChartComponentView.prototype.updateHitmap=function(){
if(!this.hitmap){
return;
}
if(this.drawPanel){
this.drawPanel.clear();
}
this.hitmap.highlighted=0;
this.waitPanel.setVisible(true);
this.hitmapRequest.send(this.createHitmapRequestURL(this.getWidth(),this.getHeight()));
};
IlvChartComponentView.prototype.createHitmapRequestURL=function(_21,_22){
var _23=[this.servletURL,"?request=hitmap","&comp=",this.component,"&width=",_21,"&height=",_22,this.getHitInfoTypes(),this.getAgainParam(),this.getAdditionalParameters(),];
return _23.join("");
};
IlvChartComponentView.prototype.againString=function(){
var _24=new Date();
var str=_24.toUTCString();
str=str+" "+_24.getMilliseconds();
return escape(str);
};
IlvChartComponentView.prototype.addImagePreloadListener=function(_26){
this.imagePreloadListeners.addListener(_26);
};
IlvChartComponentView.prototype.removeImagePreloadListener=function(_27){
this.imagePreloadListeners.removeListener(_27);
};
IlvChartComponentView.prototype.addImageLoadListener=function(_28){
this.imageLoadListeners.addListener(_28);
};
IlvChartComponentView.prototype.removeImageLoadListener=function(_29){
this.imageLoadListeners.removeListener(_29);
};
IlvChartComponentView.prototype.addImageLoadingListener=function(_2a){
this.imageLoadingListeners.addListener(_2a);
};
IlvChartComponentView.prototype.removeImageLoadingListener=function(_2b){
this.imageLoadingListeners.removeListener(_2b);
};
IlvChartComponentView.onImageLoading=function(_2c){
var _2d=_2c.compView;
_2d.imageLoading();
};
IlvChartComponentView.prototype.imageLoading=function(){
this.imageLoadingListeners.notify(this);
};
IlvChartComponentView.onImagePreloaded=function(_2e){
var _2f=_2e.compView;
_2f.imagePreloaded();
};
IlvChartComponentView.prototype.imagePreloaded=function(){
if(this.error){
return;
}
this.imagePreloadListeners.notify(this);
};
IlvChartComponentView.onImageLoaded=function(_30){
var _31=_30.compView;
_31.imageLoaded();
};
IlvChartComponentView.prototype.imageLoaded=function(){
if(this.error){
return;
}
this.imagePanel.setVisible(true);
this.waitPanel.setVisible(false);
this.imageLoadListeners.notify(this);
};
IlvChartComponentView.onImageError=function(_32){
var _33=_32.compView;
_33.imageError();
};
IlvChartComponentView.prototype.imageError=function(){
this.error=true;
this.waitPanel.setContent(this.getErrorHTML());
this.waitPanel.setVisible(true);
this.errorListeners.notify(this);
};
IlvChartComponentView.prototype.getImageStr=function(){
var _34=this.toString()+"image";
var str=["<img style=\"-webkit-user-drag:none\" id= \"",_34,"\" name=\"",_34,"\" width=\"",this.getWidth(),"\" height=\"",this.getHeight(),"\" border=\"0\" galleryimg=\"false\"/>"];
return str.join("");
};
IlvChartComponentView.prototype.setGenerateImageMap=function(set){
this.imageMap=set;
};
IlvChartComponentView.prototype.isGenerateImageMap=function(){
return this.imageMap;
};
IlvChartComponentView.prototype.setImageMapVisible=function(_37){
this.imageMapVisible=_37;
if(this.imageMapPanel){
this.imageMapPanel.setVisible(_37);
}
};
IlvChartComponentView.prototype.isImageMapVisible=function(){
return this.imageMapVisible;
};
IlvChartComponentView.prototype.showImageMap=function(){
this.setImageMapVisible(true);
};
IlvChartComponentView.prototype.hideImageMap=function(){
this.setImageMapVisible(false);
};
IlvChartComponentView.prototype.updateImageMap=function(){
if(!this.imageMap){
if(this.imageMapPanel){
this.imageMapPanel.setContent("");
}
return;
}
this.stopErrorTimer();
this.imageMapPanel.setVisible(false);
var div=this.imageMapPanel._div;
while(div.hasChildNodes()){
div.removeChild(this.imageMapPanel._div.lastChild);
}
this.waitPanel.setVisible(true);
this.imageMapRequest.send(this.createImageMapRequestURL(this.getWidth(),this.getHeight()));
this.startErrorTimer();
};
IlvChartComponentView.prototype.createImageMapRequestURL=function(_39,_3a){
var _3b=[this.servletURL,"?request=imagemap","&comp=",this.component,"&format=",this.imageFormat,"&width=",_39,"&height=",_3a,this.getAgainParam(),this.getAdditionalParameters(),"&mapname=",this.toString(),"_IMAP"];
if(this.emptyImagePath==null){
var tmp=new Image();
tmp.src=IlvChartComponentView.basePath+jviews.messages.IlvUtil.emptyIcon;
this.emptyImagePath=tmp.src;
}
_3b=_3b.concat(["&image=",escape(this.emptyImagePath)]);
return _3b.join("");
};
IlvChartComponentView.prototype.imageMapUpdated=function(_3d){
if(IlvBrowserInfo.instance.webkit){
this.imageMapPanel.setContent("<b></b>");
}
this.stopErrorTimer();
this.imageMapPanel.setContent(_3d);
if(this.imageMapVisible){
this.imageMapPanel.setVisible(true);
}
this.waitPanel.setVisible(false);
};
IlvChartComponentView.prototype.setChildrenBounds=function(_3e,top,_40,_41){
this.superInvoke("setChildrenBounds",_3e,top,_40,_41);
var _42=this.imagePanel;
var _43=false;
if(this._resized){
if(this.reload){
this.saveSizeToCookie();
}
var _44=_42.getImageSize();
_43=(_44.width!=this.getImageWidth()||_44.height!=this.getImageHeight());
}
if(_43){
_42.setVisible(false);
}
_42.setBounds(_3e,top,_40,_41);
if(this.inHTML){
this.waitPanel.setBounds(_3e,top,_40,_41);
this.waitPanel.setContent(this.getWaitPanelHTML());
this.imageMapPanel.setBounds(_3e,top,_40,_41);
if(this.drawPanel){
this.drawPanel.setBounds(_3e,top,_40,_41);
}
if(_43&&!this.updateOnResizeLock){
this.error=false;
this.updateImage(true);
}
}
};
IlvChartComponentView.prototype.getDrawPanel=function(){
if(!this.drawPanel){
var _45=this.parentNode;
this.drawPanel=new IlvDrawView(_45,this.left,this.top,this.width,this.height);
}
return this.drawPanel;
};
IlvChartComponentView.prototype.childrenToHTML=function(_46){
var l=this.getLeft();
var t=this.getTop();
var w=this.getWidth();
var h=this.getHeight();
this.imagePanel.setVisible(false);
this.imagePanel.toHTML(_46);
this.waitPanel=new IlvHTMLPanel(this.getWaitPanelHTML(),_46);
this.waitPanel.setBounds(l,t,w,h);
this.waitPanel.setVisible(true);
this.rectPanel=new IlvRectangle(null,_46);
this.superInvoke("childrenToHTML",_46);
this.imageMapRequest=new IlvAjax.HTMLRequest(this,this.imageMapUpdated);
this.imageMapPanel=new IlvHTMLPanel("",_46);
this.imageMapPanel.setBounds(l,t,w,h);
this.imageMapPanel.setZIndex(5);
this.hitmapRequest=new IlvAjax.HTMLRequest(this,this.hitmapUpdated);
};
IlvChartComponentView.prototype.removeHTML=function(){
this.superInvoke("removeHTML");
if(this.imagePanel){
this.imagePanel.removeHTML();
}
if(this.waitPanel){
this.waitPanel.removeHTML();
}
if(this.imageMapPanel){
this.imageMapPanel.removeHTML();
}
if(this.rectPanel){
this.rectPanel.removeHTML();
}
};
IlvChartComponentView.prototype.updateVisibility=function(){
this.superInvoke("updateVisibility");
this.imagePanel.updateVisibility();
if(this.waitPanel){
this.waitPanel.updateVisibility();
}
if(this.imageMapPanel){
this.imageMapPanel.updateVisibility();
}
if(this.rectPanel){
this.rectPanel.updateVisibility();
}
};
IlvChartComponentView.prototype.getWaitPanelHTML=function(){
return "<table "+"width=\""+this.getWidth()+"\" "+"height=\""+this.getHeight()+"\">"+"<tr><td style=\"text-align:center\" align=\"center\" valign=\"middle\">"+"<img style=\"-webkit-user-drag:none\" src=\""+this.getWaitingImage()+"\" galleryimg=\"false\"/></td></tr></table>";
};
IlvChartComponentView.prototype.getErrorHTML=function(){
return "<table "+"width=\""+this.getWidth()+"\" "+"height=\""+this.getHeight()+"\">"+"<tr><td style=\"text-align:center\" align=\"center\" valign=\"middle\">"+this.errorMessage+"</td></tr></table>";
};
IlvChartComponentView.prototype.setServletURL=function(_4b){
this.servletURL=_4b;
};
IlvChartComponentView.prototype.getServletURL=function(){
return this.servletURL;
};
IlvChartComponentView.prototype.removeAdditionalParameter=function(key){
IlvRequestParameters.removeParameter(this.additionalParams,key);
};
IlvChartComponentView.prototype.getAgainParam=function(){
var _4d=new Date();
var str=_4d.toUTCString();
str=str+" "+_4d.getMilliseconds();
return "&again="+escape(str);
};
IlvChartComponentView.prototype.getRectangle=function(){
return this.rectPanel;
};
IlvChartView=function(_4f,top,_51,_52,_53,_54){
this.superConstructor(_4f,top,_51,_52,_53,_54);
this.component="chart";
this.xRangeCookie=this.cookieName+":xRange";
this.yRangeCookie=this.cookieName+":yRange";
this.updateTimerID=null;
this.updateInterval=0;
this.cap_xVisibleMin=0;
this.cap_xVisibleMax=100;
this.cap_xDataMin=0;
this.cap_xDataMax=100;
this.cap_yVisibleMin=0;
this.cap_yVisibleMax=100;
this.cap_yDataMin=0;
this.cap_yDataMax=100;
this.cap_xPlotRect=0;
this.cap_yPlotRect=0;
this.cap_widthPlotRect=100;
this.cap_heightPlotRect=100;
this.cap_xHorizontal=true;
this.cap_allDataSets=null;
this.capabilitiesLoaded=false;
this.autoUpdateCapabilities=true;
this.updateCapabilities=true;
this.xMin=this.cap_xVisibleMin;
this.xMax=this.cap_xVisibleMax;
this.yMin=this.cap_yVisibleMin;
this.yMax=this.cap_yVisibleMax;
this.intervalInitialized=false;
this.xZoomFactor=2;
this.yZoomFactor=2;
this.maxZoom=0;
this.interactor=null;
this.legendView=null;
this.autoUpdateLegend=false;
this.deleteCookieOnDispose=false;
this.sessionDelay=120;
this.cap_sessionMaxInactiveInterval=-1;
this.sessionExpirationHandler=null;
this.registerDispose();
if(this.reload){
this.initFromCookie();
}
};
IlvChartView.prototype=new IlvChartComponentView();
IlvChartView.prototype.setClassName("IlvChartView");
IlvChartView.prototype.dispose=function(){
this.superInvoke("dispose");
this.component=null;
if(this.legendView){
this.legendView=null;
}
if(this.capabilitiesRequest){
this.capabilitiesRequest=null;
}
if(this.popupMenu){
this.popupMenu.dispose();
}
};
IlvChartView.prototype.init=function(){
this.updateImage(true);
this.initialized=true;
};
IlvChartView.prototype.setUpdateInterval=function(_55){
this.updateInterval=_55;
if(this.inHTML){
this.stopUpdateTimer();
this.startUpdateTimer();
}
};
IlvChartView.prototype.getUpdateInterval=function(){
return this.updateInterval;
};
IlvChartView.prototype.startUpdateTimer=function(){
this.stopUpdateTimer();
var _56=this.getUpdateInterval();
if(_56>0){
if(!this.updateTimerFunction){
var _57=this;
this.updateTimerFunction=function(){
_57.onUpdateTimer();
};
}
this.updateTimerID=window.setTimeout(this.updateTimerFunction,_56*1000);
}
};
IlvChartView.prototype.stopUpdateTimer=function(){
var _58=this.updateTimerID;
this.updateTimerID=null;
if(_58){
window.clearTimeout(_58);
}
};
IlvChartView.prototype.isCapabilitiesLoaded=function(){
return this.capabilitiesLoaded;
};
IlvChartView.prototype.getCapabilities=function(){
this.stopErrorTimer();
this.capabilitiesLoaded=false;
this.capabilitiesRequest.send(this.createCapabilitiesRequestURL());
this.startErrorTimer();
};
IlvChartView.prototype.createCapabilitiesRequestURL=function(){
var _59=[this.getServletURL(),"?request=capabilities&format=json","&imageWidth="+this.getWidth(),"&imageHeight=",this.getHeight(),"&comp=",this.component,this.getAdditionalParameters(),this.getAgainParam()];
return _59.join("");
};
IlvChartView.prototype.onCapabilitiesLoaded=function(_5a){
this.stopErrorTimer();
this.cap_xVisibleMin=_5a.xVisibleMin;
this.cap_xVisibleMax=_5a.xVisibleMax;
this.cap_xDataMin=_5a.xDataMin;
this.cap_xDataMax=_5a.xDataMax;
this.cap_yVisibleMin=_5a.yVisibleMin;
this.cap_yVisibleMax=_5a.yVisibleMax;
this.cap_yDataMin=_5a.yDataMin;
this.cap_yDataMax=_5a.yDataMax;
this.cap_xPlotRect=_5a.xPlotRect;
this.cap_yPlotRect=_5a.yPlotRect;
this.cap_widthPlotRect=_5a.widthPlotRect;
this.cap_heightPlotRect=_5a.heightPlotRect;
this.cap_xHorizontal=_5a.xHorizontal;
this.cap_is3D=_5a.is3D;
this.cap_isCartesian=_5a.isCartesian;
this.cap_allDataSets=[];
for(var i=0;i<_5a.dataSets.length;++i){
this.cap_allDataSets[i]=_5a.dataSets[i];
}
this.cap_sessionMaxInactiveInterval=_5a.sessionMaxInactiveInterval;
this.readAdditionalCapabilities(_5a);
this.capabilitiesLoaded=true;
this.updateCapabilities=true;
this.resetSessionExpirationTimer();
if(!this.intervalInitialized){
var w=this.getDataWindow();
this.xMin=w.xMin;
this.xMax=w.xMax;
this.yMin=w.yMin;
this.yMax=w.yMax;
this.intervalInitialized=true;
}else{
this.xMin=this.cap_xVisibleMin;
this.xMax=this.cap_xVisibleMax;
this.yMin=this.cap_yVisibleMin;
this.yMax=this.cap_yVisibleMax;
}
this.saveVisibleRangeCookie();
this.capabilitiesListeners.notify(this);
if(this.legendView&&this.isAutoUpdateLegend()){
legendView.updateImage();
}
if(this.reload){
this.initFromCookie();
}
};
IlvChartView.prototype.readAdditionalCapabilities=function(_5d){
};
IlvChartView.prototype.addCapabilitiesLoadListener=function(_5e){
this.capabilitiesListeners.addListener(_5e);
};
IlvChartView.prototype.removeCapabilitiesLoadListener=function(_5f){
this.capabilitiesListeners.removeListener(_5f);
};
IlvChartView.prototype.onUpdateTimer=function(){
if(this.autoUpdateCapabilities){
this.updateImage(true);
}else{
this.updateImage(false);
}
};
IlvChartView.prototype.isAutoUpdateCapabilities=function(){
return this.autoUpdateCapabilities;
};
IlvChartView.prototype.setAutoUpdateCapabilities=function(set){
this.autoUpdateCapabilities=set;
};
IlvChartView.prototype.resetSessionExpirationTimer=function(){
if(this.sessionTimer){
clearTimeout(this.sessionTimer);
}
if(!this.error&&this.cap_sessionMaxInactiveInterval&&this.cap_sessionMaxInactiveInterval!=-1&&this.sessionExpirationHandler){
this.sessionTimer=setTimeout(this.sessionListener,(this.cap_sessionMaxInactiveInterval-this.sessionDelay)*1000);
}
};
IlvChartView.prototype.setSessionExpirationHandler=function(_61){
this.sessionExpirationHandler=_61;
if(_61&&!this.sessionListener){
var v=this;
this.sessionListener=function(){
if(v.sessionExpirationHandler){
v.sessionExpirationHandler(v);
}
};
}
};
IlvChartView.prototype.getDataSets=function(){
var _63=[];
if(this.capabilitiesLoaded){
var l=this.cap_allDataSets.length;
for(var i=0;i<l;i++){
_63[_63.length]=this.cap_allDataSets[i];
}
}
return _63;
};
IlvChartView.prototype.isXHorizontal=function(){
return this.cap_xHorizontal;
};
IlvChartView.prototype.is3D=function(){
return this.cap_is3D;
};
IlvChartView.prototype.isCartesian=function(){
return this.cap_isCartesian;
};
IlvChartView.prototype.canPan=function(){
return (this.isCartesian()&&!this.is3D());
};
IlvChartView.prototype.canZoom=function(){
return (this.isCartesian()&&!this.is3D());
};
IlvChartView.prototype.setLegend=function(_66){
if(_66.instanceOf&&_66.instanceOf(IlvLegendView)){
this.legendView=_66;
}else{
alert("Legend must me an instance of IlvLegendView !");
}
};
IlvChartView.prototype.getLegend=function(){
return this.legendView;
};
IlvChartView.prototype.setAutoUpdateLegend=function(_67){
this.autoUpdateLegend=_67;
};
IlvChartView.prototype.isAutoUpdateLegend=function(){
return this.autoUpdateLegend;
};
IlvChartView.prototype.translateX=function(_68){
var _69=this.xMin+_68;
var _6a=this.xMax+_68;
this.setXVisibleRange(_69,_6a);
};
IlvChartView.prototype.translateY=function(_6b){
var _6c=this.yMin+_6b;
var _6d=this.yMax+_6b;
this.setYVisibleRange(_6c,_6d);
};
IlvChartView.prototype.setXZoomFactor=function(_6e){
this.xZoomFactor=_6e;
};
IlvChartView.prototype.getXZoomFactor=function(){
return this.xZoomFactor;
};
IlvChartView.prototype.setYZoomFactor=function(_6f){
this.yZoomFactor=_6f;
};
IlvChartView.prototype.getYZoomFactor=function(){
return this.yZoomFactor;
};
IlvChartView.prototype.zoomToFit=function(){
var w=this.getDataWindow();
this.setVisibleWindow(w.xMin,w.xMax,w.yMin,w.yMax);
};
IlvChartView.prototype.zoomInX=function(){
this.zoomBy(this.xZoomFactor,1);
};
IlvChartView.prototype.zoomOutX=function(){
this.zoomBy(1/this.xZoomFactor,1);
};
IlvChartView.prototype.zoomInY=function(){
this.zoomBy(1,this.yZoomFactor);
};
IlvChartView.prototype.zoomOutY=function(){
this.zoomBy(1,1/this.yZoomFactor);
};
IlvChartView.prototype.zoomIn=function(byX,byY){
var _73=this.xZoomFactor;
var _74=this.yZoomFactor;
if(!byX){
_73=1;
}
if(!byY){
_74=1;
}
this.zoomBy(_73,_74);
};
IlvChartView.prototype.zoomOut=function(byX,byY){
var _77=1/this.xZoomFactor;
var _78=1/this.yZoomFactor;
if(!byX){
_77=1;
}
if(!byY){
_78=1;
}
this.zoomBy(_77,_78);
};
IlvChartView.prototype.zoomBy=function(_79,_7a){
var len,_7c,_7d;
if(_79!=1&&_7a!=1){
len=((this.xMax-this.xMin)/_79)/2;
var _7e=(this.xMin+this.xMax)/2-len;
var _7f=(this.xMin+this.xMax)/2+len;
len=((this.yMax-this.yMin)/_79)/2;
var _80=(this.yMin+this.yMax)/2-len;
var _81=(this.yMin+this.yMax)/2+len;
this.setVisibleWindow(_7e,_7f,_80,_81);
}else{
if(_79!=1){
len=((this.xMax-this.xMin)/_79)/2;
_7c=(this.xMin+this.xMax)/2-len;
_7d=(this.xMin+this.xMax)/2+len;
this.setXVisibleRange(_7c,_7d);
}else{
if(_7a!=1){
len=((this.yMax-this.yMin)/_7a)/2;
_7c=(this.yMin+this.yMax)/2-len;
_7d=(this.yMin+this.yMax)/2+len;
this.setYVisibleRange(_7c,_7d);
}
}
}
};
IlvChartView.prototype.getMaxZoomLevel=function(){
return this.maxZoom;
};
IlvChartView.prototype.getXVisibleRange=function(){
return {min:this.xMin,max:this.xMax};
};
IlvChartView.prototype.setXVisibleRange=function(_82,_83){
this.xMin=_82;
this.xMax=_83;
this.intervalInitialized=true;
this.updateImage(true);
};
IlvChartView.prototype.getYVisibleRange=function(){
return {min:this.yMin,max:this.yMax};
};
IlvChartView.prototype.setYVisibleRange=function(_84,_85){
this.yMin=_84;
this.yMax=_85;
this.intervalInitialized=true;
this.updateImage(true);
};
IlvChartView.prototype.getVisibleWindow=function(){
return {xMin:this.xMin,xMax:this.xMax,yMin:this.yMin,yMax:this.yMax};
};
IlvChartView.prototype.setVisibleWindow=function(_86,_87,_88,_89){
this.xMin=_86;
this.xMax=_87;
this.yMin=_88;
this.yMax=_89;
this.intervalInitialized=true;
this.updateImage(true);
};
IlvChartView.prototype.getDataWindow=function(){
return {xMin:this.cap_xDataMin,xMax:this.cap_xDataMax,yMin:this.cap_yDataMin,yMax:this.cap_yDataMax};
};
IlvChartView.prototype.resetRange=function(){
this.intervalInitialized=false;
};
IlvChartView.prototype.getPlotRect=function(){
return {left:this.cap_xPlotRect+this.left,top:this.cap_yPlotRect+this.top,width:this.cap_widthPlotRect,height:this.cap_heightPlotRect};
};
IlvChartView.prototype.isInPlotRect=function(x,y){
return (x>this.cap_xPlotRect)&&(x<this.cap_xPlotRect+this.cap_widthPlotRect)&&(y>this.cap_yPlotRect)&&(y<this.cap_yPlotRect+this.cap_heightPlotRect);
};
IlvChartView.prototype.setPopupMenu=function(_8c){
this.popupMenu=_8c;
this.popupMenu.setViewInternal(this);
};
IlvChartView.prototype.getPopupMenu=function(){
return this.popupMenu;
};
IlvChartView.prototype.addInteractorListener=function(_8d){
this.interactorListeners.addListener(_8d);
};
IlvChartView.prototype.removeInteractorListener=function(_8e){
this.interactorListeners.removeListener(_8e);
};
IlvChartView.prototype.mouseDown=function(e){
var _90=this.interactor;
var _91=this.popupMenu;
if(_91!=null&&_91.isPopupTrigger(e)){
this.eventPanel._dragging=false;
return true;
}else{
if(_91!=null){
_91.internalResetEvent();
_91.hidePopupMenu();
}
if(_90!=null&&_90.mouseDown&&this.isCapabilitiesLoaded()){
_90.mouseDown(e);
}
}
};
IlvChartView.prototype.mouseOver=function(e){
var _93=this.interactor;
if(_93!=null){
if(_93.message){
window.status=_93.message;
if(this.initialized&&this.infoPanel){
this.infoPanel.setContent(_93.message);
}
}
if(_93.mouseOver){
_93.mouseOver(e);
}
}
};
IlvChartView.prototype.mouseOut=function(e){
var _95=this.interactor;
if(_95!=null){
window.status="";
if(this.initialized&&this.infoPanel){
this.infoPanel.setContent("");
}
if(_95.mouseOut){
_95.mouseOut(e);
}
}
};
IlvChartView.prototype.mouseMove=function(e){
if(this.interactor!=null&&this.interactor.mouseMove){
this.interactor.mouseMove(e);
}
};
IlvChartView.prototype.mouseDrag=function(e){
var _98=this.interactor;
if(_98!=null&&_98.mouseDrag&&this.isCapabilitiesLoaded()){
_98.mouseDrag(e);
}
};
IlvChartView.prototype.mouseUp=function(e){
var _9a=this.interactor;
var _9b=this.popupMenu;
if(_9b!=null&&_9b.isPopupTrigger(e)){
if(this.imagePanel.isImageLoaded()){
var _9c;
if(_9a!=null){
_9c=_9a.getMenuModelId();
}
return _9b.displayPopupMenu(this,e,_9c);
}else{
e.preventDefault();
return false;
}
}else{
if(this.interactor!=null&&this.interactor.mouseUp){
this.interactor.mouseUp(e);
}
}
return true;
};
IlvChartView.prototype.keyPress=function(e){
if(this.interactor!=null&&this.interactor.keyPress){
this.interactor.keyPress(e);
}
};
IlvChartView.prototype.keyDown=function(e){
if(this.interactor!=null&&this.interactor.keyDown){
this.interactor.keyDown(e);
}
};
IlvChartView.prototype.keyUp=function(e){
if(this.interactor!=null&&this.interactor.keyUp){
this.interactor.keyUp(e);
}
};
IlvChartView.prototype.setDefaultHotkeys=function(){
this.superInvoke("setDefaultHotkeys");
var _a0=this.hotkeys;
_a0.moveNodeUp=null;
_a0.moveNodeDown=null;
_a0.moveNodeLeft=null;
_a0.moveNodeRight=null;
_a0.zoomIn=null;
_a0.zoomOut=null;
var _a1={zoomInByX:{hotkey:[IlvUtil.keys.NUMPAD_PLUS,IlvUtil.keys.EQUALS],filter:{ctrl:false,alt:false,shift:true}},zoomOutByX:{hotkey:[IlvUtil.keys.NUMPAD_MINUS,IlvUtil.keys.DASH],filter:{ctrl:false,alt:false,shift:true}},zoomInByY:{hotkey:[IlvUtil.keys.NUMPAD_PLUS,IlvUtil.keys.EQUALS],filter:{ctrl:false,alt:true,shift:false}},zoomOutByY:{hotkey:[IlvUtil.keys.NUMPAD_MINUS,IlvUtil.keys.DASH],filter:{ctrl:false,alt:true,shift:false}}};
_a0.zoomInByX=_a1.zoomInByX;
_a0.zoomInByY=_a1.zoomInByY;
_a0.zoomOutByX=_a1.zoomOutByX;
_a0.zoomOutByY=_a1.zoomOutByY;
};
IlvChartView.prototype.updateImage=function(_a2){
if(this.error){
this.waitPanel.setContent(this.getWaitPanelHTML());
}
this.error=false;
this.stopUpdateTimer();
this.updateCapabilities=_a2||false;
this.superInvoke("updateImage");
this.startErrorTimer();
};
IlvChartView.prototype.createImageRequestURL=function(_a3,_a4){
var _a5=this.superInvoke("createImageRequestURL",_a3,_a4);
if(this.intervalInitialized){
var req=["&xMin=",this.xMin,"&xMax=",this.xMax,"&yMin=",this.yMin,"&yMax=",this.yMax];
_a5+=req.join("");
}
return _a5;
};
IlvChartView.prototype.imageLoaded=function(){
if(this.error){
return;
}
this.stopErrorTimer();
if(this.updateCapabilities){
this.getCapabilities();
}
updateCapabilities=true;
this.resetSessionExpirationTimer();
this.superInvoke("imageLoaded");
this.startUpdateTimer();
this.updateImageMap();
this.updateHitmap();
};
IlvChartView.prototype.setDeletingCookieOnDispose=function(del){
if(del){
this.deleteCookieOnDispose=true;
}else{
this.deleteCookieOnDispose=false;
}
};
IlvChartView.prototype.isDeletingCookieOnDispose=function(){
return this.deleteCookieOnDispose;
};
IlvChartView.prototype.initFromCookie=function(){
this.superInvoke("initFromCookie");
this.readVisibleRangeCookie();
};
IlvChartView.prototype.saveVisibleRangeCookie=function(){
if(this.isStateInCookie()){
IlvUtil.setCookie(this.xRangeCookie,"&xMin="+this.xMin+"&xMax="+this.xMax);
IlvUtil.setCookie(this.yRangeCookie,"&yMin="+this.yMin+"&yMax="+this.yMax);
}else{
this.saveState(this);
}
};
IlvChartView.prototype.readVisibleRangeCookie=function(){
if(this.isStateInCookie()){
var _a8=IlvUtil.getCookie(this.xRangeCookie);
var _a9=false;
var _aa=false;
if(_a8){
this.xMin=parseFloat(this.parseValue(_a8,"xMin"));
this.xMax=parseFloat(this.parseValue(_a8,"xMax"));
_a9=true;
}
_a8=IlvUtil.getCookie(this.yRangeCookie);
if(_a8){
this.yMin=parseFloat(this.parseValue(_a8,"yMin"));
this.yMax=parseFloat(this.parseValue(_a8,"yMax"));
_aa=true;
}
}else{
this.restoreState(this);
_a9=true;
_aa=true;
}
this.intervalInitialized=_a9&&_aa;
};
IlvChartView.prototype.parseValue=function(str,_ac){
var s=str.indexOf(_ac,0);
if(s==-1){
return -1;
}
var e=str.indexOf("&",s+1);
if(e==-1){
e=str.length;
}
return str.substring(s+_ac.length+1,e);
};
IlvChartView.prototype.childrenToHTML=function(_af){
this.superInvoke("childrenToHTML",_af);
this.capabilitiesRequest=new IlvAjax.JSRequest(this,this.onCapabilitiesLoaded);
};
IlvChartView.prototype.performAction=function(_b0,_b1,_b2){
var buf=_b0+"(";
if(_b1!=null){
buf+=_b1.join(",");
}
buf+=")";
this.setAdditionalParameters("action",buf);
if(_b2){
this.updateImage(true);
}else{
this.getCapabilities();
}
this.setAdditionalParameters("action",null);
};
IlvChartView.imagePath=IlvConstants.contextPath+"jviews/chart/images/";
IlvChartComponentView.basePath=IlvConstants.contextPath+"jviews/images/";
IlvChartOverview=function(_b4,top,_b6,_b7,_b8,_b9,_ba){
if(!window.IlvAbstractView){
alert(jviews.messages.IlvChartOverview.requiresIlvAbstractView);
}
this.superConstructor(_b4,top,_b6,_b7,_ba);
this.reload=_b9||false;
this.view=_b8;
this.lineWidth=2;
this.color="black";
this.actionName="OverviewAction";
this.visible=false;
this.ghostW=0;
this.ghostH=0;
this.imageH=_b7;
this.imageW=_b6;
this.overviewRefresh=false;
this.firstTime=true;
this.oldVisibleWindow={};
this.oldVisibleWindow.xMin=0;
this.oldVisibleWindow.xMax=0;
this.oldVisibleWindow.yMin=0;
this.oldVisibleWindow.yMax=0;
this.oldDataWindow={};
this.oldDataWindow.xMin=0;
this.oldDataWindow.xMax=0;
this.oldDataWindow.yMin=0;
this.oldDataWindow.yMax=0;
this.updateOnResizeLock=false;
this.capabilitiesLoaded=false;
this.capabilitiesListeners=new IlvListenerList();
this.imagePanel=new IlvImageView(_b4,top,_b6,_b7);
this.imagePanel.setImageSize(3,3);
this.imagePanel.addImageLoadListener(IlvChartOverview.onImageLoaded);
this.imagePanel.overview=this;
this.needAdjust=true;
this.setMessage(jviews.messages.IlvChartOverview.moveRectangleToView);
this.setViewInternal(_b8);
this.setMinimumSize(10,10);
this.imagePanel.setBlendTransform(false);
if(this.reload){
this.initFromCookie();
}
};
IlvChartOverview.prototype=new IlvAbstractView();
IlvChartOverview.prototype.setClassName("IlvChartOverview");
IlvChartOverview.prototype.dispose=function(){
this.capabilitiesListeners.dispose();
if(this.view){
this.view=null;
}
this.superInvoke("dispose");
if(this.waitPanel){
this.waitPanel.dispose();
}
if(this.rect){
this.rect.dispose();
}
if(this.imagePanel){
this.imagePanel.overview=null;
this.imagePanel.dispose();
}
};
IlvChartOverview.prototype.setViewInternal=function(_bb){
if(_bb){
var _bc=this;
this.view=_bb;
_bb.addCapabilitiesLoadListener(function(_bd){
_bc.onTargetCapabilitiesLoaded(_bd);
});
if(this.waitPanel){
this.waitPanel.setContent(this.getWaitPanelHTML());
}
}
};
IlvChartOverview.prototype.initFromCookie=function(){
this.initSizeFromCookie();
};
IlvChartOverview.prototype.initSizeFromCookie=function(){
var _be=this.readSizeFromCookie();
if(_be.width!=this.getWidth()||_be.height!=this.getHeight()){
this.setSize(_be.width,_be.height);
}
};
IlvChartOverview.prototype.isCapabilitiesLoaded=function(){
return this.capabilitiesLoaded;
};
IlvChartOverview.prototype.getCapabilities=function(){
this.capabilitiesLoaded=false;
this.capabilitiesRequest.send(this.createCapabilitiesRequestURL());
};
IlvChartOverview.prototype.createCapabilitiesRequestURL=function(){
var _bf=[this.view.getServletURL(),"?request=capabilities&format=json","&comp=overview","&imageWidth=",this.getWidth(),"&imageHeight=",this.getHeight(),this.view.getAdditionalParameters(),this.view.getAgainParam()];
return _bf.join("");
};
IlvChartOverview.prototype.onCapabilitiesLoaded=function(_c0){
this.cap_visibleRect={left:_c0.visLeft,top:_c0.visTop,width:_c0.visWidth,height:_c0.visHeight};
this.cap_plotRect={left:_c0.xPlotRect,top:_c0.yPlotRect,width:_c0.widthPlotRect,height:_c0.heightPlotRect};
this.adjust();
this.readAdditionalCapabilities(_c0);
this.capabilitiesLoaded=true;
this.capabilitiesListeners.notify(this);
};
IlvChartOverview.prototype.readAdditionalCapabilities=function(_c1){
};
IlvChartOverview.prototype.addCapabilitiesLoadListener=function(_c2){
this.capabilitiesListeners.addListener(_c2);
};
IlvChartOverview.prototype.removeCapabilitiesLoadListener=function(_c3){
this.capabilitiesListeners.removeListener(_c3);
};
IlvChartOverview.prototype.getTargetView=function(){
return this.view;
};
IlvChartOverview.prototype.setMessage=function(_c4){
this.message=_c4;
};
IlvChartOverview.prototype.getMessage=function(){
return this.message;
};
IlvChartOverview.prototype.setMessagePanel=function(_c5){
this.infoPanel=_c5;
};
IlvChartOverview.prototype.getMessagePanel=function(){
return this.infoPanel;
};
IlvChartOverview.prototype.setColor=function(_c6){
this.color=_c6;
if(this.rect){
this.rect.setColor(_c6);
}
};
IlvChartOverview.prototype.getColor=function(){
return this.color;
};
IlvChartOverview.prototype.setLineWidth=function(lw){
this.lineWidth=lw;
if(this.rect){
this.rect.setThickness(lw);
this.adjust();
}
};
IlvChartOverview.prototype.getLineWidth=function(){
return this.lineWidth;
};
IlvChartOverview.prototype.setWaitingImage=function(_c8){
this.waitingImage=_c8;
if(this.waitPanel){
this.waitPanel.setContent(this.getWaitPanelHTML());
}
};
IlvChartOverview.prototype.getWaitingImage=function(){
if(this.waitingImage){
return this.waitingImage;
}
if(this.view){
return this.view.getWaitingImage();
}
};
IlvChartOverview.prototype.setAutoRefresh=function(set){
this.overviewRefresh=set;
};
IlvChartOverview.prototype.isAutoRefresh=function(){
return this.overviewRefresh;
};
IlvChartOverview.prototype.canPan=function(){
var _ca=this.getTargetView();
if(_ca&&_ca.canPan()){
return true;
}
return false;
};
IlvChartOverview.prototype.mouseDown=function(e){
if(!this.canPan()){
return false;
}
this.dragging=true;
return this.mouseDrag(e);
};
IlvChartOverview.prototype.mouseOver=function(e){
if(!this.canPan()){
return false;
}
if(this.message){
window.status=this.message;
if(this.view.initialized&&this.infoPanel){
this.infoPanel.setContent(this.message);
}
}
};
IlvChartOverview.prototype.mouseOut=function(e){
if(!this.canPan()){
return false;
}
if(this.message){
window.status="";
if(this.view.initialized&&this.infoPanel){
this.infoPanel.setContent("");
}
}
};
IlvChartOverview.prototype.mouseDrag=function(e){
if(!this.canPan()){
return false;
}
var x=e.mouseX;
var y=e.mouseY;
var h=this.ghostH;
var w=this.ghostW;
if(x<w/2){
x=w/2;
}
if(y<h/2){
y=h/2;
}
if(x+w/2>this.imageW-1){
x=this.imageW-1-w/2;
}
if(y+h/2>this.imageH-1){
y=this.imageH-1-h/2;
}
this.drawRect(x-w/2,y-h/2,w,h);
return true;
};
IlvChartOverview.prototype.mouseUp=function(e){
if(!this.canPan()){
return false;
}
if(this.dragging==false){
return false;
}
this.needAdjust=false;
this.dragging=false;
this.doPan();
return false;
};
IlvChartOverview.prototype.doPan=function(){
var _d4=this.rect.getBounds();
var _d5=[_d4.left-this.getLeft(),_d4.top-this.getTop(),_d4.width,_d4.height,this.getWidth(),this.getHeight()];
this.view.performAction(this.actionName,_d5,true);
};
IlvChartOverview.prototype.drawRect=function(_d6,top,_d8,_d9){
var _da=this.cap_plotRect.left;
var _db=this.cap_plotRect.top;
var _dc=this.cap_plotRect.width;
var _dd=this.cap_plotRect.height;
if(_d6<0){
_d6=0;
}
if(_d6<_da){
_d6=_da;
}
if(_d6>_dc-1+_da){
_d6=_dc-1+_da;
}
if(_d8<0){
_d8=0;
}
if(_d8+_d6>_da+_dc-1){
_d6=_dc-1+_da-_d8;
}
if(top<0){
top=0;
}
if(top<_db){
top=_db;
}
if(top>_db+_dd-1){
top=_dd-1+_db;
}
if(_d9<0){
_d9=0;
}
if(_d9+top>_dd-1+_db){
top=_dd-1+_db-_d9;
}
_d6=parseInt(_d6);
top=parseInt(top);
_d8=parseInt(_d8);
_d9=parseInt(_d9);
this.rect.setBounds(this.getLeft()+_d6,this.getTop()+top,_d8,_d9);
};
IlvChartOverview.prototype.adjust=function(){
if(this.needAdjust==false){
this.needAdjust=true;
return;
}
if(this.cap_visibleRect){
var _de=this.cap_visibleRect.left;
var _df=this.cap_visibleRect.top;
var _e0=this.cap_visibleRect.width;
var _e1=this.cap_visibleRect.height;
this.ghostW=this.cap_visibleRect.width;
this.ghostH=this.cap_visibleRect.height;
this.drawRect(_de,_df,_e0,_e1);
if(!this.canPan()){
this.rect.setVisible(false);
this.visible=false;
}else{
if(this.visible==false){
this.rect.setVisible(true);
this.visible=true;
}
}
}
};
IlvChartOverview.prototype.onTargetCapabilitiesLoaded=function(_e2){
if(this.capabilitiesLoaded){
if(!this.canPan()){
this.rect.setVisible(false);
this.visible=false;
}else{
if(this.visible==false){
this.forceUpdate=true;
}
}
}
var _e3=_e2.getDataWindow();
if(this.forceUpdate||this.oldDataWindow.xMin!=_e3.xMin||this.oldDataWindow.xMax!=_e3.xMax||this.oldDataWindow.yMin!=_e3.yMin||this.oldDataWindow.yMax!=_e3.yMax){
this.oldDataWindow=_e3;
this.updateImage();
return;
}
if(this.overviewRefresh){
this.updateImage();
return;
}
var _e4=_e2.getVisibleWindow();
if(this.oldVisibleWindow.xMin!=_e4.xMin||this.oldVisibleWindow.xMax!=_e4.xMax||this.oldVisibleWindow.yMin!=_e4.yMin||this.oldVisibleWindow.yMax!=_e4.yMax){
this.getCapabilities();
this.oldVisibleWindow=_e4;
}
};
IlvChartOverview.prototype.updateImage=function(){
this.waitPanel.setVisible(true);
var _e5=this.imagePanel.getImageSize();
this.imageW=this.getWidth();
this.imageH=this.getHeight();
var _e6=this.view.getServletURL()+"?request=image";
var _e7=this.view.getDataWindow();
_e6+="&format="+this.view.imageFormat;
_e6+="&comp=overview";
_e6+="&width="+this.imageW;
_e6+="&height="+this.imageH;
if(this.view.imgbgcolor){
_e6+="&bgcolor=0x"+this.view.imgbgcolor;
}
_e6+=this.view.getAdditionalParameters();
_e6+=this.view.getAgainParam();
var _e8=(_e5.width!=this.imageW||_e5.height!=this.imageH);
var _e9=_e6;
if(_e8){
this.imagePanel.setImage(_e9,this.imageW,this.imageH);
}else{
this.imagePanel.setImage(_e9);
}
};
IlvChartOverview.onImageLoaded=function(_ea){
var _eb=_ea.overview;
_eb.imageLoaded();
};
IlvChartOverview.prototype.imageLoaded=function(){
if(this.error){
return;
}
this.imagePanel.setVisible(true);
this.waitPanel.setVisible(false);
var _ec=this.view.getVisibleWindow();
if(this.forceUpdate||this.oldVisibleWindow.xMin!=_ec.xMin||this.oldVisibleWindow.xMax!=_ec.xMax||this.oldVisibleWindow.yMin!=_ec.yMin||this.oldVisibleWindow.yMax!=_ec.yMax){
this.oldVisibleWindow=_ec;
this.forceUpdate=false;
this.getCapabilities();
}
};
IlvChartOverview.prototype.updateAll=function(){
this.forceUpdate=true;
this.updateImage();
};
IlvChartOverview.prototype.getWaitPanelHTML=function(){
var img=this.getWaitingImage();
if(img){
return "<table "+"width=\""+this.getWidth()+"\" "+"height=\""+this.getHeight()+"\">"+"<tr><td align=\"center\" valign=\"middle\">"+"<img style=\"-webkit-user-drag:none\" src=\""+img+"\" galleryimg=\"false\"/></td></tr></table>";
}else{
return "";
}
};
IlvChartOverview.prototype.getErrorHTML=function(){
return this.view.getErrorHTML();
};
IlvChartOverview.prototype.setChildrenBounds=function(_ee,top,_f0,_f1){
this.superInvoke("setChildrenBounds",_ee,top,_f0,_f1);
this.imagePanel.setBounds(_ee,top,_f0,_f1);
if(this.inHTML){
this.waitPanel.setBounds(_ee,top,_f0,_f1);
this.waitPanel.setContent(this.getWaitPanelHTML());
if(this._resized){
if(this.reload){
this.saveSizeToCookie();
}
if(!this.updateOnResizeLock){
this.updateAll();
}
}else{
this.adjust();
}
}
};
IlvChartOverview.prototype.childrenToHTML=function(_f2){
this.imagePanel.setVisible(false);
this.imagePanel.toHTML(_f2);
this.rect=new IlvRectangle(null,_f2);
this.rect.setThickness(this.lineWidth);
this.setColor(this.color);
this.capabilitiesRequest=new IlvAjax.JSRequest(this,this.onCapabilitiesLoaded);
this.waitPanel=new IlvHTMLPanel(this.getWaitPanelHTML(),_f2);
this.waitPanel.setBounds(this.getLeft(),this.getTop(),this.getWidth(),this.getHeight());
this.waitPanel.setVisible(true);
this.superInvoke("childrenToHTML",_f2);
};
IlvChartOverview.prototype.removeHTML=function(){
this.superInvoke("removeHTML");
this.imagePanel.removeHTML();
this.waitPanel.removeHTML();
this.rect.removeHTML();
};
IlvChartOverview.prototype.updateVisibility=function(){
this.superInvoke("updateVisibility");
this.imagePanel.updateVisibility();
this.waitPanel.updateVisibility();
this.rect.updateVisibility();
};
IlvLegendView=function(_f3,top,_f5,_f6,_f7,_f8){
if(!window.IlvChartComponentView){
alert(jviews.messages.IlvLegendView.requiresIlvChartComponentView);
}
this.superConstructor(_f3,top,_f5,_f6,_f7,_f8);
this.component="legend";
if(this.reload){
this.initFromCookie();
}
};
IlvLegendView.prototype=new IlvChartComponentView();
IlvLegendView.prototype.setClassName("IlvLegendView");
IlvLegendView.prototype.dispose=function(){
this.superInvoke("dispose");
this.view=null;
this.hitmap=null;
};
IlvLegendView.prototype.init=function(){
this.updateImage();
this.initialized=true;
};
IlvLegendView.prototype.setComponent=function(_f9){
};
IlvLegendView.prototype.imageLoaded=function(){
if(this.error){
return;
}
this.superInvoke("imageLoaded");
this.updateImageMap();
this.updateHitmap();
};
IlvLegendView.prototype.mouseMove=function(e){
if(!this.hitmap){
return;
}
var x=e.mouseX,y=e.mouseY;
var _fd=this.hitmap;
if(!this.tooltip){
this.tooltip=new IlvTooltip(0,0);
}
var _fe=this.tolerance?_fd.hittest(x,y,this.tolerance):_fd.hittest(x,y);
if(_fd.highlighted==_fe){
if(_fd.highlighted==0){
this.tooltip.setVisible(false);
}else{
this.tooltip.move(e.clientX,e.clientY);
var _ff=_fd.tooltips?_fd.tooltips[_fe]:"";
this.tooltip.setMessage(_ff);
this.tooltip.setVisible(true);
}
return;
}
_fd.highlighted=_fe;
var _100=this.getDrawPanel();
_100.clear();
if(_fd.highlighted==0){
this.tooltip.setVisible(false);
return;
}
var _101=_fd.getShape(_fe);
this.color="#FF7F50";
this.opacity=0.5;
if(!_100.cannotHightlight){
_100.addShape(_101,this.color,this.opacity);
}
};
IlvLegendView.prototype.enableHitmap=function(_102,_103){
if(_102&&this.view){
if(this.view.hitmap){
this.hitmap=this.view.hitmap;
}else{
this.hitmap=new IlvHitmap();
}
}else{
this.hitmap=null;
}
this.tolerance=_103;
this.putHitInfoType("tooltip");
this.updateHitmap();
};
IlvLegendView.prototype.performAction=function(_104,_105,_106){
var buf=_104+"(";
if(_105!=null){
var p=[];
var l=_105.length;
for(var i=0;i<l;i++){
p.push(_105[i]);
}
buf+=p.join(",");
}
buf+=")";
this.setAdditionalParameters("action",buf);
if(_106){
this.updateImage();
}
this.setAdditionalParameters("action",null);
};
IlvChartZoomInteractor=function(_10b){
this.superConstructor();
this.actionName=_10b;
this.setMessage(jviews.messages.IlvChartZoomInteractor.selectAnAreaZoomIn);
this.setCursor("crosshair");
this.listeners=new IlvListenerList();
this.color="black";
this.zleft=0;
this.ztop=0;
this.zbottom=0;
this.zright=0;
this.startx=0;
this.starty=0;
this.lineWidth=2;
this.dragging=false;
this.xZoomAllowed=true;
this.yZoomAllowed=false;
var _10c=this;
this.addRectangleDraggedListener(function(_10d){
_10c.onEndDrag(_10d);
});
};
IlvChartZoomInteractor.prototype=new IlvInteractor();
IlvChartZoomInteractor.prototype.setClassName("IlvChartZoomInteractor");
IlvChartZoomInteractor.prototype.isXZoomAllowed=function(){
return this.xZoomAllowed;
};
IlvChartZoomInteractor.prototype.setXZoomAllowed=function(_10e){
this.xZoomAllowed=_10e;
};
IlvChartZoomInteractor.prototype.isYZoomAllowed=function(){
return this.yZoomAllowed;
};
IlvChartZoomInteractor.prototype.setYZoomAllowed=function(_10f){
this.yZoomAllowed=_10f;
};
IlvChartZoomInteractor.prototype.addRectangleDraggedListener=function(_110){
this.listeners.addListener(_110);
};
IlvChartZoomInteractor.prototype.removeRectangleDraggedListener=function(_111){
this.listeners.removeListener(_111);
};
IlvChartZoomInteractor.prototype.setColor=function(_112){
this.color=_112;
};
IlvChartZoomInteractor.prototype.getColor=function(){
return this.color;
};
IlvChartZoomInteractor.prototype.setLineWidth=function(_113){
this.lineWidth=_113;
this.adjust();
};
IlvChartZoomInteractor.prototype.getLineWidth=function(){
return this.lineWidth;
};
IlvChartZoomInteractor.prototype.adjust=function(){
if(this.view&&this.view.getRectangle()){
var view=this.view;
var _115=this.computeZoomedWindow();
view.getRectangle().setColor(this.color);
view.getRectangle().setThickness(this.lineWidth);
view.getRectangle().setBounds(_115.left,_115.top,_115.width,_115.height);
}
};
IlvChartZoomInteractor.prototype.computeZoomedWindow=function(){
var view=this.view;
var _117=this.zleft+view.getLeft();
var _118=this.zright+view.getLeft();
var ztop=this.ztop+view.getTop();
var _11a=this.zbottom+view.getTop();
var _11b=view.getPlotRect();
_117=Math.max(_117,_11b.left);
ztop=Math.max(ztop,_11b.top);
_118=Math.min(_118,_11b.left+_11b.width);
_11a=Math.min(_11a,_11b.top+_11b.height);
if(this.view.isXHorizontal()){
if(!this.isYZoomAllowed()){
ztop=_11b.top;
_11a=_11b.top+_11b.height;
}
if(!this.isXZoomAllowed()){
_117=_11b.left;
_118=_11b.left+_11b.width;
}
}else{
if(!this.isYZoomAllowed()){
_117=_11b.left;
_118=_11b.left+_11b.width;
}
if(!this.isXZoomAllowed()){
ztop=_11b.top;
_11a=_11b.top+_11b.height;
}
}
return {left:_117,top:ztop,width:_118-_117,height:_11a-ztop};
};
IlvChartZoomInteractor.prototype.startDragging=function(e){
this.startx=e.mouseX;
this.starty=e.mouseY;
this.whileDragging(e);
this.view.getRectangle().setVisible(true);
return false;
};
IlvChartZoomInteractor.prototype.getRectangle=function(){
return this.view.getRectangle().getBounds();
};
IlvChartZoomInteractor.prototype.whileDragging=function(e){
var _11e=e.mouseX;
var _11f=e.mouseY;
if(_11e>this.startx){
this.zleft=this.startx;
this.zright=_11e;
}else{
this.zleft=_11e;
this.zright=this.startx;
}
if(_11f>this.starty){
this.ztop=this.starty;
this.zbottom=_11f;
}else{
this.ztop=_11f;
this.zbottom=this.starty;
}
this.adjust();
return false;
};
IlvChartZoomInteractor.prototype.stopDragging=function(e){
this.reset();
if(this.dragevent==null){
this.dragevent={};
}
var _121=this.computeZoomedWindow();
this.dragevent.left=_121.left-this.view.left;
this.dragevent.top=_121.top-this.view.top;
this.dragevent.width=_121.width;
this.dragevent.height=_121.height;
this.dragevent.mouseEvent=e;
if(this.dragevent.width>3&&this.dragevent.height>3){
this.listeners.notify(this.dragevent);
}
return false;
};
IlvChartZoomInteractor.prototype.reset=function(e){
this.dragging=false;
this.view.getRectangle().setVisible(false);
};
IlvChartZoomInteractor.prototype.canZoom=function(){
if(this.view&&!this.view.is3D()&&this.view.isCartesian()){
return true;
}
return false;
};
IlvChartZoomInteractor.prototype.mouseDown=function(e){
if(!this.canZoom()){
return false;
}
if(this.view!=null&&this.view.isInPlotRect(e.mouseX,e.mouseY)){
if(!this.dragging){
this.dragging=true;
return this.startDragging(e);
}else{
return this.stopDragging(e);
}
}
return false;
};
IlvChartZoomInteractor.prototype.mouseDrag=function(e){
if(!this.canZoom()){
return false;
}
if(this.dragging){
return this.whileDragging(e);
}
return false;
};
IlvChartZoomInteractor.prototype.mouseUp=function(e){
if(!this.canZoom()){
return false;
}
if(this.dragging){
this.stopDragging(e);
return false;
}
return false;
};
IlvChartZoomInteractor.prototype.keyPress=function(e){
if(e.keyCode==27&&this.dragging){
this.reset();
return false;
}
return false;
};
IlvChartZoomInteractor.prototype.onEndDrag=function(_127){
var _128=[_127.left,_127.top,_127.width,_127.height];
this.view.performAction(this.actionName,_128,true);
};
IlvChartPickInteractor=function(_129){
this.superConstructor();
this.actionName=_129;
this.setMessage(jviews.messages.IlvChartPickInteractor.clickAPointToSelect);
this.pendingImageUpdate=false;
var _12a=this;
this.viewImageLoadListener=function(view){
_12a.onImageLoaded(view);
};
};
IlvChartPickInteractor.prototype=new IlvInteractor();
IlvChartPickInteractor.prototype.setClassName("IlvChartPickInteractor");
IlvChartPickInteractor.prototype.setView=function(view){
if(this.view!=null){
this.view.removeImageLoadListener(this.viewImageLoadListener);
}
if(view!=null){
if(view.instanceOf&&view.instanceOf(IlvChartView)){
view.addImageLoadListener(this.viewImageLoadListener);
}else{
alert(jviews.messages.IlvChartPickInteractor.onlySetOnIlvChartView);
}
}
};
IlvChartPickInteractor.prototype.mouseDown=function(e){
if(this.pendingImageUpdate){
return;
}
var view=this.view;
var xPos=e.mouseX;
var yPos=e.mouseY;
if(view!=null&&!view.isInPlotRect(xPos,yPos)){
return;
}
if(yPos<0||xPos<0){
return;
}
this.pendingImageUpdate=true;
this.pickPoint(xPos,yPos);
return false;
};
IlvChartPickInteractor.prototype.pickPoint=function(xPos,yPos){
this.view.performAction(this.actionName,[xPos,yPos],true);
};
IlvChartPickInteractor.prototype.onImageLoaded=function(view){
if(this.pendingImageUpdate){
this.pendingImageUpdate=false;
}
};
IlvChartPanInteractor=function(_134){
this.superConstructor();
this.actionName=_134;
this.setMessage(jviews.messages.IlvChartPanInteractor.scrollVisibleRange);
this.listeners=new IlvListenerList();
this.color="black";
this.ghostLeft=0;
this.ghostTop=0;
this.ghostBottom=0;
this.ghostRight=0;
this.oldx=0;
this.oldy=0;
this.startx=0;
this.starty=0;
this.lineWidth=2;
this.dragging=false;
this.xPanAllowed=true;
this.yPanAllowed=false;
var _135=this;
this.addRectangleDraggedListener(function(_136){
_135.onEndDrag(_136);
});
};
IlvChartPanInteractor.prototype=new IlvInteractor();
IlvChartPanInteractor.prototype.setClassName("IlvChartPanInteractor");
IlvChartPanInteractor.prototype.isXPanAllowed=function(){
return this.xPanAllowed;
};
IlvChartPanInteractor.prototype.setXPanAllowed=function(_137){
this.xPanAllowed=_137;
};
IlvChartPanInteractor.prototype.isYPanAllowed=function(){
return this.yPanAllowed;
};
IlvChartPanInteractor.prototype.setYPanAllowed=function(_138){
this.yPanAllowed=_138;
};
IlvChartPanInteractor.prototype.addRectangleDraggedListener=function(_139){
this.listeners.addListener(_139);
};
IlvChartPanInteractor.prototype.removeRectangleDraggedListener=function(_13a){
this.listeners.removeListener(_13a);
};
IlvChartPanInteractor.prototype.setColor=function(_13b){
this.color=_13b;
};
IlvChartPanInteractor.prototype.getColor=function(){
return this.color;
};
IlvChartPanInteractor.prototype.setLineWidth=function(_13c){
this.lineWidth=_13c;
this.adjust();
};
IlvChartPanInteractor.prototype.getLineWidth=function(){
return this.lineWidth;
};
IlvChartPanInteractor.prototype.adjust=function(_13d,_13e){
if(this.view&&this.view.getRectangle()){
var view=this.view;
if(view.isXHorizontal()){
if(this.isXPanAllowed()){
this.ghostLeft+=_13d;
}
if(this.isYPanAllowed()){
this.ghostTop+=_13e;
}
}else{
if(this.isXPanAllowed()){
this.ghostTop+=_13e;
}
if(this.isYPanAllowed()){
this.ghostLeft+=_13d;
}
}
var left=this.ghostLeft;
var _141=this.ghostWidth;
var top=this.ghostTop;
var _143=this.ghostHeight;
if(left<view.left){
_141-=view.left-left;
left=view.left;
}else{
if(left+_141>view.left+view.width){
if(left>view.left+view.width){
left=view.left+view.width;
}
_141-=left+_141-view.left-view.width;
}
}
if(_141<0){
_141=0;
}
if(top<view.top){
_143-=view.top-top;
top=view.top;
}else{
if(top+_143>view.top+view.height){
if(top>view.top+view.height){
top=view.top+view.height;
}
_143-=top+_143-view.top-view.height;
}
}
if(_143<0){
_143=0;
}
view.getRectangle().setColor(this.color);
view.getRectangle().setThickness(this.lineWidth);
view.getRectangle().setBounds(left,top,_141,_143);
}
};
IlvChartPanInteractor.prototype.startDragging=function(e){
this.oldx=e.mouseX;
this.oldy=e.mouseY;
this.startx=e.mouseX;
this.starty=e.mouseY;
var _145=this.view.getPlotRect();
this.ghostLeft=_145.left;
this.ghostTop=_145.top;
this.ghostWidth=_145.width;
this.ghostHeight=_145.height;
this.adjust(0,0);
this.view.getRectangle().setVisible(true);
return false;
};
IlvChartPanInteractor.prototype.whileDragging=function(e){
var _147=e.mouseX;
var _148=e.mouseY;
var _149=_147-this.oldx;
var _14a=_148-this.oldy;
this.adjust(_149,_14a);
this.oldx=_147;
this.oldy=_148;
return false;
};
IlvChartPanInteractor.prototype.stopDragging=function(e){
this.dragging=false;
this.view.getRectangle().setVisible(false);
if(this.dragevent==null){
this.dragevent={};
}
var _14c=e.mouseX;
var _14d=e.mouseY;
this.dragevent.deltaX=this.startx-_14c;
this.dragevent.deltaY=this.starty-_14d;
if(this.dragevent.deltaX!=0||this.dragevent.deltaY!=0){
this.dragevent.mouseEvent=e;
this.listeners.notify(this.dragevent);
}
return false;
};
IlvChartPanInteractor.prototype.canPan=function(){
if(this.view&&!this.view.is3D()&&this.view.isCartesian()){
return true;
}
return false;
};
IlvChartPanInteractor.prototype.mouseDown=function(e){
if(!this.canPan()){
return false;
}
if(this.view!=null&&this.view.isInPlotRect(e.mouseX,e.mouseY)){
if(this.view.isMultiInteractor){
this.oldCursor=this.view.getCursor();
this.view.setCursor("move");
}
if(!this.dragging){
this.dragging=true;
return this.startDragging(e);
}else{
return this.stopDragging(e);
}
}
return false;
};
IlvChartPanInteractor.prototype.mouseDrag=function(e){
if(!this.canPan()){
return false;
}
if(this.dragging){
return this.whileDragging(e);
}
return false;
};
IlvChartPanInteractor.prototype.mouseUp=function(e){
if(!this.canPan()){
return false;
}
if(this.dragging){
this.stopDragging(e);
if(this.view.isMultiInteractor){
this.view.setCursor(this.oldCursor);
}
return false;
}
return false;
};
IlvChartPanInteractor.prototype.onEndDrag=function(_151){
if(!this.isXPanAllowed()&&!this.isYPanAllowed()){
var _152=[0,0,_151.mouseEvent];
}else{
if(!this.isXPanAllowed()&&this.isYPanAllowed()){
var _152=[0,_151.deltaY,_151.mouseEvent];
}else{
if(this.isXPanAllowed()&&!this.isYPanAllowed()){
var _152=[_151.deltaX,0,_151.mouseEvent];
}else{
var _152=[_151.deltaX,_151.deltaY,_151.mouseEvent];
}
}
}
this.view.performAction(this.actionName,_152,true);
};
IlvChartPopupMenu=function(mode){
if(typeof (mode)=="undefined"){
return;
}
this.superConstructor(true);
this.mode=mode;
};
IlvChartPopupMenu.prototype=new IlvAbstractPopupMenu();
IlvChartPopupMenu.prototype.setClassName("IlvChartPopupMenu");
IlvChartPopupMenu.prototype.setMode=function(mode){
this.mode=mode;
};
IlvChartPopupMenu.prototype.getMode=function(){
return this.mode;
};
IlvChartPopupMenu.prototype.createRequestURL=function(view,_156,_157){
var x=_156.mouseX;
var y=_156.mouseY;
var _15a=[view.getServletURL(),"?request=",this.factory.getRequestType(),"&format=html&point=(",x,",",y,")","&mode=",(this.mode=="ITEM"?1:this.mode=="NEAREST_ITEM"?2:0),"&xMin=",view.xMin,"&xMax=",view.xMax,"&yMin=",view.yMin,"&yMax=",view.yMax,"&width=",bounds.width,"&height=",bounds.height,view.getAdditionalParameters()];
if(_157!=null){
_15a=_15a.concat(["&modelId=",_157]);
}
return _15a;
};
IlvChartPopupMenu.prototype.performServerAction=function(_15b,_15c,_15d){
var temp=_15c.slice(0,3);
temp[3]=this.mode=="ITEM"?1:this.mode=="NEAREST_ITEM"?2:0;
_15c=temp.concat(_15c.slice(3));
this.superInvoke("performServerAction",_15b,_15c,_15d);
};
IlvChartPopupMenu.prototype.onModelLoaded=function(){
this.view.resetSessionExpirationTimer();
};
IlvFacesChartPopupMenu=function(mode){
if(typeof (mode)!="undefined"){
this.superConstructor(mode);
}
};
IlvFacesChartPopupMenu.prototype=new IlvChartPopupMenu();
IlvFacesChartPopupMenu.prototype.setClassName("IlvFacesChartPopupMenu");
IlvFacesChartPopupMenu.prototype.createRequestURL=function(view,_161,_162){
var x=_161.mouseX;
var y=_161.mouseY;
var _165=view.getServletURL();
_165+="?request="+this.factory.getRequestType();
_165+="&format=html&point=("+x+","+y+")";
if(_162!=null){
_165+="&modelId="+_162;
}
_165+="&menufactory="+escape(this.JSFRef.factory);
_165+=view.getAdditionalParameters();
var _166=this.JSFRef.getActionParameters(x,y);
if(!_166){
return;
}
_166[8]=escape(_166[8]);
_165+="&params=("+_166[0]+","+_166[1];
for(var i=2;i<_166.length;i++){
_165+=","+_166[i];
}
_165+=")";
return _165;
};
IlvFacesChartContextualMenuProxy=function(_168,_169){
this.superConstructor(_168,_169);
this.setObject(new IlvFacesChartPopupMenu(true));
};
IlvFacesChartContextualMenuProxy.prototype=new IlvAbstractPopupMenuProxy();
IlvFacesChartContextualMenuProxy.prototype.setClassName("IlvFacesChartContextualMenuProxy");
IlvFacesChartContextualMenuProxy.prototype.getActionParameters=function(x,y){
var view=this.getObject().view;
if(view==null){
return;
}
if(y<0||x<0){
return;
}
var _16d=view.getXVisibleRange();
var _16e=view.getYVisibleRange();
return [x,y,_16d.min,_16d.max,_16e.min,_16e.max,view.getWidth(),view.getHeight(),this.finder];
};
IlvFacesChartContextualMenuProxy.prototype.adaptParameters=function(_16f){
var x=_16f[0];
var y=_16f[1];
var path=_16f[2];
var _173=_16f.slice(3);
var _174=this.getActionParameters(x,y);
_174[_174.length]=path;
return _174.concat(_173);
};
IlvFacesChartView=function(left,top,_177,_178,_179,_17a){
if(_177){
this.superConstructor(left,top,_177,_178,_179,_17a);
}
};
IlvFacesChartView.prototype=new IlvChartView();
IlvFacesChartView.prototype.setClassName("IlvFacesChartView");
IlvFacesChartView.prototype.initFromCookie=function(){
this.setStateInCookie(false);
this.superInvoke("initFromCookie");
this.readVisibleRangeCookie();
};
IlvChartViewProxy=function(_17b,_17c,_17d,_17e,_17f){
if(_17b){
this.superConstructor(_17b);
this.setStateURL(_17f);
var size=this.getCreationSize(_17c,_17d,_17e);
this.setObject(new IlvFacesChartView(0,0,size.width,size.height,true));
var _181=this.getObject();
_181.JSFRef=this;
this.updateLegend=true;
_181.saveState=IlvChartViewProxy.saveState;
_181.restoreState=IlvChartViewProxy.restoreState;
this.getObject().initFromCookie();
this.servletClass="ilog.views.chart.faces.servlet.IlvFacesChartServlet";
this.addRequestParameters();
this.registerResizeListener(_181);
_181.addImageLoadListener(IlvChartViewProxy.imageLoaded);
}
};
IlvChartViewProxy.prototype=new IlvBasicViewProxy();
IlvChartViewProxy.prototype.setClassName("IlvChartViewProxy");
IlvChartViewProxy.prototype.dispose=function(){
if(this.overview){
this.overview.dispose();
this.overview=null;
}
if(this.legend){
this.legend.dispose();
this.legend=null;
}
this.superInvoke("dispose");
};
IlvChartViewProxy.prototype.setInteractor=function(_182){
this.interactor=_182;
this.getObject().setInteractor(_182?_182.getObject():null);
this.notify("InteractorId");
};
IlvChartViewProxy.prototype.getInteractor=function(){
return this.interactor;
};
IlvChartViewProxy.prototype.getInteractorId=function(){
return this.interactor?this.interactor.getAbsoluteId():null;
};
IlvChartViewProxy.prototype.setStateURL=function(_183){
this.stateURL=_183;
this.notify("StateURL");
};
IlvChartViewProxy.prototype.getStateURL=function(){
return this.stateURL;
};
IlvChartViewProxy.prototype.setGenerateImageMap=function(set,_185){
var _186=this.getObject();
_186.setGenerateImageMap(set);
if(_185){
_186.updateImage();
}
this.notify("GenerateImageMap");
};
IlvChartViewProxy.prototype.isGenerateImageMap=function(){
return this.getObject().isGenerateImageMap();
};
IlvChartViewProxy.prototype.setImageMapVisible=function(_187){
this.getObject().setImageMapVisible(_187);
this.notify("ImageMapVisible");
};
IlvChartViewProxy.prototype.isImageMapVisible=function(){
return this.getObject().isImageMapVisible();
};
IlvChartViewProxy.prototype.getImageMapGenerator=function(){
return this.imageMapGenerator;
};
IlvChartViewProxy.prototype.setImageMapGenerator=function(_188){
this.imageMapGenerator=_188;
this.notify("ImageMapGenerator");
this.setAdditionalParameters("imapGenerator",_188,false);
};
IlvChartViewProxy.prototype.setPopupMenu=function(_189){
this.getObject().setPopupMenu(_189.getObject());
};
IlvChartViewProxy.prototype.getPopupMenu=function(_18a){
return this.getObject().getPopupMenu();
};
IlvChartViewProxy.prototype.setResizable=function(_18b){
this.getObject().setResizable(_18b);
this.notify("Resizable");
};
IlvChartViewProxy.prototype.isResizable=function(_18c){
return this.getObject().isResizable();
};
IlvChartViewProxy.prototype.setAccessible=function(_18d){
this.getObject().setAccessible(_18d);
this.notify("Accessible");
};
IlvChartViewProxy.prototype.setHotkeys=function(_18e){
this.getObject().setHotkeys(_18e);
this.notify("Hotkeys");
};
IlvChartViewProxy.prototype.isAccessible=function(_18f){
return this.getObject().isAccessible();
};
IlvChartViewProxy.prototype.addRequestParameters=function(){
this.superInvoke("addRequestParameters");
this.getObject().setAdditionalParameters("facesComponentId",this.getClientId());
this.getObject().setAdditionalParameters("locale",IlvConstants.locale);
};
IlvChartViewProxy.prototype.setType=function(type,_191){
this.type=type;
var _192=this.getObject();
_192.setAdditionalParameters("chartType",this.type);
if(_191){
_192.updateImage(true);
}
this.notify("Type");
};
IlvChartViewProxy.prototype.getType=function(){
return this.type;
};
IlvChartViewProxy.prototype.setDataSourceId=function(_193,_194){
this.dataSourceId=_193;
var _195=this.getObject();
_195.setAdditionalParameters("chartDataSourceId",this.dataSourceId);
_195.xMin=NaN;
_195.xMax=NaN;
_195.yMin=NaN;
_195.yMax=NaN;
this._update(_194);
this.notify("DataSourceId");
};
IlvChartViewProxy.prototype.getDataSourceId=function(){
return this.dataSourceId;
};
IlvChartViewProxy.prototype.setBackgroundColor=function(_196,_197){
var _198=this.getObject();
_198.setImageBackgroundColor(_196);
if(_197){
_198.updateImage(true);
}
this.notify("BackgroundColor");
};
IlvChartViewProxy.prototype.getBackgroundColor=function(){
return this.getObject().getImageBackgroundColor();
};
IlvChartViewProxy.prototype.setStyleSheet=function(_199,_19a){
this.styleSheet=_199;
var _19b=this.getObject();
_19b.setAdditionalParameters("chartStyleSheet",this.styleSheet);
this._update(_19a);
this.notify("StyleSheet");
};
IlvChartViewProxy.prototype.getStyleSheet=function(){
return this.styleSheet;
};
IlvChartViewProxy.prototype.setStyleSheets=function(_19c,_19d){
this.styleSheets=_19c;
var _19e=this.getObject();
_19e.setAdditionalParameters("chartStyleSheets",this.styleSheets);
this._update(_19d);
this.notify("StyleSheets");
};
IlvChartViewProxy.prototype.getStyleSheets=function(){
return this.styleSheets;
};
IlvChartViewProxy.prototype.setComponent=function(_19f,_1a0){
var _1a1=this.getObject();
_1a1.setComponent(_19f);
if(_1a0){
_1a1.updateImage(true);
}
this.notify("Component");
};
IlvChartViewProxy.prototype.getComponent=function(){
return this.getObject().getComponent();
};
IlvChartViewProxy.prototype.setUpdateInterval=function(rate){
this.getObject().setUpdateInterval(rate);
this.notify("UpdateInterval");
};
IlvChartViewProxy.prototype.getUpdateInterval=function(){
return this.getObject().getUpdateInterval();
};
IlvChartViewProxy.prototype.startUpdateTimer=function(){
this.getObject().startUpdateTimer();
};
IlvChartViewProxy.prototype.stopUpdateTimer=function(){
this.getObject().stopUpdateTimer();
};
IlvChartViewProxy.prototype.zoomToFit=function(){
this.getObject().zoomToFit();
};
IlvChartViewProxy.prototype.translateX=function(_1a3){
this.getObject().translateX(_1a3);
};
IlvChartViewProxy.prototype.translateY=function(_1a4){
this.getObject().translateY(_1a4);
};
IlvChartViewProxy.prototype.setXZoomFactor=function(_1a5){
this.getObject().setXZoomFactor(_1a5);
this.notify("XZoomFactor");
};
IlvChartViewProxy.prototype.getXZoomFactor=function(){
return this.getObject().getXZoomFactor();
};
IlvChartViewProxy.prototype.setYZoomFactor=function(_1a6){
this.getObject().setYZoomFactor(_1a6);
this.notify("YZoomFactor");
};
IlvChartViewProxy.prototype.getYZoomFactor=function(){
return this.getObject().getYZoomFactor();
};
IlvChartViewProxy.prototype.zoomInX=function(){
this.getObject().zoomInX();
};
IlvChartViewProxy.prototype.zoomOutX=function(){
this.getObject().zoomOutX();
};
IlvChartViewProxy.prototype.zoomInY=function(){
this.getObject().zoomInY();
};
IlvChartViewProxy.prototype.zoomOutY=function(){
this.getObject().zoomOutY();
};
IlvChartViewProxy.prototype.zoomBy=function(_1a7,_1a8){
this.getObject().zoomBy(_1a7,_1a8);
};
IlvChartViewProxy.prototype.getVisibleWindow=function(){
return this.getObject().getVisibleWindow();
};
IlvChartViewProxy.prototype.setVisibleWindow=function(xMin,xMax,yMin,yMax){
this.getObject().setVisibleWindow(xMin,xMax,yMin,yMax);
};
IlvChartViewProxy.prototype.getDataWindow=function(){
return this.getObject().getDataWindow();
};
IlvChartViewProxy.prototype.getMaxZoomLevel=function(){
return this.getObject().getMaxZoomLevel();
};
IlvChartViewProxy.prototype.getXVisibleRange=function(){
return this.getObject().getXVisibleRange();
};
IlvChartViewProxy.prototype.setXVisibleRange=function(_1ad,_1ae){
this.getObject().setXVisibleRange(_1ad,_1ae);
};
IlvChartViewProxy.prototype.getYVisibleRange=function(){
return this.getObject().getYVisibleRange();
};
IlvChartViewProxy.prototype.setYVisibleRange=function(_1af,_1b0){
this.getObject().setYVisibleRange(_1af,_1b0);
};
IlvChartViewProxy.prototype.setErrorMessage=function(_1b1){
this.getObject().errorMessage=_1b1;
};
IlvChartViewProxy.prototype.getErrorMessage=function(){
return this.getObject().errorMessage;
};
IlvChartViewProxy.prototype.setOverview=function(_1b2){
this.overview=_1b2;
};
IlvChartViewProxy.prototype.setLegend=function(_1b3){
this.legend=_1b3;
if(_1b3){
_1b3.setServletURL(this.getServletURL());
_1b3.setServletClass(this.getServletClass());
}
};
IlvChartViewProxy.prototype.getLegend=function(){
return this.legend;
};
IlvChartViewProxy.prototype.getProject=function(){
return this.project;
};
IlvChartViewProxy.prototype.setProject=function(_1b4,_1b5){
this.project=_1b4;
var _1b6=this.getObject();
_1b6.setAdditionalParameters("chartProject",this.project);
this._update(_1b5);
this.notify("Project");
};
IlvChartViewProxy.prototype._update=function(_1b7){
if(this.overview){
this.overview.setForceUpdate(true);
}
if(!this.updateLegend){
this.updateLegend=this.legend&&_1b7;
}
if(_1b7){
var _1b8=this.getObject();
_1b8.updateImage(true);
}
};
IlvChartViewProxy.saveState=function(_1b9){
var _1ba=_1b9.JSFRef;
var _1bb="&xMin="+_1b9.xMin+"&xMax="+_1b9.xMax+"&yMin="+_1b9.yMin+"&yMax="+_1b9.yMax;
_1ba.setStateURL(_1bb);
};
IlvChartViewProxy.restoreState=function(_1bc){
var _1bd=_1bc.JSFRef;
var _1be=_1bd.getStateURL();
if(_1be){
if(_1be=="CURRENT_VISIBLE_WINDOW"){
_1bc.xMin="NaN";
_1bc.yMin="NaN";
_1bc.xMax="NaN";
_1bc.yMax="NaN";
}else{
_1bc.xMin=parseFloat(_1bc.parseValue(_1be,"xMin"));
_1bc.xMax=parseFloat(_1bc.parseValue(_1be,"xMax"));
_1bc.yMin=parseFloat(_1bc.parseValue(_1be,"yMin"));
_1bc.yMax=parseFloat(_1bc.parseValue(_1be,"yMax"));
return true;
}
}
return false;
};
IlvChartViewProxy.prototype.resetRange=function(){
this.getObject().resetRange();
};
IlvChartViewProxy.prototype.performAction=function(_1bf,_1c0,_1c1){
this.getObject().performAction(_1bf,_1c0,_1c1);
};
IlvChartViewProxy.prototype.setOnCapabilitiesLoaded=function(_1c2){
this.getObject().addCapabilitiesLoadListener(_1c2);
};
IlvChartViewProxy.prototype.setOnImageLoaded=function(_1c3){
this.getObject().addImageLoadListener(_1c3);
};
IlvChartViewProxy.prototype.setAdditionalParameters=function(name,_1c5,_1c6){
this.getObject().setAdditionalParameters(name,_1c5);
if(_1c6){
this.getObject().updateImage();
}
};
IlvChartViewProxy.prototype.removeAdditionalParameter=function(name,_1c8){
this.getObject().removeAdditionalParameter(name);
if(_1c8){
this.getObject().updateImage();
}
};
IlvChartViewProxy.prototype.addCapabilitiesLoadListener=function(_1c9){
this.getObject().addCapabilitiesLoadListener(_1c9);
};
IlvChartViewProxy.prototype.removeCapabilitiesLoadListener=function(_1ca){
this.getObject().removeCapabilitiesLoadListener(_1ca);
};
IlvChartViewProxy.prototype.addImagePreloadListener=function(_1cb){
this.getObject().addImagePreloadListener(_1cb);
};
IlvChartViewProxy.prototype.removeImagePreloadListener=function(_1cc){
this.getObject().removeImagePreloadListener(_1cc);
};
IlvChartViewProxy.prototype.addImageLoadListener=function(_1cd){
this.getObject().addImageLoadListener(_1cd);
};
IlvChartViewProxy.prototype.removeImageLoadListener=function(_1ce){
this.getObject().removeImageLoadListener(_1ce);
};
IlvChartViewProxy.prototype.addImageLoadingListener=function(_1cf){
this.getObject().addImageLoadingListener(_1cf);
};
IlvChartViewProxy.prototype.removeImageLoadingListener=function(_1d0){
this.getObject().removeImageLoadingListener(_1d0);
};
IlvChartViewProxy.prototype.updateImage=function(_1d1){
this.getObject().updateImage(_1d1);
};
IlvChartViewProxy.prototype.performJSFAction=function(mb,_1d3,_1d4){
var p=_1d3?[mb].concat(_1d3):[mb];
this.performAction("jsfAction",p,_1d4);
};
IlvChartViewProxy.prototype.setBeforeSessionExpirationHandler=function(_1d6){
var h=function(v){
_1d6(v.JSFRef);
};
this.getObject().setSessionExpirationHandler(h);
};
IlvChartViewProxy.prototype.setNamespace=function(_1d9){
var view=this.getObject();
view.setAdditionalParameters("namespace",_1d9);
};
IlvChartViewProxy.imageLoaded=function(_1db){
_1db.removeAdditionalParameter("chartDataSourceId");
_1db.removeAdditionalParameter("chartStyleSheets");
_1db.removeAdditionalParameter("chartType");
_1db.removeAdditionalParameter("chartProject");
if(_1db.JSFRef.updateLegend){
if(_1db.getLegend()){
_1db.getLegend().updateImage();
}
_1db.JSFRef.updateLegend=false;
}
};
IlvChartOverviewProxy=function(_1dc,_1dd,_1de,_1df){
if(_1dc){
this.superConstructor(_1dc);
var size=this.getCreationSize(_1dd);
var _1e1=new IlvChartOverview(0,0,size.width,size.height);
this.setObject(_1e1);
_1e1.setStateInCookie(false);
this.registerResizeListener(_1e1);
}
};
IlvChartOverviewProxy.prototype=new IlvBasicViewHelperProxy();
IlvChartOverviewProxy.prototype.setClassName("IlvChartOverviewProxy");
IlvChartOverviewProxy.prototype.setLineColor=function(_1e2){
this.getObject().setColor(_1e2);
this.notify("LineColor");
};
IlvChartOverviewProxy.prototype.setLineWidth=function(_1e3){
this.getObject().setLineWidth(_1e3);
this.notify("LineWidth");
};
IlvChartOverviewProxy.prototype.setAutoRefresh=function(_1e4){
this.getObject().setAutoRefresh(_1e4);
this.notify("AutoRefresh");
};
IlvChartOverviewProxy.prototype.setWaitingImage=function(_1e5){
this.getObject().setWaitingImage(_1e5);
this.notify("WaitingImage");
};
IlvChartOverviewProxy.prototype.getWaitingImage=function(){
return this.getObject().getWaitingImage();
};
IlvChartOverviewProxy.prototype.getLineColor=function(){
return this.getObject().getColor();
};
IlvChartOverviewProxy.prototype.getLineWidth=function(){
return this.getObject().getLineWidth();
};
IlvChartOverviewProxy.prototype.getAutoRefresh=function(){
return this.getObject().getAutoRefresh();
};
IlvChartOverviewProxy.prototype.setForceUpdate=function(_1e6){
this.getObject().forceUpdate=_1e6;
};
IlvChartOverviewProxy.prototype.updateImage=function(){
return this.getObject().updateImage();
};
IlvChartOverviewProxy.prototype.setResizable=function(_1e7){
this.getObject().setResizable(_1e7);
this.notify("Resizable");
};
IlvChartOverviewProxy.prototype.isResizable=function(_1e8){
return this.getObject().isResizable();
};
IlvChartLegendProxy=function(_1e9,_1ea,_1eb,_1ec){
if(_1e9){
this.superConstructor(_1e9);
var size=this.getCreationSize(_1ea);
this.setObject(new IlvLegendView(0,0,size.width,size.height,true));
var _1ee=this.getObject();
_1ee.setStateInCookie(false);
this.servletClass="ilog.views.chart.faces.servlet.IlvFacesChartServlet";
this.addRequestParameters();
_1ee.addImageLoadListener(IlvChartLegendProxy.imageLoaded);
this.registerResizeListener(_1ee);
_1ee.setWaitingImage("");
}
};
IlvChartLegendProxy.prototype=new IlvBasicViewProxy();
IlvChartLegendProxy.prototype.setClassName("IlvChartLegendProxy");
IlvLegendView.prototype.init=function(){
this.initialized=true;
};
IlvChartLegendProxy.prototype.setEnableHitmap=function(_1ef,_1f0){
var obj=this.getObject();
obj.enableHitmap(_1ef,_1f0);
};
IlvLegendView.prototype.getWaitingImage=function(){
if(this.waitingImage){
return this.waitingImage;
}
if(this.view){
return this.view.getWaitingImage();
}
};
IlvChartLegendProxy.prototype.setViewInternal=function(view){
this.view=view;
view.setLegend(this);
view.getObject().setLegend(this.getObject());
this.getObject().view=view;
this.getObject().setAdditionalParameters("facesComponentId",view.getClientId());
this.notify("ViewId");
};
IlvChartLegendProxy.prototype.getViewId=function(){
return this.view.getAbsoluteId();
};
IlvChartLegendProxy.prototype.getViewInternal=function(){
return this.view.getAbsoluteId();
};
IlvChartLegendProxy.prototype.setView=function(view){
this.setViewInternal(view);
};
IlvChartLegendProxy.prototype.getView=function(view){
return this.view;
};
IlvChartLegendProxy.prototype.setServletURL=function(_1f5){
this.getObject().setServletURL(_1f5);
this.notify("ServletURL");
};
IlvChartLegendProxy.prototype.getServletURL=function(){
return this.getObject().getServletURL();
};
IlvChartLegendProxy.prototype.getServletClass=function(){
return this.servletClass;
};
IlvChartLegendProxy.prototype.setServletClass=function(_1f6){
this.servletClass=_1f6;
this.getObject().setAdditionalParameters("facesData",this.servletClass);
};
IlvChartLegendProxy.prototype.setLayout=function(_1f7,_1f8){
this.layout=_1f7;
var _1f9=this.getObject();
_1f9.setAdditionalParameters("chartLegendLayout",this.layout);
if(_1f8){
_1f9.updateImage();
}
this.notify("Layout");
};
IlvChartLegendProxy.prototype.getLayout=function(){
return this.layout;
};
IlvChartLegendProxy.prototype.addRequestParameters=function(){
this.getObject().setAdditionalParameters("facesService","forward");
this.getObject().setAdditionalParameters("facesData",this.getServletClass());
};
IlvChartLegendProxy.imageLoaded=function(_1fa){
_1fa.removeAdditionalParameter("chartLegendLayout");
};
IlvChartLegendProxy.prototype.setGenerateImageMap=function(set,_1fc){
var _1fd=this.getObject();
_1fd.setGenerateImageMap(set);
if(_1fc){
_1fd.updateImage();
}
this.notify("GenerateImageMap");
};
IlvChartLegendProxy.prototype.isGenerateImageMap=function(){
return this.getObject().isGenerateImageMap();
};
IlvChartLegendProxy.prototype.setImageMapVisible=function(_1fe){
this.getObject().setImageMapVisible(_1fe);
this.notify("ImageMapVisible");
};
IlvChartLegendProxy.prototype.isImageMapVisible=function(){
return this.getObject().isImageMapVisible();
};
IlvChartLegendProxy.prototype.getImageMapGenerator=function(){
return this.imageMapGenerator;
};
IlvChartLegendProxy.prototype.setImageMapGenerator=function(_1ff){
this.imageMapGenerator=_1ff;
this.notify("ImageMapGenerator");
this.getObject().setAdditionalParameters("imapGenerator",_1ff,false);
};
IlvChartLegendProxy.prototype.setBackgroundColor=function(_200,_201){
var _202=this.getObject();
_202.setImageBackgroundColor(_200);
if(_201){
_202.updateImage(true);
}
this.notify("BackgroundColor");
};
IlvChartLegendProxy.prototype.getBackgroundColor=function(){
return this.getObject().getImageBackgroundColor();
};
IlvChartLegendProxy.prototype.setErrorMessage=function(_203){
this.getObject().errorMessage=_203;
this.notify("ErrorMessage");
};
IlvChartLegendProxy.prototype.getErrorMessage=function(){
return this.getObject().errorMessage;
};
IlvChartLegendProxy.prototype.setOnCapabilitiesLoaded=function(_204){
this.getObject().addCapabilitiesLoadListener(_204);
};
IlvChartLegendProxy.prototype.setOnImageLoaded=function(_205){
this.getObject().addImageLoadListener(_205);
};
IlvChartLegendProxy.prototype.setResizable=function(_206){
this.getObject().setResizable(_206);
this.notify("Resizable");
};
IlvChartLegendProxy.prototype.isResizable=function(_207){
return this.getObject().isResizable();
};
IlvChartPanInteractorProxy=function(_208,_209){
this.superConstructor(_208);
this.setObject(new IlvChartPanInteractor(_209));
};
IlvChartPanInteractorProxy.prototype=new IlvDragRectInteractorProxy();
IlvChartPanInteractorProxy.prototype.setClassName("IlvChartPanInteractorProxy");
IlvChartPanInteractorProxy.prototype.isXPanAllowed=function(){
return this.getObject().isXPanAllowed();
};
IlvChartPanInteractorProxy.prototype.setXPanAllowed=function(_20a){
this.getObject().setXPanAllowed(_20a);
this.notify("XPanAllowed");
};
IlvChartPanInteractorProxy.prototype.isYPanAllowed=function(){
return this.getObject().isYPanAllowed();
};
IlvChartPanInteractorProxy.prototype.setYPanAllowed=function(_20b){
this.getObject().setYPanAllowed(_20b);
this.notify("YPanAllowed");
};
IlvChartPickInteractorProxy=function(_20c,_20d){
this.superConstructor(_20c);
this.setObject(new IlvChartPickInteractor(_20d));
};
IlvChartPickInteractorProxy.prototype=new IlvInteractorProxy();
IlvChartPickInteractorProxy.prototype.setClassName("IlvChartPickInteractorProxy");
IlvChartSelectInteractor=function(){
this.superConstructor();
this.setMessage(jviews.messages.IlvChartSelectInteractor.ClickAObject);
};
IlvChartSelectInteractor.prototype=new IlvInteractor();
IlvChartSelectInteractor.prototype.setClassName("IlvFacesObjectSelectInteractor");
IlvChartSelectInteractor.prototype.setView=function(view){
if(view!=null){
this.JSFRef.setViewId(view.JSFRef.getAbsoluteId());
}
};
IlvChartSelectInteractor.prototype.mouseDown=function(e){
if(e.button!=2&&!this.view.forcePan){
var view=this.view;
var x=e.mouseX;
var y=e.mouseY;
if(view!=null&&!view.isInPlotRect(x,y)){
return;
}
if(y<0||x<0){
return;
}
var _213=this.view.hitmap;
if(_213){
if(_213.hittest(x,y)==0){
return;
}
}
var _214=view.getXVisibleRange();
var _215=view.getYVisibleRange();
var _216=[x,y,_214.min,_214.max,_215.min,_215.max,view.getWidth(),view.getHeight()];
if(this.JSFRef.invocationContext=="IMAGE_SERVLET_CONTEXT"){
_216=_216.concat([this.JSFRef.methodRef,this.JSFRef.mode,this.JSFRef.finder,this.JSFRef.listenersRef]);
this.view.performAction("facesSelectAction",_216,true);
}else{
this.JSFRef.performSelect(_216);
}
}
return false;
};
IlvChartSelectInteractorProxy=function(_217,_218){
if(_217){
this.superConstructor(_217,_218);
var _219=new IlvChartSelectInteractor();
_219.JSFRef=this;
this.setObject(_219);
this.mode="NEAREST_POINT";
}
};
IlvChartSelectInteractorProxy.prototype=new IlvObjectSelectInteractorProxy();
IlvChartSelectInteractorProxy.prototype.setClassName("IlvChartSelectInteractorProxy");
IlvChartSelectInteractorProxy.prototype.getMode=function(){
return this.mode;
};
IlvChartSelectInteractorProxy.prototype.setMode=function(mode){
this.mode=mode;
this.notify("Mode");
};
IlvChartSelectInteractorProxy.prototype.getPickingMode=function(){
return this.mode;
};
IlvChartSelectInteractorProxy.prototype.setPickingMode=function(mode){
this.mode=mode;
this.notify("Mode");
};
IlvChartZoomInteractorProxy=function(_21c,_21d){
this.superConstructor(_21c);
this.setObject(new IlvChartZoomInteractor(_21d));
};
IlvChartZoomInteractorProxy.prototype=new IlvDragRectInteractorProxy();
IlvChartZoomInteractorProxy.prototype.setClassName("IlvChartZoomInteractorProxy");
IlvChartZoomInteractorProxy.prototype.isXZoomAllowed=function(){
return this.getObject().isXZoomAllowed();
};
IlvChartZoomInteractorProxy.prototype.setXZoomAllowed=function(_21e){
this.getObject().setXZoomAllowed(_21e);
this.notify("XZoomAllowed");
};
IlvChartZoomInteractorProxy.prototype.isYZoomAllowed=function(){
return this.getObject().isYZoomAllowed();
};
IlvChartZoomInteractorProxy.prototype.setYZoomAllowed=function(_21f){
this.getObject().setYZoomAllowed(_21f);
this.notify("YZoomAllowed");
};
}
