/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

AbstractProjector.prototype._reversed;
AbstractProjector.prototype._xCoeff;
AbstractProjector.prototype._yCoeff;
function AbstractProjector(){
}
AbstractProjector.prototype.isReversed=function(){
return this._reversed;
};
AbstractProjector.prototype.setReversed=function(_1){
this._reversed=_1;
};
AbstractProjector.prototype.toDisplay=function(_2,_3,_4){
var _5=_4.getXAxis();
var _6=_4.getYAxis();
var _7=this._xCoeff;
var _8=this._yCoeff;
if(_7==null||_8==null){
_7=new Coefficient();
_8=new Coefficient();
this.computeCoefficients(_3,_4,_7,_8);
}
this.project(_2,_3,_7,_8);
};
AbstractProjector.prototype.toData=function(_9,_a,_b){
var _c=_b.getXAxis();
var _d=_b.getYAxis();
var _e=new Coefficient();
var _f=new Coefficient();
var _10=new DataPos();
this.computeMinMaxPos(_a,_c,_10);
if(_c.isReversed()){
_10.reverse();
}
this.computeInvCoeff(_a,_c,_10,_e);
this.computeMinMaxPos(_a,_d,_10);
if(_d.isReversed()){
_10.reverse();
}
this.computeInvCoeff(_a,_d,_10,_f);
this.project(_9,_a,_e,_f);
};
AbstractProjector.prototype.getOrigin=function(_11,_12){
};
AbstractProjector.prototype.shiftAlongAxis=function(_13,_14,_15,_16){
};
AbstractProjector.prototype.getAxisLength=function(_17,_18){
return 0;
};
AbstractProjector.prototype.computeMinMaxPos=function(_19,_1a,pos){
};
AbstractProjector.prototype.computeCoeff=function(_1c,_1d,pos,_1f){
};
AbstractProjector.prototype.computeInvCoeff=function(_20,_21,pos,_23){
};
AbstractProjector.prototype.project=function(pts,_25,_26,_27){
var _28=_26.scaling;
var _29=_26.constant;
var _2a=_27.scaling;
var _2b=_27.constant;
for(var i=pts.size();--i>=0;){
pts.xValues[i]=pts.xValues[i]*_28+_29;
pts.yValues[i]=pts.yValues[i]*_2a+_2b;
}
};
AbstractProjector.prototype.toDataWindow=function(_2d,_2e,_2f){
var _30=new IlvDataWindow();
var pts=new DoublePoints(2);
pts.addValues(_2d.x,_2d.y);
pts.addValues(_2d.x+_2d.width,_2d.y+_2d.height);
this.toData(pts,_2e,_2f);
if(pts.getX(0)<pts.getX(1)){
_30.xRange.set(pts.getX(0),pts.getX(1));
}else{
_30.xRange.set(pts.getX(1),pts.getX(0));
}
if(pts.getY(0)<pts.getY(1)){
_30.yRange.set(pts.getY(0),pts.getY(1));
}else{
_30.yRange.set(pts.getY(1),pts.getY(0));
}
return _30;
};
AbstractProjector.prototype.toRectangle=function(_32,_33,_34){
var _35=new Rectangle();
var pts=new DoublePoints(2);
pts.addValues(_32.getXMin(),_32.getYMin());
pts.addValues(_32.getXMax(),_32.getYMax());
this.toDisplay(pts,_33,_34);
if(pts.getX(0)>pts.getX(1)){
_35.x=Math.floor(pts.getX(1));
_35.width=Math.floor(pts.getX(0))-_35.x;
}else{
_35.x=Math.floor(pts.getX(0));
_35.width=Math.floor(pts.getX(1))-_35.x;
}
if(pts.getY(0)>pts.getY(1)){
_35.y=Math.floor(pts.getY(1));
_35.height=Math.floor(pts.getY(0))-_35.y;
}else{
_35.y=Math.floor(pts.getY(0));
_35.height=Math.floor(pts.getY(1))-_35.y;
}
return _35;
};
AbstractProjector.prototype.getProjectorRect=function(_37,_38,_39,_3a){
return _37;
};
AbstractProjector.prototype.getShapeFromValue=function(_3b,_3c,_3d,_3e){
var _3f=null;
if(_3c==Axis.X_AXIS){
_3f=_3e.getYAxis().getVisibleRange();
}else{
_3f=_3e.getXAxis().getVisibleRange();
}
return this.getShapeFromValueImpl(_3b,_3f,_3c,_3d,_3e);
};
AbstractProjector.prototype.getLocalProjector=function(_40,_41){
var prj=this.clone();
prj.prepareCoefficients(_40,_41);
return prj;
};
AbstractProjector.prototype.prepareCoefficients=function(_43,_44){
this._xCoeff=new Coefficient();
this._yCoeff=new Coefficient();
this.computeCoefficients(_43,_44,this._xCoeff,this._yCoeff);
};
AbstractProjector.prototype.computeCoefficients=function(_45,_46,_47,_48){
var _49=new DataPos();
this.computeMinMaxPos(_45,_46.getXAxis(),_49);
if(_46.getXAxis().isReversed()){
_49.reverse();
}
this.computeCoeff(_45,_46.getXAxis(),_49,_47);
this.computeMinMaxPos(_45,_46.getYAxis(),_49);
if(_46.getYAxis().isReversed()){
_49.reverse();
}
this.computeCoeff(_45,_46.getYAxis(),_49,_48);
};
