/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Axis.MAX_FILTER=5;
Axis.MIN_PRECISION=1e-14;
function MaxCrossing(){
}
MaxCrossing.prototype.getValue=function(_1){
return _1.getVisibleMax();
};
function MinCrossing(){
}
MinCrossing.prototype.getValue=function(_2){
return _2.getVisibleMin();
};
function AnchoredCrossing(_3){
this.value=_3;
}
AnchoredCrossing.prototype.getValue=function(_4){
return this.value;
};
Axis.MAX_VALUE=new MaxCrossing();
Axis.MIN_VALUE=new MinCrossing();
Axis.X_AXIS=1;
Axis.Y_AXIS=2;
Axis.AUTO_DATA_MAX=1;
Axis.AUTO_DATA_MIN=2;
Axis.AUTO_DATA_RANGE=Axis.AUTO_DATA_MAX|Axis.AUTO_DATA_MIN;
Axis.AUTO_VISIBLE_RANGE=4;
Axis.ADJUSTING_FLAG=32;
Axis.REVERSED_FLAG=64;
Axis.DEFAULT_FLAG=Axis.AUTO_DATA_RANGE|Axis.AUTO_VISIBLE_RANGE;
EventDispatcher.initialize(Axis.prototype);
function Axis(_5){
this._type=_5;
this._flags=new Flags(Axis.DEFAULT_FLAG);
this._visibleRange=new IlvDataInterval();
this._dataRange=new IlvDataInterval(-Number.MAX_VALUE,Number.MAX_VALUE);
}
Axis.prototype.setChart=function(_6){
this._mainChart=_6;
};
Axis.prototype.isXAxis=function(){
return this._type==Axis.X_AXIS;
};
Axis.prototype.isYAxis=function(){
return this._type==Axis.Y_AXIS;
};
Axis.prototype.getType=function(){
return this._type;
};
Axis.prototype.setType=function(_7){
this._type=_7;
};
Axis.prototype.setReversed=function(_8){
if(_8!=isReversed()){
this._flags.setFlag(Axis.REVERSED_FLAG,_8);
this.fireChangeEvent(AxisChangedEvent.ORIENTATION_CHANGE);
}
};
Axis.prototype.isReversed=function(){
return this._flags.getFlag(Axis.REVERSED_FLAG);
};
Axis.prototype.getDataRange=function(){
return new IlvDataInterval(this._dataRange.getMin(),this._dataRange.getMax());
};
Axis.prototype.getDataMin=function(){
return this._dataRange.getMin();
};
Axis.prototype.getDataMax=function(){
return this._dataRange.getMax();
};
Axis.prototype.isBounded=function(){
return this._dataRange.getMin()!=-Number.MAX_VALUE&&this._dataRange.getMax()!=Number.MAX_VALUE;
};
Axis.prototype.getVisibleRange=function(){
return new IlvDataInterval(this._visibleRange.getMin(),this._visibleRange.getMax());
};
Axis.prototype.getVisibleMin=function(){
return this._visibleRange.getMin();
};
Axis.prototype.getVisibleMax=function(){
return this._visibleRange.getMax();
};
Axis.prototype.getTVisibleRange=function(){
var _9=this.getVisibleRange();
return _9;
};
Axis.prototype.updateVisibleRange=function(){
if(!this.isBounded()||!this._flags.getFlag(Axis.AUTO_VISIBLE_RANGE)){
return false;
}
return this._setVisibleRange(this._dataRange.getMin(),this._dataRange.getMax(),true);
};
Axis.prototype.updateDataRange=function(_a){
var _b=this.isAutoDataMin()?_a.getMin():this.getDataMin();
var _c=this.isAutoDataMax()?_a.getMax():this.getDataMax();
return this._setDataRange(_b,_c);
};
Axis.prototype.setAutoVisibleRange=function(_d){
if(_d==this.isAutoVisibleRange()){
return;
}
this._flags.setFlag(Axis.AUTO_VISIBLE_RANGE,_d);
if(_d){
this.updateVisibleRange();
}
};
Axis.prototype.isAutoVisibleRange=function(){
return this._flags.getFlag(Axis.AUTO_VISIBLE_RANGE);
};
Axis.prototype.setVisibleRange=function(_e,_f){
if(_e==this.getVisibleMin()&&_f==this.getVisibleMax()){
return;
}
this._flags.setFlag(Axis.AUTO_VISIBLE_RANGE,false);
this._setVisibleRange(_e,_f,true);
};
Axis.prototype.setVisibleMin=function(min){
this.setVisibleRange(min,this.getVisibleMax());
};
Axis.prototype.setVisibleMax=function(max){
this.setVisibleRange(this.getVisibleMin(),max);
};
Axis.prototype.translateVisibleRange=function(_12){
_12=this.trimTranslation(_12);
if(_12!=0){
this.setVisibleRange(this.getVisibleMin()+_12,this.getVisibleMax()+_12);
}
};
Axis.prototype.isAutoDataRange=function(){
return this.isAutoDataMin()||this.isAutoDataMax();
};
Axis.prototype.setAutoDataRange=function(_13){
if(_13==(this.isAutoDataMax()&&this.isAutoDataMin())){
return;
}
this._flags.setFlag(Axis.AUTO_DATA_MIN,_13);
this._flags.setFlag(Axis.AUTO_DATA_MAX,_13);
if(_13&&this._mainChart!=null){
this._mainChart.updateDataRange(this);
}
};
Axis.prototype.setAutoDataMax=function(_14){
if(_14==this.isAutoDataMax()){
return;
}
this._flags.setFlag(Axis.AUTO_DATA_MAX,_14);
if(_14&&this._mainChart!=null){
this._mainChart.updateDataRange(this);
}
};
Axis.prototype.isAutoDataMax=function(){
return this._flags.getFlag(Axis.AUTO_DATA_MAX);
};
Axis.prototype.setAutoDataMin=function(_15){
if(_15==this.isAutoDataMin()){
return;
}
this._flags.setFlag(Axis.AUTO_DATA_MIN,_15);
if(_15&&this._mainChart!=null){
this._mainChart.updateDataRange(this);
}
};
Axis.prototype.isAutoDataMin=function(){
return this._flags.getFlag(Axis.AUTO_DATA_MIN);
};
Axis.prototype.setDataRange=function(min,max){
this._flags.setFlag(Axis.AUTO_DATA_MIN,false);
this._flags.setFlag(Axis.AUTO_DATA_MAX,false);
this._setDataRange(min,max);
};
Axis.prototype.setDataMin=function(min){
this._flags.setFlag(Axis.AUTO_DATA_MIN,false);
this._setDataRange(min,this.getDataMax());
};
Axis.prototype.setDataMax=function(max){
this._flags.setFlag(Axis.AUTO_DATA_MAX,false);
this._setDataRange(this.getDataMin(),max);
};
Axis.prototype._setDataRange=function(min,max){
var _1c=new IlvDataInterval(min,max);
if(this._dataRange.equals(_1c)){
return false;
}
this.fireRangeChanged(_1c,true,false);
var _1d=this._dataRange;
this._dataRange=_1c;
this.fireRangeChanged(_1d,false,false);
return this.updateVisibleRange()||this.revalidateRange();
};
Axis.prototype._setVisibleRange=function(min,max,_20){
if(_20&&min==this.getVisibleMin()&&max==this.getVisibleMax()){
return false;
}
var _21=new IlvDataInterval(min,max);
this.validateRange(_21);
if(!this.checkRangeValidity(_21)||_21.equals(this._visibleRange)){
return false;
}
this.fireRangeChanged(_21,true,true);
this.validateRange(_21);
var _22=this._visibleRange;
this._visibleRange=_21;
this.fireRangeChanged(_22,false,true);
return true;
};
Axis.prototype.checkRangeValidity=function(_23){
return !_23.isEmpty()&&(Math.abs(_23.getLength()/_23.getMin())>Axis.MIN_PRECISION);
};
Axis.prototype.revalidateRange=function(){
return this._setVisibleRange(this.getVisibleMin(),this.getVisibleMax(),false);
};
Axis.prototype.validateRange=function(_24){
var _25=false;
var _26=0;
do{
_25=this.trimToDataRange(_24)||_25;
}while((_26++<Axis.MAX_FILTER)&&_25);
};
Axis.prototype.trimToDataRange=function(_27){
if(this._dataRange.contains(_27)){
return false;
}
_27.intersection(this._dataRange);
if(_27.isEmpty()){
if(_27.getMin()>this.getDataMax()){
_27.set(this.getDataMax(),this.getDataMax());
}else{
_27.set(this.getDataMin(),this.getDataMin());
}
}
return true;
};
Axis.prototype.isAdjusting=function(){
return this._flags.getFlag(Axis.ADJUSTING_FLAG);
};
Axis.prototype.setAdjusting=function(_28){
if(_28!=this.isAdjusting()){
this._flags.setFlag(Axis.ADJUSTING_FLAG,_28);
this.fireChangeEvent(AxisChangedEvent.ADJUSTMENT_CHANGE);
}
};
Axis.prototype.transformerChanged=function(){
this.fireChangeEvent(AxisChangedEvent.TRANSFORMER_CHANGE);
this.revalidateRange();
};
Axis.prototype.fireChangeEvent=function(_29){
this.dispatchEvent(new AxisChangedEvent(this,_29,this.isAdjusting()));
};
Axis.prototype.fireRangeChanged=function(_2a,_2b,_2c){
this.dispatchEvent(new AxisRangeEvent(this,_2a,_2b,this.isAdjusting(),_2c));
};
Axis.prototype.trimTranslation=function(_2d){
if(_2d>0&&(this.getDataMax()>=this.getVisibleMax())){
return Math.min(this.getDataMax()-this.getVisibleMax(),_2d);
}else{
if(_2d<0&&(this.getDataMin()<=this.getVisibleMin())){
return Math.max(this.getDataMin()-this.getVisibleMin(),_2d);
}else{
return 0;
}
}
};
Axis.prototype.toString=function(){
return "Axis "+(this.isXAxis()?" X":" Y")+" Visi "+this._visibleRange+" Data "+this._dataRange;
};
Axis.prototype.resetDefaults=function(){
this.setReversed(false);
this.setAutoVisibleRange(true);
this.setAutoDataRange(true);
};
