/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

CartesianProjector.filterOn=false;
CartesianProjector.prototype._clusterSize=1;
function CartesianProjector(){
}
CartesianProjector.prototype=new AbstractProjector();
CartesianProjector.prototype.getClusterSize=function(){
return this._clusterSize;
};
CartesianProjector.prototype.setClusterSize=function(_1){
this._clusterSize=_1;
};
CartesianProjector.prototype.computeMinMaxPos=function(_2,_3,_4){
if(this.onXImpl(_3)){
_4.min=_2.x;
_4.max=_2.x+_2.width-1;
}else{
_4.min=_2.y+_2.height-1;
_4.max=_2.y;
}
};
CartesianProjector.prototype.computeCoeff=function(_5,_6,_7,_8){
var _9=_6.getTVisibleRange();
var _a=_9.getLength();
if(MathUtil.isNear0(_a)){
_8.scaling=0;
_8.constant=_7.min;
}else{
_8.scaling=(_7.max-_7.min)/_a;
_8.constant=-_9.getMin()*_8.scaling+_7.min;
}
};
CartesianProjector.prototype.computeInvCoeff=function(_b,_c,_d,_e){
var _f=_c.getTVisibleRange();
var len=_d.max-_d.min;
if(MathUtil.isNear0(len)){
_e.scaling=0;
_e.constant=_f.getMin();
}else{
_e.scaling=_f.getLength()/len;
_e.constant=_f.getMin()-_d.min*_e.scaling;
}
};
CartesianProjector.prototype.toDisplay=function(pts,_12,_13){
AbstractProjector.prototype.toDisplay.call(this,pts,_12,_13);
if(this.isReversed()){
var tmp=pts.getXValues();
pts.xValues=pts.getYValues();
pts.yValues=tmp;
}
};
CartesianProjector.prototype.toData=function(pts,_16,_17){
if(this.isReversed()){
var tmp=pts.getXValues();
pts.xValues=pts.getYValues();
pts.yValues=tmp;
}
AbstractProjector.prototype.toData.call(this,pts,_16,_17);
};
CartesianProjector.prototype.toRectangle=function(_19,_1a,_1b){
if(_19.xRange.equals(_1b.getXAxis().getVisibleRange())&&_19.yRange.equals(_1b.getYAxis().getVisibleRange())){
return new Rectangle(_1a.x,_1a.y,_1a.width,_1a.height);
}else{
return AbstractProjector.prototype.toRectangle.call(this,_19,_1a,_1b);
}
};
CartesianProjector.prototype.project=function(pts,_1d,_1e,_1f){
var _20=pts.size();
if(CartesianProjector.filterOn&&_20>1000&&this._clusterSize>0){
var _21=_1e.scaling;
var _22=_1e.constant;
var _23=_1f.scaling;
var _24=_1f.constant;
var _25=Math.abs(this._clusterSize/_21);
var _26=Math.abs(this._clusterSize/_23);
var _27=pts.getXValues();
var _28=pts.getYValues();
var _29=(pts instanceof DataPoints)?pts.getIndices():null;
var _2a=_27[0]+_25;
var _2b=_28[0]-_26;
var _2c=_28[0]+_26;
_27[0]=_27[0]*_21+_22;
_28[0]=_28[0]*_23+_24;
var _2d;
var _2e;
var j=1;
for(var i=1;i<_20;i++){
_2d=_27[i];
_2e=_28[i];
if(_2d>_2a||_2e>_2c||_2e<_2b){
_27[j]=_2d*_21+_22;
_28[j]=_2e*_23+_24;
if(_29!=null){
_29[j]=_29[i];
}
_2a=_2d+_25;
_2b=_2e-_26;
_2c=_2e+_26;
++j;
}
}
pts.count=j;
}else{
AbstractProjector.prototype.project.call(this,pts,_1d,_1e,_1f);
}
};
CartesianProjector.prototype.getShape=function(_31,_32,_33){
return this.toRectangle(_31,_32,_33);
};
CartesianProjector.prototype.getShapeFromValueImpl=function(_34,_35,_36,_37,_38){
var pts=new DoublePoints(2);
if(_36==Axis.X_AXIS){
pts.addValues(_34,_35.getMin());
pts.addValues(_34,_35.getMax());
this.toDisplay(pts,_37,_38);
}else{
pts.addValues(_35.getMin(),_34);
pts.addValues(_35.getMax(),_34);
this.toDisplay(pts,_37,_38);
}
return new Line(pts.getX(0),pts.getY(0),pts.getX(1),pts.getY(1));
};
CartesianProjector.prototype.getOrigin=function(_3a,_3b){
_3b.x=_3a.x;
_3b.y=_3a.y;
};
CartesianProjector.prototype.shiftAlongAxis=function(_3c,_3d,p,_3f){
if(_3d.isReversed()){
_3f=-_3f;
}
if(this.onXImpl(_3d)){
p.x+=_3f;
}else{
p.y-=_3f;
}
};
CartesianProjector.prototype.getAxisLength=function(_40,_41){
if(this.onXImpl(_41)){
return _40.width;
}else{
return _40.height;
}
};
CartesianProjector.prototype.getAxisAngle=function(_42){
if(this.onXImpl(_42)){
return _42.isReversed()?180:0;
}else{
return _42.isReversed()?270:90;
}
};
CartesianProjector.prototype.computeVisibleRange=function(_43,_44,_45){
if(_43.isEmpty()||_44.isEmpty()){
return null;
}
var onX=this.onXImpl(_45);
if(onX){
if(_43.width==_44.width){
return null;
}
}else{
if(_43.height==_44.height){
return null;
}
}
var itv=_45.getTVisibleRange();
var _48=new DataPos();
this.computeMinMaxPos(_43,_45,_48);
var len=_48.max-_48.min;
this.computeMinMaxPos(_44,_45,_48);
var _4a=((_48.max-_48.min)-len)*itv.getLength()/len;
var _4b=(onX&&!_45.isReversed())||(!onX&&_45.isReversed());
if(_4b){
itv.setMax(itv.getMax()+_4a);
}else{
itv.setMin(itv.getMin()-_4a);
}
if(_45.isBounded()){
if(_4b){
var _4c=_45.getDataMax()-itv.getMax();
if(_4c<0){
itv.setMin(itv.getMin()+_4c);
}
}else{
var _4c=_45.getDataMin()-itv.getMin();
if(_4c>0){
itv.setMax(itv.getMax()+_4c);
}
}
}
return itv;
};
CartesianProjector.prototype.onXImpl=function(_4d){
return _4d.isXAxis()?!this.isReversed():this.isReversed();
};
CartesianProjector.prototype.clone=function(){
var _4e=new CartesianProjector();
_4e._clusterSize=this._clusterSize;
_4e._reversed=this._reversed;
_4e._xCoeff=this._xCoeff;
_4e._yCoeff=this._yCoeff;
return _4e;
};
