/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartAreaLayout.FIXED_LEFT_MARGIN=1;
ChartAreaLayout.FIXED_RIGHT_MARGIN=2;
ChartAreaLayout.FIXED_TOP_MARGIN=4;
ChartAreaLayout.FIXED_BOTTOM_MARGIN=8;
ChartAreaLayout.FIXED_H_MARGINS=ChartAreaLayout.FIXED_LEFT_MARGIN|ChartAreaLayout.FIXED_RIGHT_MARGIN;
ChartAreaLayout.FIXED_V_MARGINS=ChartAreaLayout.FIXED_TOP_MARGIN|ChartAreaLayout.FIXED_BOTTOM_MARGIN;
ChartAreaLayout.FIXED_MARGINS=ChartAreaLayout.FIXED_H_MARGINS|ChartAreaLayout.FIXED_V_MARGINS;
ChartAreaLayout.prototype._plotMargins;
ChartAreaLayout.prototype._chart;
ChartAreaLayout.prototype._flags;
ChartAreaLayout.prototype._fixedMargins=0;
ChartAreaLayout.prototype._tmpPlotRect=null;
ChartAreaLayout.prototype._plotRect=null;
function ChartAreaLayout(_1){
this._plotRect=new Rectangle(0,0,0,0);
this._chart=_1;
this._flags=new Flags();
this._plotMargins=new Insets(0,0,0,0);
}
ChartAreaLayout.prototype.getPlotRect=function(){
return (this._tmpPlotRect!=null)?this._tmpPlotRect:this._plotRect;
};
ChartAreaLayout.prototype._setPlotRect=function(_2){
if(_2.equals(this._plotRect)){
return;
}
var _3=new Rectangle(this._plotRect.x,this._plotRect.y,this._plotRect.width,this._plotRect.height);
this._plotRect.x=_2.x;
this._plotRect.y=_2.y;
this._plotRect.width=_2.width;
this._plotRect.height=_2.height;
this._chart.updateScales(_2);
};
ChartAreaLayout.prototype.setMargins=function(_4){
if(_4){
var _5=!_4.equals(this._plotMargins);
this._plotMargins=new Insets(_4.top,_4.left,_4.bottom,_4.right);
this.setFixedMargins(ChartAreaLayout.FIXED_MARGINS,_5);
}else{
this.setFixedMargins(0,false);
}
};
ChartAreaLayout.prototype.setFixedMargins=function(_6,_7){
if(_6!=this._fixedMargins){
this._fixedMargins=_6;
_7=true;
}
if(_7){
this._chart.drawArea();
}
};
ChartAreaLayout.prototype.getFixedMargins=function(){
return this._fixedMargins;
};
ChartAreaLayout.prototype.getMargins=function(){
return this._plotMargins;
};
ChartAreaLayout.prototype.layout=function(){
if(this.getFixedMargins()==ChartAreaLayout.FIXED_MARGINS){
this.performMarginsLayout();
}else{
this.performAutoLayout();
}
};
ChartAreaLayout.prototype.performMarginsLayout=function(){
var _8=this._chart.getDrawRect();
var _9=this._chart._scaleArray.length;
for(var i=0;i<_9;i++){
var _b=this._chart._scaleArray[i];
if(_b&&_b.isViewable()){
_b.getSteps().invalidateValues();
_b.recalc();
}
}
_8=new Rectangle(_8.x,_8.y,_8.width,_8.height);
_8.x+=this._plotMargins.left;
_8.y+=this._plotMargins.top;
_8.width-=this._plotMargins.left+this._plotMargins.right;
_8.height-=this._plotMargins.top+this._plotMargins.bottom;
this._setPlotRect(_8);
};
ChartAreaLayout.prototype.getScalesBounds=function(_c){
var _d=this._chart._scaleArray.length;
if(_d==0){
return null;
}
var _e=new Rectangle();
var _f=null;
for(var i=0;i<_d;i++){
var _11=this._chart._scaleArray[i];
if(_11&&_11.isViewable()){
_f=_11.getBounds(_f,_c);
GraphicUtil.addToRect(_e,_f);
}
}
return _e;
};
ChartAreaLayout.prototype.getPreferredMargins=function(){
var _12=new Insets(0,0,0,0);
var _13=this._chart.getDrawRect();
var _14=this.getScalesBounds(_13);
if(!_14||_14.isEmpty()){
_12.left=_13.x-_14.x;
_12.right=(_14.x+_14.width)-_13.width-_13.x;
_12.top=_13.y-_14.y;
_12.bottom=(_14.y+_14.height)-_13.height-_13.y;
}
return _12;
};
ChartAreaLayout.prototype.performAutoLayout=function(){
var _15=this._chart.getDrawRect();
var _16=new Rectangle(_15.x,_15.y,_15.width,_15.height);
this._tmpPlotRect=_15;
var _17=this.getScalesBounds(_15);
var _18=this.computeMargins(_17,_15,true,null);
if(this._chart.getType()!=IlvChart.CARTESIAN){
var _19=0;
_19=Math.max(_19,_18.right);
_19=Math.max(_19,_18.bottom);
_19=Math.max(_19,_18.left);
_19=Math.max(_19,_18.top);
_16.grow(-_19,-_19);
}else{
this.applyMargins(_16,_18);
this._tmpPlotRect=_16;
_17=this.getScalesBounds(_16);
_18=this.computeMargins(_17,_15,true,null);
if(!this.layoutComplete(_18)){
this.applyAutoMargins(_16,_18);
}
}
this._tmpPlotRect=null;
this._setPlotRect(_16);
this._plotMargins=ChartAreaLayout.computeInsets(_15,_16,this._plotMargins);
};
ChartAreaLayout.prototype.computeMargins=function(_1a,_1b,_1c,_1d){
if(_1d==null){
_1d=new Insets(0,0,0,0);
}
var _1e=(_1a==null)||_1a.isEmpty();
if(_1c&&this.isFixedLeft()){
_1d.left=_plotMargins.left;
}else{
_1d.left=_1e?0:_1b.x-_1a.x;
}
if(_1c&&this.isFixedRight()){
_1d.right=_plotMargins.right;
}else{
_1d.right=_1e?0:(_1a.x+_1a.width-_1b.width-_1b.x);
}
if(_1c&&this.isFixedTop()){
_1d.top=_plotMargins.top;
}else{
_1d.top=_1e?0:_1b.y-_1a.y;
}
if(_1c&&this.isFixedBottom()){
_1d.bottom=_plotMargins.bottom;
}else{
_1d.bottom=_1e?0:_1a.y+_1a.height-_1b.height-_1b.y;
}
return _1d;
};
ChartAreaLayout.prototype.layoutComplete=function(_1f){
return (this.isFixedLeft()||_1f.left==0)&&(this.isFixedRight()||_1f.right==0)&&(this.isFixedBottom()||_1f.bottom==0)&&(this.isFixedTop()||_1f.top==0);
};
ChartAreaLayout.prototype.applyMargins=function(_20,_21){
_21.top+=3;
_21.left+=3;
_21.bottom+=3;
_21.right+=3;
if(this.isFixedRight()||_21.right>0){
_20.width-=_21.right;
}
if(this.isFixedLeft()||_21.left>0){
_20.x+=_21.left;
_20.width-=_21.left;
}
if(this.isFixedTop()||_21.top>0){
_20.y+=_21.top;
_20.height-=_21.top;
}
if(this.isFixedBottom()||_21.bottom>0){
_20.height-=_21.bottom;
}
};
ChartAreaLayout.prototype.applyAutoMargins=function(_22,_23){
if(!this.isFixedRight()&&_23.right>0){
_22.width-=_23.right;
}
if(!this.isFixedLeft()&&_23.left>0){
_22.x+=_23.left;
_22.width-=_23.left;
}
if(!this.isFixedTop()&&_23.top>0){
_22.y+=_23.top;
_22.height-=_23.top;
}
if(!this.isFixedBottom()&&_23.bottom>0){
_22.height-=_23.bottom;
}
};
ChartAreaLayout.prototype.isFixedTop=function(){
return (this._fixedMargins&ChartAreaLayout.FIXED_TOP_MARGIN)!=0;
};
ChartAreaLayout.prototype.isFixedBottom=function(){
return (this._fixedMargins&ChartAreaLayout.FIXED_BOTTOM_MARGIN)!=0;
};
ChartAreaLayout.prototype.isFixedLeft=function(){
return (this._fixedMargins&ChartAreaLayout.FIXED_LEFT_MARGIN)!=0;
};
ChartAreaLayout.prototype.isFixedRight=function(){
return (this._fixedMargins&ChartAreaLayout.FIXED_RIGHT_MARGIN)!=0;
};
ChartAreaLayout.computeInsets=function(_24,_25,_26){
var r=_26;
if(!r){
r=new Insets(0,0,0,0);
}
r.left=_25.x-_24.x;
r.top=_25.y-_24.y;
r.right=_24.width+_24.x-_25.width-_25.x;
r.bottom=_24.height+_24.y-_25.height-_25.y;
return r;
};
ChartAreaLayout.addInsets=function(r,_29){
r.x-=_29.left;
r.y-=_29.top;
r.width+=_29.left+_29.right;
r.height+=_29.top+_29.bottom;
return r;
};
