/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartInteractor.CTRL_MOD=1;
ChartInteractor.SHIFT_MOD=2;
ChartInteractor.ALT_MOD=4;
ChartInteractor.META_MOD=8;
ChartInteractor.prototype._chart;
ChartInteractor.prototype._aborted=false;
ChartInteractor.prototype._inOperation=false;
ChartInteractor.prototype._yAxisIndex;
ChartInteractor.prototype._button;
ChartInteractor.prototype._ghostColor="black";
ChartInteractor.prototype._allowDrawGhost=false;
ChartInteractor.prototype._xorGhost=false;
function ChartInteractor(_1,_2,_3){
if(_3==undefined){
_3=1;
}
this._yAxisIndex=_3;
this._button=_1;
this._modifier=_2;
}
ChartInteractor.prototype.getXAxis=function(){
return this._chart.getXAxis();
};
ChartInteractor.prototype.getYAxis=function(){
return this._chart.getAxis(this._yAxisIndex);
};
ChartInteractor.prototype.getCoordinateSystem=function(){
return this._chart.getCoordinateSystem(this._yAxisIndex);
};
ChartInteractor.prototype.getChart=function(){
return this._chart;
};
ChartInteractor.prototype.setChart=function(_4){
var _5=this._chart;
if(_4!=_5){
this._chart=_4;
this.chartConnected(_5,_4);
}
};
ChartInteractor.prototype.chartConnected=function(){
};
ChartInteractor.prototype.interactionStarted=function(){
};
ChartInteractor.prototype.isAborted=function(){
return this._aborted;
};
ChartInteractor.prototype.setAborted=function(_6){
this._aborted=_6;
};
ChartInteractor.prototype.isInOperation=function(){
return this._inOperation;
};
ChartInteractor.prototype.setInOperation=function(_7){
this._inOperation=_7;
};
ChartInteractor.prototype.getYAxisIndex=function(){
return this._yAxisIndex;
};
ChartInteractor.prototype.getButton=function(){
return this._button;
};
ChartInteractor.prototype.getModifier=function(){
return this._modifier;
};
ChartInteractor.prototype.isAllowDrawGhost=function(){
return this._allowDrawGhost;
};
ChartInteractor.prototype.setAllowDrawGhost=function(_8){
this._allowDrawGhost=_8;
};
ChartInteractor.prototype.isHandling=function(x,y){
return this.getChart().getProjector().getShape(this.getCoordinateSystem().getVisibleWindow(),this.getChart().getPlotRect(),this.getCoordinateSystem()).contains(x,y);
};
ChartInteractor.prototype.getData=function(x,y){
var _d=new DoublePoints(1);
_d.addValues(x,y);
this.getChart().toData(_d,this.getYAxisIndex());
return new DoublePoint(_d.getX(0),_d.getY(0));
};
ChartInteractor.prototype.drawGhost=function(){
if((this.getChart()==null)||!this._allowDrawGhost){
return;
}
this.drawGhostImpl(this.getChart().getArea());
};
ChartInteractor.prototype.startOperation=function(_e){
this.setAborted(false);
this._inOperation=true;
this.getChart().interactionStarted(this,_e);
};
ChartInteractor.prototype.endOperation=function(_f){
this.setAborted(false);
this._inOperation=false;
};
ChartInteractor.prototype.abort=function(){
this.setAborted(true);
this._inOperation=false;
};
ChartInteractor.prototype.setCursor=function(_10){
var old=null;
if(_10!=null){
old=this.getChart().pushCursor(_10);
}else{
old=this.getChart().popCursor();
}
return old;
};
ChartInteractor.prototype.isModifierOn=function(evt){
return ChartInteractor.isModifierOn(this._modifier,evt);
};
ChartInteractor.isModifierOn=function(_13,evt){
if((_13&ChartInteractor.CTRL_MOD)!=0&&!evt.ctrlKey){
return false;
}
if((_13&ChartInteractor.SHIFT_MOD)!=0&&!evt.shiftKey){
return false;
}
if((_13&ChartInteractor.ALT_MOD)!=0&&!evt.altKey){
return false;
}
if((_13&ChartInteractor.META_MOD)!=0&&!evt.metaKey){
return false;
}
return true;
};
