/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartRenderer.VISIBLE_FLAG=1;
ChartRenderer.VIEWABLE_FLAG=2;
ChartRenderer.IN_LEGEND_FLAG=4;
ChartRenderer.DEFAULT_FLAGS=ChartRenderer.VISIBLE_FLAG|ChartRenderer.IN_LEGEND_FLAG;
ChartRenderer.prototype._chart;
ChartRenderer.prototype._parent;
ChartRenderer.prototype._xShift=0;
ChartRenderer.prototype._flags;
ChartRenderer.prototype._dataSource;
ChartRenderer.prototype._axis;
ChartRenderer.BAR=0;
ChartRenderer.STACKED_BAR=1;
ChartRenderer.SUPERIMPOSED_BAR=2;
ChartRenderer.AREA=3;
ChartRenderer.STACKED_AREA=4;
ChartRenderer.POLYLINE=5;
ChartRenderer.SCATTER=6;
ChartRenderer.STAIR=7;
ChartRenderer.BUBBLE=8;
ChartRenderer.HILO=9;
ChartRenderer.PIE=10;
ChartRenderer.STACKED_POLYLINE=11;
ChartRenderer.CANDLE=12;
ChartRenderer.HLOC=13;
ChartRenderer.STACKED_STAIR=14;
ChartRenderer.SUMMED_STAIR=15;
ChartRenderer.COMBO=16;
ChartRenderer.STACKED100_BAR=17;
ChartRenderer.STACKED100_POLYLINE=18;
ChartRenderer.STACKED100_AREA=19;
ChartRenderer.STACKED100_STAIR=20;
ChartRenderer.HILO_ARROW=21;
ChartRenderer.HILO_STICK=22;
ChartRenderer.prototype._flags;
function ChartRenderer(_1){
if(_1){
this._flags=new Flags(ChartRenderer.DEFAULT_FLAGS);
this.setDataSource(new DefaultDataSource());
}
}
ChartRenderer.createRenderer=function(_2){
var _3=null;
switch(_2){
case ChartRenderer.BAR:
_3=new BarChartRenderer();
break;
case ChartRenderer.STACKED_BAR:
_3=new BarChartRenderer(BarChartRenderer.STACKED);
break;
case ChartRenderer.STACKED100_BAR:
_3=new BarChartRenderer(BarChartRenderer.STACKED);
_3.setStacked100Percent(true);
break;
case ChartRenderer.SUPERIMPOSED_BAR:
_3=new BarChartRenderer(BarChartRenderer.SUPERIMPOSED);
break;
case ChartRenderer.AREA:
_3=new AreaChartRenderer();
break;
case ChartRenderer.STACKED_AREA:
_3=new AreaChartRenderer(PolylineChartRenderer.STACKED);
break;
case ChartRenderer.STACKED100_AREA:
_3=new AreaChartRenderer(PolylineChartRenderer.STACKED);
_3.setStacked100Percent(true);
break;
case ChartRenderer.POLYLINE:
_3=new PolylineChartRenderer(null,true);
break;
case ChartRenderer.STACKED_POLYLINE:
_3=new PolylineChartRenderer(PolylineChartRenderer.STACKED,true);
break;
case ChartRenderer.STACKED100_POLYLINE:
_3=new PolylineChartRenderer(PolylineChartRenderer.STACKED,true);
_3.setStacked100Percent(true);
break;
case ChartRenderer.STAIR:
_3=new StairChartRenderer();
break;
case ChartRenderer.STACKED_STAIR:
_3=new StairChartRenderer(PolylineChartRenderer.STACKED);
break;
case ChartRenderer.STACKED100_STAIR:
_3=new StairChartRenderer(PolylineChartRenderer.STACKED);
_3.setStacked100Percent(true);
break;
case ChartRenderer.SUMMED_STAIR:
_3=new StairChartRenderer(StairChartRenderer.SUMMED);
break;
case ChartRenderer.SCATTER:
_3=new ScatterChartRenderer();
break;
case ChartRenderer.COMBO:
_3=new ComboChartRenderer();
break;
case ChartRenderer.BUBBLE:
_3=new BubbleChartRenderer();
break;
case ChartRenderer.HILO:
_3=new HiLoChartRenderer();
break;
case ChartRenderer.HILO_ARROW:
_3=new HiLoChartRenderer(HiLoChartRenderer.CLUSTERED,SingleHiLoRenderer.ARROW);
break;
case ChartRenderer.HILO_STICK:
_3=new HiLoChartRenderer(HiLoChartRenderer.CLUSTERED,SingleHiLoRenderer.STICK);
break;
case ChartRenderer.CANDLE:
_3=new HiLoChartRenderer(HiLoChartRenderer.CANDLE,SingleHiLoRenderer.BAR);
break;
case ChartRenderer.HLOC:
_3=new HiLoChartRenderer(HiLoChartRenderer.OPENCLOSE,SingleHiLoRenderer.BAR);
break;
case ChartRenderer.PIE:
_3=new PieChartRenderer();
break;
}
return _3;
};
ChartRenderer.prototype.isViewable=function(){
return this._flags.getFlag(ChartRenderer.VIEWABLE_FLAG);
};
ChartRenderer.prototype.toData=function(_4){
var _5=this.getChart();
if(_5!=null){
_5.getProjector().toData(_4,this.getPlotRect(),this.getCoordinateSystem());
}
};
ChartRenderer.prototype.toDisplay=function(_6){
var _7=this.getChart();
if(_7!=null){
var _8=this.getXShift();
if(_8!=0){
for(var i=0;i<_6.count;i++){
_6.setX(i,_6.getX(i)+_8);
}
}
_7.getProjector().toDisplay(_6,this.getPlotRect(),this.getCoordinateSystem());
}
};
ChartRenderer.prototype.getPlotRect=function(){
if(this._parent!=null){
return this._parent.getPlotRect();
}else{
return this._chart.getPlotRect();
}
};
ChartRenderer.prototype.getCoordinateSystem=function(){
return this._chart.getCoordinateSystem(this._axis);
};
ChartRenderer.prototype.getChart=function(){
return this._chart;
};
ChartRenderer.prototype.setChart=function(_a,_b){
var _c=this._chart;
this._chart=_a;
this._axis=_b;
this.chartConnected(_c,_a);
this.updateViewableFlag(false);
if(this._children){
for(var i=0;i<this._children.length;i++){
this._children[i].setChart(_a,_b);
}
}
if(this._chart){
this._chart.pushInvalidatedRenderer(this);
this._chart.updateAndRedraw(true);
}else{
if(this instanceof SingleChartRenderer){
_c.pushInvalidatedRenderer(this);
}
_c.updateAndRedraw(true);
}
};
ChartRenderer.prototype.setXShift=function(_e){
this._xShift=_e;
};
ChartRenderer.prototype.getXShift=function(){
return (this._parent==null)?this._xShift:this._xShift+this._parent.getXShift();
};
ChartRenderer.prototype.isVisible=function(){
return this._flags.getFlag(ChartRenderer.VISIBLE_FLAG);
};
ChartRenderer.prototype.setVisible=function(_f){
if(_f==this.isVisible()){
return;
}
this._flags.setFlag(ChartRenderer.VISIBLE_FLAG,_f);
this.updateViewableFlag(true);
};
ChartRenderer.prototype.isVisibleInLegend=function(){
return this._flags.getFlag(ChartRenderer.IN_LEGEND_FLAG);
};
ChartRenderer.prototype.setVisibleInLegend=function(_10){
if(_10==this.isVisibleInLegend()){
return;
}
this._flags.setFlag(ChartRenderer.IN_LEGEND_FLAG,_10);
};
ChartRenderer.prototype.getMinDataSetCount=function(){
return 1;
};
ChartRenderer.prototype.setDataSource=function(_11){
var _12=this.getDataSource();
if(_12==_11){
return;
}
if(_12!=null){
this.disconnectDataSource(_12);
}
this._dataSource=_11;
this.connectDataSource(_11);
this.updateViewableFlag(true);
};
ChartRenderer.prototype.getDataSource=function(){
return this._dataSource;
};
ChartRenderer.prototype.updateViewableFlag=function(_13){
var old=this._flags.getFlag(ChartRenderer.VIEWABLE_FLAG);
var b=this.isVisible()&&(this.getDataSource().getDataSetCount()>=this.getMinDataSetCount())&&(this._axis!=null);
this._flags.setFlag(ChartRenderer.VIEWABLE_FLAG,b);
if(old!=b&&_13){
this._chart.updateAndRedraw(true);
}
};
ChartRenderer.prototype.disconnectDataSource=function(_16){
var _17=_16.getDataSets();
_16.removeEventListener("dataSourceChanged",this);
if(_17.length>0){
this.dataSetsRemoved(0,_17.length-1,_17);
if(this.getChart()!=null){
this.processDataSets(_16.getDataSets(),false,null);
}
}
};
ChartRenderer.prototype.connectDataSource=function(_18){
_18.addEventListener("dataSourceChanged",this);
if(_18.getDataSetCount()>0){
this.dataSetsAdded(0,_18.getDataSetCount()-1,new Array());
if(this.getChart()!=null){
this.processDataSets(_18.getDataSets(),true,null);
}
}
};
ChartRenderer.prototype.getParent=function(){
return this._parent;
};
ChartRenderer.prototype.setParent=function(_19){
if(_19!=null){
this._parent=_19;
this.setChart(_19.getChart(),_19._axis);
}else{
this._parent=null;
this.setChart(null,null);
}
};
ChartRenderer.prototype.dataSourceChanged=function(evt){
var _1b=evt.getFirstIdx();
var _1c=evt.getLastIdx();
if(evt.getType()==DataSourceEvent.DATASET_ADDED){
this.dataSetsAdded(_1b,_1c,evt.getOldDataSets());
if(this.getChart()!=null){
var _1d=new Array(_1c-_1b+1);
for(var i=_1b,j=0;i<=_1c;++i,++j){
_1d[j]=this.getDataSource().getDataSet(i);
}
this.processDataSets(_1d,true,null);
}
}else{
if(evt.getType()==DataSourceEvent.DATASET_REMOVED){
this.dataSetsRemoved(_1b,_1c,evt.getOldDataSets());
if(this.getChart()!=null){
var _1d=new Array(_1c-_1b+1);
for(var i=_1b,j=0;i<=_1c;++i,++j){
_1d[j]=evt.getOldDataSets()[i];
}
this.processDataSets(_1d,false,null);
}
}
}
this.updateViewableFlag(false);
};
ChartRenderer.prototype.processDataSets=function(_20,_21,_22){
var _23=(this.getChart()==null)?_22:this.getChart();
if(!_21){
}else{
this.applyStyles(_20);
}
};
ChartRenderer.prototype.applyStyles=function(_24){
if(this._children&&(window.getDataSetStyle||window.getDataSetProperties)){
for(var i=0;i<this._children.length;i++){
this._children[i].applyStyles(_24);
}
}
};
ChartRenderer.prototype.chartConnected=function(_26,_27){
if(_27!=null){
this.processDataSets(this.getDataSource().getDataSets(),true,_26);
}else{
this.processDataSets(this.getDataSource().getDataSets(),false,_26);
}
};
ChartRenderer.prototype.isDisplayingDataSet=function(_28){
return (this._dataSource!=null)&&this._dataSource.containsDataSet(_28);
};
