/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

DataIndicator.X_VALUE=0;
DataIndicator.Y_VALUE=1;
DataIndicator.X_RANGE=2;
DataIndicator.Y_RANGE=3;
DataIndicator.WINDOW=4;
DataIndicator.prototype._value;
DataIndicator.prototype._window;
DataIndicator.prototype._style;
DataIndicator.prototype._type;
DataIndicator.prototype._axisIdx;
DataIndicator.prototype._labelRenderer;
DataIndicator.prototype._drawOrder=-1;
function DataIndicator(_1){
if(_1.hasAttributeNS(null,"text")){
this._labelRenderer=new TextRenderer(_1.getAttributeNS(null,"text"));
}
var _2=0;
if(_1.hasAttributeNS(null,"axis")){
_2=parseInt(_1.getAttributeNS(null,"axis"));
}
if(_1.hasAttributeNS(null,"value")){
this.setValueImpl(_2,parseFloat(_1.getAttributeNS(null,"value")));
}else{
if(_1.hasAttributeNS(null,"start")){
this.setRangeImpl(_2,new IlvDataInterval(parseFloat(_1.getAttributeNS(null,"start")),parseFloat(_1.getAttributeNS(null,"end"))));
}else{
this.setDataWindowImpl(_2,new IlvDataWindow(parseFloat(_1.getAttributeNS(null,"xmin")),parseFloat(_1.getAttributeNS(null,"xmax")),parseFloat(_1.getAttributeNS(null,"ymin")),parseFloat(_1.getAttributeNS(null,"ymax"))));
}
}
if(_1.hasAttributeNS(null,"style")){
this._style=Style.create(_1.getAttributeNS(null,"style"));
this._style["shape-rendering"]="optimizeSpeed";
}
if(_1.hasAttributeNS(null,"drawOrder")){
this._drawOrder=_1.getAttributeNS(null,"drawOrder");
}
}
DataIndicator.prototype.setChart=function(_3){
this._chart=_3;
};
DataIndicator.prototype.getChart=function(){
return this._chart;
};
DataIndicator.prototype.getAxisIndex=function(){
return this._axisIdx;
};
DataIndicator.prototype.getDrawOrder=function(){
return this._drawOrder;
};
DataIndicator.prototype.getType=function(){
return this._type;
};
DataIndicator.prototype.setValueImpl=function(_4,_5){
this._axisIdx=_4;
this._window=null;
this._type=((_4==0)?DataIndicator.X_VALUE:DataIndicator.Y_VALUE);
this.setValue(_5);
};
DataIndicator.prototype.setValue=function(_6){
if(_6!=this._value){
this._value=_6;
if(this.getChart()!=null){
this.getChart().drawDrawable(this);
}
}
};
DataIndicator.prototype.getValue=function(){
return this._value;
};
DataIndicator.prototype.setRange=function(_7){
if(this.getType()==DataIndicator.X_RANGE){
if(!this._window.xRange.equals(_7)){
this._setDataWindow(_7.getMin(),_7.getMax(),-Number.MAX_VALUE,Number.MAX_VALUE);
}
}else{
if(this.getType()==DataIndicator.Y_RANGE){
if(!this._window.yRange.equals(_7)){
this._setDataWindow(-Number.MAX_VALUE,Number.MAX_VALUE,_7.getMin(),_7.getMax());
}
}
}
};
DataIndicator.prototype.getRange=function(){
var _8=(this.getType()==DataIndicator.X_RANGE)?this._window.xRange:this._window.yRange;
return new IlvDataInterval(_8);
};
DataIndicator.prototype.setRangeImpl=function(_9,_a){
this._axisIdx=_9;
if(_9==0){
this._setDataWindow(_a.getMin(),_a.getMax(),-Number.MAX_VALUE,Number.MAX_VALUE);
this._type=DataIndicator.X_RANGE;
}else{
this._setDataWindow(-Number.MAX_VALUE,Number.MAX_VALUE,_a.getMin(),_a.getMax());
this._type=DataIndicator.Y_RANGE;
}
};
DataIndicator.prototype.setDataWindowImpl=function(_b,w){
this._axisIdx=_b;
this._type=DataIndicator.WINDOW;
this._setDataWindow(w.getXMin(),w.getXMax(),w.getYMin(),w.getYMax());
};
DataIndicator.prototype.setDataWindow=function(w){
this._setDataWindow(w.getXMin(),w.getXMax(),w.getYMin(),w.getYMax());
};
DataIndicator.prototype.getDataWindow=function(){
return (this._window==null)?null:new IlvDataWindow(this._window.getXMin(),this._window.getXMax(),this._window.getYMin(),this._window.getYMax());
};
DataIndicator.prototype.contains=function(x,y){
var shp=this.getShape();
if(shp==null){
return false;
}
var _11=this.getDrawStyle()["stroke-width"];
if(!_11||_11<4){
_11=4;
}
return shp.contains(x,y,_11/2);
};
DataIndicator.prototype._setDataWindow=function(_12,_13,_14,_15){
if(!(this._window!=null&&_12==this._window.xRange.getMin()&&_13==this._window.xRange.getMax()&&_14==this._window.yRange.getMin()&&_15==this._window.yRange.getMax())){
if(this._window==null){
this._window=new DataWindow(_12,_13,_14,_15);
}else{
this._window.xRange.set(_12,_13);
this._window.yRange.set(_14,_15);
}
if(this.getChart()!=null){
this.getChart().drawDrawable(this);
}
}
};
DataIndicator.prototype.getStyle=function(){
return this._style;
};
DataIndicator.prototype.setStyle=function(_16){
if(_16!=this._style){
this._style=_16;
}
};
DataIndicator.prototype.draw=function(g){
var _18=true;
if(g&&!this._container){
this._container=DrawUtil.createContainer(g.ownerDocument);
}
if(this.getType()==DataIndicator.X_VALUE||this.getType()==DataIndicator.Y_VALUE){
_18=this.drawValue(this._container);
}else{
_18=this.drawWindow(this._container);
}
if(g&&_18){
g.appendChild(this._container);
}
};
DataIndicator.prototype.computeLabelLocation=function(_19){
var loc=new DoublePoints(1);
if(this.getType()==DataIndicator.X_VALUE||this.getType()==DataIndicator.Y_VALUE){
var _1b=(this._axisIdx==0)?Axis.X_AXIS:Axis.Y_AXIS;
if(_1b==Axis.X_AXIS){
loc.addValues(this._value,(_19.getYMin()+_19.getYMax())/2);
}else{
loc.addValues((_19.getXMin()+_19.getXMax())/2,this._value);
}
}else{
loc.addValues((_19.getXMin()+_19.getXMax())/2,(_19.getYMin()+_19.getYMax())/2);
}
var _1c=(this._axisIdx>1)?this._axisIdx:1;
this.getChart().getProjector().toDisplay(loc,this.getChart().getPlotRect(),this.getChart().getCoordinateSystem(_1c));
return new DoublePoint(loc.getX(0),loc.getY(0));
};
DataIndicator.prototype.getShape=function(){
var _1d=this.getChart();
if(_1d==null){
return null;
}
var _1e=(this._axisIdx>1)?this._axisIdx:1;
var sys=_1d.getCoordinateSystem(_1e);
var shp=null;
if(this.getType()==DataIndicator.WINDOW||this.getType()==DataIndicator.X_RANGE||this.getType()==DataIndicator.Y_RANGE){
var w=this.getDataWindow();
var _22=sys.getVisibleWindow();
w.intersection(_22.xRange,_22.yRange);
if(w.isEmpty()){
shp=null;
}else{
shp=_1d.getProjector().getShape(w,_1d.getPlotRect(),sys);
}
}else{
var _23=(this._axisIdx==0)?Axis.X_AXIS:Axis.Y_AXIS;
shp=_1d.getProjector().getShapeFromValue(this._value,_23,_1d.getPlotRect(),sys);
}
return shp;
};
DataIndicator.prototype.drawValue=function(g){
if(!this.getAxis().getVisibleRange().isInside(this._value)){
if(this._container.parentNode){
this._container.parentNode.removeChild(this._container);
}
return false;
}
var _25=this.getChart();
var _26=(this._axisIdx>1)?this._axisIdx:1;
var sys=this.getChart().getCoordinateSystem(_26);
var _28=(this._axisIdx==0)?Axis.X_AXIS:Axis.Y_AXIS;
var shp=_25.getProjector().getShapeFromValue(this._value,_28,_25.getPlotRect(),sys);
Style.drawLine(this.getDrawStyle(),g,shp.x1,shp.y1,shp.x2,shp.y2,g.getElementsByTagNameNS(SVG_NS,"line").item(0));
if(this._labelRenderer!=null){
var loc=this.computeLabelLocation(sys.getVisibleWindow());
this._labelRenderer.draw(g,loc.x,loc.y);
}
return true;
};
DataIndicator.prototype.drawWindow=function(g){
var _2c=(this._axisIdx>1)?this._axisIdx:1;
var _2d=this.getChart();
var sys=_2d.getCoordinateSystem(_2c);
var w=this.getDataWindow();
var _30=sys.getVisibleWindow();
w.intersection(_30.xRange,_30.yRange);
if(w.isEmpty()){
if(this._container.parentNode){
this._container.parentNode.removeChild(this._container);
}
return false;
}
var _31=_2d.getPlotRect();
var shp=_2d.getProjector().getShape(w,_31,sys);
Style.drawRect(this.getDrawStyle(),g,shp.x,shp.y,shp.width,shp.height,g.getElementsByTagNameNS(SVG_NS,"rect").item(0));
if(this._labelRenderer!=null){
var loc=this.computeLabelLocation(w);
this._labelRenderer.draw(g,loc.x,loc.y);
}
return true;
};
DataIndicator.prototype.getAxis=function(){
return this.getChart().getAxis(this._axisIdx);
};
DataIndicator.prototype.getDrawStyle=function(){
var _34=this.getStyle();
if(_34==null){
var _34=Style.create(this.getChart().getAreaStyleAttr());
if(this.getType()==DataIndicator.X_VALUE||this.getType()==DataIndicator.Y_VALUE){
_34.fill=_34.stroke;
_34.stroke=null;
}
}
return _34;
};
