/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

function DefaultDataRangePolicy(){
}
DefaultDataRangePolicy.prototype.computeDataRange=function(_1,_2,_3){
if(_3==null){
_3=new IlvDataInterval();
}else{
_3.empty();
}
var _4=_1.getRendererCount();
var _5=null;
var r;
for(var i=0;i<_4;++i){
r=_1.getRenderer(i);
if(!r.isViewable()){
continue;
}
if(_2.isXAxis()){
_3.addInterval(r.getXRange(_5));
}else{
if(r.getCoordinateSystem().getYAxis()==_2){
_3.addInterval(r.getYRange(_5));
}
}
}
if(!_2.isAutoDataMin()){
_3.setMin(_2.getDataMin());
}
if(!_2.isAutoDataMax()){
_3.setMax(_2.getDataMax());
}
if(this.shouldAdjust(_1,_2)){
this.adjustRange(_1,_2,_3);
}
return _3;
};
DefaultDataRangePolicy.prototype.shouldAdjust=function(_8,_9){
return _9.isYAxis();
};
DefaultDataRangePolicy.prototype.adjustRange=function(_a,_b,_c){
if(_c.getLength()==0&&_b.isYAxis()){
var _d=_a.getDataSource();
if(_d==null){
return;
}
var _e=false;
for(var i=_d.getDataSetCount();--i>=0;){
if(_d.getDataSet(i).getDataCount()>0){
_e=true;
break;
}
}
if(!_e){
return;
}
_c.addValue(_a.getCoordinateSystem(_b).getXCrossingValue());
if(_c.getLength()==0){
_c.addValue(0);
}
if(_c.getLength()==0){
_c.expand(1);
}
}
if(!this.isAdjustable(_c)){
return;
}
var _10=_a.getScale(_b);
if(_10==null){
return;
}
_10.getStepsDefinition().adjustRange(null,_c);
};
DefaultDataRangePolicy.prototype.isAdjustable=function(_11){
return !_11.isEmpty()&&(_11.getMin()!=Number.NEGATIVE_INFINITY)&&(_11.getMax()!=Number.POSITIVE_INFINITY)&&(_11.getMax()<Number.MAX_VALUE/2)&&(_11.getMin()>-Number.MAX_VALUE/2);
};
