/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

DefaultStepsDefinition.prototype=new StepsDefinition();
DefaultStepsDefinition.AUTO_FORMAT_FLAG=1;
DefaultStepsDefinition.AUTO_STEPUNIT_FLAG=2;
DefaultStepsDefinition.AUTO_SUBSTEPUNIT_FLAG=4;
DefaultStepsDefinition.FIX_PRECISION_FLAG=16;
DefaultStepsDefinition.SUBSTEPCOUNT_FLAG=32;
DefaultStepsDefinition.DEFAULT_FLAG=DefaultStepsDefinition.AUTO_FORMAT_FLAG|DefaultStepsDefinition.AUTO_SUBSTEPUNIT_FLAG|DefaultStepsDefinition.AUTO_STEPUNIT_FLAG;
DefaultStepsDefinition.SIMPLE_MODE=1;
DefaultStepsDefinition.COMPLEX_MODE=2;
DefaultStepsDefinition.prototype._flags;
DefaultStepsDefinition.prototype._stepUnit=1;
DefaultStepsDefinition.prototype._subStepUnit=0;
DefaultStepsDefinition.prototype._precision=0;
DefaultStepsDefinition.prototype._precisionBase=10;
DefaultStepsDefinition.prototype._precisionFix=0;
DefaultStepsDefinition.prototype._stepsSpacing=10;
DefaultStepsDefinition.prototype._subStepCount=0;
DefaultStepsDefinition.prototype._autoMode=DefaultStepsDefinition.SIMPLE_MODE;
DefaultStepsDefinition.prototype.fractionDigits=0;
function DefaultStepsDefinition(_1){
this._flags=new Flags(DefaultStepsDefinition.DEFAULT_FLAG);
if(_1){
this.setAutoMode(_1);
}
}
DefaultStepsDefinition.prototype.setPrecision=function(_2,_3){
if(!_3){
this._precisionBase=10;
}else{
this._precisionBase=_3;
}
this._precision=_2;
this._precisionFix=(_2>0)?Math.pow(_3,_2):Math.pow(_3,-_2);
if(this.isAutoNumberFormat()){
this.autoComputeFormat();
}
};
DefaultStepsDefinition.prototype.getPrecision=function(){
return this._precision;
};
DefaultStepsDefinition.prototype.getPrecisionBase=function(){
return this._precisionBase;
};
DefaultStepsDefinition.prototype.isAutoNumberFormat=function(){
return this._flags.getFlag(DefaultStepsDefinition.AUTO_FORMAT_FLAG);
};
DefaultStepsDefinition.prototype.setAutoNumberFormat=function(_4){
if(this.isAutoNumberFormat()==_4){
return;
}
this._flags.setFlag(DefaultStepsDefinition.AUTO_FORMAT_FLAG,_4);
if(this.getScale()!=null){
this.getScale().revalidateChartLayout();
}
};
DefaultStepsDefinition.prototype.setAutoStepUnit=function(_5){
if(this.isAutoStepUnit()==_5){
return;
}
this._flags.setFlag(DefaultStepsDefinition.AUTO_STEPUNIT_FLAG,_5);
if(this.getScale()!=null){
this.getScale().getSteps().invalidateValues();
this.getScale().revalidateChartLayout();
}
};
DefaultStepsDefinition.prototype.setAutoMode=function(_6){
this._autoMode=_6;
};
DefaultStepsDefinition.prototype.getAutoMode=function(){
return this._autoMode;
};
DefaultStepsDefinition.prototype.isAutoStepUnit=function(){
return this._flags.getFlag(DefaultStepsDefinition.AUTO_STEPUNIT_FLAG);
};
DefaultStepsDefinition.prototype.setAutoSubStepUnit=function(_7){
if(this.isAutoSubStepUnit()==_7){
return;
}
this._flags.setFlag(DefaultStepsDefinition.AUTO_SUBSTEPUNIT_FLAG,_7);
this._flags.setFlag(DefaultStepsDefinition.SUBSTEPCOUNT_FLAG,false);
if(this.getScale()!=null){
this.getScale().getSteps().invalidateValues();
this.getScale().revalidateChartLayout();
}
};
DefaultStepsDefinition.prototype.isAutoSubStepUnit=function(){
return this._flags.getFlag(DefaultStepsDefinition.AUTO_SUBSTEPUNIT_FLAG);
};
DefaultStepsDefinition.prototype.setStepUnit=function(_8){
this._setStepUnit(_8);
this.setAutoStepUnit(false);
};
DefaultStepsDefinition.prototype._setStepUnit=function(_9){
if(_9==this._stepUnit){
return;
}
this.setPrecision(DefaultStepsDefinition.getUnitPrecision(_9,this._precisionBase),this._precisionBase);
this._stepUnit=_9;
var _a=Math.pow(this._precisionBase,this._precision);
var r=_9/_a;
this._flags.setFlag(DefaultStepsDefinition.FIX_PRECISION_FLAG,(Math.floor(r)==r));
};
DefaultStepsDefinition.prototype.setSubStepUnit=function(_c){
this._setSubStepUnit(_c);
this._flags.setFlag(DefaultStepsDefinition.SUBSTEPCOUNT_FLAG,false);
this.setAutoSubStepUnit(false);
};
DefaultStepsDefinition.prototype._setSubStepUnit=function(_d){
this._subStepUnit=_d;
};
DefaultStepsDefinition.prototype.getValidatedSubStepUnit=function(){
return (this._subStepUnit>this._stepUnit)?0:this._subStepUnit;
};
DefaultStepsDefinition.prototype.setSubStepCount=function(_e){
this._subStepCount=_e;
this._flags.setFlag(DefaultStepsDefinition.SUBSTEPCOUNT_FLAG,true);
this.setAutoSubStepUnit(false);
};
DefaultStepsDefinition.prototype.getSubStepCount=function(){
return this._flags.getFlag(DefaultStepsDefinition.SUBSTEPCOUNT_FLAG)?this._subStepCount:(this.getValidatedSubStepUnit()!=0)?(Math.floor(this._stepUnit/this._subStepUnit))-1:0;
};
DefaultStepsDefinition.prototype.getSubStepUnit=function(){
var _f=this.getScale();
if(this.isAutoSubStepUnit()&&_f!=null&&!_f.getSteps().isValuesValid()){
_f.getSteps().update(null);
}
return this._subStepUnit;
};
DefaultStepsDefinition.prototype.getStepUnit=function(){
var _10=this.getScale();
if(this.isAutoStepUnit()&&_10!=null&&!_10.getSteps().isValuesValid()){
_10.getSteps().update(null);
}
return this._stepUnit;
};
DefaultStepsDefinition.prototype.update=function(){
if(this.getScale()==null){
this._setStepUnit(1);
this._setSubStepUnit(0);
return;
}
if(this.isAutoStepUnit()){
this.autoComputeStepUnit();
}
if(this.isAutoSubStepUnit()){
this.autoComputeSubStepUnit();
}
if(this._stepUnit==0||this.getRange().getLength()>500*this._stepUnit){
this._setStepUnit(this.getRange().getLength()/10);
}
if(this._flags.getFlag(DefaultStepsDefinition.SUBSTEPCOUNT_FLAG)){
this._setSubStepUnit(this._subStepCount!=0?this._stepUnit/(_subStepCount+1):0);
}
};
DefaultStepsDefinition.prototype.hasSubStep=function(){
return this.getValidatedSubStepUnit()>0;
};
DefaultStepsDefinition.prototype.computeStepUnit=function(){
if(this.getAutoMode()==DefaultStepsDefinition.SIMPLE_MODE){
return this.simpleUnit();
}else{
return this.complexUnit();
}
};
DefaultStepsDefinition.prototype.simpleUnit=function(){
var _11=this.getRange();
return DefaultStepsDefinition.getPreferredUnit(_11.getLength());
};
DefaultStepsDefinition.prototype.complexUnit=function(){
var _12=getRange();
var _13=this.getMaxStepCount(_12,this.fractionDigits,this._stepsSpacing);
var _14=_12.getLength()/(_13-1);
var _15=DefaultStepsDefinition.getUnitPrecision(_14,this.getPrecisionBase());
var _16=Math.pow(this.getPrecisionBase(),_15);
if(this.getPrecisionBase()==10){
while(_14>2*_16){
if(_14<=5*_16){
_14=5*_16;
break;
}else{
++_15;
_16=Math.pow(this.getPrecisionBase(),_15);
_14=_16;
}
}
}
if(_14==this._stepUnit){
return _14;
}
var _17=Math.floor(_12.getLength()/_14)+1;
if(this.isAutoNumberFormat()){
var _18=DefaultStepsDefinition.computeFormat(_15,this.getPrecisionBase());
_13=this.getMaxStepCount(_12,_18,this._stepsSpacing);
if(_17>_13){
if(this._stepUnit==0){
var _19=_17/_13;
if(_19<=2){
_14=2*_16;
}else{
if(_19<=5){
_14=5*_16;
}else{
_14=Math.ceil(_19)*_16;
}
}
}else{
_14=this._stepUnit;
}
}
}
return _14;
};
DefaultStepsDefinition.prototype.autoComputeStepUnit=function(){
if(this.getAxis()==null){
this._setStepUnit(1);
this._setSubStepUnit(0);
}
this._setStepUnit(this.computeStepUnit());
};
DefaultStepsDefinition.prototype.autoComputeSubStepUnit=function(){
var _1a=Math.pow(this.getPrecisionBase(),this.getPrecision());
var _1b=Math.round(this._stepUnit/_1a);
if(_1b==1){
_1a/=this.getPrecisionBase();
_1b=this.getPrecisionBase();
}
if(this.getAxis()!=null){
var _1c=this.getScale().getScaleLength();
var _1d=Math.floor(this.getRange().getLength()/this._stepUnit)+1;
if(_1c<4*_1d*_1b){
this._setSubStepUnit(0);
return;
}
}
this._setSubStepUnit(_1a);
};
DefaultStepsDefinition.prototype.getRange=function(){
return this.getAxis().getVisibleRange();
};
DefaultStepsDefinition.prototype.getMaxStepCount=function(_1e,_1f,_20){
var _21=getScale().getLabelFont();
var _22=SVGUtil.getStringWidth(_21,this.computeLabel(_1f,_1e.min));
var _23=Math.max(_22,SVGUtil.getStringWidth(_21,this.computeLabel(_1f,_1e.max)));
return this.getScale().getMaxStepCount(_23,SVGUtil.getFontHeight(_21),_20);
};
DefaultStepsDefinition.prototype.autoComputeFormat=function(){
this.fractionDigits=DefaultStepsDefinition.computeFormat(this.getPrecision(),this.getPrecisionBase());
};
DefaultStepsDefinition.prototype.fixPrecision=function(d){
if(!this._flags.getFlag(DefaultStepsDefinition.FIX_PRECISION_FLAG)){
return d;
}else{
if(this._precision<0){
return Math.floor(d*this._precisionFix+0.5)/this._precisionFix;
}else{
return Math.floor(d/this._precisionFix+0.5)*this._precisionFix;
}
}
};
DefaultStepsDefinition.prototype.previousStep=function(v){
return this.fixPrecision(Math.floor(v/this._stepUnit)*this._stepUnit);
};
DefaultStepsDefinition.prototype.incrementStep=function(v){
return this.fixPrecision(v+this._stepUnit);
};
DefaultStepsDefinition.prototype.previousSubStep=function(v){
return Math.floor(v/this._subStepUnit)*this._subStepUnit;
};
DefaultStepsDefinition.prototype.incrementSubStep=function(v){
return v+this._subStepUnit;
};
DefaultStepsDefinition.prototype.computeLabel=function(_29){
if(this.fractionDigits!=-1){
return DefaultStepsDefinition.stripNumber(_29.toFixed(this.fractionDigits));
}else{
var str=_29.toExponential(6);
var ei=str.indexOf("e");
var pre=str.substring(0,ei);
var _2d=str.substring(ei,str.length);
pre=DefaultStepsDefinition.stripNumber(pre);
return pre+_2d;
}
};
DefaultStepsDefinition.stripNumber=function(str){
while(str.charAt(str.length-1)=="0"){
str=str.substring(0,str.length-1);
}
if(str.charAt(str.length-1)=="."){
str=str.substring(0,str.length-1);
}
return str;
};
DefaultStepsDefinition.computeFormat=function(_2f,_30){
if(_2f<0){
if(_2f<4){
return -1;
}else{
if(_30==10){
return -Math.round(_2f);
}else{
return -Math.round(Math.log(Math.pow(_30,_2f))/Math.log(10));
}
}
}else{
if(_2f>4){
return -1;
}else{
return 2;
}
}
};
DefaultStepsDefinition.getUnitPrecision=function(_31,_32){
return Math.floor(Math.log(Math.abs(_31))/Math.log(_32)+0.000001);
};
DefaultStepsDefinition.getPreferredUnit=function(l){
if(l==0){
return 0;
}
var p=DefaultStepsDefinition.getUnitPrecision(l,10);
if(p==0){
return 1;
}
var _35=Math.pow(10,p);
var d=l/_35;
if(p<0){
if(d<=1){
return 2*_35/10;
}else{
if(d<=5){
return 5*_35/10;
}else{
return _35;
}
}
}else{
if(d<1){
return _35/10;
}else{
if(d<2){
return 2*_35/10;
}else{
if(d<5){
return 5*_35/10;
}else{
return _35;
}
}
}
}
};
DefaultStepsDefinition.prototype.adjustRange=function(_37,_38){
var _39=DefaultStepsDefinition.getPreferredUnit(_38.getLength());
if(_39==0){
return;
}
_38.setMin(Math.floor(_38.getMin()/_39)*_39);
_38.setMax(Math.ceil(_38.getMax()/_39)*_39);
var _3a=DefaultStepsDefinition.getPreferredUnit(_38.getLength());
if(_39!=_3a){
_38.setMin(Math.floor(_38.getMin()/_3a)*_3a);
_38.setMax(Math.ceil(_38.getMax()/_3a)*_3a);
}
};
