/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

DoublePoints.NULL_ARRAY=new Array();
DoublePoints.prototype.count;
DoublePoints.prototype.xValues;
DoublePoints.prototype.yValues;
function DoublePoints(_1,_2,_3){
if(_1==undefined){
this.count=0;
this.xValues=DoublePoints.NULL_ARRAY;
this.yValues=DoublePoints.NULL_ARRAY;
}else{
if(_2&&_3){
this.count=_1;
this.xValues=_2;
this.yValues=_3;
}else{
this.count=0;
this.xValues=ArrayPool.take(_1,this);
this.yValues=ArrayPool.take(_1,this);
}
}
}
DoublePoints.prototype.dispose=function(){
ArrayPool.release(this.xValues);
ArrayPool.release(this.yValues);
};
DoublePoints.prototype.addValues=function(x,y){
if(this.xValues.length==this.count||this.yValues.length==this.count){
this.addArrays([x],[y],1);
}else{
this.xValues[this.count]=x;
this.yValues[this.count++]=y;
}
};
DoublePoints.prototype.addArrays=function(x,y,_8){
var _9=this.count+_8;
if(this.xValues!=this.NULL_ARRAY){
if(_9>this.xValues.length){
this.xValues=ArrayPool.reAlloc(this.xValues,_9,this);
}
if(_9>this.yValues.length){
this.yValues=ArrayPool.reAlloc(this.yValues,_9,this);
}
}else{
this.xValues=ArrayPool.take(_8,this);
this.yValues=ArrayPool.take(_8,this);
}
for(var i=0;i<_8;i++){
this.xValues[i+this.count]=x[i];
this.yValues[i+this.count]=y[i];
}
this.count=_9;
};
DoublePoints.prototype.addArraysAt=function(_b,x,y,_e){
if(_b==this.count){
this.addArrays(x,y,_e);
return;
}
var _f=this.count+_e;
var _10=ArrayPool.take(this.count);
for(var i=0;i<this.count;i++){
_10[i]=this.xValues[i];
}
if(_f>this.xValues.length){
ArrayPool.release(this.xValues);
this.xValues=ArrayPool.take(_f,this);
if(_b>0){
for(var i=0;i<_b;i++){
this.xValues[i]=_10[i];
}
}
}
for(var i=0;i<_e;i++){
this.xValues[_b+i]=x[i];
}
for(var i=_b;i<this.count;i++){
this.xValues[_b+_e+i]=_10[i];
}
for(var i=0;i<this.count;i++){
_10[i]=this.yValues[i];
}
if(_f>this.yValues.length){
ArrayPool.release(this.yValues);
this.yValues=ArrayPool.take(_f,this);
if(_b>0){
for(var i=0;i<_b;i++){
this.yValues[i]=_10[i];
}
}
}
for(var i=0;i<_e;i++){
this.yValues[_b+i]=y[i];
}
for(var i=_b;i<this.count;i++){
this.yValues[_b+_e+i]=_10[i];
}
this.count=_f;
ArrayPool.release(_10);
};
DoublePoints.prototype.remove=function(_12,_13){
this.xValues.splice(_12,_13);
this.yValues.splice(_12,_13);
this.count-=_13;
};
DoublePoints.prototype.addPoints=function(pts){
this.addArrays(pts.xValues,pts.yValues,pts.count);
};
DoublePoints.prototype.getX=function(i){
return this.xValues[i];
};
DoublePoints.prototype.getXFloor=function(i){
return GraphicUtil.toInt(this.xValues[i]);
};
DoublePoints.prototype.getY=function(i){
return this.yValues[i];
};
DoublePoints.prototype.getYFloor=function(i){
return GraphicUtil.toInt(this.yValues[i]);
};
DoublePoints.prototype.setX=function(i,x){
this.xValues[i]=x;
};
DoublePoints.prototype.setY=function(i,y){
this.yValues[i]=y;
};
DoublePoints.prototype.set=function(idx,x,y){
this.xValues[idx]=x;
this.yValues[idx]=y;
};
DoublePoints.prototype.size=function(){
return this.count;
};
DoublePoints.prototype.getXValues=function(){
return this.xValues;
};
DoublePoints.prototype.getXValuesClone=function(){
var _20=new Array(this.count);
for(var i=0;i<this.count;i++){
_20[i]=this.xValues[i];
}
return _20;
};
DoublePoints.prototype.getYValues=function(){
return this.yValues;
};
DoublePoints.prototype.getYValuesClone=function(){
var _22=new Array(this.count);
for(var i=0;i<this.count;i++){
_22[i]=this.yValues[i];
}
return _22;
};
DoublePoints.prototype.setSize=function(_24){
this.count=_24;
};
DoublePoints.prototype.reset=function(){
this.setSize(0);
};
DoublePoints.prototype.toString=function(){
var buf="[";
for(var i=0;i<this.count;++i){
buf=buf+"("+this.xValues[i]+","+this.yValues[i]+")";
if(i!=this.count-1){
buf=buf+", ";
}
if((i%16)==0&&i>0){
buf=buf+"\n'";
}
}
buf=buf+"]";
return buf;
};
