/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Grid._defaultGridColor="lightgray";
Grid.prototype._axisIdx;
Grid.prototype._majVisible=true;
Grid.prototype._minVisible=false;
Grid.prototype._majStyle;
Grid.prototype._minStyle;
Grid.prototype._drawOrder=-1;
function Grid(_1){
this._def=_1;
if(this._def.hasAttributeNS(null,"crossingValue")){
this.setCrossingValue(parseFloat(this._def.getAttributeNS(null,"crossingValue")));
}
if(this._def.hasAttributeNS(null,"drawOrder")){
this._drawOrder=parseInt(this._def.getAttributeNS(null,"drawOrder"));
}
var _2=this._def.getElementsByTagNameNS(CHART_NS,"major").item(0);
if(_2){
if(_2.getAttributeNS(null,"visible")=="false"){
this._majVisible=false;
}
if(_2.hasAttributeNS(null,"style")){
this._majStyle=Style.create(_2.getAttributeNS(null,"style"));
this._majStyle["shape-rendering"]="optimizeSpeed";
if(!this._majStyle["stroke"]){
this._majStyle["stroke"]="rgb(192,192,192)";
}
}else{
this._majStyle=Style.create("stroke:rgb(192,192,192);shape-rendering:optimizeSpeed");
}
}else{
this._majStyle=Style.create("stroke:rgb(192,192,192);shape-rendering:optimizeSpeed");
}
var _3=this._def.getElementsByTagNameNS(CHART_NS,"minor").item(0);
if(_3){
if(_3.getAttributeNS(null,"visible")=="true"){
this._minVisible=true;
}
if(_3.hasAttributeNS(null,"style")){
this._minStyle=Style.create(_3.getAttributeNS(null,"style"));
this._minStyle["shape-rendering"]="optimizeSpeed";
if(!this._minStyle["stroke"]){
this._minStyle["stroke"]="rgb(192,192,192)";
}
}else{
this._minStyle=Style.create("stroke:rgb(192,192,192);shape-rendering:optimizeSpeed");
}
}
}
Grid.prototype.getDrawOrder=function(){
return this._drawOrder;
};
Grid.prototype.getAxis=function(){
return (this._axisIdx==undefined)?null:this._chart.getAxis(this._axisIdx);
};
Grid.prototype.getCoordinateSystem=function(){
return (this._axisIdx==undefined)?null:this._chart.getCoordinateSystem(this.getAxis());
};
Grid.prototype.getChart=function(){
return this._chart;
};
Grid.prototype.setAxis=function(_4,_5){
this._chart=_5;
this._axisIdx=_4;
};
Grid.prototype.draw=function(g){
if(this.getChart()==null){
return;
}
if(this.getScale()==null){
return;
}
if(this._majVisible){
var _7=this.getScale().getStepValues();
if(_7.length>0){
this.drawImpl(g,_7,true);
}
}
if(this._minVisible){
var _7=this.getScale().getSubStepValues();
if(_7.length>0){
this.drawImpl(g,_7,false);
}
}
};
Grid.prototype.drawImpl=function(g,_9,_a){
this.drawBasic(g,_9,_a);
};
Grid.prototype.getBasicGridPoints=function(_b){
var _c=this.getCoordinateSystem();
var _d=0;
var _e=_b.length;
if(this._chart.getType()==IlvChart.CARTESIAN){
var _f=Style.create(this._chart.getPlotStyleAttr());
if(Style.isStrokeOn(_f)){
var _10=0;
var _11=this.isXAxis()?_c.getXAxis():_c.getYAxis();
if(_b[0]==_11.getVisibleMin()){
++_d;
++_10;
}
if(_b[_e-1]==_11.getVisibleMax()){
++_10;
}
_e-=_10;
}
}
var _12=_e<<1;
var _13=new DoublePoints(_12);
var _14=_b.slice(_d,_d+_e);
if(this.isXAxis()){
_13.xValues=_14;
_13.xValues=_13.xValues.concat(_14);
_13.yValues=new Array(_12);
var i;
var val=_c.getYAxis().getVisibleMin();
for(i=0;i<_e;++i){
_13.yValues[i]=val;
}
val=_c.getYAxis().getVisibleMax();
for(;i<_12;++i){
_13.yValues[i]=val;
}
}else{
_13.yValues=_14;
_13.yValues=_13.yValues.concat(_14);
_13.xValues=new Array(_12);
var i;
var val=_c.getXAxis().getVisibleMin();
for(i=0;i<_e;++i){
_13.xValues[i]=val;
}
val=_c.getXAxis().getVisibleMax();
for(;i<_12;++i){
_13.xValues[i]=val;
}
}
_13.setSize(_12);
this.getChart().getProjector().toDisplay(_13,this.getChart().getPlotRect(),_c);
return _13;
};
Grid.prototype.drawBasic=function(g,_18,_19){
var _1a=this.getBasicGridPoints(_18);
var _1b=_19?this._majStyle:this._minStyle;
var xp=_1a.getXValues();
var yp=_1a.getYValues();
var _1e=_1a.size()>>1;
for(var i=0,j=_1e;i<_1e;++i,++j){
Style.drawLine(_1b,g,xp[i],yp[i],xp[j],yp[j]);
}
_1a.dispose();
};
Grid.prototype.getYAxisIdx=function(){
return this.isXAxis()?0:this._axisIdx;
};
Grid.prototype.isXAxis=function(){
return this.getAxis().isXAxis();
};
Grid.prototype.getScale=function(){
return this.getChart().getScale(this.getAxis());
};
