/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

var SVG_NS="http://www.w3.org/2000/svg";
var CHART_NS="http://xmlns.ilog.com/JViews/RichWebChartConfig";
IlvChart.ANTIALIAS_FLAG=1;
IlvChart.ANTIALIAS_TEXT_FLAG=2;
IlvChart.DATARANGE_FLAG=4;
IlvChart.AUTOREDRAW_FLAG=16;
IlvChart.CARTESIAN=1;
IlvChart.PIE=3;
IlvChart.DEFAULT_FLAGS=IlvChart.AUTOREDRAW_FLAG;
IlvChart.prototype._projector;
IlvChart.prototype._axisArray;
IlvChart.prototype._coordSys;
IlvChart.prototype._scaleArray;
IlvChart.prototype._drawables;
IlvChart.prototype._flags;
IlvChart.prototype._renderers;
IlvChart.prototype._rangePolicy;
IlvChart.prototype._defaultRenderer;
IlvChart.prototype._config;
IlvChart.prototype._rect;
IlvChart.prototype._drawRect;
IlvChart.prototype._legend;
IlvChart.prototype._inters;
IlvChart.prototype._cursors;
function IlvChart(g){
if(window.getPointStyle){
this._stylingEngineHint=new Object();
this._stylingEngineHint.getStyle=function(dp,_3){
return getPointStyle(dp,Style.copy(_3));
};
}
if(window.getPointProperties){
if(!this._stylingEngineHint){
this._stylingEngineHint=new Object();
this._stylingEngineHint.getStyle=function(dp,_5){
return _5;
};
}
this._stylingEngineHint.getMarker=function(dp,_7){
var _8=getPointProperties(dp,new Object());
if(!_8["marker"]){
return _7;
}else{
return Marker[_8["marker"]];
}
};
}
this._chartDef=g.getElementsByTagNameNS(CHART_NS,"chart").item(0);
this.getViewport().setAttributeNS(null,"pointer-events","all");
this._area=DrawUtil.createContainer(this._chartDef.ownerDocument);
if(this._chartDef.getAttributeNS(null,"type")=="PIE"){
this._defaultRenderer=ChartRenderer.PIE;
}else{
if(this._chartDef.hasAttributeNS(null,"renderingType")){
this._defaultRenderer=ChartRenderer[this._chartDef.getAttributeNS(null,"renderingType")];
}else{
this._defaultRenderer=ChartRenderer.POLYLINE;
}
}
var _9=false;
var _a=this._chartDef.getAttributeNS(null,"width");
if(_a.indexOf("%")!=-1){
_9=true;
}
var _b=IlvChart.getInnerWidth(_a);
_a=this._chartDef.getAttributeNS(null,"height");
if(_a.indexOf("%")!=-1){
_9=true;
}
var _c=IlvChart.getInnerHeight(_a);
if(this._chartDef.hasAttributeNS(null,"resizingPolicy")){
this._resizingPolicy=eval(this._chartDef.getAttributeNS(null,"resizingPolicy"));
}
var _d=Style.create(this.getStyleAttr());
if(_d["text-rendering"]){
this._area.setAttributeNS(null,"text-rendering",_d["text-rendering"]);
}
if(_d["shape-rendering"]){
this._area.setAttributeNS(null,"shape-rendering",_d["shape-rendering"]);
}
this._area.setAttributeNS(null,"class","area");
var _d=Style.create(this.getStyleAttr().replace(/stroke:[^;]*;?/,""));
if(this._chartDef.getAttributeNS(null,"opaque")=="true"){
this._back=Style.drawRect(_d,this._chartDef.parentNode,this._chartDef.getAttributeNS(null,"x"),this._chartDef.getAttributeNS(null,"y"),_b,_c);
this._back.setAttributeNS(null,"class","background");
}
this._chartDefArea=this._chartDef.getElementsByTagNameNS(CHART_NS,"area").item(0);
if(this._chartDefArea.getAttributeNS(null,"opaque")=="true"){
this._areaBack=Style.drawRect(_d,this._area,0,0,0,0);
this._areaBack.setAttributeNS(null,"class","background");
}
this._plotDef=this._chartDefArea.getElementsByTagNameNS(CHART_NS,"plot").item(0);
if(this._defaultRenderer!=ChartRenderer.PIE){
_d=Style.create(this.getPlotStyleAttr()+";stroke:none");
this._plotBackFill=DrawUtil.createRect(this._chartDef.ownerDocument);
Style.applyStyle(_d,this._plotBackFill);
this._plotBackFill.setAttributeNS(null,"class","background");
}
this._plotBackHolder=DrawUtil.createContainer(this._chartDef.ownerDocument);
if(this._defaultRenderer!=ChartRenderer.PIE){
this._plotBackHolder.appendChild(this._plotBackFill);
}
this._area.appendChild(this._plotBackHolder);
this._content=DrawUtil.createContainer(this._chartDef.ownerDocument);
this._area.appendChild(this._content);
if(this._defaultRenderer!=ChartRenderer.PIE){
_d=Style.create(this.getAreaStyleAttr()+";fill:none");
this._plotBack=DrawUtil.createRect(this._chartDef.ownerDocument);
Style.applyStyle(_d,this._plotBack);
}
if(this.eInit){
this.eInit();
}
this._chartDef.parentNode.appendChild(this._area);
this._rect=new Rectangle(parseFloat(this._chartDef.getAttributeNS(null,"x")),parseFloat(this._chartDef.getAttributeNS(null,"y")),_b,_c);
this._invalidatedRenderers=new Array();
var _e=new Axis(Axis.X_AXIS);
var _f=new Axis(Axis.Y_AXIS);
this._axisArray=new Array();
this._axisArray.push(_e);
this._axisArray.push(_f);
var _10=new CoordinateSystem(_e,_f);
this._coordSys=new Array();
this._coordSys.push(_10);
this._coordSys.push(_10);
this._scaleArray=new Array();
this._drawables=new Array();
this._flags=new Flags(IlvChart.DEFAULT_FLAGS);
this._rangePolicy=new DefaultDataRangePolicy();
this._renderers=new Array();
this._layout=new ChartAreaLayout(this);
var _11=this._chartDefArea.getAttributeNS(null,"margins");
if(_11&&_11!=""){
_11=_11.split(",");
this._layout.setMargins(new Insets(parseInt(_11[0]),parseInt(_11[1]),parseInt(_11[2]),parseInt(_11[3])));
}
this.createLegend(this._chartDef);
if(this._defaultRenderer==ChartRenderer.PIE){
this.setType(IlvChart.PIE);
}else{
this.setType(IlvChart.CARTESIAN);
}
if(this._legend){
this._legend.setChart(this);
}else{
this.updateLayout();
}
if(this._chartDef.getAttributeNS(null,"projectorReversed")=="true"){
this._projector.setReversed(true);
}
var _12=this._chartDef.getElementsByTagNameNS(CHART_NS,"xscale").item(0);
if(_12){
this.setScale(0,this._config.createScale(_12));
}
var _13=this._chartDef.getElementsByTagNameNS(CHART_NS,"yscale").item(0);
if(_13){
this.setScale(1,this._config.createScale(_13));
}
var _14=this._chartDef.getElementsByTagNameNS(CHART_NS,"xgrid").item(0);
if(_14){
this.setGrid(0,this._config.createGrid(_14));
}
var _15=this._chartDef.getElementsByTagNameNS(CHART_NS,"ygrid").item(0);
if(_15){
this.setGrid(1,this._config.createGrid(_15));
}
this._inters=new Array();
var _16=this._chartDef.getElementsByTagNameNS(CHART_NS,"interactors");
for(var i=0;i<_16.length;i++){
var _18=_16.item(i);
var _19=_18.firstChild;
var _1a;
var _1b=new Object();
while(_19){
if(_19.localName=="xscroll"){
_1a=new ChartScrollInteractor(37,39,2,0);
}else{
if(_19.localName=="yscroll"){
_1a=new ChartScrollInteractor(40,38,2,1);
}else{
if(_19.localName=="pan"){
_1a=new ChartPanInteractor();
if(_19.getAttributeNS(null,"xAxisAllowed")=="false"){
_1a.setXPanAllowed(false);
}
if(_19.getAttributeNS(null,"yAxisAllowed")=="true"){
_1a.setYPanAllowed(true);
}
}else{
if(_19.localName=="highlight"){
_1a=new ChartHighlightInteractor();
if(_19.hasAttributeNS(null,"onhighlight")){
_1a.action=_19.getAttributeNS(null,"onhighlight");
}
if(_19.hasAttributeNS(null,"style")){
_1a.style=Style.create(_19.getAttributeNS(null,"style"));
}
if(_19.hasAttributeNS(null,"marker")){
_1a.marker=Marker[_19.getAttributeNS(null,"marker")];
}
if(_19.getAttributeNS(null,"pickingMode")=="ITEM_PICKING"){
_1a.setPickingMode(ChartDataInteractor.ITEM_PICKING);
}
}else{
if(_19.localName=="pick"){
_1a=new ChartPickInteractor();
if(_19.hasAttributeNS(null,"onpick")){
_1a.action=_19.getAttributeNS(null,"onpick");
}
if(_19.hasAttributeNS(null,"style")){
_1a.style=Style.create(_19.getAttributeNS(null,"style"));
}
if(_19.hasAttributeNS(null,"marker")){
_1a.marker=Marker[_19.getAttributeNS(null,"marker")];
}
if(_19.getAttributeNS(null,"pickingMode")=="NEARESTPOINT_PICKING"){
_1a.setPickingMode(ChartDataInteractor.NEARESTPOINT_PICKING);
}
}else{
if(_19.localName=="zoom"){
_1a=new ChartZoomInteractor(0,ChartInteractor.CTRL_MOD,ChartInteractor.SHIFT_MOD);
if(_19.getAttributeNS(null,"xAxisAllowed")=="false"){
_1a._xZoomAllowed=false;
}
if(_19.getAttributeNS(null,"yAxisAllowed")=="true"){
_1a._yZoomAllowed=true;
}
if(_19.getAttributeNS(null,"zoomOutAllowed")=="false"){
_1a._zoomOutAllowed=false;
}
}else{
if(_19.localName=="infoview"){
_1a=new ChartInfoViewInteractor();
if(_19.getAttributeNS(null,"followingMouse")=="true"){
_1a._followMouse=true;
}
if(_19.getAttributeNS(null,"pickingMode")=="ITEM_PICKING"){
_1a.setPickingMode(ChartDataInteractor.ITEM_PICKING);
}
}
}
}
}
}
}
}
if(_1a){
_1a.enableEvents(_1b);
this.addInteractor(_1a);
}
_19=_19.nextSibling;
_1a=null;
}
}
for(var i in _1b){
this.getViewport().addEventListener(i,this,false);
}
var _1c=this._chartDef.getElementsByTagNameNS(CHART_NS,"dataIndicator");
for(var i=0;i<_1c.length;i++){
var _1d=new DataIndicator(_1c.item(i));
_1d.setChart(this);
this.addDrawable(_1d);
}
if(_9){
if(window.parent.addEventListener){
window.parent.addEventListener("resize",this,false);
}else{
this._chartDef.ownerDocument.documentElement.addEventListener("SVGResize",this,false);
}
}
var fit;
var _1f=this;
if(this._chartDef.hasAttributeNS(null,"visibleWindow")){
var _20=this._chartDef.getAttributeNS(null,"visibleWindow").split(",");
var _21=new IlvDataWindow(parseFloat(_20[0]),parseFloat(_20[1]),parseFloat(_20[2]),parseFloat(_20[3]));
fit=function(){
_1f.zoom(_21,1);
};
}
var _22=function(_23){
if(_23.contentXML.firstChild.firstChild&&fit){
fit();
}
var _24=_1f._chartDef.ownerDocument.getElementById("jvrcwaiting");
_24.parentNode.removeChild(_24);
};
var _25=this._chartDef.hasAttributeNS(null,"updateInterval")?parseInt(this._chartDef.getAttributeNS(null,"updateInterval"))*1000:0;
var ds=new XMLStreamDataSource(this._chartDef.getAttributeNS(null,"dataURL"),_25);
ds.init(_22);
this.setDataSource(ds);
var _27=this._chartDef.getAttributeNS(null,"id");
window.parent[_27]=this;
if(!window.parent.IlvAjaxUtil){
window.parent.IlvAjaxUtil=IlvAjaxUtil;
window.parent.IlvDataWindow=IlvDataWindow;
window.parent.IlvDataInterval=IlvDataInterval;
}
}
IlvChart.prototype.setAutoVisibleRange=function(_28){
this.getAxis(0).setAutoVisibleRange(_28);
this.getAxis(1).setAutoVisibleRange(_28);
};
IlvChart.prototype.updateDataSource=function(_29){
this.getDataSource().update(_29,true);
};
IlvChart.prototype.getVisibleWindow=function(){
return this.getCoordinateSystem().getVisibleWindow();
};
IlvChart.prototype.updateJSFForm=function(){
var _2a=this._chartDef.getAttributeNS(null,"clientId");
if(window.parent){
var _2b=window.parent.document.getElementById(_2a);
if(_2b){
var _2c=this.getVisibleWindow();
_2b.value=_2a+"("+_2c.xRange.min+","+_2c.xRange.max+","+_2c.yRange.min+","+_2c.yRange.max+")";
}
}
};
IlvChart.prototype.getArea=function(){
return this._area;
};
IlvChart.prototype.createLegend=function(_2d){
var _2e=_2d.getElementsByTagNameNS(CHART_NS,"legend");
if(_2e.length!=0&&_2e.item(0).getAttributeNS(null,"visible")!="false"){
this._legend=new Legend(_2e.item(0));
}
};
IlvChart.prototype.isInvalidatedRenderer=function(_2f){
return this._invalidatedRenderers.indexOf(_2f)!=-1;
};
IlvChart.prototype.pushInvalidatedRenderer=function(_30){
if(!this.isInvalidatedRenderer(_30)){
this._invalidatedRenderers.push(_30);
}
};
IlvChart.prototype.drawArea=function(_31){
if(!this.getDataSource()){
return;
}
var _32;
if(document.rootElement.suspendRedraw){
_32=this._content.ownerDocument.rootElement.suspendRedraw(1000);
}
if(!_31){
this.clearArea();
this._before=DrawUtil.createContainer(this._content.ownerDocument);
this.drawDrawables(true);
this._content.appendChild(this._before);
if(this.getType()!=IlvChart.PIE){
this._content.appendChild(this._plotBack);
}
var _33=this.getRendererCount();
var _34;
for(var i=0;i<_33;i++){
_34=this.getRenderer(i);
if(_34.isViewable()){
_34.draw(this._content,false);
}
}
this._after=DrawUtil.createContainer(this._content.ownerDocument);
this.drawDrawables(false);
this._content.appendChild(this._after);
this._invalidatedRenderers.length=0;
}else{
while(this._invalidatedRenderers.length!=0){
var _34=this._invalidatedRenderers.pop();
_34.draw(this._content,true);
}
}
if(_32){
this._content.ownerDocument.rootElement.unsuspendRedraw(_32);
}
};
IlvChart.prototype.drawDrawables=function(_36){
var _37;
for(var i=0;i<this._drawables.length;i++){
_37=this._drawables[i];
if(_37&&((_36&&_37.getDrawOrder()<0)||(!_36&&_37.getDrawOrder()>0))){
_37.draw(_36?this._before:this._after);
}
}
};
IlvChart.prototype.drawDrawable=function(_39){
_39.draw();
};
IlvChart.prototype.clearArea=function(){
while(this._content.hasChildNodes()){
this._content.removeChild(this._content.firstChild);
}
this._before=null;
this._after=null;
};
IlvChart.prototype.getDrawingAreaInsertionPoint=function(){
return this._after;
};
IlvChart.prototype.dataSetContentsChanged=function(evt,_3b){
var _3c=evt.getDataSet();
if(evt.getType()==DataSetContentsEvent.AFTER_DATA_CHANGED){
if(!this.updateDataRange()){
this.pushInvalidatedRenderer(_3b);
this.invalidate(true);
}else{
this.invalidate();
}
}else{
if(evt.getType()==DataSetContentsEvent.DATA_ADDED){
this.dataPointsAdded(_3b,_3c,evt.getFirstIdx(),evt.getLastIdx(),true);
}else{
if(evt.getType()==DataSetContentsEvent.FULL_UPDATE||evt.getType()==DataSetContentsEvent.DATA_CHANGED){
if(this.isShiftScroll()){
var max=this.getXAxis().getVisibleMax();
var _3e=_3c.getXRange().getMax();
var _3f=this.updateDataRange();
this.shiftScroll(_3e,max,_3f,true,_3b);
}else{
if(!this.updateDataRange()){
this.pushInvalidatedRenderer(_3b);
this.invalidate(true);
}else{
this.invalidate();
}
}
}
}
}
};
IlvChart.prototype.dataPointsAdded=function(_40,ds,_42,_43,_44){
var max=this.getXAxis().getVisibleMax();
var _46=ds.getXData(_43);
var _47=this.updateDataRange();
this.shiftScroll(_46,max,_47,_44,_40);
};
IlvChart.prototype.shiftScroll=function(_48,max,_4a,_4b,_4c){
if(_48>max){
if(this.isShiftScroll()){
var min=this.getXAxis().getVisibleMin();
var _4e=0;
if(this.getScrollRatio()==0){
_4e=_48-max;
}else{
var _4f=(max-min)*this.getScrollRatio();
_4e=Math.ceil((_48-max)/_4f)*_4f;
}
this.getXAxis().setVisibleRange(min+_4e,max+_4e);
_4a=true;
}else{
_4b=false;
}
}
if(_4b){
if(!_4a){
this.pushInvalidatedRenderer(_4c);
}
this.invalidate(!_4a);
}
};
IlvChart.prototype.addRenderer=function(_50,_51){
if(_51){
var ds=new DefaultDataSource(new Array(_51));
_50.setDataSource(ds);
this.addRendererImpl(this.getRendererCount(),_50,0);
}else{
this.addRendererImpl(this.getRendererCount(),_50,0);
}
};
IlvChart.prototype.addRendererImpl=function(_53,_54,_55){
if(_53>this._renderers.length){
_53=this._renderers.length;
}
this._renderers.addItemAt(_53,_54);
_54.setChart(this,this._axisArray[_55+1]);
this.updateDataRange();
if(this.getAutoRedraw()){
this.updateAndRedraw(false);
}
};
IlvChart.prototype.removeRenderer=function(_56){
this.removeRendererImpl(_56);
};
IlvChart.prototype.removeRendererImpl=function(_57){
if(this._renderers.removeItem(_57)){
_57.setChart(null,null);
this.updateDataRange();
if(this.getAutoRedraw()){
this.updateAndRedraw(false);
}
}
};
IlvChart.prototype.setAutoRedraw=function(b){
this._flags.setFlag(IlvChart.AUTOREDRAW_FLAG,b);
};
IlvChart.prototype.getAutoRedraw=function(){
return this._flags.getFlag(IlvChart.AUTOREDRAW_FLAG);
};
IlvChart.prototype.isShiftScroll=function(){
return this._chartDef.getAttributeNS(null,"shiftScroll")=="true";
};
IlvChart.prototype.getScrollRatio=function(){
var sr=this._chartDef.getAttributeNS(null,"scrollRatio");
if(sr){
return parseFloat(sr);
}else{
return 0;
}
};
IlvChart.prototype.getXAxis=function(){
return this._axisArray[0];
};
IlvChart.prototype.getAxis=function(_5a){
return this._axisArray[_5a];
};
IlvChart.prototype.getDualAxis=function(_5b){
return this._axisArray[_5b].isXAxis()?this._coordSys[_5b].getYAxis():this._coordSys[_5b].getXAxis();
};
IlvChart.prototype.getYAxisCount=function(){
return this._axisArray.length-1;
};
IlvChart.prototype.getRendererCount=function(){
return this._renderers.length;
};
IlvChart.prototype.getRenderer=function(idx){
return this._renderers[idx];
};
IlvChart.prototype.getProjector=function(){
return this._projector;
};
IlvChart.prototype.setProjector=function(_5d){
this._projector=_5d;
};
IlvChart.prototype.getLocalProjector=function(_5e,_5f){
return this._projector.getLocalProjector(_5e,_5f);
};
IlvChart.prototype.toData=function(pts,_61){
this.getProjector().toData(pts,this.getPlotRect(),this.getCoordinateSystem(_61));
};
IlvChart.prototype.getPlotRect=function(){
return this._layout.getPlotRect();
};
IlvChart.prototype.getDrawRect=function(){
return this._drawRect;
};
IlvChart.prototype.getBounds=function(){
return this._rect;
};
IlvChart.prototype.scroll=function(_62,_63){
var _64=arguments[2];
if(_64==undefined){
_64=1;
}
this.setAutoRedraw(false);
if(_62!=0){
this.getXAxis().translateVisibleRange(_62);
}
if(_63!=0){
this.getAxis(_64).translateVisibleRange(_63);
}
this.setAutoRedraw(true);
if(_62!=0||_63!=0){
this.invalidate();
}
};
IlvChart.prototype.zoom=function(_65){
if(_65.isEmpty()){
return;
}
var _66=arguments[1];
if(_66==undefined){
_66=1;
}
this.setAutoRedraw(false);
this.getXAxis().setVisibleRange(_65.xRange.getMin(),_65.xRange.getMax());
this.getAxis(_66).setVisibleRange(_65.yRange.getMin(),_65.yRange.getMax());
this.setAutoRedraw(true);
this.drawArea();
};
IlvChart.prototype.setDataSource=function(_67){
var r=null;
for(var i=this.getRendererCount();--i>=0;){
r=this.getRenderer(i);
this.removeRenderer(r);
}
if(_67!=null){
r=ChartRenderer.createRenderer(this._defaultRenderer);
r.setDataSource(_67);
this.addRenderer(r);
}
};
IlvChart.prototype.getDataSource=function(){
if(this.getRendererCount()>0){
return this.getRenderer(0).getDataSource();
}
return null;
};
IlvChart.prototype.updateDataRange=function(){
this.setAutoRedraw(false);
var _6a=null;
var _6b=false;
var _6c=this._axisArray.length;
for(var i=0;i<_6c;++i){
var _6e=this._axisArray[i];
if(!_6e.isAutoDataRange()){
continue;
}
_6a=this._rangePolicy.computeDataRange(this,_6e,_6a);
if(!_6a.isEmpty()){
_6b=_6e.updateDataRange(_6a)||_6b;
}
}
this.setAutoRedraw(true);
return _6b;
};
IlvChart.prototype.getCoordinateSystem=function(_6f){
return this._coordSys[0];
};
IlvChart.prototype.invalidate=function(_70){
if(this.getDataSource().isBatched()){
this.getDataSource().addChart(this);
if(!_70){
for(var i=0;i<this._renderers.length;i++){
this.pushInvalidatedRenderer(this._renderers[i]);
}
}
}else{
this.drawArea(_70);
}
};
IlvChart.prototype.getType=function(){
return this._config.getType();
};
IlvChart.prototype.setType=function(_72){
if(this._config!=null&&this._config.getType()==_72){
return;
}
var _73=ChartConfig.create(_72);
if(this._config!=null){
this._config.setChart(null);
}
this._config=_73;
if(this._config!=null){
this._config.setChart(this);
}
};
IlvChart.prototype.addDrawable=function(_74){
this._drawables.push(_74);
this._drawables.sort(compareDrawables);
};
IlvChart.prototype.setScale=function(_75,_76){
if(_76){
_76.setAxis(_75,this);
}
this._scaleArray[_75]=_76;
if(_76){
if(this.getAxis(_75).isXAxis()){
_76.setConfiguration(this._config.createXScaleConfig());
}else{
_76.setConfiguration(this._config.createYScaleConfig());
}
_76.setPlotRect(this.getPlotRect(),false);
this.addDrawable(_76);
}
this.updateAreaLayout();
this.drawArea();
};
IlvChart.prototype.getScale=function(_77){
var idx=_77.isXAxis()?0:1;
for(var i=0;i<this._scaleArray.length;i++){
if(this._scaleArray[i]&&this._scaleArray[i].getAxis()==this.getAxis(idx)){
return this._scaleArray[i];
}
}
return null;
};
IlvChart.prototype.getXScale=function(){
return this._scaleArray[0];
};
IlvChart.prototype.updateAndRedraw=function(_7a){
if(!this.getDataSource()){
return;
}
if(this.getDataSource().isBatched()){
this.getDataSource().addChart(this);
return;
}
var _7b=false;
if(this._legend){
_7b=this._legend.recomputeItems();
}
if(this.updateDataRange()||!_7a||_7b){
this.invalidate();
}else{
this.invalidate(true);
}
};
IlvChart.prototype.setGrid=function(_7c,_7d){
if(_7d){
_7d.setAxis(_7c,this);
this.addDrawable(_7d);
}
this.drawArea();
};
IlvChart.prototype.updateAreaLayout=function(){
this._layout.layout();
var _7e=this.getPlotRect();
if(!this._clipPath){
this._clipPath=DrawUtil.createRect(this._area.ownerDocument);
}
this._clipPath.setAttributeNS(null,"x",_7e.x);
this._clipPath.setAttributeNS(null,"y",_7e.y);
this._clipPath.setAttributeNS(null,"width",_7e.width-1);
this._clipPath.setAttributeNS(null,"height",_7e.height-1);
if(this._clipPath.parentNode==null){
var _7f=this._area.ownerDocument.createElementNS(SVG_NS,"clipPath");
_7f.setAttributeNS(null,"shape-rendering","optimizeSpeed");
_7f.setAttributeNS(null,"id","plotAreaCP");
_7f.appendChild(this._clipPath);
this._area.appendChild(_7f);
}
if(this.getType()!=IlvChart.PIE){
this._plotBack.setAttributeNS(null,"x",_7e.x);
this._plotBack.setAttributeNS(null,"y",_7e.y);
this._plotBack.setAttributeNS(null,"width",_7e.width-1);
this._plotBack.setAttributeNS(null,"height",_7e.height-1);
this._plotBackFill.setAttributeNS(null,"x",_7e.x);
this._plotBackFill.setAttributeNS(null,"y",_7e.y);
this._plotBackFill.setAttributeNS(null,"width",_7e.width-1);
this._plotBackFill.setAttributeNS(null,"height",_7e.height-1);
}
if(this.eUpdate){
this.eUpdate(_7e);
}
};
IlvChart.prototype.updateLayout=function(){
if(!this._legend){
this._drawRect=new Rectangle(this._rect.x+2,this._rect.y+2,this._rect.width-4,this._rect.height-4);
}else{
this._drawRect=new Rectangle();
var _80=this._legend.getPreferredSize();
switch(this._legend.getPosition()){
case Legend.NORTH:
this._legend.x=0;
this._legend.y=0;
this._drawRect.x=this._rect.x;
this._drawRect.y=this._rect.y+_80.height;
this._drawRect.width=this._rect.width;
this._drawRect.height=this._rect.height-_80.height;
break;
case Legend.SOUTH:
this._legend.x=0;
this._legend.y=this._rect.y+this._rect.height-_80.height;
this._drawRect.x=this._rect.x;
this._drawRect.y=this._rect.y;
this._drawRect.width=this._rect.width;
this._drawRect.height=this._rect.height-_80.height;
break;
case Legend.WEST:
this._legend.x=0;
this._legend.y=0;
this._drawRect.x=this._rect.x+_80.width;
this._drawRect.y=this._rect.y;
this._drawRect.width=this._rect.width-_80.width;
this._drawRect.height=this._rect.height;
break;
case Legend.EAST:
this._legend.x=this._rect.x+this._rect.width-_80.width;
this._legend.y=0;
this._drawRect.x=this._rect.x;
this._drawRect.y=this._rect.y;
this._drawRect.width=this._rect.width-_80.width;
this._drawRect.height=this._rect.height;
}
this._drawRect.grow(-2,-2);
}
if(this._areaBack){
this._areaBack.setAttributeNS(null,"x",this._drawRect.x);
this._areaBack.setAttributeNS(null,"y",this._drawRect.y);
this._areaBack.setAttributeNS(null,"width",this._drawRect.width);
this._areaBack.setAttributeNS(null,"height",this._drawRect.height);
}
this.updateAreaLayout();
};
IlvChart.prototype.isProjectorReversed=function(){
if(this.getType()!=IlvChart.CARTESIAN){
return false;
}
return this.getProjector().isReversed();
};
IlvChart.prototype.getAreaStyleAttr=function(){
if(this._chartDefArea.hasAttributeNS(null,"style")){
return this._chartDefArea.getAttributeNS(null,"style");
}else{
return this.getStyleAttr();
}
};
IlvChart.prototype.getPlotStyleAttr=function(){
var _81="fill:white";
if(this._plotDef&&this._plotDef.hasAttributeNS(null,"style")){
return _81+";"+this._plotDef.getAttributeNS(null,"style");
}
return _81;
};
IlvChart.prototype.getStyleAttr=function(){
return "fill:lightGrey;"+this._chartDef.getAttributeNS(null,"style");
};
IlvChart.prototype.getStylingEngineHint=function(){
return this._stylingEngineHint;
};
IlvChart.prototype.hasStylingEngineMarker=function(){
return (this._stylingEngineHint)?this._stylingEngineHint.getMarker!=undefined:false;
};
IlvChart.prototype.updateScales=function(_82){
var _83=this._axisArray.length;
var _84;
for(var i=0;i<_83;++i){
_84=this._scaleArray[i];
if(_84==null){
continue;
}
_84.setPlotRect(_82,false,true);
}
};
IlvChart.prototype.getDefaultColors=function(){
};
IlvChart.prototype.xClientToAreaCS=function(x){
return (x-this.getViewport().currentTranslate.x)/this.getViewport().currentScale;
};
IlvChart.prototype.yClientToAreaCS=function(y){
return (y-this.getViewport().currentTranslate.y)/this.getViewport().currentScale;
};
IlvChart.prototype.lockGlassPane=function(){
this._glassPane=DrawUtil.drawRect(this._chartDef.parentNode,"0%","0%","100%","100%");
this._glassPane.setAttributeNS(null,"visibility","hidden");
this._glassPane.setAttributeNS(null,"pointer-events","all");
};
IlvChart.prototype.releaseGlassPane=function(){
this._chartDef.parentNode.removeChild(this._glassPane);
};
IlvChart.prototype.getDisplayItem=function(x,y,_8a,_8b,_8c){
return IlvChart.getDisplayItem(x,y,_8a,_8b,_8c,this._renderers);
};
IlvChart.prototype.getNearestPoint=function(x,y,_8f){
return IlvChart.getNearestPoint(x,y,_8f,this._renderers);
};
IlvChart.getDisplayItem=function(x,y,_92,_93,_94,_95){
var dp=null;
var ds=_95[0].getChart().getDataSource().getDataSet(_92);
for(var i=_95.length-1;i>=0;i--){
var _99=_95[i];
if(_99.isViewable()){
if(_99.isDisplayingDataSet(ds)){
dp=_99.getDisplayItem(x,y,_92,_93,_94);
if(dp!=null){
break;
}
}
}
}
return dp;
};
IlvChart.getNearestPoint=function(x,y,_9c,_9d){
var _9e=null;
var dx;
var dy;
var _a1;
var _a2=Number.MAX_VALUE;
for(var i=_9d.length-1;i>=0;i--){
var _a4=_9d[i];
if(_a4.isViewable()){
var res=_a4.getNearestPoint(x,y,_9c);
if(res!=null){
dx=res.getXCoord()-x;
dy=res.getYCoord()-y;
_a1=dx*dx+dy*dy;
if(_a1<_a2){
_a2=_a1;
_9e=res;
}
}
}
}
return _9e;
};
IlvChart.prototype.getAllRenderers=function(){
var all=new Array();
for(var i=0;i<this._renderers.length;i++){
IlvChart.fillWithChildren(this._renderers[i],all);
}
return all;
};
IlvChart.fillWithChildren=function(_a8,_a9){
_a9.push(_a8);
if(_a8.getChildCount){
var _aa=_a8.getChildCount();
for(var i=0;i<_aa;i++){
IlvChart.fillWithChildren(_a8.getChild(i),_a9);
}
}
};
IlvChart.prototype.dispatchToInteractor=function(evt,i){
if(evt.charCode||evt.keyCode){
return i.handleEvent(evt);
}else{
var x=this.xClientToAreaCS(evt.clientX);
var y=this.yClientToAreaCS(evt.clientY);
if(i.isHandling(x,y)||i.isInOperation()){
return i.handleEvent(evt);
}
}
return false;
};
IlvChart.prototype.addInteractor=function(_b0){
this._inters.push(_b0);
_b0.setChart(this);
};
IlvChart.prototype.handleEvent=function(_b1){
if(_b1.type=="SVGResize"||_b1.type=="resize"){
this.handleResize();
return;
}
var _b2=this._activeChartInteractor;
if(_b2!=null){
this.dispatchToInteractor(_b1,_b2);
if(!_b2.isInOperation()){
this._activeChartInteractor=null;
}
_b1.preventDefault();
return;
}
this.dispatchInternal(_b1);
};
IlvChart.prototype.interactionStarted=function(_b3,evt){
for(var i=0;i<this._inters.length;++i){
var _b6=this._inters[i];
if(_b6!=_b3){
_b6.interactionStarted(_b3,evt);
}
}
};
IlvChart.prototype.dispatchInternal=function(evt){
for(var i=0;i<this._inters.length;++i){
var _b9=this._inters[i];
if(this.dispatchToInteractor(evt,_b9)){
if(evt.type=="mousedown"){
this._activeChartInteractor=_b9;
focus();
evt.preventDefault();
}
return true;
}
}
return false;
};
IlvChart.prototype.pushCursor=function(_ba){
var old=this._area.hasAttributeNS(null,"cursor")?this._area.getAttributeNS(null,"cursor"):null;
if(_ba==null){
return old;
}
if(!this._cursors){
this._cursors=new Array(old);
}else{
this._cursors.push(old);
}
this.getViewport().setAttributeNS(null,"cursor",_ba);
return old;
};
IlvChart.prototype.popCursor=function(){
if(!this._cursors||this._cursors.length==0){
return null;
}
var old=this.getViewport().hasAttributeNS(null,"cursor")?this.getViewport().getAttributeNS(null,"cursor"):null;
var _bd=this._cursors.pop();
if(_bd!=null){
this.getViewport().setAttributeNS(null,"cursor",_bd);
}else{
this.getViewport().setAttributeNS(null,"cursor","default");
}
return old;
};
IlvChart.prototype.getViewport=function(){
return document.documentElement;
};
IlvChart.getInnerWidth=function(_be){
var _bf=_be.indexOf("%");
if(_bf==-1){
return parseFloat(_be);
}else{
_be=parseFloat(_be.substring(0,_bf));
return innerWidth*_be/100;
}
};
IlvChart.getInnerHeight=function(_c0){
var _c1=_c0.indexOf("%");
if(_c1==-1){
return parseFloat(_c0);
}else{
_c0=parseFloat(_c0.substring(0,_c1));
return innerHeight*_c0/100;
}
};
IlvChart.prototype.handleResize=function(){
var _c2=this.getDrawRect().clone();
var _c3=IlvChart.getInnerWidth(this._chartDef.getAttributeNS(null,"width"));
var _c4=IlvChart.getInnerHeight(this._chartDef.getAttributeNS(null,"height"));
if(this._back){
this._back.setAttributeNS(null,"width",_c3);
this._back.setAttributeNS(null,"height",_c4);
}
this._rect.width=_c3;
this._rect.height=_c4;
this.updateLayout();
if(this._resizingPolicy){
var _c5=this.getDrawRect();
this.setAutoRedraw(false);
this.applyResizingPolicy(_c2,_c5);
this.setAutoRedraw(true);
this.invalidate();
}else{
this.updateAndRedraw(false);
}
};
IlvChart.prototype.applyResizingPolicy=function(_c6,_c7){
if(this.getType()!=IlvChart.CARTESIAN){
return;
}
var _c8=this._axisArray.length;
for(var i=0;i<_c8;++i){
var _ca=this._axisArray[i];
if(!_ca.isAutoVisibleRange()){
var _cb=this._resizingPolicy.call(this,_ca,_c6,_c7);
_ca.setVisibleRange(_cb.getMin(),_cb.getMax());
}
}
};
IlvChart.rangeResize=function(_cc,_cd,_ce){
if(this.getType()!=IlvChart.CARTESIAN){
return _cc.getVisibleRange();
}
var prj=this.getProjector();
var _d0=prj.computeVisibleRange(_cd,_ce,_cc);
if(_d0==null){
_d0=_cc.getVisibleRange();
}
return _d0;
};
function compareDrawables(a,b){
return a.getDrawOrder()-b.getDrawOrder();
}
