/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

IlvDataInterval.prototype.min;
IlvDataInterval.prototype.max;
function IlvDataInterval(_1,_2){
if(_1==undefined&&_2==undefined){
_1=1;
_2=-1;
}
this.min=_1;
this.max=_2;
}
IlvDataInterval.prototype.empty=function(){
this.min=1;
this.max=-1;
};
IlvDataInterval.prototype.isEmpty=function(){
return this.max<this.min;
};
IlvDataInterval.prototype.getMin=function(){
return this.min;
};
IlvDataInterval.prototype.getMax=function(){
return this.max;
};
IlvDataInterval.prototype.setMin=function(_3){
this.min=_3;
};
IlvDataInterval.prototype.setMax=function(_4){
this.max=_4;
};
IlvDataInterval.prototype.set=function(_5,_6){
this.min=_5;
this.max=_6;
};
IlvDataInterval.prototype.isBefore=function(_7){
return this.isEmpty()?false:_7<=this.min;
};
IlvDataInterval.prototype.isStrictlyBefore=function(_8){
return this.isEmpty()?false:_8<this.min;
};
IlvDataInterval.prototype.isAfter=function(_9){
return this.isEmpty()?false:_9>=this.max;
};
IlvDataInterval.prototype.isStrictlyAfter=function(_a){
return this.isEmpty()?false:_a>this.max;
};
IlvDataInterval.prototype.isInside=function(_b){
return this.isEmpty()?false:!(this.isStrictlyBefore(_b)||this.isStrictlyAfter(_b));
};
IlvDataInterval.prototype.isStrictlyInside=function(_c){
return this.isEmpty()?false:!(this.isBefore(_c)||isAfter(_c));
};
IlvDataInterval.prototype.isOutside=function(_d){
return this.isBefore(_d)||this.isAfter(_d);
};
IlvDataInterval.prototype.isStrictlyOutside=function(_e){
return this.isStrictlyBefore(_e)||this.isStrictlyAfter(_e);
};
IlvDataInterval.prototype.contains=function(_f){
return this.isInside(_f.getMin())&&this.isInside(_f.getMax());
};
IlvDataInterval.prototype.translate=function(_10){
this.min+=_10;
this.max+=_10;
};
IlvDataInterval.prototype.expand=function(_11){
if(!this.isEmpty()){
this.min-=_11;
this.max+=_11;
}
};
IlvDataInterval.prototype.intersects=function(itv){
return this.isEmpty()?false:!(this.isStrictlyBefore(itv.getMax())||this.isStrictlyAfter(itv.getMin()));
};
IlvDataInterval.prototype.addValue=function(val){
if(this.isEmpty()){
this.min=this.max=val;
return true;
}else{
if(this.isStrictlyBefore(val)){
this.setMin(val);
return true;
}else{
if(this.isStrictlyAfter(val)){
this.setMax(val);
return true;
}
}
}
return false;
};
IlvDataInterval.prototype.addInterval=function(itv){
if(itv.isEmpty()){
return false;
}else{
if(this.isEmpty()){
this.min=itv.getMin();
this.max=itv.getMax();
return true;
}else{
var res=this.addValue(itv.getMin());
return this.addValue(itv.getMax())||res;
}
}
};
IlvDataInterval.prototype.intersection=function(itv){
if(!itv.isEmpty()&&this.intersects(itv)){
if(itv.isStrictlyBefore(this.getMin())){
this.setMin(itv.getMin());
}
if(itv.isStrictlyAfter(this.getMax())){
this.setMax(itv.getMax());
}
}else{
this.empty();
}
};
IlvDataInterval.prototype.getLength=function(){
return this.isEmpty()?0:this.max-this.min;
};
IlvDataInterval.prototype.getMiddle=function(){
return this.isEmpty()?0:(this.max+this.min)/2;
};
IlvDataInterval.prototype.clamp=function(_17){
if(this.isEmpty()){
return _17;
}else{
return MathUtil.clamp(_17,this.min,this.max);
}
};
IlvDataInterval.prototype.clone=function(){
return new IlvDataInterval(this.min,this.max);
};
IlvDataInterval.prototype.equals=function(obj){
if(this==obj){
return true;
}
return (this.min==obj.min)&&(this.max==obj.max);
};
IlvDataInterval.prototype.toString=function(){
return this.isEmpty()?"[EMPTY]":("["+this.min+","+this.max+"]");
};
