/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Legend.NORTH=1;
Legend.WEST=2;
Legend.SOUTH=3;
Legend.EAST=4;
Legend.prototype._infoItems;
Legend.prototype._symbolSize;
Legend.prototype._symbolTextSpacing=4;
Legend.prototype._chart=null;
Legend.prototype._margin=5;
Legend.prototype._title;
Legend.prototype._position;
Legend.prototype._preferredSize={width:0,height:0};
function Legend(_1){
this._def=_1;
if(_1.hasAttributeNS(null,"symbolSize")){
var _2=_1.getAttributeNS(null,"symbolSize").split(",");
this._symbolSize={width:parseInt(_2[0]),height:parseInt(_2[1])};
}else{
this._symbolSize={width:21,height:15};
}
if(_1.hasAttributeNS(null,"fsymbolTextSpacing")){
this._symbolTextSpacing=parseInt(_1.getAttributeNS(null,"fsymbolTextSpacing"));
}
this._position=Legend.decodePosition(_1.getAttributeNS(null,"position"));
if(_1.hasAttributeNS(null,"title")){
this.setTitle(_1.getAttributeNS(null,"title"));
}
}
Legend.prototype.getPosition=function(){
return this._position;
};
Legend.prototype.getItemsStyleAttr=function(){
return this._def.getAttributeNS(null,"items-style");
};
Legend.prototype.getPreferredSize=function(){
return this._preferredSize;
};
Legend.prototype.computePreferredSize=function(){
var _3=this._margin;
var _4=this._margin;
var _5=0;
var _6=0;
if(this._title){
var _7=this._title.getBounds();
_4+=_7.height+2;
_5=_7.width;
_6=_7.height;
}
if(this._position==Legend.NORTH||this._position==Legend.SOUTH){
var _8=this._chart.getBounds().width;
if(this._infoItems.length==0){
return {width:_8,height:_6};
}
var _9=0;
var _a;
var _b=_4;
var x=_3;
var _d=this._infoItems[_9];
var w=_d.getPreferredSize().width;
if(x+w>_8){
_8=x+w;
}
while(_9<this._infoItems.length){
_a=0;
while(x+w<=_8&&_9<this._infoItems.length){
_d.x=x+0.5;
_d.y=_b+0.5;
_d.width=w;
_d.height=_d.getPreferredSize().height;
x+=w+2*this._margin;
_a=Math.max(_a,_d.height);
_d=this._infoItems[++_9];
if(_d){
w=_d.getPreferredSize().width;
}
}
x=_3;
_b+=_a+this._margin;
}
return {width:_8,height:_b+(this._title?2:0)};
}
if(this._position==Legend.WEST||this._position==Legend.EAST){
var _f=this._chart.getBounds().height;
if(this._infoItems.length==0){
return {width:_5,height:_f};
}
var _9=0;
var _10;
var _11=_3;
var y=_4;
var _d=this._infoItems[_9];
var h=_d.getPreferredSize().height;
if(y+h+(this._title?2:0)>_f){
_f=y+h+(this._title?2:0);
}
while(_9<this._infoItems.length){
_10=0;
while(y+h+(this._title?2:0)<=_f&&_9<this._infoItems.length){
_d.x=_11;
_d.y=y;
_d.width=_d.getPreferredSize().width;
_d.height=h;
y+=h+2*this._margin;
_10=Math.max(_10,_d.width);
_d=this._infoItems[++_9];
if(_d){
h=_d.getPreferredSize().height;
}
}
y=_4;
_11+=_10+this._margin;
}
return {width:Math.max(_11,_5),height:_f};
}
return {width:0,height:0};
};
Legend.prototype.setTitle=function(_14){
this._title=new TextRenderer(_14);
this._title.setStyleAttr(this.getItemsStyleAttr());
};
Legend.prototype.getSymbolSize=function(){
return this._symbolSize;
};
Legend.prototype.getSymbolTextSpacing=function(){
return this._symbolTextSpacing;
};
Legend.prototype.setSymbolTextSpacing=function(_15){
if(_15!=this._symbolTextSpacing){
this._symbolTextSpacing=_15;
this.revalidate();
}
};
Legend.prototype.setChart=function(_16){
var _17=this._chart;
if(_16!=_17){
this._chart=_16;
this._g=DrawUtil.createContainer(_16._area.ownerDocument);
this._g.setAttributeNS(null,"class","legend");
this._content=DrawUtil.createContainer(_16._area.ownerDocument);
this._g.appendChild(this._content);
_16._area.parentNode.appendChild(this._g);
this.chartConnected(_17,_16);
}
};
Legend.prototype.chartConnected=function(_18,_19){
if(_19!=null){
this.recomputeItems();
}
};
Legend.prototype.getChart=function(){
return this._chart;
};
Legend.prototype.draw=function(){
if(this.x!=0||this.y!=0){
this._g.setAttributeNS(null,"transform","translate("+this.x+","+this.y+")");
}else{
if(this._g.hasAttributeNS(null,"transform")){
this._g.removeAttributeNS(null,"transform");
}
}
if(this._def.getAttributeNS(null,"opaque")!="false"){
if(!this._back){
var _1a="fill:lightGray;";
if(this._def.hasAttributeNS(null,"style")){
_1a=_1a+this._def.getAttributeNS(null,"style");
}
this._back=Style.drawRect(Style.create(_1a),this._g,0,0,0,0);
this._back.setAttributeNS(null,"class","background");
this._g.insertBefore(this._back,this._content);
}
var _1b=this.getPreferredSize();
this._back.setAttributeNS(null,"width",_1b.width);
this._back.setAttributeNS(null,"height",_1b.height);
}
if(this._title){
var _1c=this._title.getBounds();
var _1b=this.getPreferredSize();
_1c=this._title.getBounds(true,_1c.width/2+6+2,_1c.height/2+2,_1c);
var d="M"+2.5+" "+(2+_1c.height/2)+"v"+(_1b.height-6-(2.5+_1c.height/2))+"a8 8 0 0 0 4 4h"+(_1b.width-6-6+0.5)+"a8 8 0 0 0 4 -4v"+-(_1b.height-6-(2.5+_1c.height/2))+"a8 8 0 0 0 -4 -4h"+-(_1b.width-6-_1c.width-4-5)+"m"+(-_1c.width-3.5)+" 0a8 8 0 0 0-4 4";
var _1a="stroke:black;"+this.getItemsStyleAttr().replace(/fill/g,"stroke")+";fill:none";
var _1e=Style.drawPath(Style.create(_1a),this._content,d);
this._title.draw(this._content,_1c.width/2+7,_1c.height/2);
}
this.drawItems(this._content);
};
Legend.prototype.drawItems=function(g){
for(var i=0;i<this._infoItems.length;i++){
this._infoItems[i].draw(g);
}
};
Legend.prototype.recomputeItems=function(){
if(this.getChart()==null){
return;
}
this._infoItems=new Array();
while(this._content.hasChildNodes()){
this._content.removeChild(this._content.firstChild);
}
var _21=this.getChart().getRendererCount();
for(var i=0;i<_21;i++){
var d=this.getChart().getRenderer(i);
var _24=d.createLegendItems();
if(_24!=null){
for(var j=0;j<_24.length;j++){
this._infoItems.push(_24[j]);
_24[j].setLegend(this);
}
}
}
var r=this.updateLayout();
this.draw();
return r;
};
Legend.prototype.updateLayout=function(){
var _27={width:this._preferredSize.width,height:this._preferredSize.height};
this._preferredSize=this.computePreferredSize();
if(this._preferredSize.width!=_27.width||this._preferredSize.height!=_27.height){
this.getChart().updateLayout();
return true;
}
return false;
};
Legend.decodePosition=function(_28){
if(_28){
if(_28.indexOf("West")!=-1){
return Legend.WEST;
}else{
if(_28.indexOf("South")!=-1){
return Legend.SOUTH;
}else{
if(_28=="East"){
return Legend.EAST;
}
}
}
}
return Legend.NORTH;
};
