/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

LegendItem.prototype._legend;
LegendItem.prototype._textRenderer;
LegendItem.prototype._render;
function LegendItem(_1,_2){
if(_2){
this._renderer=_1;
var _3=_1.getLegendText(this);
if(_3){
this._textRenderer=new TextRenderer(_3);
}
}
}
LegendItem.prototype.setLegend=function(_4){
this._legend=_4;
if(this._textRenderer){
this._textRenderer.setStyleAttr(this._legend.getItemsStyleAttr());
}
};
LegendItem.prototype.getSymbolBounds=function(){
if(this._legend==null){
return new Rectangle();
}
var r=new Rectangle();
var _6=this._legend.getSymbolSize();
r.x=0;
r.y=(this.height-_6.height)/2;
r.width=_6.width;
r.height=_6.height;
return r;
};
LegendItem.prototype.draw=function(g){
if(this._legend==null){
return;
}
var _8=DrawUtil.createContainer(g.ownerDocument);
_8.setAttributeNS(null,"transform","translate("+this.x+","+this.y+")");
this.drawSymbol(_8);
this.drawText(_8);
g.appendChild(_8);
};
LegendItem.prototype.drawSymbol=function(g){
if(this._renderer!=null){
var r=this.getSymbolBounds();
this._renderer.drawLegendSymbol(this,g,r.x,r.y,r.width-1,r.height-1);
}
};
LegendItem.prototype.drawText=function(g){
if(!this._textRenderer){
return;
}
var r=this.getSymbolBounds();
var _d=this._textRenderer.getBounds(true);
r.x+=this._legend.getSymbolSize().width+this._legend.getSymbolTextSpacing()+_d.width/2;
r.y+=this._legend.getSymbolSize().height/2;
this._textRenderer.draw(g,r.x,r.y);
};
LegendItem.prototype.getPreferredSize=function(){
if(!this._legend){
return {width:0,height:0};
}
var _e=this._textRenderer?this._textRenderer.getBounds(true):{width:0,height:0};
_e.width+=this._legend.getSymbolSize().width+this._legend.getSymbolTextSpacing();
_e.height=Math.max(this._legend.getSymbolSize().height,_e.height);
return _e;
};
