/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

PolarProjector.prototype=new AbstractProjector();
PolarProjector.prototype._startingAngle=0;
PolarProjector.prototype._range=360;
PolarProjector.prototype._symmetric=true;
function PolarProjector(){
}
PolarProjector.prototype.setSymmetric=function(b){
this._symmetric=b;
};
PolarProjector.prototype.isSymmetric=function(){
return this._symmetric;
};
PolarProjector.prototype.getStartingAngle=function(){
return this._startingAngle;
};
PolarProjector.prototype.setStartingAngle=function(_2){
this._startingAngle=_2;
};
PolarProjector.prototype.getRange=function(){
return this._range;
};
PolarProjector.prototype.setRange=function(_3){
this._range=(_3>360||_3<-360)?MathUtil.mod360(_3):_3;
};
PolarProjector.prototype.toCartesian=function(_4,_5){
var _6=_4.count;
var _7=_4.getXValues();
var _8=_4.getYValues();
var _9;
var _a;
var _b=(_5.x+_5.width/2);
var _c=(_5.y+_5.height/2);
for(var i=0;i<_6;++i){
_a=_8[i];
_9=MathUtil.toRadians(_7[i]+this._startingAngle);
_7[i]=_b+_a*Math.cos(_9);
_8[i]=_c-_a*Math.sin(_9);
}
};
PolarProjector.prototype.toPolar=function(_e,_f){
var _10=_e.count;
var _11=_e.getXValues();
var _12=_e.getYValues();
var dx;
var dy;
var _15=(_f.x+_f.width/2);
var _16=(_f.y+_f.height/2);
for(var i=0;i<_10;++i){
dx=_11[i]-_15;
dy=-_12[i]+_16;
_11[i]=MathUtil.toDegrees(Math.atan2(dy,dx))-this._startingAngle;
if(_11[i]<0){
_11[i]+=360;
}
_12[i]=Math.sqrt(dx*dx+dy*dy);
}
};
PolarProjector.prototype.toDisplay=function(pts,_19,_1a){
AbstractProjector.prototype.toDisplay.call(this,pts,_19,_1a);
this.toCartesian(pts,_19);
};
PolarProjector.prototype.toData=function(pts,_1c,_1d){
this.toPolar(pts,_1c);
AbstractProjector.prototype.toData.call(this,pts,_1c,_1d);
};
PolarProjector.prototype.shiftAlongAxis=function(_1e,_1f,p,_21){
if(_21==0){
return;
}
var _22=_1e.x+_1e.width/2;
var _23=_1e.y+_1e.height/2;
if(_1f.isXAxis()){
if(_1f.isReversed()){
_21=-_21;
}
var dx=p.x-_22;
var dy=-p.y+_23;
var _26=Math.sqrt(dx*dx+dy*dy);
if(_26>1){
var _27=_21/_26+Math.atan2(dy,dx);
p.x=(_22+_26*Math.cos(_27));
p.y=(_23-_26*Math.sin(_27));
}
}else{
var dx=p.x-_22;
var dy=p.y-_23;
_26=Math.sqrt(dx*dx+dy*dy);
if(_26>1){
_26=_21/_26;
p.x+=dx*_26;
p.y+=dy*_26;
}
}
};
PolarProjector.prototype.getOrigin=function(_28,_29){
_29.x=_28.x+_28.width/2;
_29.y=_28.y+_28.height/2;
};
PolarProjector.prototype.computeMinMaxPos=function(_2a,_2b,pos){
if(_2b.isXAxis()){
pos.min=0;
pos.max=this._range;
}else{
var dim=Math.min(_2a.width,_2a.height);
if(this._symmetric){
pos.max=(dim/2)-1;
pos.min=-pos.max;
}else{
pos.max=(dim/2)-1;
pos.min=0;
}
}
};
PolarProjector.prototype.computeCoeff=function(_2e,_2f,_30,_31){
var _32=_2f.getTVisibleRange();
var len=_32.getLength();
if(MathUtil.isNear0(len)){
_31.scaling=0;
_31.constant=_30.min;
}else{
if(this.isSymmetric()&&!_2f.isXAxis()){
_32.setMax(Math.max(Math.abs(_32.getMin()),Math.abs(_32.getMax())));
_32.setMin(-_32.getMax());
len=2*_32.getMax();
}
_31.scaling=(_30.max-_30.min)/len;
_31.constant=-_32.getMin()*_31.scaling+_30.min;
}
};
PolarProjector.prototype.computeInvCoeff=function(_34,_35,_36,_37){
var _38=_35.getTVisibleRange();
var len=_36.max-_36.min;
if(MathUtil.isNear0(len)){
_37.scaling=0;
_37.constant=_38.getMin();
}else{
if(this.isSymmetric()&&!_35.isXAxis()){
_38.setMax(Math.max(Math.abs(_38.getMin()),Math.abs(_38.getMax())));
_38.setMin(-_38.getMax());
}
_37.scaling=_38.getLength()/(_36.max-_36.min);
_37.constant=_38.getMin()-_36.min*_37.scaling;
}
};
PolarProjector.prototype.toDataWindow=function(_3a,_3b,_3c){
var _3d=new IlvDataWindow();
var _3e=false;
_3d.yRange.set(_3c.getYAxis().getVisibleMin(),_3c.getYAxis().getVisibleMax());
if(this.isSymmetric()){
_3d.xRange.set(_3c.getXAxis().getVisibleMin(),_3c.getXAxis().getVisibleMax());
return _3d;
}
var _3f=new DoublePoint();
this.getOrigin(_3b,_3f);
if(_3a.contains(_3f.x,_3f.y)){
_3e=true;
}
var _40=new DoublePoints(4);
_40.addValues(_3a.x,_3a.y);
_40.addValues(_3a.x+_3a.width,_3a.y);
_40.addValues(_3a.x+_3a.width,_3a.y+_3a.height);
_40.addValues(_3a.x,_3a.y+_3a.height);
this.toPolar(_40,_3b);
var min=Math.min(Math.min(_40.getX(0),_40.getX(1)),Math.min(_40.getX(2),_40.getX(3)));
var max=Math.max(Math.max(_40.getX(0),_40.getX(1)),Math.max(_40.getX(2),_40.getX(3)));
var _43=false;
if(max-min>180){
_43=true;
}
AbstractProjector.prototype.toData.call(this,_40,_3b,_3c);
min=Math.min(Math.min(_40.getX(0),_40.getX(1)),Math.min(_40.getX(2),_40.getX(3)));
max=Math.max(Math.max(_40.getX(0),_40.getX(1)),Math.max(_40.getX(2),_40.getX(3)));
if(_3e||_43){
_3d.xRange.set(_3c.getXAxis().getVisibleMin(),_3c.getXAxis().getVisibleMax());
}else{
_3d.xRange.set(min,max);
}
return _3d;
};
PolarProjector.prototype.getAxisLength=function(_44,_45){
if(_45.isXAxis()){
return Math.min(_44.width,_44.height)*360/this._range;
}else{
return Math.min(_44.width,_44.height)/2;
}
};
PolarProjector.prototype.getShape=function(_46,_47,_48){
if(_47.width<=0||_47.height<=0){
return new Rectangle(0,0,0,0);
}
var _49=new DoublePoints(2);
_49.addValues(_46.getXMin(),_46.getYMin());
_49.addValues(_46.getXMax(),_46.getYMax());
AbstractProjector.prototype.toDisplay.call(this,_49,_47,_48);
_49.setX(0,_49.getX(0)+this._startingAngle);
_49.setX(1,_49.getX(1)+this._startingAngle);
if(this.isSymmetric()){
_49.setY(0,0);
}
var _4a=new Path();
var _4b=new DoublePoint();
this.getOrigin(_47,_4b);
var _4c=_49.getX(0);
var _4d=_49.getX(1)-_49.getX(0);
_4a.addArc(_4b.x,_4b.y,_49.getY(1),_4c,_4d,false);
if(_49.getY(0)!=0){
_4c=_49.getX(1);
_4a.addArc(_4b.x,_4b.y,_49.getY(0),_4c,-_4d,true);
}else{
_4a.addLineTo(_4b.x,_4b.y);
}
_4a.closePath();
return _4a;
};
PolarProjector.prototype.getAngleDeg=function(_4e,_4f,_50){
var pts=new DoublePoints(_4e,_50.getYAxis().getVisibleMax());
AbstractProjector.prototype.toDisplay.call(this,pts,_4f,_50);
return pts.getX(0)+this._startingAngle;
};
PolarProjector.prototype.getShapeFromValue=function(_52,_53,_54,_55){
if(_54.width<=0||_54.height<=0){
return new Rectangle(0,0,0,0);
}
if(_53==IlvAxis.Y_AXIS||!this.isSymmetric()){
return PolarProjector.prototype.getShape.call(this,_52,_53,_54,_55);
}else{
var _56=_55.getYAxis().getVisibleRange();
_56.setMin(0);
return this.getShape(_52,_56,_53,_54,_55);
}
};
PolarProjector.prototype.getShapeFromValueImpl=function(_57,_58,_59,_5a,_5b){
if(_5a.width<=0||_5a.height<=0){
return new Rectangle(0,0,0,0);
}
var pts=new DoublePoints(2);
if(_59==IlvAxis.Y_AXIS){
pts.addValues(_58.getMin(),_57);
pts.addValues(_58.getMax(),_57);
AbstractProjector.prototype.toDisplay.call(this,pts,_5a,_5b);
pts.setX(0,pts.getX(0)+_startingAngle);
pts.setX(1,pts.getX(1)+_startingAngle);
var _5d=new DoublePoint();
this.getOrigin(_5a,_5d);
var _5e=pts.getX(0);
var _5f=pts.getX(1)-pts.getX(0);
var _60=new Path();
_60.addArc(_5d.x,_5d.y,pts.getY(1),_5e,_5f,false);
return _60;
}else{
pts.addValues(_57,_58.getMin());
pts.addValues(_57,_58.getMax());
this.toDisplay(pts,_5a,_5b);
}
};
