/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

RectangularScaleConfiguration.prototype=new ScaleConfiguration();
RectangularScaleConfiguration.prototype._scaleExt;
RectangularScaleConfiguration.prototype._scaleAngle;
RectangularScaleConfiguration.prototype._xOffset;
RectangularScaleConfiguration.prototype._yOffset;
function RectangularScaleConfiguration(){
}
RectangularScaleConfiguration.prototype.getAxisBounds=function(_1){
var _2=this.getScaleExt();
var x=_2.getX(0);
var y=_2.getY(0);
var b=_1;
if(!b){
b=new Rectangle(x,y,1,1);
}else{
b.x=x;
b.y=y;
b.width=1;
b.height=1;
}
b.add(_2.getX(1),_2.getY(1));
return b;
};
RectangularScaleConfiguration.prototype.getMaxStepCount=function(_6,_7,_8){
var _9=this.getScaleAngle();
_9+=this.scale.getLabelRotation();
_9=MathUtil.toRadians(_9);
var _a=Math.sin(_9);
var _b=Math.cos(_9);
var _c=this.getScaleLength();
var _d=Math.abs(_6*_b)+Math.abs(_7*_a)+_8;
return Math.max(Math.round(_c/_d)+1,2);
};
RectangularScaleConfiguration.prototype.draw=function(_e){
if(this.isTranslated()){
_e=DrawUtil.createContainer(_e.ownerDocument);
_e.setAttributeNS(null,"transform","translate("+this._xOffset+","+this._yOffset+")");
}
ScaleConfiguration.prototype.draw.call(this,_e);
};
RectangularScaleConfiguration.prototype.validateBounds=function(_f){
ScaleConfiguration.prototype.validateBounds.call(this,_f);
};
RectangularScaleConfiguration.prototype.getAxisTitleOffset=function(){
var _10=this.scale.getInternalTitle().getPlacement();
if(_10==100||_10==0){
return this.scale.getTitleOffset();
}else{
var _11=this.scale.getTitleOffset()+this.scale.getAxisLabelOffset();
if(this.scale.isLabelVisible()){
_11+=this.isHorizontal()?this.scale.getSteps().getMaxHeight():this.scale.getSteps().getMaxWidth();
}
return _11;
}
};
RectangularScaleConfiguration.prototype.getTickAngle=function(v){
if(this.isCartesian()){
return this.getCartesianTickAngle();
}else{
return this._scaleAngle+90;
}
};
RectangularScaleConfiguration.prototype.getCartesianTickAngle=function(){
var _13=this.scale.getProjector().getAxisAngle(this.scale.getDualAxis());
return (this.scale.getCrossing()==Axis.MAX_VALUE)?_13:_13+180;
};
RectangularScaleConfiguration.prototype.getScaleLength=function(){
if(this.isCartesian()){
return this.scale.getProjector().getAxisLength(this.scale.getPlotRect(),this.scale.getAxis());
}
};
RectangularScaleConfiguration.prototype.recalc=function(dst){
this.updateScaleGeometry();
return ScaleConfiguration.prototype.recalc.call(this,dst);
};
RectangularScaleConfiguration.prototype.getDefaultCrossing=function(){
return Axis.MIN_VALUE;
};
RectangularScaleConfiguration.prototype.isCartesian=function(){
return true;
};
RectangularScaleConfiguration.prototype.drawAxis=function(dst){
var ext=this.getScaleExt();
Style.drawLine(this.scale.getAxisStyle(),dst,ext.getX(0),ext.getY(0),ext.getX(1),ext.getY(1));
};
RectangularScaleConfiguration.prototype.updateScaleGeometry=function(){
var ext=new Array(this.scale.getAxis().getVisibleMin(),this.scale.getAxis().getVisibleMax());
this._scaleExt=this.scale.getPointsOnAxis(ext,2);
this._scaleAngle=GraphicUtil.pointAngleDeg(this._scaleExt.getX(0),this._scaleExt.getY(0),this._scaleExt.getX(1),this._scaleExt.getY(1));
};
RectangularScaleConfiguration.prototype.getScaleAngle=function(){
return this._scaleAngle;
};
RectangularScaleConfiguration.prototype.isHorizontal=function(){
return this._scaleAngle==0||this._scaleAngle==180;
};
RectangularScaleConfiguration.prototype.isVertical=function(){
return this._scaleAngle==90||this._scaleAngle==270;
};
RectangularScaleConfiguration.prototype.getScaleExt=function(){
return this._scaleExt;
};
RectangularScaleConfiguration.prototype.isTranslated=function(){
return false;
};
RectangularScaleConfiguration.prototype.computeTitleLocation=function(loc){
var ext;
var _1a=this.scale.getInternalTitle().getPlacement();
var _1b;
if(this.scale.getAxis().getVisibleRange().getLength()==0||this.scale.getDualAxis().getVisibleRange().getLength()==0){
var r=this.scale.getPlotRect();
ext=new DoublePoints(2);
if((this.scale.getAxis().isXAxis()&&!this.scale.getChart().isProjectorReversed())||(this.scale.getAxis().isYAxis()&&this.scale.getChart().isProjectorReversed())){
ext.addValues(r.x,r.y+r.height);
ext.addValues(r.x+r.width,r.y+r.height);
_1b=0;
}else{
ext.addValues(r.x,r.y+r.height);
ext.addValues(r.x,r.y);
_1b=90;
}
}else{
ext=this.getScaleExt();
_1b=this.getScaleAngle();
}
var _1d;
if(_1a==100){
loc.x=ext.getX(1);
loc.y=ext.getY(1);
_1d=_1b;
}else{
if(_1a==0){
loc.x=ext.getX(0);
loc.y=ext.getY(0);
_1d=_1b+180;
}else{
loc.x=ext.getX(0)+(ext.getX(1)-ext.getX(0))*_1a/100;
loc.y=ext.getY(0)+(ext.getY(1)-ext.getY(0))*_1a/100;
_1d=this.getTickAngle(0);
}
}
var _1e=this.scale.getInternalTitle().getBounds();
GraphicUtil.computeTextLocation(loc,_1d,this.getAxisTitleOffset(),_1e.width,_1e.height);
};
