/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Scale.TICK_INSIDE=1;
Scale.TICK_OUTSIDE=2;
Scale.TICK_CROSS=3;
Scale.CONSTANT=1;
Scale.ADAPTIVE=2;
Scale.RECTANGULAR=1;
Scale.VISIBLE_FLAG=1;
Scale.SKIPLABEL_FLAG=2;
Scale.MAJ_VISIBLE_FLAG=4;
Scale.MIN_VISIBLE_FLAG=8;
Scale.AXIS_VISIBLE_FLAG=16;
Scale.LAB_VISIBLE_FLAG=32;
Scale.MIDLABEL_FLAG=128;
Scale.BOUNDS_VALID=1024;
Scale.CATEGORY_FLAG=2048;
Scale.DEFAULT_FLAG=Scale.VISIBLE_FLAG|Scale.AXIS_VISIBLE_FLAG|Scale.MAJ_VISIBLE_FLAG|Scale.MIN_VISIBLE_FLAG|Scale.LAB_VISIBLE_FLAG|Scale.SKIPLABEL_FLAG;
Scale.prototype._flags;
Scale.prototype._drawOrder=Number.MAX_VALUE;
Scale.prototype._majorTickSize=6;
Scale.prototype._minorTickSize=3;
Scale.prototype._labelOffset=3;
Scale.prototype._titleOffset=3;
Scale.prototype._tickLayout=Scale.TICK_OUTSIDE;
Scale.prototype._skipMode=Scale.CONSTANT;
Scale.prototype._labelRotation=0;
Scale.prototype._axisIdx;
Scale.prototype._chart;
Scale.prototype._axisListener;
Scale.prototype._crossing;
Scale.prototype._plotRect;
Scale.prototype._bounds;
Scale.prototype._steps;
Scale.prototype._stepsDefinition;
Scale.prototype._axisStyle;
Scale.prototype._config;
Scale.prototype._title;
Scale.prototype._def;
function Scale(_1){
this._def=_1;
this._flags=new Flags(Scale.DEFAULT_FLAG);
if(this._def.hasAttributeNS(null,"crossingValue")){
this.setCrossingValue(parseFloat(this._def.getAttributeNS(null,"crossingValue")));
}
if(this._def.hasAttributeNS(null,"drawOrder")){
this._drawOrder=parseInt(this._def.getAttributeNS(null,"drawOrder"));
}
if(this._def.hasAttributeNS(null,"style")){
this._style=this._def.getAttributeNS(null,"style");
}
if(this._def.hasAttributeNS(null,"majorTickSize")){
this._majorTickSize=parseInt(this._def.getAttributeNS(null,"majorTickSize"));
}
if(this._def.getAttributeNS(null,"majorTickVisible")=="false"){
this._flags.setFlag(Scale.MAJ_VISIBLE_FLAG,false);
}
if(this._def.hasAttributeNS(null,"minorTickSize")){
this._majorTickSize=parseInt(this._def.getAttributeNS(null,"minorTickSize"));
}
if(this._def.getAttributeNS(null,"minorTickVisible")=="false"){
this._flags.setFlag(Scale.MIN_VISIBLE_FLAG,false);
}
if(this._def.hasAttributeNS(null,"tickLayout")){
this._tickLayout=Scale[this._def.getAttributeNS(null,"tickLayout")];
}
if(this._def.hasAttributeNS(null,"title")){
this.setTitle(this._def.getAttributeNS(null,"title"));
}
if(this._def.hasAttributeNS(null,"titleOffset")){
this._titleOffset=parseInt(this._def.getAttributeNS(null,"titleOffset"));
}
if(this._def.hasAttributeNS(null,"titlePlacement")){
this.setTitlePlacement(parseInt(this._def.getAttributeNS(null,"titlePlacement")));
}
if(this._def.hasAttributeNS(null,"titleRotation")){
this.setTitleRotation(parseFloat(this._def.getAttributeNS(null,"titleRotation")));
}
if(this._def.getAttributeNS(null,"visible")=="false"){
this._flags.setFlag(Scale.VISIBLE_FLAG,false);
}
var _2=this._def.getElementsByTagNameNS(CHART_NS,"defaultSteps").item(0);
var _3=null;
if(_2){
_3=new DefaultStepsDefinition();
if(_2.hasAttributeNS(null,"stepUnit")){
_3.setStepUnit(parseFloat(_2.getAttributeNS(null,"stepUnit")));
}else{
if(_2.getAttributeNS(null,"autoStepUnit")=="false"){
_3.setAutoStepUnit(false);
}
}
if(_2.hasAttributeNS(null,"subStepUnit")){
_3.setStepUnit(parseFloat(_2.getAttributeNS(null,"subStepUnit")));
}else{
if(_2.getAttributeNS(null,"autoSubStepUnit")=="false"){
_3.setAutoSubStepUnit(false);
}
}
}else{
_2=this._def.getElementsByTagNameNS(CHART_NS,"timeSteps").item(0);
if(_2){
_3=new TimeStepsDefinition();
if(_2.hasAttributeNS(null,"unit")){
_3.setUnit(TimeUnit[_2.getAttributeNS(null,"unit")]);
}else{
if(_2.getAttributeNS(null,"autoUnit")=="false"){
_3.setAutoUnit(false);
}
}
}else{
_2=this._def.getElementsByTagNameNS(CHART_NS,"categorySteps").item(0);
if(_2){
_3=new CategoryStepsDefinition(_2.getAttributeNS(null,"stepBetweenCategory")=="true");
}
}
}
if(_3){
this.setStepsDefinition(_3);
}else{
this.setStepUnit();
}
var _4=this._def.getElementsByTagNameNS(CHART_NS,"labels").item(0);
if(_4){
if(_4.hasAttributeNS(null,"style")){
this._labelsStyle=_4.getAttributeNS(null,"style");
}
if(_4.hasAttributeNS(null,"offset")){
this._labelOffset=parseInt(_4.getAttributeNS(null,"offset"));
}
if(_4.hasAttributeNS(null,"rotation")){
this._labelRotation=parseFloat(_4.getAttributeNS(null,"rotation"));
}
if(_4.getAttributeNS(null,"visible")=="false"){
this._flags.setFlag(Scale.LAB_VISIBLE_FLAG,false);
}
if(_4.hasAttributeNS(null,"skipMode")){
this._skipMode=Scale[_4.getAttributeNS(null,"skipMode")];
}
if(_4.getAttributeNS(null,"skipping")=="false"){
this._flags.setFlag(Scale.SKIPLABEL_FLAG,false);
}
}
this._plotRect=new Rectangle(0,0,-1,-1);
this._bounds=new Rectangle();
}
Scale.prototype.getConfig=function(){
return this._config;
};
Scale.prototype.setConfiguration=function(_5){
if(this._config){
this._config.setScale(null);
}
this._config=_5;
if(this._def.getAttributeNS(null,"autoCrossing")=="false"){
this.setAutoCrossing(false);
}
if(_5!=null){
_5.setScale(this);
}
this.getSteps().invalidateValues();
};
Scale.prototype.getAxisStyle=function(){
if(this._axisStyle==null){
this._axisStyle=Style.create(this.getStyleAttr());
this._axisStyle["shape-rendering"]="optimizeSpeed";
if(!this._axisStyle["stroke"]){
this._axisStyle["stroke"]="black";
}
}
return this._axisStyle;
};
Scale.prototype.getStyleAttr=function(){
if(!this._style&&this.getChart()!=null){
return this.getChart().getAreaStyleAttr();
}else{
return this._style;
}
};
Scale.prototype.getLabelsStyleAttr=function(){
if(!this._labelsStyle){
this._labelsStyle=this.getStyleAttr();
if(this._labelsStyle){
this._labelsStyle=this._labelsStyle.replace(/fill[^;]*;?/g,"");
this._labelsStyle=this._labelsStyle.replace("stroke:","fill:");
this._labelsStyle=this._labelsStyle.replace("stroke-opacity:","fill-opacity:");
}
}
return this._labelsStyle;
};
Scale.prototype.getDrawOrder=function(){
return this._drawOrder;
};
Scale.prototype.getMajorTickSize=function(){
return this._majorTickSize;
};
Scale.prototype.getMinorTickSize=function(){
return this._minorTickSize;
};
Scale.prototype.getTickLayout=function(){
return this._tickLayout;
};
Scale.prototype.getLabelOffset=function(){
return this._labelOffset;
};
Scale.prototype.getTitleOffset=function(){
return this._titleOffset;
};
Scale.prototype._getTitle=function(){
if(this._title==null){
this._title=new Title(this,null,0);
}
return this._title;
};
Scale.prototype.getTitleRotation=function(){
return this._getTitle().getLabelRenderer().getRotation();
};
Scale.prototype.setTitleRotation=function(_6){
if(window.Title){
this._getTitle().getLabelRenderer().setRotation(_6);
}
};
Scale.prototype.updateTitleRotation=function(_7,_8){
var _9;
if(_7){
_9=this.getAxis().isXAxis()?0:-90;
if(this.getChart()!=null&&this.getChart().isProjectorReversed()){
_9=(_9==0)?-90:0;
}
this._getTitle().getLabelRenderer().setRotation(_9);
}
if(_8){
this.revalidateChartLayout();
}
};
Scale.prototype.getTitle=function(){
return this._getTitle().getText();
};
Scale.prototype.setTitle=function(_a,_b){
this._getTitle().setText(_a);
if(_b){
this._getTitle().getLabelRenderer().setRotation(_b);
}
this.revalidateChartLayout();
};
Scale.prototype.getTitleRenderer=function(){
return this._getTitle().getLabelRenderer();
};
Scale.prototype.getTitlePlacement=function(){
return this._getTitle().getPlacement();
};
Scale.prototype.setTitlePlacement=function(_c){
if(window.Title){
this._getTitle().setPlacement(_c);
}
};
Scale.prototype.getInternalTitle=function(){
return this._title;
};
Scale.prototype.isViewable=function(){
var _d=this.getDualAxis();
if(_d==null){
return false;
}
var _e=_d.getVisibleRange();
return this.isVisible()&&(this.getAxis()!=null)&&(!this.isAnchored()||_e.isInside(this.getCrossingValue()));
};
Scale.prototype.getLabelRotation=function(){
return this._labelRotation;
};
Scale.prototype.isSkippingLabel=function(){
return this._flags.getFlag(Scale.SKIPLABEL_FLAG);
};
Scale.prototype.getSkipLabelMode=function(){
return this._skipMode;
};
Scale.prototype.setCategoryFlag=function(_f){
this._flags.setFlag(Scale.CATEGORY_FLAG,_f);
};
Scale.prototype.isBetweenCategory=function(){
return this.isCategory()&&this.getStepsDefinition().isStepBetweenCategory();
};
Scale.prototype.isVisible=function(){
return this._flags.getFlag(Scale.VISIBLE_FLAG);
};
Scale.prototype.isAxisVisible=function(){
return this._flags.getFlag(Scale.AXIS_VISIBLE_FLAG);
};
Scale.prototype.isMajorTickVisible=function(){
return this._flags.getFlag(Scale.MAJ_VISIBLE_FLAG);
};
Scale.prototype.isMinorTickVisible=function(){
return this._flags.getFlag(Scale.MIN_VISIBLE_FLAG);
};
Scale.prototype.isLabelVisible=function(){
return this._flags.getFlag(Scale.LAB_VISIBLE_FLAG);
};
Scale.prototype.isMiddleLabel=function(){
return this._flags.getFlag(Scale.MIDLABEL_FLAG);
};
Scale.prototype.setCrossingValue=function(_10){
this.setCrossing(new AnchoredCrossing(_10));
};
Scale.prototype.setCrossing=function(_11){
this._crossing=_11;
if(this.getSteps()){
this.getSteps().invalidatePoints();
}
this.revalidateChartLayout();
};
Scale.prototype.setAutoCrossing=function(_12){
if(_12){
this.setCrossing(null);
}else{
this.setCrossing(this.getCrossing());
}
};
Scale.prototype.isAutoCrossing=function(){
return (this._crossing==null);
};
Scale.prototype.getCrossingValue=function(){
return this.getCrossing().getValue(this.getDualAxis());
};
Scale.prototype.getCrossing=function(){
return (this._crossing==null)?this.getDefaultCrossing():this._crossing;
};
Scale.prototype.getDefaultCrossing=function(){
return this.getConfig().getDefaultCrossing();
};
Scale.prototype.getStepsDefinition=function(){
return this._stepsDefinition;
};
Scale.prototype.setStepsDefinition=function(_13){
if(this._stepsDefinition!=null){
this._stepsDefinition.setScale(null);
}
this.setCategoryFlag(window.CategoryStepsDefinition&&_13 instanceof CategoryStepsDefinition);
this._stepsDefinition=_13;
this._stepsDefinition.setScale(this);
if(this.getSteps()!=null){
this.getSteps().invalidateValues();
}
this.revalidateChartLayout();
};
Scale.prototype.setStepUnit=function(_14,_15){
var _16=false;
var _17=null;
if(this.getStepsDefinition()&&this.getStepsDefinition() instanceof DefaultStepsDefinition){
_17=this.getStepsDefinition();
}else{
_17=new DefaultStepsDefinition();
_16=true;
}
if(_14){
_17.setStepUnit(_14);
}else{
_17.setAutoStepUnit(true);
}
if(_15){
_17.setSubStepUnit(_15);
}else{
_17.setAutoSubStepUnit(true);
}
if(_16){
this.setStepsDefinition(_17);
}
};
Scale.prototype.setTimeUnit=function(_18){
var _19=false;
var _1a=null;
if(this.getStepsDefinition() instanceof TimeStepsDefinition){
_1a=this.getStepsDefinition();
}else{
_1a=new TimeStepsDefinition();
_19=true;
}
if(_18!=null){
_1a.setUnit(_18);
}else{
_1a.setAutoUnit(true);
}
if(_19){
this.setStepsDefinition(_1a);
}
};
Scale.prototype.setCategories=function(_1b,_1c){
this.setStepsDefinition(new CategoryStepsDefinition(_1c,_1b));
};
Scale.prototype.setCategory=function(_1d){
if(_1d){
this.setCategory(null,true);
}else{
this.setStepUnit(null,null);
}
};
Scale.prototype.isCategory=function(){
return this._flags.getFlag(Scale.CATEGORY_FLAG);
};
Scale.prototype.getSteps=function(){
return this._steps;
};
Scale.prototype.setSteps=function(_1e){
this._steps=_1e;
};
Scale.prototype.getProjector=function(){
return (!this._chart)?null:this._chart.getProjector();
};
Scale.prototype.getAxis=function(){
return (this._axisIdx==undefined)?null:this._chart.getAxis(this._axisIdx);
};
Scale.prototype.getDualAxis=function(){
return (this._axisIdx==undefined)?null:this._chart.getDualAxis(this._axisIdx);
};
Scale.prototype.getCoordinateSystem=function(){
return (this._axisIdx==undefined)?null:this._chart.getCoordinateSystem(this.getAxis());
};
Scale.prototype.getChart=function(){
return this._chart;
};
Scale.prototype.getPlotRect=function(){
return this._plotRect;
};
Scale.prototype.setAxis=function(_1f,_20){
if(this._axisIdx!=undefined){
this.getAxis().removeEventListener("axisChanged",this.getAxisListener());
this.getAxis().removeEventListener("axisRangeChanged",this.getAxisListener());
}
this._chart=_20;
this._axisIdx=_1f;
if(this._axisIdx!=undefined){
this.getAxis().addEventListener("axisChanged",this.getAxisListener());
this.getAxis().addEventListener("axisRangeChanged",this.getAxisListener());
if(this._def.getAttributeNS(null,"visible")=="false"){
this._flags.setFlag(Scale.AXIS_VISIBLE_FLAG,false);
}
if(this._def.getAttributeNS(null,"autoDataRange")=="false"){
this.getAxis().setAutoDataRange(false);
}
if(this._def.getAttributeNS(null,"autoVisibleRange")=="false"){
this.getAxis().setAutoVisibleRange(false);
}
if(this._def.hasAttributeNS(null,"dataMin")){
this.getAxis().setDataMin(parseFloat(this._def.getAttributeNS(null,"dataMin")));
}
if(this._def.hasAttributeNS(null,"dataMax")){
this.getAxis().setDataMax(parseFloat(this._def.getAttributeNS(null,"dataMax")));
}
if(this._def.getAttributeNS(null,"reversed")=="true"){
this.getAxis().setReversed(true);
}
if(this._def.hasAttributeNS(null,"visibleMin")&&this._def.hasAttributeNS(null,"visibleMax")){
this.getAxis().setVisibleRange(parseFloat(this._def.getAttributeNS(null,"visibleMin")),parseFloat(this._def.getAttributeNS(null,"visibleMax")));
}
if(this.hasTitle()){
this.updateTitleRotation(true,false);
var tmp=this.getStyleAttr();
if(tmp){
tmp=tmp.replace(/fill[^;]*;?/g,"");
tmp=tmp.replace("stroke:","fill:");
tmp=tmp.replace("stroke-opacity:","fill-opacity:");
}
this._title.getLabelRenderer().setStyleAttr(tmp);
}
}
};
Scale.prototype.setPlotRect=function(_22,_23,_24){
if(!this._plotRect.equals(_22)){
this._plotRect.x=_22.x;
this._plotRect.y=_22.y;
this._plotRect.width=_22.width;
this._plotRect.height=_22.height;
if(_23){
this._steps.invalidatePoints();
}else{
this._steps.invalidateValues();
}
if(_24){
this.recalc(null);
}
}
};
Scale.prototype.getTickAngle=function(_25){
return this._config.getTickAngle(_25);
};
Scale.prototype.getTickExt=function(x,y,_28,_29,_2a){
var _2b=MathUtil.toRadians(_29);
var _2c=Math.cos(_2b);
var _2d=Math.sin(_2b);
if(this.getTickLayout()==Scale.TICK_OUTSIDE){
_2a[0]=x;
_2a[1]=y;
_2a[2]=x+_28*_2c;
_2a[3]=y-_28*_2d;
}else{
if(this.getTickLayout()==Scale.TICK_INSIDE){
_2a[0]=x;
_2a[1]=y;
_2a[2]=x-_28*_2c;
_2a[3]=y+_28*_2d;
}else{
var dx=_28*_2c;
var dy=-_28*_2d;
_2a[0]=x+dx;
_2a[1]=y+dy;
_2a[2]=x-dx;
_2a[3]=y-dy;
}
}
};
Scale.prototype.getLabelBounds=function(idx){
return this._steps.getTextRenderer(idx).getBounds(true);
};
Scale.prototype.getStepLabel=function(idx){
return this._steps.getLabel(idx);
};
Scale.prototype.getStepPoints=function(){
return this._steps.getPoints();
};
Scale.prototype.getSubStepPoints=function(){
return this._steps.getSubPoints();
};
Scale.prototype.getLabelPoints=function(){
return this._steps.getLabelPoints();
};
Scale.prototype.getStepValues=function(){
this._steps.update(null);
return this._steps.getValues();
};
Scale.prototype.getSubStepValues=function(){
this._steps.update(null);
return this._steps.getSubValues();
};
Scale.prototype.recalc=function(dst){
return this._config.recalc(dst);
};
Scale.prototype.draw=function(dst){
if(!this.isViewable()){
return;
}
this._config.draw(dst);
};
Scale.prototype.hasTitle=function(){
return (this._title!=null)&&(this._title.getText()!=null);
};
Scale.prototype.computeTitleLocation=function(loc){
this._config.computeTitleLocation(loc);
};
Scale.prototype.getNumSkippedSteps=function(_35,_36){
var _37=_35.size();
if(_37==0||!this.isSkippingLabel()||this.getSkipLabelMode()!=Scale.CONSTANT){
return 1;
}
var _38=this.getSteps().getLabelValues();
var _39=false;
var _3a=this.getLabelBounds(0);
var w=_3a.width;
var h=_3a.height;
var loc=new DoublePoint(_35.getX(0),_35.getY(0));
loc=this.computeLabelLocation(loc,this.getTickAngle(_38[0]),_36,w,h);
var _3e=Scale.getLabelBounds(loc,w,h,null);
_3e.grow(3,3);
var _3f=null;
var _40=null;
var _41=1;
var _42=1;
for(var i=1;i<_37;i+=_41){
_3a=this.getLabelBounds(i);
w=_3a.width;
h=_3a.height;
loc.setLocation(_35.getX(i),_35.getY(i));
loc=this.computeLabelLocation(loc,this.getTickAngle(_38[i]),_36,w,h);
_3f=Scale.getLabelBounds(loc,w,h,_3f);
_3f.grow(3,3);
if(_3e.intersects(_3f.x,_3f.y,_3f.width,_3f.height)){
++_42;
}else{
_40=_3e;
_3e=_3f;
_3f=_40;
if(_42>_41){
_41=_42;
}
_42=1;
}
}
return _41;
};
Scale.prototype.getTickOffset=function(_44){
return this._config.getTickOffset(_44);
};
Scale.prototype.getAxisLabelOffset=function(){
var _45=this.getLabelOffset();
if(!this.isMiddleLabel()&&!this.isBetweenCategory()){
if(this.isMajorTickVisible()&&(this.getTickLayout()==Scale.TICK_OUTSIDE||this.getTickLayout()==Scale.TICK_CROSS)){
_45+=this.getMajorTickSize();
}
}
return _45;
};
Scale.prototype.getPointOnAxis=function(_46,_47){
var pts=new DoublePoints(1);
if(this.getAxis().isXAxis()){
pts.addValues(_46,this.getCrossingValue());
}else{
pts.addValues(this.getCrossingValue(),_46);
}
this.toDisplay(pts);
_47.x=pts.getX(0);
_47.y=pts.getY(0);
};
Scale.prototype.getPointsOnAxis=function(_49,_4a){
if(_4a!=0){
var pts=this._getPoints(_49,_4a);
this.toDisplay(pts);
return pts;
}else{
return new DoublePoints(0);
}
};
Scale.prototype.getAxisBounds=function(_4c){
return this._config.getAxisBounds(_4c);
};
Scale.prototype.invalidateBounds=function(){
this._flags.setFlag(Scale.BOUNDS_VALID,false);
};
Scale.prototype.getBounds=function(_4d,_4e){
if(_4e){
var _4f=this.getPlotRect();
var _50=new Rectangle(_4f.x,_4f.y,_4f.width,_4f.height);
this.setPlotRect(_4e,true);
}
this._steps.invalidateValues();
this.recalc();
if(this._flags.getFlag(Scale.BOUNDS_VALID)){
if(_4d==null){
result=new Rectangle(this._bounds.x,this._bounds.y,this._bounds.width,this._bounds.height);
}else{
result=_4d;
result.x=this._bounds.x;
result.y=this._bounds.y;
result.width=this._bounds.width;
result.height=this._bounds.height;
}
}else{
result=this.getAxisBounds(_4d);
if(this.isLabelVisible()){
result=this.addLabelBounds(result);
}
if(this.isMajorTickVisible()||this.isMinorTickVisible()){
if(!this.isLabelVisible()||this.getTickLayout()==Scale.TICK_CROSS||this.getTickLayout()==Scale.TICK_INSIDE){
result=this.addTickBounds(result,this.isMajorTickVisible());
}
}
if(this.hasTitle()){
var _51=this._title.getBounds(null);
GraphicUtil.addToRect(result,_51);
}
this._bounds.x=result.x;
this._bounds.y=result.y;
this._bounds.width=result.width;
this._bounds.height=result.height;
}
this._flags.setFlag(Scale.BOUNDS_VALID,true);
this._config.validateBounds(_4d);
if(_4e){
this.setPlotRect(_50,true);
}
return result;
};
Scale.prototype.addLabelBounds=function(_52){
var _53=this.getAxisLabelOffset();
var _54=this.getLabelPoints();
var _55=this.getSteps().getLabelValues();
var _56=_54.size();
var _57=null;
var loc=new DoublePoint();
var _59;
var w;
var h;
for(var i=0;i<_56;++i){
_59=this.getLabelBounds(i);
w=_59.width;
h=_59.height;
loc.setLocation(_54.getX(i),_54.getY(i));
loc=this.computeLabelLocation(loc,this.getTickAngle(_55[i]),_53,w,h);
_57=Scale.getLabelBounds(loc,w,h,_57);
_52=GraphicUtil.addToRect(_52,_57);
}
return _52;
};
Scale.prototype.addTickBounds=function(_5d,_5e){
var _5f=_5e?this._steps.getPoints():this._steps.getSubPoints();
var _60=_5f.size();
if(_60==0){
return _5d;
}
var _61=_5e?this._steps.getValues():this._steps.getSubValues();
var _62=this.getTickOffset(_5e);
var _63=new Array(4);
for(var i=0;i<_60;++i){
this.getTickExt(_5f.getX(i),_5f.getY(i),_62,this.getTickAngle(_61[i]),_63);
if(this.getTickLayout()==Scale.TICK_CROSS){
_5d.add(_63[0],_63[1]);
}
_5d.add(_63[2],_63[3]);
}
return _5d;
};
Scale.prototype.toDisplay=function(pts){
this.getProjector().toDisplay(pts,this.getPlotRect(),this.getCoordinateSystem());
};
Scale.prototype._getPoints=function(_66,_67){
var _68=this.getAxis().isXAxis();
var _69=new Array(_67);
if(_68){
var val=this.getCrossingValue();
for(var i=0;i<_67;++i){
_69[i]=val;
}
return new DoublePoints(_67,_66,_69);
}else{
var val=this.getCrossingValue();
for(var i=0;i<_67;++i){
_69[i]=val;
}
return new DoublePoints(_67,_69,_66);
}
};
Scale.prototype.getScaleLength=function(){
return this._config.getScaleLength();
};
Scale.prototype.getMaxStepCount=function(_6c,_6d,_6e){
return this._config.getMaxStepCount(_6c,_6d,_6e);
};
Scale.prototype.computeValues=function(_6f,_70){
_6f.splice(0,_6f.length);
_70.splice(0,_70.length);
var _71=this.getStepsDefinition();
if(_71==null){
return;
}
_71.update();
var _72=this.getAxis().getVisibleRange();
var val=_72.getMin();
if(!_71.hasNext(val)){
return;
}
var max=_72.getMax();
if(_71.hasSubStep()){
var _75=_71.firstSubStep(val);
val=_71.firstStep(val);
if(val==_75){
_75=_71.incrementSubStep(_75);
}
while(_75<val){
if(MathUtil.equals(_75,val)){
break;
}
_70.push(_75);
_75=_71.incrementSubStep(_75);
}
while(val<=max){
_6f.push(val);
_75=_71.firstSubStep(val);
if(val==_75){
_75=_71.incrementSubStep(_75);
}
if(!_71.hasNext(val)){
break;
}
val=_71.incrementStep(val);
while(_75<val&&(_75<=max)){
if(MathUtil.equals(_75,val)){
break;
}
_70.push(_75);
_75=_71.incrementSubStep(_75);
}
}
}else{
val=_71.firstStep(val);
while(val<=max){
_6f.push(val);
if(!_71.hasNext(val)){
break;
}
val=_71.incrementStep(val);
}
}
};
Scale.prototype.getLabelCount=function(){
return this.getLabelPoints().size();
};
Scale.prototype.getLabelValue=function(_76){
return this.getSteps().getLabelValues().get(_76);
};
Scale.prototype.computeLabel=function(_77){
return (this.getStepsDefinition()==null)?"":this.getStepsDefinition().computeLabel(_77);
};
Scale.prototype.isAnchored=function(){
var _78=this.getCrossing();
return (_78!=Axis.MIN_VALUE&&_78!=Axis.MAX_VALUE);
};
Scale.prototype.updateDualScales=function(){
if(this.getAxis().isXAxis()){
var _79=this.getChart().getYAxisCount();
for(var i=1;i<_79;++i){
var _7b=this.getChart().getYScale(i);
if(_7b!=null&&_7b.isAnchored()){
_7b.getSteps().invalidatePoints();
}
}
}else{
var _7b=this.getChart().getXScale();
if(_7b!=null&&_7b.isAnchored()){
_7b.getSteps().invalidatePoints();
}
}
};
Scale.prototype.getAxisListener=function(){
if(this._axisListener==null){
this._axisListener=new AxisLST(this);
}
return this._axisListener;
};
Scale.prototype.computeLabelLocation=function(loc,_7d,_7e,_7f,_80){
return GraphicUtil.computeTextLocation(loc,_7d,_7e,_7f,_80);
};
Scale.getLabelBounds=function(loc,w,h,_84){
var _85=_84;
if(_85==null){
_85=new Rectangle(loc.x-w/2,loc.y-h/2,w,h);
}else{
_85.x=loc.x-w/2;
_85.y=loc.y-h/2;
_85.width=w;
_85.height=h;
}
return _85;
};
Scale.prototype.revalidateChartLayout=function(){
this.invalidateBounds();
if(this.getChart()!=null){
this.getChart().updateAreaLayout();
if(this.getChart().getAutoRedraw()){
this.getChart().drawArea();
}
}
};
AxisLST.prototype=new Object();
function AxisLST(_86){
this._scale=_86;
}
AxisLST.prototype.axisRangeChanged=function(ev){
if(ev.isVisibleRangeEvent()&&ev.isChangedEvent()){
this._scale.updateDualScales();
if(this._scale.getSteps()){
this._scale.getSteps().invalidateValues();
}
if(!ev.isAdjusting()){
this._scale.getChart().updateJSFForm();
this._scale.revalidateChartLayout();
}
}
};
AxisLST.prototype.axisChanged=function(ev){
if(ev.getType()!=AxisChangedEvent.ADJUSTMENT_CHANGE){
if(ev.getType()==AxisChangedEvent.TRANSFORMER_CHANGE){
this._scale.getSteps().invalidateValues();
}
this._scale.updateDualScales();
}
if(!ev.isAdjusting()){
this._scale.revalidateChartLayout();
}
};
