/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

function ScaleConfiguration(){
}
ScaleConfiguration.prototype.scale;
ScaleConfiguration.createConfig=function(_1){
var _2=null;
switch(_1){
case Scale.RECTANGULAR:
_2=new RectangularScaleConfiguration();
break;
}
return _2;
};
ScaleConfiguration.prototype.setScale=function(_3){
this.scale=_3;
if(_3!=null){
_3.setSteps(this.createSteps());
}
};
ScaleConfiguration.prototype.getDefaultCrossing=function(){
};
ScaleConfiguration.prototype.getTickAngle=function(_4){
};
ScaleConfiguration.prototype.getAxisBounds=function(){
};
ScaleConfiguration.prototype.createSteps=function(){
return new Steps(this.scale);
};
ScaleConfiguration.prototype.getScaleLength=function(){
return Math.min(this.scale.getPlotRect().width,this.scale.getPlotRect().height);
};
ScaleConfiguration.prototype.validateBounds=function(_5){
};
ScaleConfiguration.getMaxStepCount=function(_6,_7,_8){
};
ScaleConfiguration.prototype.getAxisTitleOffset=function(){
};
ScaleConfiguration.prototype.getTickOffset=function(_9){
return _9?this.scale.getMajorTickSize():this.scale.getMinorTickSize();
};
ScaleConfiguration.prototype.recalc=function(_a){
if(this.scale.getSteps().update(null)){
if(this.scale.hasTitle()){
this.scale.getInternalTitle().updateLocation();
}
return true;
}else{
return false;
}
};
ScaleConfiguration.prototype.draw=function(_b){
this.recalc(_b);
if(this.scale.isAxisVisible()){
this.drawAxis(_b);
}
if(this.scale.isMajorTickVisible()){
this.drawTicks(_b,true);
}
if(this.scale.isMinorTickVisible()&&!this.scale.isBetweenCategory()){
this.drawTicks(_b,false);
}
if(this.scale.isLabelVisible()){
this.drawLabels(_b);
}
if(this.scale.hasTitle()){
this.scale.getInternalTitle().draw(_b);
}
};
ScaleConfiguration.prototype.drawAxis=function(_c){
};
ScaleConfiguration.prototype.drawTicks=function(_d,_e){
var _f=_e?this.scale.getStepPoints():this.scale.getSubStepPoints();
var _10=_f.size();
if(_10==0){
return;
}
var _11=_e?this.scale.getSteps().getValues():this.scale.getSteps().getSubValues();
var _12=this.getTickOffset(_e);
var _13=new Array(4);
var g=DrawUtil.createContainer(_d.ownerDocument);
Style.applyStroke(this.scale.getAxisStyle(),g);
for(var i=0;i<_10;++i){
this.scale.getTickExt(_f.getX(i),_f.getY(i),_12,this.scale.getTickAngle(_11[i]),_13);
DrawUtil.drawLine(g,_13[0],_13[1],_13[2],_13[3]);
}
_d.appendChild(g);
};
ScaleConfiguration.prototype.drawLabels=function(dst){
var _17=this.scale.getLabelPoints();
var _18=_17.size();
if(_18==0){
return;
}
var _19=this.scale.getAxisLabelOffset();
var _1a=this.scale.getNumSkippedSteps(_17,_19);
var _1b=this.scale.getSteps().getLabelValues();
var loc=new DoublePoint();
var _1d=null;
var _1e=null;
var _1f=this.scale.isSkippingLabel()&&(this.scale.getSkipLabelMode()==Scale.ADAPTIVE_SKIP);
var _20=false;
var _21;
var w;
var h;
var _24=this.scale.getLabelRotation();
for(var i=0;i<_18;i+=_1a){
loc.setLocation(_17.getX(i),_17.getY(i));
_21=this.scale.getLabelBounds(i);
w=_21.width;
h=_21.height;
loc=this.scale.computeLabelLocation(loc,this.getTickAngle(_1b[i]),_19,w,h);
if(_20){
var _1d=Scale.getLabelBounds(loc,w,h,_1d);
if(_1f){
if(_1e!=null){
if(_1e.intersects(_1d.x,_1d.y,_1d.width,_1d.height)){
continue;
}else{
var tmp=_1e;
_1e=_1d;
_1d=tmp;
}
}else{
_1e=_1d;
_1d=null;
}
}
}
this.scale.getSteps().getTextRenderer(i).draw(dst,loc.x,loc.y);
}
};
ScaleConfiguration.prototype.computeTitleLocation=function(loc){
var _28=this.scale.getAxis().getVisibleRange();
var _29=_28.getMin()+((_28.getLength()*this.scale.getInternalTitle().getPlacement())/100);
this.scale.getPointOnAxis(_29,loc);
var _2a=scale.getInternalTitle().getBounds(true);
GraphicUtil.computeTextLocation(loc,this.getTickAngle(_29),this.getAxisTitleOffset(),titleSize.width,titleSize.height);
};
