/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

TextRenderer.prototype._text;
TextRenderer.prototype._rotation=0;
TextRenderer.prototype._alignment;
TextRenderer.prototype._textElt;
function TextRenderer(_1,_2){
this._text=_1;
if(_2!=undefined){
this._rotation=_2;
}
}
TextRenderer.prototype.draw=function(g,x,y){
var _6=this.createText(g,x,y,this._rotation);
var _7=_6.parentNode;
if(_7!=g){
if(_7!=null){
_7.removeChild(_6);
}
g.appendChild(_6);
}
};
TextRenderer.prototype.setStyleAttr=function(_8){
this._style=_8;
};
TextRenderer.prototype.createText=function(g,x,y,r){
if(!this._textElt){
this._textElt=g.ownerDocument.createElementNS(SVG_NS,"text");
if(this._style){
this._textElt.setAttributeNS(null,"style",this._style.replace(/stroke:[^;]*;?/,""));
}
this._textElt.setAttributeNS(null,"text-anchor","middle");
var _d=g.ownerDocument.createTextNode("A");
this._textElt.appendChild(_d);
this._ascent=this.getHeight(g);
_d.replaceData(0,_d.length,"Ap");
this._descent=this.getHeight(g)-this._ascent;
_d.replaceData(0,_d.length,this._text);
}
if(x!=undefined){
y+=(this._ascent-this._descent)/2;
if(r&&r!=0){
this._textElt.setAttributeNS(null,"transform","rotate("+r+","+x+","+y+")");
}
this._textElt.setAttributeNS(null,"x",x);
this._textElt.setAttributeNS(null,"y",y);
}
return this._textElt;
};
TextRenderer.prototype.getHeight=function(g){
try{
var _f=this._textElt.getBBox().height;
}
catch(e){
g.appendChild(this._textElt);
try{
var _f=this._textElt.getBBox().height;
}
catch(f){
var _f=12;
}
g.removeChild(this._textElt);
}
return _f;
};
TextRenderer.prototype.getBounds=function(_10,x,y,_13){
var _14=this.createText(document.documentElement,x?x:undefined,y?y:undefined,(_10==true)?this._rotation:0);
_14.setAttributeNS(null,"style",_14.getAttributeNS(null,"style"));
try{
var _15=_14.getBBox();
}
catch(e){
document.documentElement.appendChild(_14);
try{
var _15=_14.getBBox();
}
catch(f){
var _15=new Rectangle(0,0,90,12);
}
document.documentElement.removeChild(_14);
}
if(_13){
_13.x=_15.x;
_13.y=_15.y;
_13.width=_15.width;
_13.height=_15.height;
}else{
_13=new Rectangle(_15.x,_15.y,_15.width,_15.height);
}
if(_10&&this._rotation!=0){
var _16=document.documentElement.createSVGMatrix();
if(x!=undefined){
_16=_16.translate(x,y);
}
_16=_16.rotate(this._rotation);
if(x!=undefined){
_16=_16.translate(-x,-y);
}
_13=GraphicUtil.transform(_13,_16);
}
return _13;
};
TextRenderer.prototype.getRotation=function(){
return this._rotation;
};
TextRenderer.prototype.setRotation=function(_17){
if(this._rotation==_17){
return;
}
this._rotation=_17;
};
TextRenderer.prototype.getText=function(){
return this._text;
};
TextRenderer.prototype.setText=function(_18){
if(_18!=this._text){
this._text=_18;
if(this._textElt){
var _19=this._textElt.firstChild;
_19.replaceData(0,_19.length,_18);
}
}
};
