/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

function TimeUnit(){
}
TimeUnit.DAY_LIST=["Sun","Mon","Tue","Wen","Thu","Fri","Sat"];
TimeUnit.MONTH_LIST=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
TimeUnit.WEEK_LETTER="W";
TimeUnit.MILLISECOND=new Object();
TimeUnit.MILLISECOND.previousUnitTime=function(_1){
return _1;
};
TimeUnit.MILLISECOND.incrementTime=function(_2){
_2.setMilliseconds(_2.getMilliseconds()+1);
return _2;
};
TimeUnit.MILLISECOND.millis=1;
TimeUnit.MILLISECOND.getLabel=function(_3){
return NumberFormat.format2(_3.getHours())+":"+NumberFormat.format2(_3.getMinutes())+":"+NumberFormat.format2(_3.getSeconds())+"."+NumberFormat.format3(_3.getMilliseconds());
};
TimeUnit.MILLISECOND.size=12;
TimeUnit.SECOND=new Object();
TimeUnit.SECOND.previousUnitTime=function(_4){
_4.setMilliseconds(0);
return _4;
};
TimeUnit.SECOND.incrementTime=function(_5){
_5.setSeconds(_5.getSeconds()+1);
return _5;
};
TimeUnit.SECOND.millis=1000;
TimeUnit.SECOND.getLabel=function(_6){
return NumberFormat.format2(_6.getHours())+":"+NumberFormat.format2(_6.getMinutes())+":"+NumberFormat.format2(_6.getSeconds());
};
TimeUnit.SECOND.size=8;
TimeUnit.MINUTE=new Object();
TimeUnit.MINUTE.previousUnitTime=function(_7){
_7.setSeconds(0);
_7.setMilliseconds(0);
return _7;
};
TimeUnit.MINUTE.incrementTime=function(_8){
_8.setMinutes(_8.getMinutes()+1);
return _8;
};
TimeUnit.MINUTE.millis=60000;
TimeUnit.MINUTE.getLabel=function(_9){
return NumberFormat.format2(_9.getHours())+":"+NumberFormat.format2(_9.getMinutes());
};
TimeUnit.MINUTE.size=5;
TimeUnit.HOUR=new Object();
TimeUnit.HOUR.previousUnitTime=function(_a){
_a.setMinutes(0);
_a.setSeconds(0);
_a.setMilliseconds(0);
return _a;
};
TimeUnit.HOUR.incrementTime=function(_b){
_b.setHours(_b.getHours()+1);
return _b;
};
TimeUnit.HOUR.millis=60*60000;
TimeUnit.HOUR.getLabel=function(_c){
return NumberFormat.format2(_c.getHours())+":"+NumberFormat.format2(_c.getMinutes());
};
TimeUnit.HOUR.size=5;
TimeUnit.DAY=new Object();
TimeUnit.DAY.previousUnitTime=function(_d){
_d.setHours(0);
_d.setMinutes(0);
_d.setSeconds(0);
_d.setMilliseconds(0);
return _d;
};
TimeUnit.DAY.incrementTime=function(_e){
_e.setDate(_e.getDate()+1);
return _e;
};
TimeUnit.DAY.millis=24*60*60000;
TimeUnit.DAY.getLabel=function(_f){
return TimeUnit.DAY_LIST[_f.getDay()]+" "+_f.getDate();
};
TimeUnit.DAY.size=4;
TimeUnit.WEEK=new Object();
TimeUnit.WEEK.previousUnitTime=function(_10){
_10.setDate(_10.getDate()-_10.getDay()%7);
_10.setHours(0);
_10.setMinutes(0);
_10.setSeconds(0);
_10.setMilliseconds(0);
return _10;
};
TimeUnit.WEEK.incrementTime=function(_11){
_11.setDate(_11.getDate()+7);
return _11;
};
TimeUnit.WEEK.millis=7*24*60*60000;
TimeUnit.WEEK.getLabel=function(_12){
var _13=new Date(_12.getFullYear(),0);
var w=Math.round(1+(Math.round((_12-_13)/86400000))/7);
return TimeUnit.WEEK_LETTER+w;
};
TimeUnit.WEEK.size=3;
TimeUnit.MONTH=new Object();
TimeUnit.MONTH.previousUnitTime=function(_15){
_15.setDate(1);
_15.setHours(0);
_15.setMinutes(0);
_15.setSeconds(0);
_15.setMilliseconds(0);
return _15;
};
TimeUnit.MONTH.incrementTime=function(_16){
_16.setMonth(_16.getMonth()+1);
return _16;
};
TimeUnit.MONTH.millis=30*24*60*60000;
TimeUnit.MONTH.getLabel=function(_17){
var _18=new String(_17.getFullYear());
return TimeUnit.MONTH_LIST[_17.getMonth()]+" "+_18.slice(2,4);
};
TimeUnit.MONTH.size=6;
TimeUnit.YEAR=new Object();
TimeUnit.YEAR.previousUnitTime=function(_19){
_19.setMonth(0);
_19.setDate(1);
_19.setHours(0);
_19.setMinutes(0);
_19.setSeconds(0);
_19.setMilliseconds(0);
return _19;
};
TimeUnit.YEAR.incrementTime=function(_1a){
_1a.setFullYear(_1a.getFullYear()+1);
return _1a;
};
TimeUnit.YEAR.millis=365*24*60*60000;
TimeUnit.YEAR.getLabel=function(_1b){
return _1b.getFullYear();
};
TimeUnit.YEAR.size=4;
TimeStepsDefinition.AUTO_UNITS=[TimeUnit.MILLISECOND,TimeUnit.SECOND,TimeUnit.MINUTE,TimeUnit.HOUR,TimeUnit.DAY,TimeUnit.WEEK,TimeUnit.MONTH,TimeUnit.YEAR];
TimeStepsDefinition.prototype=new StepsDefinition();
TimeStepsDefinition.prototype._autoUnit=true;
TimeStepsDefinition.prototype._unit=TimeUnit.DAY;
function TimeStepsDefinition(){
}
TimeStepsDefinition.prototype.isAutoUnit=function(){
return this._autoUnit;
};
TimeStepsDefinition.prototype.setAutoUnit=function(_1c){
this._autoUnit=_1c;
};
TimeStepsDefinition.prototype.getUnit=function(){
return this._unit;
};
TimeStepsDefinition.prototype.setUnit=function(_1d){
this.setAutoUnit(false);
this._setUnit(_1d);
};
TimeStepsDefinition.prototype._setUnit=function(_1e){
this._unit=_1e;
};
TimeStepsDefinition.prototype.update=function(){
if(this.getScale()==null){
this.setUnit(TimeUnit.DAY);
return;
}
if(this.isAutoUnit()){
this.autoComputeUnit();
}
};
TimeStepsDefinition.prototype.autoComputeUnit=function(){
this._setUnit(this.computeTimeUnit());
};
TimeStepsDefinition.prototype.computeTimeUnit=function(){
var _1f=Style.create(this.getScale().getLabelsStyleAttr())["font-size"];
if(!_1f){
_1f=12;
}else{
if(_1f.indexOf("px")!=-1){
_1f=_1f.substring(0,_1f.indexOf("px")-1);
}
}
var _20=this.getAxis().getVisibleMax()-this.getAxis().getVisibleMin();
var _21;
var _22=Number.MAX_VALUE;
var _23=Number.MAX_VALUE;
var _24;
var _25=TimeStepsDefinition.AUTO_UNITS.length;
for(var i=0;i<_25;++i){
_24=TimeStepsDefinition.AUTO_UNITS[i];
_21=_20/_24.millis;
if(_21<0.1||_21>200){
continue;
}
var _27=this.getScale().getMaxStepCount(_24.size*_1f,_1f,6);
var _28=Math.abs(_21-_27)/_27;
if(_28>0&&_28<_22){
_23=i;
_22=_28;
}
}
if(_23<_25){
return TimeStepsDefinition.AUTO_UNITS[_23];
}else{
return TimeUnit.YEAR;
}
};
TimeStepsDefinition.prototype.previousStep=function(_29){
return this._unit.previousUnitTime(new Date(_29)).getTime();
};
TimeStepsDefinition.prototype.incrementStep=function(_2a){
return this._unit.incrementTime(new Date(_2a)).getTime();
};
TimeStepsDefinition.prototype.computeLabel=function(_2b,_2c){
if(!_2c){
return this._unit.getLabel(new Date(_2b));
}else{
var _2d=TimeStepsDefinition.AUTO_UNITS.length;
for(var i=0;i<_2d;i++){
if(TimeStepsDefinition.AUTO_UNITS[i]==this._unit){
break;
}
}
var _2f=new Date(_2b);
if(i<=4){
return _2f.toDateString()+" "+TimeStepsDefinition.AUTO_UNITS[Math.max(0,i-1)].getLabel(_2f);
}else{
if(i>4){
return _2f.toDateString();
}
}
}
};
