/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartInfoViewInteractor.prototype=new ChartHighlightInteractor();
ChartInfoViewInteractor.prototype._followMouse=false;
function ChartInfoViewInteractor(_1){
ChartHighlightInteractor.call(this,_1);
}
ChartInfoViewInteractor.prototype.getInfoText=function(pt){
var x=pt.getXData();
var y=pt.getYData();
var _5=this.getChart();
var _6=pt.getDataSet().getName();
return _6+", x: "+_5.getScale(_5.getAxis(0)).getStepsDefinition().computeLabel(x,true)+" | y: "+_5.getScale(_5.getAxis(1)).getStepsDefinition().computeLabel(y,true);
};
ChartInfoViewInteractor.prototype.handleEvent=function(_7){
var r=ChartHighlightInteractor.prototype.handleEvent.call(this,_7);
if(this._followMouse&&!r&&_7.type=="mousemove"&&this.getHighlightedPoint()!=null&&this._infoView!=null){
var x=this.getChart().xClientToAreaCS(_7.clientX);
var y=this.getChart().yClientToAreaCS(_7.clientY);
var _b=this._text.getBBox();
this._rect.setAttributeNS(null,"x",x-4);
this._rect.setAttributeNS(null,"y",y-_b.height-4);
this._text.setAttributeNS(null,"x",x);
this._text.setAttributeNS(null,"y",y);
}
};
ChartInfoViewInteractor.prototype.interactionStarted=function(_c,_d){
if(this.getHighlightedPoint()!=null){
this.doIt(this.getHighlightedPoint(),false,_d);
this.setHighlightedPoint(null);
}
};
ChartInfoViewInteractor.prototype.doIt=function(_e,_f,evt){
if(_f){
var x=this.getChart().xClientToAreaCS(evt.clientX);
var y=this.getChart().yClientToAreaCS(evt.clientY);
if(this._infoView==null){
this._infoView=DrawUtil.createContainer(evt.target.ownerDocument);
this._infoView.setAttributeNS(null,"pointer-events","none");
this._rect=DrawUtil.createRect(evt.target.ownerDocument);
this._rect.setAttributeNS(null,"rx",4);
this._rect.setAttributeNS(null,"ry",4);
this._rect.setAttributeNS(null,"class","tooltip-background");
this._rect.setAttributeNS(null,"fill","yellow");
this._rect.setAttributeNS(null,"stroke","black");
this._infoView.appendChild(this._rect);
this._text=evt.target.ownerDocument.createElementNS(SVG_NS,"text");
this._tNode=evt.target.ownerDocument.createTextNode("");
this._text.appendChild(this._tNode);
this._infoView.appendChild(this._text);
}
var _13=this.getInfoText(_e);
if(_13==null){
return;
}
this._tNode.data=_13;
try{
var _14=this._text.getBBox();
}
catch(e){
this.getChart().getViewport().appendChild(this._infoView);
var _14=this._text.getBBox();
}
var _15=this.getChart().getPlotRect();
var dx=0;
var dy=0;
if(x+6+_14.width>_15.x+_15.width){
dx=(_15.x+_15.width)-(x+6+_14.width);
}else{
if(x-6<_15.x){
dx=_15.x-(x-6);
}
}
if(y+6>_15.y+_15.height){
dy=(_15.y+_15.height)-(y+6);
}else{
if(y-_14.height-6<_15.y){
dy=_15.y-(y-_14.height-6);
}
}
if(dx!=0||dy!=0){
this._infoView.setAttributeNS(null,"transform","translate("+dx+","+dy+")");
}else{
if(this._infoView.hasAttributeNS(null,"transform")){
this._infoView.setAttributeNS(null,"transform","");
}
}
this._rect.setAttributeNS(null,"x",x-4);
this._rect.setAttributeNS(null,"y",y-_14.height-4);
this._rect.setAttributeNS(null,"width",_14.width+8);
this._rect.setAttributeNS(null,"height",_14.height+10);
this._text.setAttributeNS(null,"x",x);
this._text.setAttributeNS(null,"y",y);
if(this._infoView.parentNode==null){
this.getChart().getViewport().appendChild(this._infoView);
}
}else{
if(this._infoView!=null&&this._infoView.parentNode){
this.getChart().getViewport().removeChild(this._infoView);
}
}
};
