/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartPanInteractor.prototype=new ChartInteractor();
ChartPanInteractor.prototype._lastPos;
ChartPanInteractor.prototype._currentPos;
ChartPanInteractor.prototype._yPanAllowed=false;
ChartPanInteractor.prototype._xPanAllowed=true;
function ChartPanInteractor(_1,_2){
if(_1==undefined){
_1=2;
}
ChartInteractor.call(this,_1,0,_2);
this._lastPos=new DoublePoints(1);
this._lastPos.addValues(0,0);
this._currentPos=new DoublePoints(1);
this._currentPos.addValues(0,0);
}
ChartPanInteractor.prototype.enableEvents=function(_3){
_3["mousemove"]=true;
_3["mousedown"]=true;
_3["mouseup"]=true;
};
ChartPanInteractor.prototype.setXPanAllowed=function(_4){
this._xPanAllowed=_4;
};
ChartPanInteractor.prototype.setYPanAllowed=function(_5){
this._yPanAllowed=_5;
};
ChartPanInteractor.prototype.handleEvent=function(_6){
switch(_6.type){
case "mousedown":
if(this.getButton()==_6.button){
var _7=this.getChart().getPlotRect();
var x=this.getChart().xClientToAreaCS(_6.clientX);
var y=this.getChart().yClientToAreaCS(_6.clientY);
this._lastPos.set(0,x-_7.x,y-_7.y);
this.getChart().toData(this._lastPos,this.getYAxisIndex());
this.startOperation(_6);
_6.stopPropagation();
this.getChart().lockGlassPane();
return true;
}
break;
case "mouseup":
if(!this.isInOperation()){
break;
}
if(this.getButton()==_6.button){
this.endOperation(_6);
_6.stopPropagation();
this.getChart().releaseGlassPane();
return true;
}
break;
case "mousemove":
if(!this.isInOperation()){
break;
}
var _7=this.getChart().getPlotRect();
var x=this.getChart().xClientToAreaCS(_6.clientX);
var y=this.getChart().yClientToAreaCS(_6.clientY);
this._currentPos.set(0,x-_7.x,y-_7.y);
this.getChart().toData(this._currentPos,this.getYAxisIndex());
this.pan(this._lastPos,this._currentPos);
this._lastPos.set(0,x-_7.x,y-_7.y);
this.getChart().toData(this._lastPos,this.getYAxisIndex());
_6.stopPropagation();
return true;
break;
}
return false;
};
ChartPanInteractor.prototype.pan=function(_a,_b){
var _c=this._xPanAllowed?_a.getX(0)-_b.getX(0):0;
var _d=this._yPanAllowed?_a.getY(0)-_b.getY(0):0;
this.getChart().scroll(_c,_d,this.getYAxisIndex());
};
ChartPanInteractor.prototype.getCursor=function(){
return "move";
};
ChartPanInteractor.prototype.startOperation=function(_e){
ChartInteractor.prototype.startOperation.call(this,_e);
this.setCursor(this.getCursor());
this.getXAxis().setAdjusting(true);
this.getYAxis().setAdjusting(true);
};
ChartPanInteractor.prototype.endOperation=function(_f){
ChartInteractor.prototype.endOperation.call(this,_f);
this.setCursor(null);
this.getXAxis().setAdjusting(false);
this.getYAxis().setAdjusting(false);
};
ChartPanInteractor.prototype.abort=function(){
ChartPanInteractor.prototype.abort.call(this);
this.setCursor(null);
this.getXAxis().setAdjusting(false);
this.getYAxis().setAdjusting(false);
};
