/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartScrollInteractor.prototype=new ChartInteractor();
ChartScrollInteractor.DEFAULT_STEP_VALUE=2;
ChartScrollInteractor.POSITIVE_DIR=1;
ChartScrollInteractor.NEGATIVE_DIR=2;
ChartScrollInteractor.prototype._negativeDirectionKey;
ChartScrollInteractor.prototype._positiveDirectionKey;
ChartScrollInteractor.prototype._step=ChartScrollInteractor.DEFAULT_STEP_VALUE;
function ChartScrollInteractor(_1,_2,_3,_4,_5){
ChartInteractor.call(this,0,0,_5);
this._negativeDirectionKey=_1;
this._positiveDirectionKey=_2;
if(_3!=undefined){
this._step=_3;
}
if(_4!=undefined){
this._axisIndex=_4;
}
}
ChartScrollInteractor.prototype.enableEvents=function(_6){
_6["keyup"]=true;
};
ChartScrollInteractor.prototype.getPositiveDirectionKey=function(){
return this._positiveDirectionKey;
};
ChartScrollInteractor.prototype.getNegativeDirectionKey=function(){
return this._negativeDirectionKey;
};
ChartScrollInteractor.prototype.getStep=function(){
return this._step;
};
ChartScrollInteractor.prototype.handleEvent=function(_7){
if(_7.type!="keyup"){
return;
}
var _8=_7.keyCode;
if(_8==this._negativeDirectionKey||_8==this._positiveDirectionKey){
if(_8==this.getNegativeDirectionKey()){
this.scroll(ChartScrollInteractor.NEGATIVE_DIR);
}else{
this.scroll(ChartScrollInteractor.POSITIVE_DIR);
}
_7.stopPropagation();
return true;
}
return false;
};
ChartScrollInteractor.prototype.scroll=function(_9){
if(this.getAxis().isXAxis()){
if(_9==ChartScrollInteractor.NEGATIVE_DIR){
this.getChart().scroll(-this.getDelta(),0,this.getYAxisIndex());
}else{
this.getChart().scroll(this.getDelta(),0,this.getYAxisIndex());
}
}else{
if(_9==ChartScrollInteractor.NEGATIVE_DIR){
this.getChart().scroll(0,-this.getDelta(),this.getYAxisIndex());
}else{
this.getChart().scroll(0,this.getDelta(),this.getYAxisIndex());
}
}
};
ChartScrollInteractor.prototype.getAxis=function(){
return this.getChart().getAxis(this._axisIndex);
};
ChartScrollInteractor.prototype.getDelta=function(){
var _a=this.getChart().getScale(this.getAxis());
var _b=null;
if(_a!=null){
var _c=_a.getStepsDefinition();
if(window.DefaultStepsDefinition&&_c instanceof DefaultStepsDefinition){
_b=_c.getStepUnit()*this.getStep();
}else{
if(window.TimeStepsDefinition&&_c instanceof TimeStepsDefinition){
_b=_c.getUnit().millis*this.getStep();
}else{
if(window.CategoryStepsDefinition&&_c instanceof CategoryStepsDefinition){
_b=this.getStep();
}
}
}
}
return _b;
};
