/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ChartZoomInteractor.prototype=new ChartInteractor();
ChartZoomInteractor.EPSILON=5;
ChartZoomInteractor.prototype._startPoint;
ChartZoomInteractor.prototype._endPoint;
ChartZoomInteractor.prototype._xStart;
ChartZoomInteractor.prototype._yStart;
ChartZoomInteractor.prototype._dragging;
ChartZoomInteractor.prototype._zoomOut;
ChartZoomInteractor.prototype._draggedDataWindow;
ChartZoomInteractor.prototype._xZoomAllowed=true;
ChartZoomInteractor.prototype._yZoomAllowed=false;
ChartZoomInteractor.prototype._zoomOutAllowed=true;
function ChartZoomInteractor(_1,_2,_3,_4){
if(_1==undefined){
_1=0;
}
ChartInteractor.call(this,_1,_2,_4);
this._startPoint=new DoublePoints(1);
this._startPoint.addValues(0,0);
this._endPoint=new DoublePoints(1);
this._endPoint.addValues(0,0);
this._xStart=0;
this._yStart=0;
this._dragging=false;
this._zoomOut=false;
this._draggedDataWindow=null;
this._zoomOutModifier=_3;
}
ChartZoomInteractor.prototype.enableEvents=function(_5){
_5["mousemove"]=true;
_5["mousedown"]=true;
_5["mouseup"]=true;
_5["keypress"]=true;
};
ChartZoomInteractor.prototype.getDraggedWindow=function(){
return new IlvDataWindow(this._draggedDataWindow.getXMin(),this._draggedDataWindow.getXMax(),this._draggedDataWindow.getYMin(),this._draggedDataWindow.getYMax());
};
ChartZoomInteractor.prototype.getZoomedDataWindow=function(){
var _6=this.getDraggedWindow();
if(this._zoomOut){
var _7=this.getXAxis().getVisibleRange();
var _8=this.getYAxis().getVisibleRange();
var _9=this._draggedDataWindow.getXMin();
var _a=this._draggedDataWindow.getXMax();
var _b=this._draggedDataWindow.getYMin();
var _c=this._draggedDataWindow.getYMax();
var _d=_6.xRange;
var _e=_6.yRange;
var _f=_7.getLength()/(_a-_9);
var _10=_7.max-(_a-_7.min)*_f;
var _11=_7.min+(_7.max-_9)*_f;
_d.set(_10,_11);
_d.intersection(this.getXAxis().getDataRange());
_f=_8.getLength()/(_c-_b);
_10=_8.max-(_c-_8.min)*_f;
_11=_8.min+(_8.max-_b)*_f;
_e.set(_10,_11);
_e.intersection(this.getYAxis().getDataRange());
}
return _6;
};
ChartZoomInteractor.prototype.isValid=function(evt){
return (this.getButton()==evt.button)&&(this.isModifierOn(evt)||(ChartInteractor.isModifierOn(this._zoomOutModifier,evt)&&this._zoomOutAllowed));
};
ChartZoomInteractor.prototype.handleEvent=function(evt){
switch(evt.type){
case "mousedown":
if(this.isInOperation()||!this.isValid(evt)){
return false;
}
if(ChartInteractor.isModifierOn(this._zoomOutModifier,evt)){
this._zoomOut=true;
}
this._xStart=this.getChart().xClientToAreaCS(evt.clientX);
this._yStart=this.getChart().yClientToAreaCS(evt.clientY);
this._startPoint.set(0,this._xStart,this._yStart);
this.getChart().toData(this._startPoint,this.getYAxisIndex());
this._endPoint.set(0,this._xStart,this._yStart);
this.getChart().toData(this._endPoint,this.getYAxisIndex());
this.startOperation(evt);
this.computeDraggedDataWindow();
this._validate(this._draggedDataWindow);
this.drawGhost();
evt.stopPropagation();
return true;
case "mouseup":
if(!this.isInOperation()){
return false;
}
var x=this.getChart().xClientToAreaCS(evt.clientX);
var y=this.getChart().yClientToAreaCS(evt.clientY);
this._endPoint.set(0,x,y);
this.getChart().toData(this._endPoint,this.getYAxisIndex());
this.computeDraggedDataWindow();
this._validate(this._draggedDataWindow);
this.drawGhost();
if((Math.abs(x-this._xStart)>ChartZoomInteractor.EPSILON)||(Math.abs(y-this._yStart)>ChartZoomInteractor.EPSILON)){
this.doIt();
}
this.endOperation(evt);
evt.stopPropagation();
return true;
case "mousemove":
if(!this.isInOperation()){
return false;
}
this.drawGhost();
var x=this.getChart().xClientToAreaCS(evt.clientX);
var y=this.getChart().yClientToAreaCS(evt.clientY);
this._endPoint.set(0,x,y);
this.getChart().toData(this._endPoint,this.getYAxisIndex());
this.computeDraggedDataWindow();
this._validate(this._draggedDataWindow);
this.drawGhost();
evt.stopPropagation();
return true;
case "keypress":
if((evt.charCode!=27&&evt.keyCode!=27)||!this.isInOperation()){
return false;
}
this.drawGhost();
this.abort();
evt.stopPropagation();
return true;
}
return false;
};
ChartZoomInteractor.prototype.abort=function(){
ChartInteractor.prototype.abort.call(this);
this.setAllowDrawGhost(false);
this._zoomOut=false;
this._draggedDataWindow.xRange.empty();
this._draggedDataWindow.yRange.empty();
if(this._ghost.parentNode!=null){
this._ghost.parentNode.removeChild(this._ghost);
}
this.setCursor(null);
};
ChartZoomInteractor.prototype.startOperation=function(evt){
ChartInteractor.prototype.startOperation.call(this,evt);
this.setAllowDrawGhost(true);
if(this._zoomOut){
this.setCursor("-moz-zoom-out");
}else{
this.setCursor("-moz-zoom-in");
}
};
ChartZoomInteractor.prototype.endOperation=function(evt){
ChartInteractor.prototype.endOperation.call(this,evt);
this.setAllowDrawGhost(false);
this._zoomOut=false;
this._draggedDataWindow.xRange.empty();
this._draggedDataWindow.yRange.empty();
if(this._ghost.parentNode!=null){
this._ghost.parentNode.removeChild(this._ghost);
}
this.setCursor(null);
};
ChartZoomInteractor.prototype._validate=function(_18){
var cdw=this.getCoordinateSystem().getVisibleWindow();
if(!this._yZoomAllowed&&!cdw.yRange.equals(_18.yRange)){
_18.yRange.min=cdw.getYMin();
_18.yRange.max=cdw.getYMax();
}
if(!this._xZoomAllowed&&!cdw.xRange.equals(_18.xRange)){
_18.xRange.min=cdw.getXMin();
_18.xRange.max=cdw.getXMax();
}
};
ChartZoomInteractor.prototype.computeDraggedDataWindow=function(){
var _1a;
var _1b;
var _1c;
var _1d;
if(!this._draggedDataWindow){
this._draggedDataWindow=new IlvDataWindow();
}
_1a=Math.min(this._startPoint.getX(0),this._endPoint.getX(0));
_1b=Math.max(this._startPoint.getX(0),this._endPoint.getX(0));
_1c=Math.min(this._startPoint.getY(0),this._endPoint.getY(0));
_1d=Math.max(this._startPoint.getY(0),this._endPoint.getY(0));
this._draggedDataWindow.xRange.set(_1a,_1b);
this._draggedDataWindow.yRange.set(_1c,_1d);
};
ChartZoomInteractor.prototype.getGhostShape=function(){
var cdw=this.getCoordinateSystem().getVisibleWindow();
this._draggedDataWindow.intersection(cdw.xRange,cdw.yRange);
return this.getChart().getProjector().getShape(this._draggedDataWindow,this.getChart().getPlotRect(),this.getCoordinateSystem());
};
ChartZoomInteractor.prototype.drawGhostImpl=function(g){
if(this._draggedDataWindow.isEmpty()){
return;
}
var s=this.getGhostShape();
if(!this._ghost){
if(s.x){
this._ghost=g.ownerDocument.createElementNS(SVG_NS,"rect");
}else{
this._ghost=g.ownerDocument.createElementNS(SVG_NS,"path");
}
this._ghost.setAttributeNS(null,"fill-opacity","0.6");
this._ghost.setAttributeNS(null,"stroke-opacity","0.6");
this._ghost.setAttributeNS(null,"stroke-width","3");
this._ghost.setAttributeNS(null,"shape-rendering","optimizeSpeed");
}
if(s.x){
this._ghost.setAttributeNS(null,"x",s.x);
this._ghost.setAttributeNS(null,"y",s.y);
this._ghost.setAttributeNS(null,"width",s.width);
this._ghost.setAttributeNS(null,"height",s.height);
}else{
this._ghost.setAttributeNS(null,"d",s);
}
if(this._zoomOut){
this._ghost.setAttributeNS(null,"fill","none");
this._ghost.setAttributeNS(null,"stroke","black");
}else{
this._ghost.setAttributeNS(null,"stroke","none");
this._ghost.setAttributeNS(null,"fill","black");
}
if(this._ghost.parentNode==null){
g.appendChild(this._ghost);
}
};
ChartZoomInteractor.prototype.doIt=function(){
this.getChart().zoom(this.getZoomedDataWindow(),this.getYAxisIndex());
};
