/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Steps.prototype=new Object();
function Steps(_1){
this._scale=_1;
this.initTransientFields();
}
Steps.prototype._scale;
Steps.prototype._labels;
Steps.prototype._values;
Steps.prototype._subValues;
Steps.prototype._points;
Steps.prototype._subPoints;
Steps.prototype._wMax;
Steps.prototype._hMax;
Steps.prototype._valuesValid;
Steps.prototype._pointsValid;
Steps.prototype._labelsValid;
Steps.prototype._renderers;
Steps.prototype.update=function(g){
var _3=false;
if(!this.isValuesValid()){
this.recalcValues();
this.recalcPoints();
this.recalcLabels();
this.createTextRenderers();
_3=true;
}else{
if(!this.isPointsValid()){
this.recalcPoints();
_3=true;
}
if(!this.isLabelsValid()){
this.recalcLabels();
this.createTextRenderers();
_3=true;
}else{
_3=this.updateTextRenderers(false)||_3;
}
}
if(_3){
this._scale.invalidateBounds();
}
return _3;
};
Steps.prototype.getLabel=function(_4){
return this._labels[_4];
};
Steps.prototype.computeLabels=function(){
var _5=this._scale.isBetweenCategory()?this._subValues:this._values;
var _6=_5.length;
var _7=(this._labels.length==_6)?this._labels:new Array(_6);
for(var i=0;i<_6;++i){
_7[i]=this._scale.computeLabel(_5[i]);
}
return _7;
};
Steps.prototype.recalcValues=function(){
this._valuesValid=true;
this._scale.computeValues(this._values,this._subValues);
};
Steps.prototype.recalcPoints=function(){
this._pointsValid=true;
this._points=this._scale.getPointsOnAxis(this._values.clone(),this._values.length);
this._subPoints=this._scale.getPointsOnAxis(this._subValues.clone(),this._subValues.length);
};
Steps.prototype.recalcLabels=function(){
this._labels=this.computeLabels();
this._labelsValid=true;
};
Steps.prototype.setRotation=function(_9){
for(var i=this._renderers.length;--i>=0;){
this._renderers[i].setRotation(_9);
}
};
Steps.setWrappingWidth=function(_b){
for(var i=this._renderers.length;--i>=0;){
this._renderers[i].setWrappingWidth(_b);
}
this._scale.invalidateBounds();
};
Steps.prototype.createTextRenderers=function(){
var _d=this._labels;
var _e=_d.length;
var _f=Math.min(this._renderers.length,_e);
var _10=(_e==_f)?this._renderers:new Array(_e);
var i=0;
for(;i<_f;++i){
_10[i]=this.createTextRenderer(_d[i],this._renderers[i]);
}
for(;i<_e;++i){
_10[i]=this.createTextRenderer(_d[i],null);
}
this._renderers=_10;
this.updateTextRenderers(true);
};
Steps.prototype.updateTextRenderers=function(_12){
var _13=false;
var _14=this._scale.getLabelsStyleAttr();
var ds=_12||(this._oldStyle!=_14);
if(ds){
this._oldStyle=_14;
var lp;
var _17=0,_18=0;
var _19;
for(var i=this._renderers.length;--i>=0;){
lp=this._renderers[i];
if(ds){
lp.setStyleAttr(_14);
}
_19=lp.getBounds(true);
if(_19.width>_17){
_17=_19.width;
}
if(_19.height>_18){
_18=_19.height;
}
}
this._wMax=_17;
this._hMax=_18;
_13=true;
}
return _13;
};
Steps.prototype.getTextRenderer=function(idx){
return this._renderers[idx];
};
Steps.prototype.createTextRenderer=function(_1c,_1d){
if(_1d==null){
_1d=new TextRenderer(_1c);
}else{
_1d.setText(_1c);
}
_1d.setRotation(this._scale.getLabelRotation());
return _1d;
};
Steps.prototype.getLabelValues=function(){
return this._scale.isBetweenCategory()?this.getSubValues():this.getValues();
};
Steps.prototype.getValues=function(){
return this._values;
};
Steps.prototype.getSubValues=function(){
return this._subValues;
};
Steps.prototype.getPoints=function(){
return this._points;
};
Steps.prototype.getSubPoints=function(){
return this._subPoints;
};
Steps.prototype.getLabelPoints=function(){
return this._scale.isBetweenCategory()?this._subPoints:this._points;
};
Steps.prototype.getMaxWidth=function(){
return this._wMax;
};
Steps.prototype.getMaxHeight=function(){
return this._hMax;
};
Steps.prototype.invalidateValues=function(){
this._valuesValid=false;
};
Steps.prototype.invalidatePoints=function(){
this._pointsValid=false;
};
Steps.prototype.invalidateLabels=function(){
this._labelsValid=false;
};
Steps.prototype.isValuesValid=function(){
return this._valuesValid;
};
Steps.prototype.isLabelsValid=function(){
return this._labelsValid;
};
Steps.prototype.isPointsValid=function(){
return this._pointsValid;
};
Steps.prototype.initTransientFields=function(){
this._values=new Array();
this._subValues=new Array();
this._renderers=new Array(0);
this._labels=new Array(0);
};
