/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

CombinedDataSet.prototype=new IlvDataSet();
CombinedDataSet.prototype._dataSets;
CombinedDataSet.prototype._dataCount;
function CombinedDataSet(){
IlvDataSet.call(this);
this._dataSets=new Array();
}
CombinedDataSet.prototype.getDataCount=function(){
return this._dataCount;
};
CombinedDataSet.prototype.isXValuesSorted=function(){
return false;
};
CombinedDataSet.prototype.getDataSetCount=function(){
return this._dataSets.length;
};
CombinedDataSet.prototype.getDataSet=function(_1){
return this._dataSets[_1];
};
CombinedDataSet.prototype.getDataSets=function(){
return this._dataSets.clone();
};
CombinedDataSet.prototype.getDataSetIndex=function(_2){
return this._dataSets.indexOf(_2);
};
CombinedDataSet.prototype.setDataSet=function(_3,_4){
if(this._dataSets.getDataSet(_3)!=_4){
this._dataSets[_3]=_4;
_4.addEventListener("contentsChanged",this);
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
}
};
CombinedDataSet.prototype.setDataSets=function(_5){
var _6=(_5!=null?_5.length:0);
var _7=(_6==this._dataSets.length);
for(var i=0;_7&&i<_6;i++){
_7=(this._dataSets.getDataSet(i)==_5[i]);
}
if(!_7){
if(_5!=null){
this._dataSets=_5.clone();
}else{
this._dataSets.splice(0,this._dataSets.length);
}
for(var i=0;i<_6;i++){
_5[i].addEventListener("contentsChanged",this);
}
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
}
};
CombinedDataSet.prototype.addDataSet=function(_9){
this._dataSets.push(_9);
_9.addEventListener("contentsChanged",this);
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
};
CombinedDataSet.prototype.addDataSetAt=function(_a,_b){
this._dataSets.addItemAt(_a,_b);
_b.addEventListener("contentsChanged",this);
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
};
CombinedDataSet.prototype.removeDataSet=function(_c){
_dataSets.splice(_c,1);
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
};
CombinedDataSet.prototype.removeDataSet=function(_d){
if(_dataSets.removeDataSet(_d)!=-1){
this.dataSetsChanged();
this.dispatchEvent(new DataSetContentsEvent());
return true;
}else{
return false;
}
};
CombinedDataSet.prototype.dataSetContentsChanged=function(_e){
if(_e.getType()!=DataSetContentsEvent.BEFORE_DATA_CHANGED&&_e.getType()!=DataSetContentsEvent.DATA_LABEL_CHANGED){
this.updateDataCount();
this.setLimitsValid(false);
}
};
CombinedDataSet.prototype.dataSetsChanged=function(){
this.updateDataCount();
this.setLimitsValid(false);
};
CombinedDataSet.prototype.updateDataCount=function(){
this._dataCount=this.computeDataCount();
};
CombinedDataSet.prototype.computeDataCount=function(){
var _f=this.getDataSetCount();
if(_f>0){
var _10=this.getDataSet(0).getDataCount();
for(var i=1;i<_f;++i){
_10=Math.min(_10,this.getDataSet(i).getDataCount());
}
return _10;
}else{
return 0;
}
};
CombinedDataSet.prototype.contentsChanged=function(evt){
this.dataSetContentsChanged(evt);
};
