/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

IlvDataSet.DEFAULT_UNDEF_VALUE=Number.MIN_VALUE;
IlvDataSet.prototype._xRange;
IlvDataSet.prototype._yRange;
IlvDataSet.prototype._undefValue=null;
IlvDataSet.prototype._limitsValid;
IlvDataSet.prototype._batch;
IlvDataSet.prototype._batchCount;
function Batch(){
}
Batch.prototype.firstIdx=Number.MAX_VALUE;
Batch.prototype.lastIdx=Number.MIN_VALUE;
Batch.prototype.eventType=-1;
Batch.prototype.addEvent=function(_1,_2,_3){
if(this.eventType==-1){
this.eventType=_1;
this.firstIdx=_2;
this.lastIdx=_3;
}else{
if(this.eventType==DataSetContentsEvent.FULL_UPDATE){
return;
}else{
if(_1!=DataSetContentsEvent.DATA_ADDED){
this.eventType=DataSetContentsEvent.FULL_UPDATE;
this.firstIdx=0;
this.lastIdx=0;
}else{
if(_2<this.firstIdx){
this.firstIdx=_2;
}
if(_3>this.lastIdx){
this.lastIdx=_3;
}
}
}
}
};
Batch.prototype.isValid=function(){
return this.lastIdx>=this.firstIdx;
};
IlvDataSet.DATASOURCE_KEY="_DATASOURCE_";
EventDispatcher.initialize(IlvDataSet.prototype);
function IlvDataSet(){
this._xRange=new IlvDataInterval();
this._yRange=new IlvDataInterval();
this._limitsValid=false;
this._batchCount=0;
}
IlvDataSet.prototype.getDataSource=function(){
return this.getProperty(IlvDataSet.DATASOURCE_KEY);
};
IlvDataSet.prototype.getXRange=function(_4){
var _5=this.iGetXRange();
if(_4==null){
return new IlvDataInterval(_5.getMin(),_5.getMax());
}
_4.setMin(_5.getMin());
_4.setMax(_5.getMax());
return _4;
};
IlvDataSet.prototype.getYRange=function(_6){
var _7=this.iGetYRange();
if(_6==null){
return new IlvDataInterval(_7.getMin(),_7.getMax());
}
_6.setMin(_7.getMin());
_6.setMax(_7.getMax());
return _6;
};
IlvDataSet.prototype.getXMin=function(){
return this.iGetXRange().getMin();
};
IlvDataSet.prototype.getXMax=function(){
return this.iGetXRange().getMax();
};
IlvDataSet.prototype.getYMin=function(){
return this.iGetYRange().getMin();
};
IlvDataSet.prototype.getYMax=function(){
return this.iGetYRange().getMax();
};
IlvDataSet.prototype.iGetXRange=function(){
if(!this._limitsValid){
this.computeLimits();
}
return this._xRange;
};
IlvDataSet.prototype.iGetYRange=function(){
if(!this._limitsValid){
this.computeLimits();
}
return this._yRange;
};
IlvDataSet.prototype.setLimitsValid=function(_8){
this._limitsValid=_8;
};
IlvDataSet.prototype.invalidateLimits=function(){
this.setLimitsValid(false);
};
IlvDataSet.prototype.computeLimits=function(_9,_a){
if(!_9&&!_a){
this.setLimitsValid(true);
_9=this._xRange;
_a=this._yRange;
}
var _b=this.getDataCount();
_9.empty();
_a.empty();
var _c=this.getUndefValue();
if(_c!=null){
for(var i=0;i<_b;++i){
if(MathUtil.eq(this.getYData(i),_c)){
continue;
}
_9.addValue(this.getXData(i));
_a.addValue(this.getYData(i));
}
}else{
for(var i=0;i<_b;++i){
_9.addValue(this.getXData(i));
_a.addValue(this.getYData(i));
}
}
};
IlvDataSet.prototype.isXValuesSorted=function(){
return false;
};
IlvDataSet.prototype.getDataCount=function(){
return 0;
};
IlvDataSet.prototype.getXData=function(_e){
return 0;
};
IlvDataSet.prototype.getYData=function(_f){
return 0;
};
IlvDataSet.prototype.addData=function(x,y){
};
IlvDataSet.prototype.setDataAt=function(idx,x,y){
};
IlvDataSet.prototype.isEditable=function(){
return false;
};
IlvDataSet.prototype.setUndefValue=function(_15){
var _16=this._undefValue;
this._undefValue=_15;
};
IlvDataSet.prototype.getUndefValue=function(){
return this._undefValue;
};
IlvDataSet.prototype.startBatch=function(){
if(this._batch==null){
this._batch=new Batch();
}
this._batchCount++;
};
IlvDataSet.prototype.endBatch=function(){
if(this._batch==null){
return;
}
this._batchCount--;
if(this._batchCount!=0){
return;
}
if(this._batch.isValid()){
this.dispatchEvent(new DataSetContentsEvent(this._batch.eventType,this._batch.firstIdx,this._batch.lastIdx));
}
this._batch=null;
};
IlvDataSet.prototype.isBatched=function(){
return this._batch!=null;
};
IlvDataSet.prototype.dataChanged=function(_17,_18,_19){
if(_19!=DataSetContentsEvent.BEFORE_DATA_CHANGED){
this.setLimitsValid(false);
}
if(this.isBatched()){
this.addBatchEvent(_19,_17,_18);
}else{
this.fireDataChangedEvent(_17,_18,_19);
}
};
IlvDataSet.prototype.dataAdded=function(idx){
if(this._limitsValid){
this._xRange.addValue(this.getXData(idx));
this._yRange.addValue(this.getYData(idx));
}
if(this.isBatched()){
this.addBatchEvent(DataSetContentsEvent.DATA_ADDED,idx,idx);
}else{
this.fireDataAddedEvent(idx,idx);
}
};
IlvDataSet.prototype.addBatchEvent=function(_1b,_1c,_1d){
this._batch.addEvent(_1b,_1c,_1d);
};
IlvDataSet.prototype.fireDataAddedEvent=function(_1e,_1f){
this.dispatchEvent(new DataSetContentsEvent(DataSetContentsEvent.DATA_ADDED,_1e,_1f));
};
IlvDataSet.prototype.fireDataChangedEvent=function(_20,_21,_22){
this.dispatchEvent(new DataSetContentsEvent(_22,_20,_21));
};
IlvDataSet.prototype.getData=function(){
return this.getDataBetween(0,this.getDataCount()-1);
};
IlvDataSet.prototype.getDataBetween=function(_23,_24){
var _25=this.getDataCount();
var res=null;
if(_23<0){
_23=0;
}
if(_24>=_25){
_24=_25-1;
}
if(_23<=_24){
var _27=_24-_23+1;
res=new DataPoints(this,_27);
this.fillValues(res,_23,_24);
var _28=res.getIndices();
for(var i=0;i<_27;i++,_23++){
_28[i]=_23;
}
}
return res;
};
IlvDataSet.prototype.getDataInside=function(_2a,_2b,_2c){
var _2d=this.getDataCount();
if((_2d==0)||!_2a.xRange.intersects(this.iGetXRange())){
return null;
}
var _2e;
var _2f;
if(this.isXValuesSorted()){
_2e=_2a.getXMin()<=this.getXMin()?0:this.getFirstInside(_2a.xRange);
_2f=_2a.getXMax()>=this.getXMax()?_2d-1:this.getLastInside(_2a.xRange);
}else{
for(_2f=_2d-1;_2f!=0;--_2f){
if(this.getXData(_2f)<=_2a.xRange.getMax()){
break;
}
}
for(_2e=0;_2e<_2d;++_2e){
if(this.getXData(_2e)>=_2a.xRange.getMin()){
break;
}
}
}
if(_2b>0){
_2e=Math.max(_2e-_2b,0);
_2f=Math.min(this.getDataCount()-1,_2f+_2b);
}
var res=this.getDataBetween(_2e,_2f);
if((res!=null)&&!_2c){
if(this.isXValuesSorted()){
IlvDataSet.pruneYValues(res,_2e,_2a.yRange);
}else{
IlvDataSet.pruneXYValues(res,_2e,_2a.xRange,_2a.yRange);
}
}
return res;
};
IlvDataSet.pruneYValues=function(res,_32,_33){
var _34=res.size();
var _35=res.getIndices();
var xv=res.getXValues();
var yv=res.getYValues();
var i=0;
for(;i<_34;++i){
if(!_33.isInside(yv[i])){
break;
}
}
var j=i;
for(;i<_34;++i){
if(_33.isInside(yv[i])){
xv[j]=xv[i];
yv[j]=yv[i];
_35[j++]=_32+i;
}
}
res.setSize(j);
};
IlvDataSet.pruneXYValues=function(res,_3b,_3c,_3d){
var _3e=res.size();
var _3f=res.getIndices();
var xv=res.getXValues();
var yv=res.getYValues();
var i=0;
for(;i<_3e;++i){
if(!_3d.isInside(yv[i])||!_3c.isInside(xv[i])){
break;
}
}
var j=i;
for(;i<_3e;++i){
if(_3d.isInside(yv[i])&&_3c.isInside(xv[i])){
xv[j]=xv[i];
yv[j]=yv[i];
_3f[j++]=_3b+i;
}
}
res.setSize(j);
};
IlvDataSet.prototype.getFirstInside=function(_44){
var idx=this.searchData(_44.getMin());
if(idx<0){
return -idx-1;
}else{
while((--idx>0)&&(this.getXData(idx)==_44.getMin())){
}
return idx+1;
}
};
IlvDataSet.prototype.getLastInside=function(_46){
var idx=this.searchData(_46.getMax());
if(idx<0){
return -idx-2;
}else{
var _48=this.getDataCount();
while((++idx<_48)&&(this.getXData(idx)==_46.getMax())){
}
return idx-1;
}
};
IlvDataSet.prototype.searchData=function(val){
var hi=this.getDataCount()-1;
var lo=0;
var x;
while(lo<=hi){
var idx=Math.floor((hi+lo)/2);
x=this.getXData(idx);
if(x<val){
lo=idx+1;
}else{
if(x>val){
hi=idx-1;
}else{
return idx;
}
}
}
return -(lo+1);
};
IlvDataSet.prototype.fillValues=function(_4e,_4f,_50){
for(var i=_4f;i<=_50;i++){
_4e.addValues(this.getXData(i),this.getYData(i),i);
}
};
IlvDataSet.prototype.getProperty=function(key){
return this[key];
};
IlvDataSet.prototype.putProperty=function(key,_54){
this[key]=_54;
};
IlvDataSet.prototype.toString=function(){
return "DataSet "+" "+this.getName()+" "+this.iGetXRange()+" / "+this.iGetYRange();
};
IlvDataSet.prototype.getName=function(){
return this.getProperty("__NAME_KEY__");
};
IlvDataSet.prototype.setName=function(_55){
return this.putProperty("__NAME_KEY__",_55);
};
IlvDataSet.prototype.getDataLabel=function(idx){
return "";
};
