/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

XMLStreamDataSource.prototype=new DefaultDataSource();
XMLStreamDataSource.prototype.warningsCount=0;
XMLStreamDataSource.prototype.errorsCount=0;
XMLStreamDataSource.prototype.delay=5000;
XMLStreamDataSource.prototype.timestamp="0";
XMLStreamDataSource.ADOBE=window.navigator.appName.indexOf("Adobe")!=-1;
function XMLStreamDataSource(_1,_2){
DefaultDataSource.call(this);
this.url=_1;
if(_2!=undefined){
this.delay=_2;
}
}
XMLStreamDataSource.prototype.init=function(_3){
if(!_3){
getURL(this.url,this);
}else{
var ds=this;
var _5=new Object();
_5.operationComplete=function(_6){
_6.oncompleted=_3;
ds.operationComplete(_6);
};
getURL(this.url,_5);
}
};
XMLStreamDataSource.prototype.update=function(_7,_8){
if(_8&&this.runningTimer){
if(XMLStreamDataSource.ADOBE){
window.parent.clearTimeout(this.runningTimer);
}else{
clearTimeout(this.runningTimer);
}
}
this.runningTimer=null;
if(!_7){
getURL(this.url+"&since="+this.timestamp,this);
}else{
var ds=this;
var _a=new Object();
_a.operationComplete=function(_b){
_b.oncompleted=_7;
ds.operationComplete(_b);
};
getURL(this.url+"&since="+this.timestamp,_a);
}
};
XMLStreamDataSource.prototype.operationComplete=function(_c){
if(_c.success){
this.errorsCount=0;
this.warningsCount=0;
if(_c.content){
_c.contentXML=parseXML(_c.content,document);
}
var _d=_c.contentXML.firstChild;
this.updateFrom(_d,_c);
this.timestamp=_d.getAttributeNS(null,"timestamp");
if(this.delay>0){
if(!this.fRef){
var ds=this;
this.fRef=function(){
ds.update();
};
}
if(XMLStreamDataSource.ADOBE){
this.runningTimer=window.parent.setTimeout(this.fRef,this.delay);
}else{
this.runningTimer=setTimeout(this.fRef,this.delay);
}
}
}else{
this.warningsCount++;
if(this.warningsCount<10){
if(!this.fRef){
var ds=this;
this.fRef=function(){
return ds.update(_c.oncompleted);
};
}
if(XMLStreamDataSource.ADOBE){
this.runningTimer=window.parent.setTimeout(this.fRef,this.delay+5000);
}else{
this.runningTimer=setTimeout(this.fRef,this.delay+5000);
}
}else{
this.showWarningButton(_c.oncompleted);
}
}
};
XMLStreamDataSource.prototype.showWarningButton=function(_f){
if(this.warningButton){
return;
}
var _10=document.documentElement;
var ref=null;
try{
ref=_10.getBBox();
}
catch(e){
ref=_10.getElementsByTagNameNS(SVG_NS,"g").item(0).getBBox();
}
this.warningButton=DrawUtil.createContainer(document);
var _12=document.createElementNS(SVG_NS,"rect");
var _13=document.createElementNS(SVG_NS,"text");
var _14=document.createTextNode("Disconnected - Push to Reconnect");
_13.appendChild(_14);
var _15=null;
try{
_15=_13.getBBox();
}
catch(e){
_10.appendChild(this.warningButton);
this.warningButton.appendChild(_13);
_15=_13.getBBox();
}
this.warningButton.setAttributeNS(null,"pointer-events","all");
_12.setAttributeNS(null,"x",ref.x+10+_15.x);
_12.setAttributeNS(null,"y",ref.y+15+_15.y);
_12.setAttributeNS(null,"width",_15.width+10);
_12.setAttributeNS(null,"height",_15.height+10);
_12.setAttributeNS(null,"rx",2);
_12.setAttributeNS(null,"ry",2);
_12.setAttributeNS(null,"fill","red");
_12.setAttributeNS(null,"stroke","black");
_12.setAttributeNS(null,"fill-opacity","0.6");
_13.setAttributeNS(null,"x",ref.x+15);
_13.setAttributeNS(null,"y",ref.y+20);
_13.setAttributeNS(null,"fill","black");
_13.setAttributeNS(null,"pointer-events","none");
this.warningButton.appendChild(_12);
this.warningButton.appendChild(_13);
this.warningButton.addEventListener("mousedown",new ButtonListener(this,_f),false);
_10.appendChild(this.warningButton);
};
function ButtonListener(ds,_17){
this.oncompleted=_17;
this.ds=ds;
}
ButtonListener.prototype.handleEvent=function(evt){
evt.stopPropagation();
evt.preventDefault();
this.ds.warningButton.parentNode.removeChild(this.ds.warningButton);
this.ds.warningButton=null;
this.ds.update(this.oncompleted);
};
XMLStreamDataSource.prototype.updateFrom=function(_19,_1a){
var _1b=_19.firstChild;
if(_1b){
if(_1b.nodeName=="addDataSet"||_1b.nodeName=="removeDataSet"||_1b.nextSibling){
this.startBatch();
}
if(this.processUpdate(_1b)){
while(_1b.nextSibling){
_1b=_1b.nextSibling;
if(!this.processUpdate(_1b)){
break;
}
}
}
}
if(_1a.oncompleted){
_1a.oncompleted.call(null,_1a);
}
if(_1b&&this.isBatched()){
this.endBatch();
}
};
XMLStreamDataSource.prototype.processUpdate=function(_1c){
if(_1c.nodeName=="addDataSet"){
var ds=this.processAddDataSet(_1c);
var _1e=_1c.firstChild;
if(_1e){
this.processPoint(_1e,ds);
while(_1e.nextSibling){
_1e=_1e.nextSibling;
this.processPoint(_1e,ds);
}
}
var _1f=parseInt(_1c.getAttributeNS(null,"index"));
if(_1f==this.getDataSetCount()){
this.addDataSet(ds);
}else{
this.addDataSetAt(_1f,ds);
}
}else{
if(_1c.nodeName=="changePoints"){
var ds=this.getDataSetPerId(_1c.getAttributeNS(null,"id"));
if(ds){
ds.startBatch();
var _1e=_1c.firstChild;
this.processPoint(_1e,ds,_1c.getAttributeNS(null,"type"));
while(_1e.nextSibling){
_1e=_1e.nextSibling;
this.processPoint(_1e,ds);
}
ds.endBatch();
}else{
this.errorsCount++;
if(this.errorsCount==1){
this.setDataSets(new Array());
this.init();
return false;
}else{
alert("[ERROR] document references wrong ID in changePoints\n"+"Try to refresh web page");
return false;
}
}
}else{
if(_1c.nodeName=="removeDataSet"){
if(_1c.getAttributeNS(null,"all")==true){
this.setDataSets(new Array());
}else{
var ds=this.getDataSetPerId(_1c.getAttributeNS(null,"id"));
if(ds){
this.setDataSet(this.getDataSetIndex(ds),null);
}else{
this.errorsCount++;
if(this.errorsCount==1){
this.setDataSets(new Array());
this.init();
return false;
}else{
alert("[ERROR] document references wrong ID removeDataSet\n"+"Try to refresh web page");
return false;
}
}
}
}else{
if(_1c.nodeName=="updateDataSet"){
var ds=this.getDataSetPerId(_1c.getAttributeNS(null,"id"));
if(ds){
if(_1c.hasAttributeNS(null,"name")){
ds.setName(_1c.getAttributeNS(null,"name"));
}
if(_1c.hasAttributeNS(null,"undefValue")&&_1c.getAttributeNS(null,"undefValue")!=""){
ds.setUndefValue(parseFloat(_1c.getAttributeNS(null,"undefValue")));
}
}else{
this.errorsCount++;
if(this.errorsCount==1){
this.setDataSets(new Array());
this.init();
return false;
}else{
alert("[ERROR] document references wrong ID removeDataSet\n"+"Try to refresh web page");
return false;
}
}
}
}
}
}
return true;
};
XMLStreamDataSource.prototype.processAddDataSet=function(_20){
var ds=new DefaultDataSet(_20.getAttributeNS(null,"name"),null,new Array(),_20.hasAttributeNS(null,"xSorted")?_20.getAttributeNS(null,"xSorted"):false);
if(_20.hasAttributeNS(null,"undefValue")&&_20.getAttributeNS(null,"undefValue")!=""){
ds.setUndefValue(parseFloat(_20.getAttributeNS(null,"undefValue")));
}
ds.id=_20.getAttributeNS(null,"id");
return ds;
};
XMLStreamDataSource.prototype.processPoint=function(_22,ds,_24){
if(!_22){
return;
}
if(_22.tagName=="point"){
var _25=parseInt(_22.getAttributeNS(null,"index"));
var x=parseFloat(_22.getAttributeNS(null,"x"));
if(x!=_25){
ds.useXValues(true);
}
if(_22.hasAttributeNS(null,"label")){
ds.useLabels(true);
}
if(_24=="add"&&_25==ds.getDataCount()){
ds.addData(x,parseFloat(_22.getAttributeNS(null,"y")),_22.getAttributeNS(null,"label"));
}else{
ds.setDataAt(_25,x,parseFloat(_22.getAttributeNS(null,"y")),_22.getAttributeNS(null,"label"));
}
}
};
XMLStreamDataSource.prototype.getDataSetPerId=function(id){
for(var i=0;i<this._dataSets.length;i++){
if(this._dataSets[i].id==id){
return this._dataSets[i];
}
}
return null;
};
