/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

AbstractStackedDataSet.prototype=new VirtualDataSet();
AbstractStackedDataSet.prototype._previous;
AbstractStackedDataSet.prototype._yData;
AbstractStackedDataSet.prototype._iMin=Number.MAX_VALUE;
AbstractStackedDataSet.prototype._iMax=Number.MIN_VALUE;
function AbstractStackedDataSet(_1){
VirtualDataSet.call(this);
this._yData=new Array();
this._previous=_1;
}
AbstractStackedDataSet.prototype.getName=function(){
var _2=this.getRefDataSet();
return (_2!=null?_2.getName():null);
};
AbstractStackedDataSet.prototype.isXValuesSorted=function(){
return (this.getDataSetCount()>0)?this.getDataSet(0).isXValuesSorted():true;
};
AbstractStackedDataSet.prototype.getUndefValue=function(){
var _3=this.getRefDataSet();
return (_3!=null&&_3.getUndefValue()!=null?IlvDataSet.DEFAULT_UNDEF_VALUE:null);
};
AbstractStackedDataSet.prototype.map=function(p){
p.dataSet=this;
};
AbstractStackedDataSet.prototype.unmap=function(_5,_6){
_5.dataSet=this.getRefDataSet();
};
AbstractStackedDataSet.prototype.isEditable=function(){
return true;
};
AbstractStackedDataSet.prototype.getPreviousYData=function(_7){
var ds=this._previous;
while(ds!=null){
var v=ds.getYData(_7);
var _a=ds.getUndefValue();
if(!((_a!=null&&MathUtil.eq(v,_a)))){
return v;
}
ds=ds._previous;
}
return IlvDataSet.DEFAULT_UNDEF_VALUE;
};
AbstractStackedDataSet.prototype.dataSetContentsChanged=function(_b){
VirtualDataSet.prototype.dataSetContentsChanged.call(this,_b);
var _c=this.getDataCount();
if(_b.getType()!=DataSetContentsEvent.FULL_UPDATE&&(_b.getFirstIdx()>=_c||_b.getLastIdx()>=_c)){
return;
}
var _d=_b.getLastIdx();
if(_b.getType()==DataSetContentsEvent.AFTER_DATA_CHANGED||_b.getType()==DataSetContentsEvent.DATA_CHANGED||_b.getType()==DataSetContentsEvent.DATA_ADDED||_b.getType()==DataSetContentsEvent.FULL_UPDATE){
var _e=false;
if(_b.getType()==DataSetContentsEvent.FULL_UPDATE){
_e=true;
_d=_c-1;
}
this.invalidateStackedData(_b.getFirstIdx(),_d,_e);
}
var _f=new DataSetContentsEvent(_b.getType(),_b.getFirstIdx(),_d);
this.dispatchEvent(_f);
};
AbstractStackedDataSet.prototype.dataSetsChanged=function(){
VirtualDataSet.prototype.dataSetsChanged.call(this);
var _10=this.getDataCount();
if(_10>0){
this.invalidateStackedData(0,_10-1,true);
}
};
AbstractStackedDataSet.prototype.getXData=function(idx){
return this.getDataSet(0).getXData(idx);
};
AbstractStackedDataSet.prototype.getYData=function(idx){
this.updateStackedData();
return this._yData[idx];
};
AbstractStackedDataSet.prototype.updateStackedData=function(){
if(this._iMin==Number.MAX_VALUE){
return;
}
if(this._yData.length==0){
var _13=this.getDataCount();
if(_13>0){
this._yData=this.computeStackedData(this._yData,0,_13-1);
}
}else{
this._yData=this.computeStackedData(this._yData,this._iMin,this._iMax);
}
this._iMin=Number.MAX_VALUE;
this._iMax=Number.MIN_VALUE;
};
AbstractStackedDataSet.prototype.invalidateStackedData=function(_14,_15,_16){
if(_14<this._iMin){
this._iMin=_14;
}
if(_15>this._iMax){
this._iMax=_15;
}
if(_16){
this._yData.splice(0,this._yData.length);
}
};
AbstractStackedDataSet.prototype.computeStackedData=function(_17,_18,_19){
};
