/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

BarChartRenderer.prototype=new SimpleCompositeChartRenderer();
BarChartRenderer.SUPERIMPOSED=1;
BarChartRenderer.CLUSTERED=2;
BarChartRenderer.STACKED=3;
BarChartRenderer.prototype._barPercent;
BarChartRenderer.prototype._config;
BarChartRenderer.prototype._mode;
BarChartRenderer.prototype._autoTransparency=true;
function BarChartRenderer(_1,_2){
SimpleCompositeChartRenderer.call(this,true);
this._barPercent=!_2?Constants.DEFAULT_WIDTH:_2;
this.setMode(!_1?BarChartRenderer.CLUSTERED:_1);
if(this._mode==BarChartRenderer.CLUSTERED){
this._config.setClusterWidth(this._barPercent);
}
}
BarChartRenderer.prototype.setMode=function(_3){
if(_3==this._mode){
return;
}
if(this._config!=null){
this._config.desactivate();
}
var _4=this._mode;
this._mode=_3;
this.createConfig();
this.propagateWidthPercent();
this._config.activate();
if((_3==BarChartRenderer.SUPERIMPOSED||_4==BarChartRenderer.SUPERIMPOSED)&&this._autoTransparency){
this.resetDefaultStyles();
}
};
BarChartRenderer.prototype.getMode=function(){
return this._mode;
};
BarChartRenderer.prototype.createConfig=function(){
switch(this.getMode()){
case BarChartRenderer.STACKED:
this._config=new StackedRendererConfig(this,false);
break;
case BarChartRenderer.SUPERIMPOSED:
this._config=new SuperimposedRendererConfig(this);
break;
case BarChartRenderer.CLUSTERED:
this._config=new ClusteredRendererConfig(this);
break;
}
};
BarChartRenderer.prototype.getConfig=function(){
return this._config;
};
BarChartRenderer.prototype.isStacked100Percent=function(){
if(this.getMode()==BarChartRenderer.STACKED){
return this._config.isStacked100Percent();
}else{
return false;
}
};
BarChartRenderer.prototype.setStacked100Percent=function(_5){
if(this.getMode()!=BarChartRenderer.STACKED){
return;
}
if(_5!=this._config.isStacked100Percent()){
this._config.setStacked100Percent(_5);
}
};
BarChartRenderer.prototype.setOverlap=function(_6){
if(this.getMode()!=BarChartRenderer.CLUSTERED){
return;
}
if(_6!=this._config.getOverlap()){
this._config.setOverlap(_6);
}
};
BarChartRenderer.prototype.getOverlap=function(){
return (this.getMode()==BarChartRendererCLUSTERED)?this._config.getOverlap():0;
};
BarChartRenderer.prototype.setClusterWidth=function(_7){
if(this.getMode()!=BarChartRenderer.CLUSTERED){
return;
}
this.setWidthPercent(_7);
};
BarChartRenderer.prototype.getClusterWidth=function(){
return this.getWidthPercent();
};
BarChartRenderer.prototype.setWidthPercent=function(_8){
if(_8!=this._barPercent){
this._barPercent=_8;
this.propagateWidthPercent();
}
};
BarChartRenderer.prototype.propagateWidthPercent=function(){
var _9=this.getChildCount();
for(var i=0;i<_9;++i){
this.getChild(i).setWidthPercent(this._barPercent);
}
if(this.getMode()==BarChartRenderer.CLUSTERED){
this._config.setClusterWidth(this._barPercent);
}else{
if(this.getMode()==BarChartRenderer.SUPERIMPOSED){
this._config.updateChildren();
}
}
};
BarChartRenderer.prototype.getWidthPercent=function(){
return this._barPercent;
};
BarChartRenderer.prototype.getWidth=function(){
var _b=this.getChildCount();
var _c=0;
var _d;
for(var i=0;i<_b;++i){
_d=this.getChild(i);
if(this.getMode()==BarChartRenderer.CLUSTERED){
_c+=_d.getWidth();
}else{
if(_d.getWidth()>_c){
_c=_d.getWidth();
}
}
}
return _c;
};
BarChartRenderer.prototype.getDrawRenderers=function(){
return this._config.getDrawRenderers();
};
BarChartRenderer.prototype.updateChildren=function(){
SimpleCompositeChartRenderer.prototype.updateChildren.call(this);
this._config.updateChildren();
for(var i=0;i<this.getChildCount();++i){
var _10=this.getChild(i);
_10.setChildIndex(i);
}
};
BarChartRenderer.prototype.dataSetsAdded=function(_11,_12,_13){
SimpleCompositeChartRenderer.prototype.dataSetsAdded.call(this,_11,_12,_13);
for(var i=_11;i<=_12;++i){
var _15=this.getDataSource().getDataSet(i);
this.getConfig().dataSetAdded(_15);
}
};
BarChartRenderer.prototype.dataSetsRemoved=function(_16,_17,_18){
SimpleCompositeChartRenderer.prototype.dataSetsRemoved.call(this,_16,_17,_18);
for(var i=_16;i<=_17;++i){
var _1a=_18[i];
this.getConfig().dataSetRemoved(_1a);
}
};
BarChartRenderer.prototype.createChild=function(_1b){
return new SingleBarRenderer(null,this._barPercent);
};
BarChartRenderer.prototype.isAutoTransparency=function(){
return this._autoTransparency;
};
BarChartRenderer.prototype.setAutoTransparency=function(_1c){
if(_1c!=this._autoTransparency){
this._autoTransparency=_1c;
this.resetDefaultStyles();
}
};
BarChartRenderer.prototype.isSuperimposed=function(){
return this._mode==BarChartRenderer.SUPERIMPOSED;
};
