/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

ComboChartRenderer.prototype=new CompositeChartRenderer();
ComboChartRenderer.COMBO_RENDERING_TYPE_PROPERTY="__COMBO__";
ComboChartRenderer.prototype._renderers;
function ComboChartRenderer(){
CompositeChartRenderer.call(this,true);
this._renderers=new Array();
}
ComboChartRenderer.prototype.createChild=function(_1){
return ChartRenderer.createRenderer(ComboChartRenderer.getType(_1));
};
ComboChartRenderer.getType=function(_2){
var _3=_2.getProperty(ComboChartRenderer.COMBO_RENDERING_TYPE_PROPERTY);
if(_3==undefined){
_3=ChartRenderer.POLYLINE;
}
return _3;
};
ComboChartRenderer.setType=function(_4,_5){
_4.putProperty(ComboChartRenderer.COMBO_RENDERING_TYPE_PROPERTY,_5);
};
ComboChartRenderer.prototype.dataSetsRemoved=function(_6,_7,_8){
this.reinitChildren();
};
ComboChartRenderer.prototype.dataSetsAdded=function(_9,_a,_b){
this.reinitChildren();
};
ComboChartRenderer.prototype.reinitChildren=function(){
var _c=this.getDataSource();
var _d=_c.getDataSetCount();
while(this.getChildCount()>0){
var _e=this.getChild(this.getChildCount()-1);
_e.getDataSource().setDataSets(null);
this.removeChild(_e);
}
this._renderers=new Array();
var _f=0;
for(var i=0;i<_d;++i){
var _11=_c.getDataSet(i);
if(window.getDataSetProperties){
var _12=getDataSetProperties(_11,new Object());
if(_12["renderingType"]!=undefined){
ComboChartRenderer.setType(_11,_12["renderingType"]);
}else{
ComboChartRenderer.setType(_11,null);
}
}
var p=_11.getProperty(ComboChartRenderer.COMBO_RENDERING_TYPE_PROPERTY);
if(p==undefined){
p=ChartRenderer.POLYLINE;
}
var r=this._renderers[p];
if(r==null){
r=this.createChild(_11);
this._renderers[p]=r;
this.addChild(_f++,r);
}
r.getDataSource().addDataSet(_11);
}
};
ComboChartRenderer.prototype.updateChildren=function(){
var _15=this.getChildCount();
for(var i=0;i<_15;++i){
this.getChild(i).updateChildren();
}
};
ComboChartRenderer.prototype.createLegendItems=function(){
var _17=null;
if(this.isViewable()){
_17=new Array();
var _18=this.getDataSource();
var _19=_18.getDataSetCount();
for(var i=0;i<_19;++i){
var _1b=this.getSingleChild(_18.getDataSet(i));
if(_1b!=null){
var _1c=_1b.createLegendItems();
if(_1c!=null){
for(var j=0;j<_1c.length;j++){
_17.push(_1c[j]);
}
}
}
}
}
return _17;
};
ComboChartRenderer.prototype.getSingleChild=function(_1e){
var _1f=this.getChildCount();
for(var i=0;i<_1f;++i){
var r=this.getChild(i).getChildForDS(_1e);
if(r!=null){
return r;
}
}
return null;
};
ComboChartRenderer.prototype.getNextRenderer=function(_22){
var _23=this.getChild(this.getChildIndex(_22)+1);
if(_23){
return _23.getChild(0);
}else{
return null;
}
};
