/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

CompositeChartRenderer.prototype=new ChartRenderer();
function CompositeChartRenderer(_1){
if(_1){
ChartRenderer.call(this,true);
this._children=new Array();
}
}
CompositeChartRenderer.prototype._children;
CompositeChartRenderer.prototype._childStyles;
CompositeChartRenderer.prototype.isViewable=function(){
if(this.isVisible()){
for(var i=0;i<this.getChildCount();++i){
if(this.getChild(i).isViewable()){
return true;
}
}
}
return false;
};
CompositeChartRenderer.prototype.setStyles=function(_3){
if(!_3){
var _4=this.getChildCount();
for(var i=0;i<_4;++i){
this.getChild(i).setStyles(null);
}
}else{
var _4=Math.min(_3.length,this.getChildCount());
for(var i=0;i<_4;++i){
this.getChild(i).setStyles(new Array(_3[i]));
}
}
this._childStyles=_3;
};
CompositeChartRenderer.prototype.hasDefaultStyles=function(){
return this._childStyles==null;
};
CompositeChartRenderer.prototype.resetDefaultStyles=function(){
var _6=this.getChildCount();
for(var i=0;i<_6;++i){
this.getChild(i).resetDefaultStyles();
}
};
CompositeChartRenderer.prototype.getStyles=function(){
var _8=new Array();
var _9;
for(var i=0;i<this.getChildCount();++i){
_9=this.getChild(i).getStyles();
for(var j=0;j<_9.length;++j){
_8.push(_9[j]);
}
}
return _8;
};
CompositeChartRenderer.prototype.getStyle=function(_c,_d){
var _e=this.getChildCount();
for(var i=0;i<_e;++i){
if(this.getChild(i).isDisplayingDataSet(_c)){
return this.getChild(i).getStyle(_c,_d);
}
}
return null;
};
CompositeChartRenderer.prototype.getChildCount=function(){
return this._children.length;
};
CompositeChartRenderer.prototype.getChild=function(idx){
return this._children[idx];
};
CompositeChartRenderer.prototype.getChildren=function(){
return this._children;
};
CompositeChartRenderer.prototype.getChildIndex=function(_11){
return this._children.indexOf(_11);
};
CompositeChartRenderer.prototype.addChild=function(_12,_13){
if(_12==-1){
this._children.push(_13);
}else{
this._children.addItemAt(_12,_13);
}
var _14=_13.getStyles();
if(_14==null||_14.length==0){
if(this._childStyles!=null&&_12<this._childStyles.length){
_13.setStyles(new Array(this._childStyles[_12]));
}
}
this.attach(_13);
this.updateChildren();
};
CompositeChartRenderer.prototype.setChild=function(_15,_16){
var _17=this.getChild(_15);
if(_16!=_17){
if(_17!=null){
_16.setDataSource(_17.getDataSource());
}
this._children.set(_15,_16);
this.attach(_16);
this.updateChildren();
}
};
CompositeChartRenderer.prototype.removeChild=function(_18){
this._children.removeItem(_18);
this.detach(_18);
this.updateChildren();
};
CompositeChartRenderer.prototype.removeChildren=function(){
this._children.splice(0,this._children.length);
};
CompositeChartRenderer.prototype.getChildForDS=function(_19){
var _1a=this.getChildCount();
var _1b;
for(var i=0;i<_1a;++i){
_1b=this.getChild(i);
if(_1b.isDisplayingDataSet(_19)){
return _1b;
}
}
return null;
};
CompositeChartRenderer.prototype.getDrawRenderers=function(){
return this._children;
};
CompositeChartRenderer.prototype.attach=function(_1d){
_1d.setParent(this);
};
CompositeChartRenderer.prototype.detach=function(_1e){
_1e.setParent(null);
};
CompositeChartRenderer.prototype.updateChildren=function(){
};
CompositeChartRenderer.prototype.setDisplayPoint=function(_1f,_20,_21,_22){
var _23=this.getChildForDS(_1f);
if(_23!=null){
_23.setDisplayPoint(_1f,_20,_21,_22);
}
};
CompositeChartRenderer.prototype.setDataPoint=function(_24,_25,_26,_27){
var _28=this.getChildForDS(_24);
if(_28!=null){
_28.setDataPoint(_24,_25,_26,_27);
}
};
CompositeChartRenderer.prototype.draw=function(dst,_2a){
var _2b;
var _2c=this.getDrawRenderers();
for(var i=0;i<_2c.length;i++){
_2b=_2c[i];
if(_2b.isViewable()){
_2b.draw(dst,_2a);
}
}
};
CompositeChartRenderer.prototype.getNearestPoint=function(x,y,_30){
return IlvChart.getNearestPoint(x,y,_30,this._children);
};
CompositeChartRenderer.prototype.getDisplayItem=function(x,y,_33,_34,_35){
return IlvChart.getDisplayItem(x,y,_33,_34,_35,this._children);
};
CompositeChartRenderer.prototype.getDisplayPoint=function(_36,_37){
var _38=this.getChildForDS(_36);
return (_38==null)?null:_38.getDisplayPoint(_36,_37);
};
CompositeChartRenderer.prototype.getXRange=function(_39){
if(_39==null){
_39=new IlvDataInterval();
}
_39.empty();
var _3a=null;
var _3b=this.getChildCount();
var _3c;
for(var i=0;i<_3b;++i){
_3c=this.getChild(i);
if(_3c.isViewable()){
_3a=_3c.getXRange(_3a);
_39.addInterval(_3a);
}
}
return _39;
};
CompositeChartRenderer.prototype.getYRange=function(_3e){
if(_3e==null){
_3e=new IlvDataInterval();
}
_3e.empty();
var _3f=null;
var _40=this.getChildCount();
var _41;
for(var i=0;i<_40;++i){
_41=this.getChild(i);
if(_41.isViewable()){
_3f=_41.getYRange(_3f);
_3e.addInterval(_3f);
}
}
return _3e;
};
CompositeChartRenderer.prototype.createLegendItems=function(){
var _43;
if(this.isViewable()){
var _43=new Array();
for(var i=0;i<this.getChildCount();++i){
var _45=this.getChild(i).createLegendItems();
if(_45!=null){
for(var j=0;j<_45.length;j++){
_43.push(_45[j]);
}
}
}
}
return _43;
};
CompositeChartRenderer.prototype.getNextRenderer=function(_47){
var _48=this.getChild(this.getChildIndex(_47)+1);
if(!_48&&this.getParent()){
return this.getParent().getNextRenderer(this);
}else{
return _48;
}
};
