/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

HiLoChartRenderer.prototype=new CompositeChartRenderer();
HiLoChartRenderer.CLUSTERED=1;
HiLoChartRenderer.CANDLE=2;
HiLoChartRenderer.OPENCLOSE=3;
HiLoChartRenderer.prototype._widthPercent;
HiLoChartRenderer.prototype._type;
HiLoChartRenderer.prototype._mode;
HiLoChartRenderer.prototype._config;
function HiLoChartRenderer(_1,_2,_3){
CompositeChartRenderer.call(this,true);
this._mode=(_1!=undefined)?_1:HiLoChartRenderer.CLUSTERED;
if(this._mode==HiLoChartRenderer.CLUSTERED){
this.createConfig();
}
this._type=(_2!=undefined)?_2:SingleHiLoRenderer.BAR;
this.setWidthPercent((_3!=undefined)?_3:Constants.DEFAULT_WIDTH);
}
HiLoChartRenderer.prototype.createConfig=function(){
if(this._config!=null){
this._config.desactivate();
}
this._config=new ClusteredRendererConfig(this);
this._config.activate();
};
HiLoChartRenderer.prototype.getType=function(){
return this._type;
};
HiLoChartRenderer.prototype.getMode=function(){
return this._mode;
};
HiLoChartRenderer.prototype.setOverlap=function(_4){
if(this.getMode()!=HiLoChartRenderer.CLUSTERED){
return;
}
this._config.setOverlap(_4);
};
HiLoChartRenderer.prototype.getOverlap=function(){
return (this.getMode()==HiLoChartRenderer.CLUSTERED)?this._config.getOverlap():0;
};
HiLoChartRenderer.prototype.setWidthPercent=function(_5){
if(_5!=this._widthPercent){
this._widthPercent=_5;
var _6=this.getChildCount();
for(var i=0;i<_6;++i){
this.getChild(i).setWidthPercent(_5);
}
if(this.getMode()==HiLoChartRenderer.CLUSTERED){
this._config.setClusterWidth(_5);
}
}
};
HiLoChartRenderer.prototype.getWidthPercent=function(){
var _8=this.getChildCount();
var _9=0;
var _a;
for(var i=0;i<_8;++i){
_a=this.getChild(i);
if(this.getMode()==HiLoChartRenderer.CLUSTERED){
_9+=_a.getWidthPercent();
}else{
if(_a.getWidthPercent()>_9){
_9=_a.getWidthPercent();
}
}
}
return _9;
};
HiLoChartRenderer.prototype.getWidth=function(){
var _c=this.getChildCount();
var _d=0;
var _e;
for(var i=0;i<_c;++i){
_e=this.getChild(i);
if(this.getMode()==HiLoChartRenderer.CLUSTERED){
_d+=_e.getWidth();
}else{
if(_e.getWidthPercent()>_d){
_d=_e.getWidth();
}
}
}
return _d;
};
HiLoChartRenderer.prototype.dataSetsRemoved=function(_10,_11,_12){
this.reinitChildren();
};
HiLoChartRenderer.prototype.dataSetsAdded=function(_13,_14,_15){
this.reinitChildren();
};
HiLoChartRenderer.prototype.reinitChildren=function(){
var _16=this.getDataSource().getDataSetCount();
var _17=this.getChildCount();
if(this._mode==HiLoChartRenderer.CLUSTERED){
for(var i=0;i<Math.floor(_16/2);++i){
var _19=this.getChild(i);
if(_19==null){
_19=this.createChild(this.getDataSource().getDataSet(i*2));
this.addChild(_17++,_19);
}
this.configureChilds(i);
}
}else{
for(var i=0;i<Math.floor(_16/4);++i){
var _19=this.getChild(i);
if(_19==null){
_19=this.createChild(this.getDataSource().getDataSet(i*2));
this.addChild(_17++,_19);
}
_19=this.getChild(2*i+1);
if(_19==null){
_19=this.createChild(this.getDataSource().getDataSet(i*2+2));
this.addChild(_17++,_19);
}
this.configureChilds(i);
}
}
if(this._mode==HiLoChartRenderer.CLUSTERED){
while(this.getChildCount()>Math.floor(_16/2)){
var _19=this.getChild(this.getChildCount()-1);
_19.getDataSource().setDataSets(null);
this.removeChild(_19);
}
}else{
while(this.getChildCount()>Math.floor((_16-_16%4)/2)){
var _19=this.getChild(this.getChildCount()-1);
_19.getDataSource().setDataSets(null);
this.removeChild(_19);
}
}
if(this._mode==HiLoChartRenderer.CLUSTERED){
this._config.updateChildren();
}
};
HiLoChartRenderer.prototype.configureChilds=function(_1a){
var _1b=null;
switch(this._mode){
case HiLoChartRenderer.CLUSTERED:
_1b=this.getChild(_1a);
_1b.getDataSource().setDataSets([this.getDataSource().getDataSet(_1a*2),this.getDataSource().getDataSet(_1a*2+1)]);
_1b.setType(this._type);
break;
case HiLoChartRenderer.CANDLE:
_1b=this.getChild(_1a);
_1b.getDataSource().setDataSets([this.getDataSource().getDataSet(_1a*2),this.getDataSource().getDataSet(_1a*2+1)]);
_1b.setType(SingleHiLoRenderer.STICK);
++_1a;
_1b=this.getChild(_1a);
_1b.getDataSource().setDataSets([this.getDataSource().getDataSet(_1a*2),this.getDataSource().getDataSet(_1a*2+1)]);
_1b.setType(SingleHiLoRenderer.BAR);
break;
case HiLoChartRenderer.OPENCLOSE:
_1b=this.getChild(_1a);
_1b.getDataSource().setDataSets([this.getDataSource().getDataSet(_1a*2),this.getDataSource().getDataSet(_1a*2+1)]);
_1b.setType(SingleHiLoRenderer.STICK);
++_1a;
_1b=this.getChild(_1a);
_1b.getDataSource().setDataSets([this.getDataSource().getDataSet(_1a*2),this.getDataSource().getDataSet(_1a*2+1)]);
_1b.setType(SingleHiLoRenderer.MARKED);
break;
}
};
HiLoChartRenderer.prototype.createChild=function(_1c){
return new SingleHiLoRenderer(null,null,this._type,this._widthPercent);
};
HiLoChartRenderer.prototype.setStyles=function(_1d){
var _1e=this.getChildCount();
if(_1e==0){
return;
}
if(2*_1e>_1d.length){
throw new Error("Cannot set the styles : the array should have at least 2 styles per child");
}
var _1f=new Array(2);
for(var i=0;i<_1e;++i){
_1f[0]=_1d[2*i];
_1f[1]=_1d[2*i+1];
this.getChild(i).setStyles(_1f);
}
};
HiLoChartRenderer.prototype.createLegendItems=function(){
if(this._mode==HiLoChartRenderer.CLUSTERED){
return CompositeChartRenderer.prototype.createLegendItems.call(this);
}else{
if(this.isViewable()&&this.isVisibleInLegend()){
return [new LegendItem(this,true)];
}
}
return null;
};
HiLoChartRenderer.prototype.getLegendText=function(_21){
var _22=new Array();
for(var i=0;i<this.getChildCount();++i){
_22.push(this.getChild(i).getLegendText(_21));
}
return _22.join("/");
};
HiLoChartRenderer.prototype.drawLegendSymbol=function(_24,g,x,y,w,h){
if(this._mode==HiLoChartRenderer.CANDLE){
var s=Math.min(w,h);
x+=(w-s)/2;
y+=(h-s)/2;
Style.drawLine(this.getChild(0).getStyle(0),g,x+s/2,y,x+s/2,y+h);
Style.drawRect(this.getChild(1).getRiseStyle(),g,x,y+0.2*h,s,h*0.4);
Style.drawRect(this.getChild(1).getFallStyle(),g,x,y+h*0.6-1,s,h*0.3);
}else{
for(var i=0;i<this.getChildCount();++i){
this.getChild(i).drawLegendSymbol(_24,g,x,y,w,h);
}
}
};
