/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

PieDataSet.prototype=new VirtualDataSet();
PieDataSet.prototype._sum;
PieDataSet.prototype._pieData;
PieDataSet.prototype._renderer;
function PieDataSet(_1,ds){
VirtualDataSet.call(this);
this._renderer=_1;
this._pieData=new Array();
if(ds){
this.addDataSet(ds);
}
}
PieDataSet.prototype.getName=function(){
if(this.getDataSetCount()==1){
return this.getDataSet(0).getName();
}else{
return null;
}
};
PieDataSet.prototype.isXValuesSorted=function(){
return true;
};
PieDataSet.prototype.getPreviousXData=function(_3){
if(_3==0){
return PieDataSet.DEFAULT_XMIN;
}
var _4=this.getXData(_3-1);
var _5=this.getUndefValue();
if(_5!=null){
var j=_3-1;
while(MathUtil.eq(_4,_5)){
if(j==0){
_4=DEFAULT_XMIN;
break;
}else{
_4=getXData(--j);
}
}
}
return _4;
};
PieDataSet.prototype.map=function(p){
p.dataSet=this;
};
PieDataSet.prototype.unmap=function(_8,_9){
if(this.getDataSetCount()==1){
_8.dataSet=this.getDataSet(0);
}
if(_9){
var _a=_8.dataSet;
_9.x=_8.getXData();
if(_9.x>PieDataSet.DEFAULT_XMAX){
_9.y=_8.getYData();
return;
}
var _b=_a.getDataCount();
var _c=this.getXData(_8.index-1);
var _d=_9.x-_c;
if(_d<=0){
_9.y=0;
}else{
var i;
var _f=0;
for(var i=0;i<_8.index;++i){
_f+=_a.getYData(i);
}
var _10=0;
for(++i;i<_b;++i){
_10+=_a.getYData(i);
}
_9.y=_d*(_f+_10)/(PieDataSet.DEFAULT_XMAX-_d);
}
}
};
PieDataSet.prototype.getUndefValue=function(){
if(this.getDataSetCount()==0){
return null;
}else{
var _11=this.getDataSet(0);
return (_11!=null&&_11.getUndefValue()!=null?IlvDataSet.DEFAULT_UNDEF_VALUE:null);
}
};
PieDataSet.prototype.getPercent=function(idx){
if(this.getDataSetCount()==0){
return 0;
}else{
return this.getDataSet(0).getYData(idx)*100/this._sum;
}
};
PieDataSet.prototype.getPartialSum=function(idx){
if(this.getDataSetCount()==0){
return 0;
}
var ds=this.getDataSet(0);
var sum=0;
for(var i=0;i<=idx;++i){
sum+=ds.getYData(i);
}
return sum;
};
PieDataSet.prototype.getXData=function(idx){
return this._pieData[idx];
};
PieDataSet.prototype.getYData=function(idx){
return this._renderer._yRange.getMax();
};
PieDataSet.prototype.dataSetContentsChanged=function(evt){
VirtualDataSet.prototype.dataSetContentsChanged.call(this,evt);
if(evt.getType()!=DataSetContentsEvent.BEFORE_DATA_CHANGED&&evt.getType()!=DataSetContentsEvent.DATA_LABEL_CHANGED){
var _1a=false;
if(evt.getType()==DataSetContentsEvent.FULL_UPDATE){
_1a=true;
}
this.updatePieData(0,this.getDataCount()-1,_1a);
this.dispatchEvent(new DataSetContentsEvent());
}
};
PieDataSet.prototype.dataSetsChanged=function(){
VirtualDataSet.prototype.dataSetsChanged.call(this);
var _1b=this.getDataCount();
if(_1b>0){
this.updatePieData(0,_1b-1,true);
}
};
PieDataSet.prototype.updatePieData=function(_1c,_1d,_1e){
if(_1e){
this._pieData.length=0;
}
this._sum=this.computePieData(this._pieData,_1c,_1d);
};
PieDataSet.prototype.computePieData=function(_1f,_20,_21){
var ds=this.getDataSet(0);
var _23=ds.getUndefValue();
var _24=ds.getDataCount();
var max=_1f.length;
var sum=0;
var _27=0;
for(var i=0;i<_24;++i){
var v=ds.getYData(i);
if(_23!=null&&MathUtil.eq(v,_23)){
continue;
}
if(i<_20){
_27+=v;
}
sum+=v;
}
for(var i=_20;i<=_21;++i){
var v=ds.getYData(i);
if(_23!=null&&MathUtil.eq(v,_23)){
v=IlvDataSet.DEFAULT_UNDEF_VALUE;
}else{
if(i==_24-1){
v=SinglePieRenderer.DEFAULT_XMAX;
}else{
_27+=v;
v=MathUtil.clamp(_27*(SinglePieRenderer.DEFAULT_XMAX/sum),0,100);
}
}
if(i>=max){
_1f.push(v);
}else{
_1f[i]=v;
}
}
return sum;
};
PieDataSet.prototype.computeLimits=function(_2a,_2b){
if(!_2a&&!_2b){
this.setLimitsValid(true);
_2a=this._xRange;
_2b=this._yRange;
}
if(this.getDataCount()>0){
_2a.set(SinglePieRenderer.DEFAULT_XMIN,SinglePieRenderer.DEFAULT_XMAX);
}else{
_2a.empty();
}
_2b.set(this._renderer._yRange.getMin(),this._renderer._yRange.getMax());
};
