/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

PolylineChartRenderer.prototype=new SimpleCompositeChartRenderer();
PolylineChartRenderer.SUPERIMPOSED=1;
PolylineChartRenderer.STACKED=2;
PolylineChartRenderer.prototype._config;
PolylineChartRenderer.prototype._mode;
PolylineChartRenderer.prototype._marker;
PolylineChartRenderer.prototype._markerSize;
PolylineChartRenderer.prototype._autoTransparency=true;
function PolylineChartRenderer(_1,_2){
SimpleCompositeChartRenderer.call(this,_2);
if(_2){
this.setMode(!_1?PolylineChartRenderer.SUPERIMPOSED:_1);
}
}
PolylineChartRenderer.prototype.setMode=function(_3){
if(_3==this._mode){
return;
}
var _4=this._mode;
this._mode=_3;
this.updateConfig();
if((_3==PolylineChartRenderer.SUPERIMPOSED||_4==PolylineChartRenderer.SUPERIMPOSED)&&this._autoTransparency){
this.resetDefaultStyles();
}
};
PolylineChartRenderer.prototype.getMode=function(){
return this._mode;
};
PolylineChartRenderer.prototype.setMarker=function(_5,_6){
this._marker=_5;
this._markerSize=_6;
};
PolylineChartRenderer.prototype.getMarker=function(){
return this._marker;
};
PolylineChartRenderer.prototype.getMarkerSize=function(){
return this._markerSize;
};
PolylineChartRenderer.prototype.updateConfig=function(){
if(this._config){
this._config.desactivate();
}
this._config=this.createConfig();
this._config.activate();
};
PolylineChartRenderer.prototype.createConfig=function(){
switch(this.getMode()){
case PolylineChartRenderer.STACKED:
return new StackedRendererConfig(this,false);
case PolylineChartRenderer.SUPERIMPOSED:
default:
return new CompositeRendererConfig(this);
}
};
PolylineChartRenderer.prototype.getConfig=function(){
return this._config;
};
PolylineChartRenderer.prototype.isStacked100Percent=function(){
if(this.getMode()==PolylineChartRenderer.STACKED){
return this._config.isStacked100Percent();
}else{
return false;
}
};
PolylineChartRenderer.prototype.setStacked100Percent=function(_7){
if(this.getMode()!=PolylineChartRenderer.STACKED){
return;
}
if(_7!=this._config.isStacked100Percent()){
this._config.setStacked100Percent(_7);
}
};
PolylineChartRenderer.prototype.getDrawRenderers=function(){
return this.getConfig().getDrawRenderers();
};
PolylineChartRenderer.prototype.dataSetsAdded=function(_8,_9,_a){
SimpleCompositeChartRenderer.prototype.dataSetsAdded.call(this,_8,_9,_a);
for(var i=_8;i<=_9;++i){
var _c=this.getDataSource().getDataSet(i);
this.getConfig().dataSetAdded(_c);
}
};
PolylineChartRenderer.prototype.dataSetsRemoved=function(_d,_e,_f){
SimpleCompositeChartRenderer.prototype.dataSetsRemoved.call(this,_d,_e,_f);
for(var i=_d;i<=_e;++i){
var _11=_f[i];
this.getConfig().dataSetRemoved(_11);
}
};
PolylineChartRenderer.prototype.createChild=function(_12){
var _13=new SinglePolylineRenderer(true);
if(this._marker!=null){
_13.setMarker(this._marker);
_13.setMarkerSize(this._markerSize);
}
return _13;
};
PolylineChartRenderer.prototype.isAutoTransparency=function(){
return this._autoTransparency;
};
PolylineChartRenderer.prototype.setAutoTransparency=function(_14){
if(_14!=this._autoTransparency){
this._autoTransparency=_14;
this.resetDefaultStyles();
}
};
PolylineChartRenderer.prototype.isSuperimposed=function(){
return this._mode==PolylineChartRenderer.SUPERIMPOSED;
};
