/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SingleBarRenderer.prototype=new SingleChartRenderer();
function SingleBarRenderer(_1,_2){
SingleChartRenderer.call(this,_1,true);
this._barPercent=_2;
this.clipping=true;
}
SingleBarRenderer.prototype.processItems=function(_3,_4){
var _5=this.getWidth()/2;
if(_5==0){
return;
}
var _6=this.getCoordinateSystem();
var _7=this.getPlotRect();
var _8=this.getChart().getLocalProjector(_7,_6);
var _9=new BarItem(this,7);
var _a=_3.size();
var _b=this.getStyle();
var _c=_3.getDataSet().getUndefValue();
var _d=this.getChart().getProjector().getAxisLength(_7,this.getXAxis());
var _e=((2*_d*_5)/this.getXAxis().getVisibleRange().getLength()>this.getStrokeThreshold());
if(Style.isFillOn(_b)&&!_e){
_b=Style.copy(_b);
_b.stroke="none";
}
if(this.holdsRenderingHint()){
var _f;
var _10=_b;
var dp=null;
var _12=_3.getIndices();
for(var i=0;i<_a;++i){
if(MathUtil.eq(_3.getYDataAt(i),_c)){
continue;
}
_9.update(_3,i,_5);
_8.toDisplay(_9,_7,_6);
dp=new DisplayPoint(this,_3.getDataSet(),_12[i],0,0);
_f=this.getRenderingHint(dp);
if(_f!=null){
_10=_f.getStyle(dp,_b);
if(_10==null){
continue;
}
}else{
_10=_b;
}
var elt=_4.processItem(_3,i,_9,_10);
if(elt){
var ds=_3.getDataSet();
if(ds.getRefDataSet){
ds=ds.getRefDataSet();
}
elt.setAttributeNS(CHART_NS,"dsIdx",ds.getDataSource().getDataSetIndex(ds));
elt.setAttributeNS(CHART_NS,"ptIdx",_3.getDataIndex(i));
}
}
}else{
for(var i=0;i<_a;++i){
if(MathUtil.eq(_3.getYDataAt(i),_c)){
continue;
}
_9.update(_3,i,_5);
_8.toDisplay(_9,_7,_6);
var elt=_4.processItem(_3,i,_9,_b);
if(elt){
var ds=_3.getDataSet();
if(ds.getRefDataSet){
ds=ds.getRefDataSet();
}
elt.setAttributeNS(CHART_NS,"dsIdx",ds.getDataSource().getDataSetIndex(ds));
elt.setAttributeNS(CHART_NS,"ptIdx",_3.getDataIndex(i));
}
}
}
};
SingleBarRenderer.prototype.setWidthPercent=function(_16){
if(_16<0||_16>100){
throw new IllegalArgumentException("Percentage must be in [0..100]");
}
this._barPercent=_16;
};
SingleBarRenderer.prototype.getWidthPercent=function(){
return this._barPercent;
};
SingleBarRenderer.prototype.getWidth=function(){
return this.getWidthPercent()*this.getCategorySpacing()/100;
};
SingleBarRenderer.prototype.getStrokeThreshold=function(){
return 6;
};
SingleBarRenderer.prototype.getBarOrigin=function(_17){
if(this._childIdx!=0&&this._barParent!=null&&this._barParent.getMode()==BarChartRenderer.STACKED){
var v=this.getDrawingDataSet().getPreviousYData(_17);
if(v!=IlvDataSet.DEFAULT_UNDEF_VALUE){
return Math.max(this.getYAxis().getVisibleMin(),v);
}
}
return Math.max(this.getYAxis().getVisibleMin(),this.getCoordinateSystem().getXCrossingValue());
};
SingleBarRenderer.prototype.setChildIndex=function(idx){
this._childIdx=idx;
};
SingleBarRenderer.prototype.setParent=function(_1a){
if(_1a instanceof BarChartRenderer){
this._barParent=_1a;
}else{
this._barParent=null;
}
SingleChartRenderer.prototype.setParent.call(this,_1a);
};
SingleBarRenderer.prototype.getXRange=function(_1b){
var _1c=SingleChartRenderer.prototype.getXRange.call(this,_1b);
_1c.expand(this.getWidth()/2);
return _1c;
};
SingleBarRenderer.prototype.expandSelectionWindow=function(w){
var _1e=this.getWidth()/2;
if(_1e>0){
w.xRange.expand(_1e);
}
return w;
};
SingleBarRenderer.prototype.createDefaultStyle=function(_1f,_20,_21){
var _22=SingleChartRenderer.prototype.createDefaultStyle.call(this,_1f,_20,_21);
var _23=this.getParent();
if(_22!=null&&this.isFilled()&&_23.isSuperimposed&&_23.isSuperimposed()&&_23.isAutoTransparency()){
_22["fill-opacity"]="0.5";
}
return _22;
};
