/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SingleChartRenderer.prototype=new ChartRenderer();
SingleChartRenderer.prototype.constructor=SingleChartRenderer;
SingleChartRenderer.PICK_DIST=5;
SingleChartRenderer.INSTANCE_COUNT=0;
SingleChartRenderer.prototype._hasHintMarker=0;
function SingleChartRenderer(_1,_2){
if(_2){
this.instanceRef=new String(SingleChartRenderer.INSTANCE_COUNT++);
ChartRenderer.call(this,true);
if(_1){
this.setStyle(_1);
}
}
}
SingleChartRenderer.prototype.contentsChanged=function(_3){
var _4=this.getChart();
if(this.isViewable()){
_4.dataSetContentsChanged(_3,this);
}
};
SingleChartRenderer.prototype.applyStyles=function(_5){
if(!window.getDataSetStyle&&!window.getDataSetProperties){
return;
}
for(var i=0;i<_5.length;i++){
if(this.isDisplayingDataSet(_5[i])){
if(window.getDataSetStyle){
var _7=Style.create();
getDataSetStyle(_5[i],_7);
if(!Style.equals(_7,Style.create())){
this.setStyle(_7);
}
}
if(window.getDataSetProperties){
var _8=getDataSetProperties(_5[i],new Object());
if(_8["marker"]!=undefined&&this.setMarker){
this.setMarker(_8["marker"]);
}
if(_8["markerSize"]!=undefined&&this.setMarkerSize){
if(!this.getMarkerRenderer||this.getMarkerRenderer()){
this.setMarkerSize(_8["markerSize"]);
}
}
if(_8["minSize"]!=undefined&&this.setMinSize){
this.setMinSize(_8["minSize"]);
}
if(_8["maxSize"]!=undefined&&this.setMaxSize){
this.setMaxSize(_8["maxSize"]);
}
if(_8["visible"]==false){
this.setVisible(false);
}
if(_8["visibleInLegend"]==false){
this.setVisibleInLegend(false);
}
}
}
}
};
SingleChartRenderer.prototype.draw=function(_9,_a){
if(!this.isVisible()){
return;
}
var _b=null;
if(_a&&this.getParent()){
_b=this.getChart().getDrawingAreaInsertionPoint();
if(this._g){
_b=this._g.nextSibling;
}else{
var _c=this.getParent().getNextRenderer(this);
if(_c&&_c._g){
_b=_c._g;
}
}
}
this.clear();
if(this.getParent()&&this._dataSource.getDataSetCount()>0){
this._g=DrawUtil.createContainer(_9.ownerDocument);
this.drawDataPoints(this._g,this.selectDataPoints(null));
_9.insertBefore(this._g,_b);
}
};
SingleChartRenderer.prototype.clear=function(){
if(this._g&&this._g.parentNode){
this._g.parentNode.removeChild(this._g);
}
};
SingleChartRenderer.prototype.drawPoints=function(_d,_e){
if(this.clipping){
_d.setAttributeNS(null,"clip-path","url(#plotAreaCP)");
}
var _f=this.getDrawAction(_d);
_f.startProcessItems();
this.processItems(_e,_f);
_f.endProcessItems();
};
SingleChartRenderer.prototype.getDrawAction=function(dst){
var _11=new DefaultDrawItem();
_11.setGraphics(dst);
return _11;
};
SingleChartRenderer.prototype.drawDataSet=function(dst,_13,_14,_15){
};
SingleChartRenderer.prototype.drawDataPoints=function(dst,_17){
if(_17==null){
return;
}
var pts=this.createPoints(_17);
if(pts.size()>0){
this.drawPoints(dst,pts);
this.lastDrawSize=pts.size();
}
this.releasePoints(pts);
};
SingleChartRenderer.prototype.getXRange=function(_19){
var _1a=this.getDrawingDataSet();
var _1b=_19;
if(_1a==null){
if(!_1b){
_1b=new IlvDataInterval();
}else{
_1b.empty();
}
return _1b;
}
var _1c=_1a.getXRange(_1b);
var _1d=this.getXShift();
if(_1d!=0){
_1c.translate(_1d);
}
return _1c;
};
SingleChartRenderer.prototype.getYRange=function(_1e){
var _1f=this.getDrawingDataSet();
if(_1f==null){
if(_1e==null){
_1e=new IlvDataInterval();
}else{
_1e.empty();
}
return _1e;
}
return _1f.getYRange(_1e);
};
SingleChartRenderer.prototype.createPoints=function(_20){
return new Points(this,_20,true);
};
SingleChartRenderer.prototype.releasePoints=function(pts){
pts.dispose();
};
SingleChartRenderer.prototype.selectDataPoints=function(_22){
var w=null;
if(_22!=null){
w=this.getSelectionWindow(this.expandSelectionRect(_22));
if(w.isEmpty()){
return null;
}
}else{
w=this.getCoordinateSystem().getVisibleWindow();
}
return this.getDrawingDataSet().getDataInside(w,this.getAdjCount(),this.isContinuous());
};
SingleChartRenderer.prototype.expandSelectionRect=function(_24){
return Style.expand(this.getStyle(),_24);
};
SingleChartRenderer.prototype.expandSelectionWindow=function(w){
return w;
};
SingleChartRenderer.prototype.getSelectionWindow=function(_26){
var _27=this.getPlotRect();
var w=this.getChart().getProjector().toDataWindow(_26,_27,this.getCoordinateSystem());
this.expandSelectionWindow(w);
if(this.getXShift()!=0){
w.xRange.translate(-this.getXShift());
}
w.xRange.intersection(this.getXAxis().getVisibleRange());
w.yRange.intersection(this.getYAxis().getVisibleRange());
return w;
};
SingleChartRenderer.prototype.getAdjCount=function(){
return 0;
};
SingleChartRenderer.prototype.isContinuous=function(){
return true;
};
SingleChartRenderer.prototype.isFilled=function(){
return true;
};
SingleChartRenderer.prototype.getDrawingDataSet=function(){
return this.getDisplayDataSet(this.getDataSource().getDataSet(0));
};
SingleChartRenderer.prototype.getDisplayDataSet=function(_29){
if(!this.isDisplayingDataSet(_29)){
return null;
}
var _2a=this.getVirtualDataSet(_29);
return (_2a==null)?_29:_2a;
};
SingleChartRenderer.prototype.getDataSet=function(){
return this._dataSource.getDataSet(0);
};
SingleChartRenderer.prototype.setStyle=function(_2b){
if(!_2b){
_2b=this.makeDefaultStyle();
this._style=_2b;
}else{
if(!this.isFilled()){
SingleChartRenderer.swapStyle(_2b);
}
if(_2b!=this._style){
this._style=_2b;
}
}
};
SingleChartRenderer.swapStyle=function(_2c){
var _2d=_2c["stroke"];
var _2e=_2c["stroke-opacity"];
if(_2c["fill"]){
_2c["stroke"]=_2c["fill"];
}else{
if(_2c["stroke"]){
delete _2c["stroke"];
}
}
if(_2c["fill-opacity"]!=undefined){
_2c["stroke-opacity"]=_2c["fill-opacity"];
}else{
if(_2c["stroke-opacity"]!=undefined){
delete _2c["stroke-opacity"];
}
}
if(_2d){
_2c["fill"]=_2d;
}else{
if(_2c["fill"]){
delete _2c["fill"];
}
}
if(_2e!=undefined){
_2c["fill-opacity"]=_2e;
}else{
if(_2c["fill-opacity"]!=undefined){
delete _2c["fill-opacity"];
}
}
};
SingleChartRenderer.prototype.getStyle=function(){
return this._style;
};
SingleChartRenderer.prototype.setStyles=function(_2f){
this.setStyle((_2f!=null)?_2f[0]:null);
};
SingleChartRenderer.prototype.getStyles=function(){
return (this._style==null)?new Array(0):new Array(this._style);
};
SingleChartRenderer.prototype.getCategorySpacing=function(){
var ds=this.getDataSet();
if(ds==null){
return 0;
}else{
var cat=null;
if(cat!=null){
return cat.doubleValue();
}
var _32=ds.getDataCount();
return (_32>1)?(ds.getXRange(null).getLength())/(_32-1):1;
}
};
SingleChartRenderer.prototype.getXAxis=function(){
return this.getCoordinateSystem().getXAxis();
};
SingleChartRenderer.prototype.getYAxis=function(){
return this.getCoordinateSystem().getYAxis();
};
SingleChartRenderer.prototype.setDisplayPoint=function(_33,_34,_35,_36){
};
SingleChartRenderer.prototype.setDataPoint=function(_37,_38,_39,_3a){
};
SingleChartRenderer.prototype.dataSetsAdded=function(_3b,_3c,_3d){
for(var i=_3b;i<=_3c;++i){
this.getDataSource().getDataSet(i).addEventListener("contentsChanged",this);
}
};
SingleChartRenderer.prototype.dataSetsRemoved=function(_3f,_40,_41){
for(var i=_3f;i<=_40;++i){
var _43=_41[i];
this.setVirtualDataSet(_43,null);
_43.removeEventListener("contentsChanged",this);
}
};
SingleChartRenderer.prototype.setVirtualDataSet=function(_44,_45,_46){
var _47=this.getVirtualDataSet(_44);
if(_47!=null){
if(_46){
_47.removeEventListener("contentsChanged",this);
}
_47.setDataSets(null);
}
_44.putProperty(this.instanceRef,_45,false);
if(_45!=null){
_44.removeEventListener("contentsChanged",this);
if(_46){
_45.addEventListener("contentsChanged",this);
}
}else{
if(_47!=_45){
_44.addEventListener("contentsChanged",this);
}
}
if(this.getChart()!=null&&(_47!=_45)){
this.getChart().updateDataRange();
}
};
SingleChartRenderer.prototype.getVirtualDataSet=function(_48){
return _48.getProperty(this.instanceRef);
};
SingleChartRenderer.prototype.makeDefaultStyle=function(){
return this.createDefaultStyle(this.findDefaultColor(),null,null);
};
SingleChartRenderer.prototype.createDefaultStyle=function(_49,_4a,_4b){
var _4c=Style.create();
if(_4b!=null){
_4c["stroke-width"]=_4b;
}
if(this.isFilled()){
if(_4a){
_4c.stroke=_4a;
}
_4c.fill=_49;
}else{
_4c.stroke=_49;
_4c.fill="none";
}
return _4c;
};
SingleChartRenderer.prototype.findDefaultColor=function(){
var c=null;
if(this.getChart()==null){
c=Constants.DEFAULT_COLORS[0];
}else{
var _4e=this.getChart().getDefaultColors();
if(!_4e){
_4e=Constants.DEFAULT_COLORS.clone();
}
var _4f=this.getUsedColors();
var idx=this.getAbsoluteIndex();
if(idx<_4e.length&&!_4f.indexOf(_4e[idx])){
c=_4e[idx];
}else{
for(var i=0;i<_4f.length;i++){
_4e.removeItem(_4f[i]);
}
if(_4e.length==0){
c=ColorUtil.getRandomColor();
}else{
return _4e[0];
}
}
}
return c;
};
SingleChartRenderer.prototype.getAbsoluteIndex=function(){
var _52=this.getChart().getAllRenderers();
var cpt=0;
for(var i=0;i<_52.length;i++){
if(_52[i] instanceof SingleChartRenderer){
cpt++;
}
}
return cpt;
};
SingleChartRenderer.prototype.getUsedColors=function(){
var _55=new Array();
var _56=this.getChart().getRendererCount();
for(var i=0;i<_56;i++){
var r=this.getChart().getRenderer(i);
SingleChartRenderer.addColors(_55,r.getStyles());
}
return _55;
};
SingleChartRenderer.prototype.chartConnected=function(_59,_5a){
ChartRenderer.prototype.chartConnected.call(this,_59,_5a);
if(_59!=null){
}
if(_5a!=null){
if(!this._style){
this.setStyle(null);
}
}
};
SingleChartRenderer.addColors=function(_5b,_5c){
if(_5c==null){
return;
}
var c=null;
for(var j=0;j<_5c.length;++j){
c=_5c[j].fill;
if(c!=null){
_5b.push(c);
}
c=_5c[j].stroke;
if(c!=null){
_5b.push(c);
}
}
};
SingleChartRenderer.prototype.drawLegendSymbol=function(_5f,g,x,y,w,h){
var s=Math.min(w,h);
Style.drawRect(this.getStyle(0),g,x+(w-s)/2,y+(h-s)/2,s,s);
};
SingleChartRenderer.prototype.createLegendItems=function(){
if(this.isViewable()&&this.isVisibleInLegend()){
return [new LegendItem(this,true)];
}
return null;
};
SingleChartRenderer.prototype.getLegendText=function(_66){
if(this.getDrawingDataSet()!=null){
return (this.getDrawingDataSet().getName()!=null?this.getDrawingDataSet().getName():"");
}else{
return "";
}
};
SingleChartRenderer.prototype.holdsRenderingHint=function(){
return (this.getChart().getStylingEngineHint()!=undefined||(this._hints&&this._hints.length>0));
};
SingleChartRenderer.prototype.getRenderingHint=function(dp){
if(dp.getDataSet().unmap){
dp.getDataSet().unmap(dp);
}
var _68=null;
if(this._hints){
_68=this._hints[dp.getIndex()];
}
if(_68==null){
_68=this.getChart().getStylingEngineHint();
}
return _68;
};
SingleChartRenderer.prototype.setRenderingHint=function(dp,_6a){
if(!this._hints){
this._hints=new Array();
}
if(this._hints[dp.getIndex()]&&this._hints[dp.getIndex()].getMarker){
this._hasHintMarker--;
}
if(_6a&&!this.isFilled()&&_6a.getStyle){
var _6b=new Object();
_6b.originalHint=_6a;
if(_6a.getMarker){
_6b.getMarker=function(dp,_6d){
return this.originalHint.getMarker(dp,_6d);
};
}
_6b.getStyle=function(dp,_6f){
var _70=this.originalHint.getStyle(dp,_6f);
if(_70!=_6f){
_70=Style.copy(_70);
SingleChartRenderer.swapStyle(_70);
}
return _70;
};
this._hints[dp.getIndex()]=_6b;
}else{
this._hints[dp.getIndex()]=_6a;
}
if(_6a&&_6a.getMarker){
this._hasHintMarker++;
}
};
SingleChartRenderer.prototype.hasHintMarker=function(){
return (this._hasHintMarker>0)||this.getChart().hasStylingEngineMarker();
};
SingleChartRenderer.prototype.getNearestPoint=function(x,y,_73){
if(this.getChart()==null){
return null;
}
var _74=new Rectangle(Math.floor(x-SingleChartRenderer.PICK_DIST),Math.floor(y-SingleChartRenderer.PICK_DIST),2*SingleChartRenderer.PICK_DIST,2*SingleChartRenderer.PICK_DIST);
var _75=this.selectDataPoints(_74);
if(_75==null){
return null;
}
var _76=_75.size();
if(_76==0){
return;
}
var pts=this.createPoints(_75);
var _78=-1;
var res=null;
var _7a=pts.getDataSet();
var _7b=_7a.getUndefValue();
var _7c=pts.getXCoords();
var _7d=pts.getYCoords();
var _7e=pts.getYData();
var _7f;
var _80=SingleChartRenderer.PICK_DIST;
for(var i=0;i<_76;++i){
var yi=_7e[i];
if((_7b!=null&&MathUtil.eq(yi,_7b))){
continue;
}
_7f=SingleChartRenderer.computeDistance(x,y,_7c[i],_7d[i]);
if(_7f<=_80){
_78=i;
if(_7f==0){
break;
}
_80=_7f;
}
}
if(_78!=-1){
res=new DisplayPoint(this,_7a,pts.getDataIndex(_78),_7c[_78],_7d[_78]);
}
if(res!=null&&_7a.unmap){
_7a.unmap(res);
if(res.getIndex()==-1){
res=null;
}
}
this.releasePoints(pts);
return res;
};
SingleChartRenderer.prototype.getDisplayItem=function(x,y,_85,_86,_87){
var res=new DisplayPoint(this,this.getDrawingDataSet(),_86,x,y);
if(res!=null&&this.getDrawingDataSet().unmap){
this.getDrawingDataSet().unmap(res);
if(res.getIndex()==-1){
res=null;
}
}
return res;
};
SingleChartRenderer.computeDistance=function(x1,y1,x2,y2){
var dx=x2-x1;
var dy=y2-y1;
return Math.sqrt(dx*dx+dy*dy);
};
