/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SingleHiLoRenderer.prototype=new SingleChartRenderer();
SingleHiLoRenderer.STICK=0;
SingleHiLoRenderer.BAR=1;
SingleHiLoRenderer.ARROW=2;
SingleHiLoRenderer.MARKED=3;
SingleHiLoRenderer.prototype._fallStyle;
SingleHiLoRenderer.prototype._sizePercent;
SingleHiLoRenderer.prototype._type;
function SingleHiLoRenderer(_1,_2,_3,_4){
SingleChartRenderer.call(this,_1,true);
this.setFallStyle(_2);
this.setType(_3);
this.setWidthPercent(_4);
}
SingleHiLoRenderer.prototype.getStrokeThreshold=function(){
return 6;
};
SingleHiLoRenderer.prototype.getMinDataSetCount=function(){
return 2;
};
SingleHiLoRenderer.prototype.isFilled=function(){
return (this.getType()==SingleHiLoRenderer.BAR)||(this.getType()==SingleHiLoRenderer.ARROW);
};
SingleHiLoRenderer.prototype.getRiseStyle=function(){
return this.getStyle();
};
SingleHiLoRenderer.prototype.setRiseStyle=function(r){
this.setStyle(r);
};
SingleHiLoRenderer.prototype.getFallStyle=function(){
return this._fallStyle;
};
SingleHiLoRenderer.prototype.setFallStyle=function(_6){
if(!this.isFilled()&&_6){
SingleChartRenderer.swapStyle(_6);
}
if(_6!=this._fallStyle){
this._fallStyle=_6;
}
};
SingleHiLoRenderer.prototype.setStyles=function(_7){
if(_7.length>=2){
this.setRiseStyle(_7[0]);
this.setFallStyle(_7[1]);
}else{
this.setRiseStyle(_7[0]);
this.setFallStyle(_7[0]);
}
};
SingleHiLoRenderer.prototype.getStyles=function(){
if(this.getRiseStyle()==null&&this.getFallStyle()==null){
return new Array(0);
}else{
if(this.getFallStyle()==null){
return [this.getRiseStyle(),this.getRiseStyle()];
}else{
if(this.getRiseStyle()==null){
return [this.getFallStyle(),this.getFallStyle()];
}
}
}
return [this.getRiseStyle(),this.getFallStyle()];
};
SingleHiLoRenderer.prototype.getDefaultStyle=function(_8,_9){
if(_8==this.getHiDataSet()){
return this.getRiseStyle();
}else{
return this.getFallStyle();
}
};
SingleHiLoRenderer.prototype.applyStyles=function(_a){
if(!window.getDataSetStyle&&!window.getDataSetProperties){
return;
}
for(var i=0;i<_a.length;i++){
if(this.isDisplayingDataSet(_a[i])){
if(window.getDataSetStyle){
var _c=Style.create();
getDataSetStyle(_a[i],_c);
if(!Style.equals(_c,Style.create())){
if(_a[i]==this.getHiDataSet()){
this.setRiseStyle(_c);
}else{
this.setFallStyle(_c);
}
}
}
if(window.getDataSetProperties){
var _d=getDataSetProperties(_a[i],new Object());
if(_d["marker"]!=undefined&&this.setMarker){
this.setMarker(_d["marker"]);
}
if(_d["markerSize"]!=undefined&&this.setMarkerSize&&this.getMarkerRenderer()){
this.setMarkerSize(_d["markerSize"]);
}
if(_d["visible"]==false){
this.setVisible(false);
}
if(_d["visibleInLegend"]==false){
this.setVisibleInLegend(false);
}
}
}
}
};
SingleHiLoRenderer.prototype.setWidthPercent=function(_e){
_e=_e/100;
if(_e!=this._sizePercent){
this._sizePercent=_e;
}
};
SingleHiLoRenderer.prototype.getWidthPercent=function(){
return this._sizePercent*100;
};
SingleHiLoRenderer.prototype.getWidth=function(){
return this._sizePercent*this.getCategorySpacing();
};
SingleHiLoRenderer.prototype.getType=function(){
return this._type;
};
SingleHiLoRenderer.prototype.setType=function(_f){
if(_f!=this._type){
var _10=this.isFilled();
this._type=_f;
if(_10!=this.isFilled()){
if(this._style){
SingleChartRenderer.swapStyle(this._style);
}
if(this._fallStyle){
SingleChartRenderer.swapStyle(this._fallStyle);
}
}
}
};
SingleHiLoRenderer.prototype.setHiLoDataSets=function(_11,_12){
this.getDataSource().setDataSets([_11,_12]);
};
SingleHiLoRenderer.prototype.getHiDataSet=function(){
return this.getDataSource().getDataSet(0);
};
SingleHiLoRenderer.prototype.getLoDataSet=function(){
return this.getDataSource().getDataSet(1);
};
SingleHiLoRenderer.prototype.selectDataPoints=function(_13){
var _14=SingleChartRenderer.prototype.selectDataPoints.call(this,_13);
if(_14==null){
return null;
}
var _15=this.getDrawingDataSet();
var _16=this.getYAxis().getVisibleRange();
if(_16.contains(_15.getYRange(null))){
return _14;
}
var _17=_14.size();
if(_17<2){
return _14;
}
var i=0;
if((_14.getIndex(i)%2)==1){
++i;
--_17;
}
if(_17%2==1){
--_17;
}
if(_17==0){
return _14;
}
var _19=_14.getIndices();
var xv=_14.getXValues();
var yv=_14.getYValues();
var _1c=new DataPoints(_15,_17);
var itv=new IlvDataInterval();
var y1;
var y2;
for(;i<_17;i+=2){
y1=yv[i];
y2=yv[i+1];
if(y2>y1){
itv.setMin(y1);
itv.setMax(y2);
}else{
itv.setMin(y2);
itv.setMax(y1);
}
if(!itv.intersects(_16)){
continue;
}
_1c.add(xv[i],y1,_19[i]);
_1c.add(xv[i+1],y2,_19[i+1]);
}
_14.dispose();
return _1c;
};
SingleHiLoRenderer.prototype.processItems=function(pts,_21){
var _22=pts.size();
if(_22<2){
return;
}
var i=0;
if((pts.getDataIndex(i)%2)==1){
++i;
--_22;
}
if(_22%2==1){
--_22;
}
if(_22==0){
return;
}
var _24=this.getYAxis().getVisibleRange();
var _25=!_24.contains(pts.getDataSet().getYRange(null));
var _26=this.getCoordinateSystem();
var _27=this.getPlotRect();
var _28=this.getChart().getProjector().getLocalProjector(_27,_26);
var _29=pts.getDataSet().getUndefValue();
var _2a=this.getWidth()/2;
var _2b=this.getRiseStyle();
var _2c=this.getFallStyle();
if(this.getType()==SingleHiLoRenderer.BAR||this.getType()==SingleHiLoRenderer.ARROW){
var len=_28.getAxisLength(_27,this.getXAxis());
var _2e=((2*len*_2a)/this.getXAxis().getVisibleRange().getLength()>this.getStrokeThreshold());
if(Style.isFillOn(_2b)&&!_2e){
_2b=Style.copy(_2b);
_2b["stroke"]="none";
}
if(Style.isFillOn(_2c)&&!_2e){
_2c=Style.copy(_2c);
_2c["stroke"]="none";
}
}
var _2f=null;
var _30=null;
var _31=new HiLoItem(this,32);
var l;
var h;
if(this.holdsRenderingHint()){
var _34;
var dp=null;
var _36=pts.getIndices();
for(;i<_22;i+=2){
l=pts.getYDataAt(i);
h=pts.getYDataAt(i+1);
if(_29!=null&&(MathUtil.eq(l,_29)||MathUtil.eq(h,_29))){
continue;
}
if(l<h){
_2f=_2b;
dp=new DisplayPoint(this,pts.getDataSet(),_36[i],0,0);
}else{
_2f=_2c;
dp=new DisplayPoint(this,pts.getDataSet(),_36[i+1],0,0);
}
_34=this.getRenderingHint(dp);
if(_34!=null){
_30=_34.getStyle(dp,_2f);
if(_30==null){
continue;
}
}else{
_30=_2f;
}
if(_25){
l=_24.clamp(l);
h=_24.clamp(h);
}
_31.update(pts,i,l,h,_2a);
_28.toDisplay(_31,_27,_26);
var elt=_21.processItem(pts,i,_31,_30);
if(elt){
var ds=pts.getDataSet();
var uds=ds.getDataSet(0);
var dp=pts.getDisplayPoint(i);
elt.setAttributeNS(CHART_NS,"dsIdx",uds.getDataSource().getDataSetIndex(uds));
elt.setAttributeNS(CHART_NS,"ptIdx",dp.getIndex());
ds.map(dp);
}
}
}else{
for(;i<_22;i+=2){
l=pts.getYDataAt(i);
h=pts.getYDataAt(i+1);
if(_29!=null&&(MathUtil.eq(l,_29)||MathUtil.eq(h,_29))){
continue;
}
_30=(l<h)?_2b:_2c;
if(_25){
l=_24.clamp(l);
h=_24.clamp(h);
}
_31.update(pts,i,l,h,_2a);
_28.toDisplay(_31,_27,_26);
var elt=_21.processItem(pts,i,_31,_30);
if(elt){
var ds=pts.getDataSet();
var uds=ds.getDataSet(0);
var dp=pts.getDisplayPoint(i);
elt.setAttributeNS(CHART_NS,"dsIdx",uds.getDataSource().getDataSetIndex(uds));
elt.setAttributeNS(CHART_NS,"ptIdx",dp.getIndex());
ds.map(dp);
}
}
}
};
SingleHiLoRenderer.prototype.getAdjCount=function(){
return 1;
};
SingleHiLoRenderer.prototype.chartConnected=function(_3a,_3b){
SingleChartRenderer.prototype.chartConnected.call(this,_3a,_3b);
if((_3b!=null)&&(this.getFallStyle()==null)){
this.setFallStyle(this.makeDefaultStyle());
}
};
SingleHiLoRenderer.prototype.dataSetsRemoved=function(_3c,_3d,_3e){
SingleChartRenderer.prototype.dataSetsRemoved.call(this,_3c,_3d,_3e);
this.updateVirtualData();
};
SingleHiLoRenderer.prototype.dataSetsAdded=function(_3f,_40,_41){
SingleChartRenderer.prototype.dataSetsAdded.call(this,_3f,_40,_41);
this.updateVirtualData();
};
SingleHiLoRenderer.prototype.updateVirtualData=function(){
var _42=this.getDataSource().getDataSetCount();
if(_42==2){
var _43=new HiLoDataSet(this.getHiDataSet(),this.getLoDataSet());
this.setVirtualDataSet(this.getHiDataSet(),_43,false);
this.setVirtualDataSet(this.getLoDataSet(),_43,true);
}
};
SingleHiLoRenderer.prototype.expandSelectionWindow=function(w){
var _45=this.getWidth()/2;
if(_45>0){
w.xRange.expand(_45);
}
return w;
};
SingleHiLoRenderer.prototype.getXRange=function(_46){
var _47=SingleChartRenderer.prototype.getXRange.call(this,_46);
var _48=this.getWidth()/2;
if(_48>0){
_47.min-=_48;
_47.max+=_48;
}
return _47;
};
SingleHiLoRenderer.prototype.drawLegendSymbol=function(_49,g,x,y,w,h){
var _4f;
var _50;
var s=Math.min(w,h);
x+=(w-s)/2;
y+=(h-s)/2;
switch(this._type){
case SingleHiLoRenderer.BAR:
Style.drawRect(this.getRiseStyle(),g,x,y+0.2*h,s,h*0.4);
Style.drawRect(this.getFallStyle(),g,x,y+h*0.6-1,s,h*0.3);
break;
case SingleHiLoRenderer.MARKED:
Style.drawLine(this.getStyle(0),g,x,y+2*s/3,x+s/2,y+2*s/3);
Style.drawLine(this.getStyle(0),g,x+s/2,y+s/3,x+s,y+s/3);
break;
case SingleHiLoRenderer.ARROW:
_4f=[x+s/4,x+s/4,x,x+s/2,x+s,x+3*s/4,x+3*s/4,x+s/4];
_50=[y+s/2,y+s/3,y+s/3,y,y+s/3,y+s/3,y+s/2,y+s/2];
Style.renderPoly(this.getRiseStyle(),g,_4f,_50,8);
_4f=[x+s/4,x+s/4,x,x+s/2,x+s,x+3*s/4,x+3*s/4,x+s/4];
_50=[y+s/2,y+2*s/3,y+2*s/3,y+s,y+2*s/3,y+2*s/3,y+s/2,y+s/2];
Style.renderPoly(this.getFallStyle(),g,_4f,_50,8);
break;
case SingleHiLoRenderer.STICK:
default:
Style.drawLine(this.getStyle(0),g,x+s/2,y,x+s/2,y+s);
break;
}
};
