/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SinglePieRenderer.prototype=new SingleChartRenderer();
SinglePieRenderer.DEFAULT_XMIN=0;
SinglePieRenderer.DEFAULT_XMAX=100;
SinglePieRenderer.DEFAULT_YMIN=0;
SinglePieRenderer.DEFAULT_YMAX=100;
SinglePieRenderer.DEFAULT_EXPLODE_RATIO=20;
SinglePieRenderer.prototype._strokeOn=true;
SinglePieRenderer.prototype._yRange;
SinglePieRenderer.prototype._pieDataSet;
SinglePieRenderer.prototype._sliceInfos;
SinglePieRenderer.prototype._explodeMax=0;
function SinglePieRenderer(_1,_2,_3){
SingleChartRenderer.call(this,_1,true);
this._yRange=new IlvDataInterval(_2?_2:SinglePieRenderer.DEFAULT_YMIN,_3?_3:SinglePieRenderer.DEFAULT_YMAX);
}
SinglePieRenderer.prototype.getAdjCount=function(){
return 1;
};
SinglePieRenderer.prototype.isContinuous=function(){
return true;
};
SinglePieRenderer.prototype.chartConnected=function(_4,_5){
if(_5!=null){
this.colorSlices();
}
SingleChartRenderer.prototype.chartConnected.call(this,_4,_5);
};
SinglePieRenderer.prototype.colorSlices=function(){
if(this.getDataSource().getDataSetCount()==0||this.getChart()==null){
return;
}
var _6=this.getDataSource().getDataSet(0).getDataCount();
var _7=(_6>0);
for(var i=0;i<_6;++i){
var _9=this.getSliceInfo(i,false);
if(_9!=null&&_9.style!=null){
_7=false;
break;
}
}
if(_7){
var _a=this.getChart().getDefaultColors();
if(!_a){
_a=Constants.DEFAULT_COLORS;
}
var _b=new Array(_6);
var i;
for(i=0;i<_6&&i<_a.length;++i){
_b[i]=_a[i];
}
for(;i<_6;++i){
_b[i]=ColorUtil.getRandomColor();
}
this.setSliceColors(_b);
}
};
SinglePieRenderer.prototype.getSliceInfo=function(i,_d){
var _e=null;
if(this._sliceInfos==null){
if(_d){
_e=new PieSliceInfo();
this._sliceInfos=new Array();
this._sliceInfos[i]=_e;
}
}else{
_e=this._sliceInfos[i];
if(_d&&(_e==null)){
_e=new PieSliceInfo();
this._sliceInfos[i]=_e;
}
}
return _e;
};
SinglePieRenderer.prototype.setSliceStyle=function(_f,_10){
this.getSliceInfo(_f,true).style=_10;
};
SinglePieRenderer.prototype.getSliceStyle=function(_11){
var _12=this.getSliceInfo(_11,false);
return (_12)?_12.style:this.style;
};
SinglePieRenderer.prototype.getDefaultStyle=function(_13,_14){
return this.getSliceStyle(_14).setStrokeOn(this.isStrokeOn());
};
SinglePieRenderer.prototype.holdsRenderingHint=function(){
return this._hints&&this._hints.length>0;
};
SinglePieRenderer.prototype.getRenderingHint=function(dp){
if(dp.getDataSet().unmap){
dp.getDataSet().unmap(dp);
}
var _16=null;
if(this._hints){
_16=this._hints[dp.getIndex()];
}
return _16;
};
SinglePieRenderer.prototype.applyStyles=function(_17){
SingleChartRenderer.prototype.applyStyles.call(this,_17);
var ds=this.getDataSource().getDataSet(0);
var _19=ds.getDataCount();
var _1a=this.getChart().getStylingEngineHint();
if(_1a){
var dp=new DisplayPoint(this,this.getDataSource().getDataSet(0));
var ref=Style.create();
for(var i=0;i<_19;++i){
dp.set(i,0,0);
var _1e=_1a.getStyle(dp,ref);
if(!Style.equals(ref,_1e)){
this.setSliceStyle(i,_1e);
}
}
}
if(window.getDataSetProperties){
var _1f=getDataSetProperties(ds,new Object());
if(_1f["strokeOn"]!=undefined){
this.setStrokeOn(_1f["strokeOn"]);
}
}
};
SinglePieRenderer.prototype.setSliceColors=function(_20){
var _21=this.getStyle();
for(var i=0;i<_20.length;++i){
var _23=new Object();
if(_21==null){
_23["stroke"]="black";
_23["fill"]=_20[i];
}else{
if(Style.isStrokeOn(_21)){
_23["stroke"]=_21["stroke"];
_23["fill"]=_20[i];
}else{
_23["fill"]=_20[i];
}
}
this.setSliceStyle(i,_23);
}
};
SinglePieRenderer.prototype.setStrokeOn=function(_24){
if(this._strokeOn==_24){
return;
}
this._strokeOn=_24;
};
SinglePieRenderer.prototype.isStrokeOn=function(){
return this._strokeOn;
};
SinglePieRenderer.prototype.isExploded=function(_25){
return this.getExplodeRatio(_25)!=0;
};
SinglePieRenderer.prototype.getExplodeRatio=function(_26){
var _27=this.getSliceInfo(_26,false);
return (_27)?_27.explodeRatio:0;
};
SinglePieRenderer.prototype.setExploded=function(_28,_29){
this.setExplodeRatio(_28,_29?SinglePieRenderer.DEFAULT_EXPLODE_RATIO:0);
};
SinglePieRenderer.prototype.setExplodeRatio=function(_2a,_2b){
var _2c=this._setExplodeRatio(_2a,_2b);
if(_2c){
if(_2b>=this._explodeMax){
this._explodeMax=_2b;
}else{
this.updateExplodeMax();
}
}
};
SinglePieRenderer.prototype.getSlicePercent=function(_2d){
return this.getPieDataSet().getPercent(_2d);
};
SinglePieRenderer.prototype.getPartialSum=function(_2e){
return this.getPieDataSet().getPartialSum(_2e);
};
SinglePieRenderer.prototype._setExplodeRatio=function(_2f,_30){
var _31=this.getSliceInfo(_2f,true);
var _32=(_31.explodeRatio!=_30);
_31.explodeRatio=_30;
return _32;
};
SinglePieRenderer.prototype.updateExplodeMax=function(){
var _33=0;
if(this._sliceInfos){
for(var i in this._sliceInfos){
_33=Math.max(this._sliceInfos[i].explodeRatio,_33);
}
}
this._explodeMax=_33;
};
SinglePieRenderer.prototype.dataSetsRemoved=function(_35,_36,_37){
SingleChartRenderer.prototype.dataSetsRemoved.call(this,_35,_36,_37);
if(this.getDataSource().getDataSetCount()==0){
this._sliceInfos.length=0;
}
};
SinglePieRenderer.prototype.dataSetsAdded=function(_38,_39,_3a){
SingleChartRenderer.prototype.dataSetsAdded.call(this,_38,_39,_3a);
if(this.getDataSource().getDataSetCount()==1){
this.makePieDataSet();
this.colorSlices();
}
};
SinglePieRenderer.prototype.makePieDataSet=function(){
var _3b=this.getRealDataSet();
this._pieDataSet=new PieDataSet(this,_3b);
this.setVirtualDataSet(_3b,this._pieDataSet,true);
};
SinglePieRenderer.prototype.getPieDataSet=function(){
return this.getDisplayDataSet(0);
};
SinglePieRenderer.prototype.getRealDataSet=function(){
return this.getDataSource().getDataSet(0);
};
SinglePieRenderer.prototype.processItems=function(pts,_3d){
var _3e=pts.size();
var _3f=this.getChart().getProjector();
var _40=this.getCoordinateSystem();
var w=new IlvDataWindow(0,0,0,0);
var _42=new PieItem(this);
var _43=this.holdsRenderingHint();
var _44=pts.getIndices();
var _45=pts.getXData();
var _46=pts.getDataSet();
var dp=new DisplayPoint(this,pts.getDataSet());
var _48=_46.getUndefValue();
for(var i=0;i<_3e;++i){
var _4a=_44[i];
var xi=_45[i];
if(_48!=null&&MathUtil.eq(_48,_45[i])){
continue;
}
if(_4a==0){
w.xRange.set(SinglePieRenderer.DEFAULT_XMIN,xi);
}else{
var _4c=_46.getPreviousXData(_4a);
w.xRange.set(_4c,xi);
}
if(w.xRange.isEmpty()){
continue;
}
w.yRange=this.getYRangeAt(i,w.yRange);
var _4d=this.getSliceRect(_4a,w.xRange.getMiddle(),w.yRange);
_42.shape=_3f.getShape(w,_4d,_40);
var _4e=this.getSliceStyle(_4a);
if(_43){
dp.set(_4a,0,0);
var _4f=this.getRenderingHint(dp);
if(_4f){
_4e=_4f.getStyle(dp,_4e);
}
}
if(_4e){
var elt=_3d.processItem(pts,i,_42,_4e);
if(elt){
elt.setAttributeNS(CHART_NS,"dsIdx",this.getDataSet().getDataSource().getDataSetIndex(this.getDataSet()));
elt.setAttributeNS(CHART_NS,"ptIdx",pts.getDataIndex(i));
}
}
}
};
SinglePieRenderer.prototype.getSliceRect=function(_51,mid,_53){
var _54=this.getPlotRect();
var _55=this.getExplodeRatio(_51);
if(_55!=0){
var pts=new DoublePoints(2);
pts.addValues(mid,_53.getMin());
pts.addValues(pts.getX(0),pts.getY(0)+_53.getLength()*_55/100);
this.getChart().getProjector().toDisplay(pts,_54,this.getCoordinateSystem());
_54.x+=GraphicUtil.toInt(pts.getX(1)-pts.getX(0));
_54.y+=GraphicUtil.toInt(pts.getY(1)-pts.getY(0));
}
return _54;
};
SinglePieRenderer.prototype.getYRangeAt=function(_57,_58){
if(_58==null){
_58=new IlvDataInterval();
}
if(this._explodeMax==0){
_58.set(this._yRange.getMin(),this._yRange.getMax());
}else{
var _59=1/(1+this._explodeMax/100);
_58.set(this._yRange.getMin(),this._yRange.getMin()+this._yRange.getLength()*_59);
}
return _58;
};
SinglePieRenderer.prototype.setYRange=function(_5a){
this._yRange=new IlvDataInterval(_5a.min,_5a.max);
};
SinglePieRenderer.prototype.getYData=function(_5b){
return this._yRange.getMax();
};
SinglePieRenderer.prototype.getLegendText=function(_5c){
var idx=_5c.getDataIndex();
var _5e=this.getSliceInfo(idx,false);
var _5f=(_5e)?_5e.text:null;
if(_5f==null&&idx<this.getRealDataSet().getDataCount()){
_5f=this.getRealDataSet().getDataLabel(idx);
}
return _5f;
};
SinglePieRenderer.prototype.createLegendItems=function(){
if(!this.isViewable()||!this.isVisibleInLegend()){
return null;
}
var _60=this.getDataSource().getDataSet(0).getDataCount();
if(_60==0){
return null;
}
var _61=new Array(_60);
for(var i=0;i<_60;++i){
_61[i]=new PieLegendItem(i,this);
}
return _61;
};
SinglePieRenderer.prototype.drawLegendSymbol=function(_63,g,x,y,w,h){
var _69=this.getSliceStyle(_63.getDataIndex());
var s=Math.min(w,h);
Style.renderRect(_69,g,x+(w-s)/2,y+(h-s)/2,s,s);
if(!Style.isStrokeOn(_69)){
Style.drawRect(_69,g,x+(w-s)/2,y+(h-s)/2,s,s);
}
};
