/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SinglePolylineRenderer.prototype=new SingleChartRenderer();
function SinglePolylineRenderer(_1){
SingleChartRenderer.call(this,null,_1);
if(_1){
this.clipping=true;
}
}
SinglePolylineRenderer.prototype.setMarker=function(_2){
if(_2!=this.getMarkerRenderer().getMarker()){
this.getMarkerRenderer().setMarker(_2);
}
};
SinglePolylineRenderer.prototype.getMarker=function(){
return (this._markerRenderer!=null)?this._markerRenderer.getMarker():null;
};
SinglePolylineRenderer.prototype.setMarkerSize=function(_3){
if(_3!=this.getMarkerRenderer().getMarkerSize()){
this.getMarkerRenderer().setMarkerSize(_3);
}
};
SinglePolylineRenderer.prototype.getMarkerSize=function(){
return (this._markerRenderer!=null)?this._markerRenderer.getMarkerSize():null;
};
SinglePolylineRenderer.prototype.getMarkerRenderer=function(){
if(this._markerRenderer==null&&window.MarkerRenderer){
this._markerRenderer=new MarkerRenderer(this);
}
return this._markerRenderer;
};
SinglePolylineRenderer.prototype.getUsedMarkerStyle=function(_4){
if(Style.isFillOn(_4)){
return _4;
}else{
var _5=Style.create();
_5["fill"]=_4["stroke"];
_5["stroke"]="none";
return _5;
}
};
SinglePolylineRenderer.prototype.expandSelectionRect=function(_6){
if(this.getMarker()!=null){
var _7=this.getMarkerSize()+1;
_6.grow(_7,_7);
}
return _6;
};
SinglePolylineRenderer.prototype.processItems=function(_8,_9){
this._processItems(_8,this.getPolyItemAction(_9),PolyItem.STROKE_FILL,false);
};
SinglePolylineRenderer.prototype._processItems=function(_a,_b,_c,_d){
var _e=_a.getXData();
var _f=_a.getYData();
var _10=_a.size();
var _11=this.getStyle();
var _12=_a.getDataSet().getUndefValue();
var _13=this.holdsRenderingHint();
if(_d||_13||_12!=null){
var _14=null;
if(_c==PolyItem.STROKE_FILL&&this.isFilled()){
_14=this.createPolyItem(_10,PolyItem.FILL_ONLY);
}else{
_14=this.createPolyItem(_10,_c);
}
var _15=_a.getIndices();
var dp=null;
var _17;
var _18=false;
var _19=_11;
var _1a=Style.copy(_11);
if(!this.isFilled()){
_1a=Style.copy(_11);
_1a["fill"]=_1a["stroke"];
_1a["fill-opacity"]=_1a["stroke-opacity"];
}
if(_13){
dp=new DisplayPoint(this,_a.getDataSet(),_15[0],0,0);
_17=this.getRenderingHint(dp);
if(_17!=null){
_19=_17.getStyle(dp,_11);
}
}
var cpt=MathUtil.eq(_12,_f[0])?1:0;
var _1c=_19;
for(var i=1;i<_10;++i){
if(_13){
dp.set(_15[i],0,0);
_17=this.getRenderingHint(dp);
if(_17!=null){
_1c=_17.getStyle(dp,_1a);
_18=(_1c==null)||!Style.equals(_1c,_19);
}else{
if(_19!=_1a){
_1c=_1a;
_18=true;
}else{
_18=false;
}
}
}
var _1e=(_1c==null)||MathUtil.eq(_12,_f[i]);
if(_d||_18||_1e){
_14.setSize(_1e?i-cpt:i-cpt+1);
_14.dataCount=_14.size();
if(_14.size()>1){
if(_19!=null){
for(var j=0;j<_14.dataCount;j++){
_14.xValues[j]=_e[cpt+j];
_14.yValues[j]=_f[cpt+j];
}
_b.processItem(_a,cpt,_14,_19);
}
}
if(_18){
_19=_1c;
}
cpt=_1e?i+1:i;
}
}
_14.setSize(_10-cpt);
_14.dataCount=_14.size();
if(_14.size()>1&&(_19!=null)){
for(var j=0;j<_14.dataCount;j++){
_14.xValues[j]=_e[cpt+j];
_14.yValues[j]=_f[cpt+j];
}
_b.processItem(_a,cpt,_14,_19);
}
_14.dispose();
if((_c==PolyItem.STROKE_FILL)&&this.isFilled()){
this._processItems(_a,_b,PolyItem.STROKE_ONLY,false);
}
}else{
var _14=this.createPolyItem(_10,_c);
_14.dataCount=_10;
_14.addArrays(_e,_f,_10);
_b.processItem(_a,0,_14,_11);
_14.dispose();
}
};
SinglePolylineRenderer.prototype.getPolyItemAction=function(_20){
return new PolyItemAction(this,_20);
};
SinglePolylineRenderer.prototype.createPolyItem=function(_21,_22){
return new PolyItem(this,_21,_22);
};
SinglePolylineRenderer.prototype.getAdjCount=function(){
return 1;
};
SinglePolylineRenderer.prototype.isFilled=function(){
return false;
};
SinglePolylineRenderer.prototype.drawLegendSymbol=function(_23,g,x,y,w,h){
Style.drawLine(this.getStyle(0),g,x,y+h/2,x+w,y+h/2);
this.drawMarkerSymbol(g,x,y,w,h);
};
SinglePolylineRenderer.prototype.drawMarkerSymbol=function(g,x,y,w,h){
if(this.getMarker()!=null){
this.getMarker()(g,x+w/2,y+h/2,Math.min(this.getMarkerSize(),Math.min(w/2,h/2)),this.getUsedMarkerStyle(this.getStyle(0)));
}
};
SinglePolylineRenderer.prototype.drawPoints=function(dst,pts){
var g=dst;
if(!this.isNullMarker()||this.hasHintMarker()){
g=DrawUtil.createContainer(dst.ownerDocument);
}
SingleChartRenderer.prototype.drawPoints.call(this,g,pts);
if(!this.isNullMarker()||this.hasHintMarker()){
dst.appendChild(g);
this.getMarkerRenderer().drawPoints(dst,pts);
}
};
SinglePolylineRenderer.prototype.isNullMarker=function(){
return this.getMarker()==null||this.getMarker()==Marker.NONE;
};
SinglePolylineRenderer.prototype.getDisplayItem=function(x,y,_33,_34,_35){
if(_34!=-1&&(!this.isNullMarker()||this.hasHintMarker())){
return new DisplayPoint(this,this.getDrawingDataSet(),_34,x,y);
}
return this.getNearestPoint(x,y,_35);
};
