/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SingleScatterRenderer.prototype=new SingleChartRenderer();
SingleScatterRenderer.DEFAULT_SIZE=3;
SingleScatterRenderer.DEFAULT_MARKER=Marker.SQUARE;
SingleScatterRenderer.prototype._marker;
SingleScatterRenderer.prototype._size;
function SingleScatterRenderer(_1,_2,_3,_4){
this._marker=(_2?_2:SingleScatterRenderer.DEFAULT_MARKER);
this._size=(_3?_3:SingleScatterRenderer.DEFAULT_SIZE);
SingleChartRenderer.call(this,_1,_4);
}
SingleScatterRenderer.prototype.getMarker=function(){
return this._marker;
};
SingleScatterRenderer.prototype.setMarker=function(_5){
this._marker=_5;
};
SingleScatterRenderer.prototype.getMarkerSize=function(_6){
return this._size;
};
SingleScatterRenderer.prototype.setMarkerSize=function(_7){
this._size=_7;
};
SingleScatterRenderer.prototype.getPreferredMargins=function(){
var _8=SingleChartRenderer.prototype.getPreferredMargins.call(this);
if(_8.left<this._size){
_8.left=this._size;
}
if(_8.right<this._size){
_8.right=this._size;
}
if(_8.top<this._size){
_8.top=this._size;
}
if(_8.bottom<this._size){
_8.bottom=this._size;
}
return _8;
};
SingleScatterRenderer.prototype.isContinuous=function(){
return false;
};
SingleScatterRenderer.prototype.processItems=function(_9,_a){
var _b=this.createItem();
var _c=_9.getXCoords();
var _d=_9.getYCoords();
var _e=_9.getIndices();
var _f=_9.size();
var _10=this.getStyle();
var _11=_9.getDataSet().getUndefValue();
if(this.holdsRenderingHint()){
var _12=_10;
var _13;
var dp=new DisplayPoint(this,_9.getDataSet());
var _15=this.getMarker();
for(var i=0;i<_f;++i){
var yi=_9.getYDataAt(i);
if(MathUtil.eq(yi,_11)){
continue;
}
dp.set(_e[i],0,0);
_13=this.getRenderingHint(dp);
if(_13!=null){
_12=_13.getStyle(dp,_10);
if(_12==null){
continue;
}
if(_13.getMarker){
_b.marker=_13.getMarker(dp,_15);
if(_b.marker==null){
continue;
}
}else{
_b.marker=_15;
}
}else{
_12=_10;
_b.marker=_15;
}
_b.x=_c[i];
_b.y=_d[i];
_b.dataIdx=_e[i];
var elt=_a.processItem(_9,i,_b,_12);
if(elt){
var ds=_9.getDataSet();
if(ds.getRefDataSet){
ds=ds.getRefDataSet();
}
elt.setAttributeNS(CHART_NS,"dsIdx",ds.getDataSource().getDataSetIndex(ds));
elt.setAttributeNS(CHART_NS,"ptIdx",_9.getDataIndex(i));
}
}
}else{
for(var i=0;i<_f;++i){
var yi=_9.getYDataAt(i);
if((_11!=null&&MathUtil.eq(yi,_11))){
continue;
}
_b.x=_c[i];
_b.y=_d[i];
_b.dataIdx=_e[i];
var elt=_a.processItem(_9,i,_b,_10);
if(elt){
var ds=_9.getDataSet();
if(ds.getRefDataSet){
ds=ds.getRefDataSet();
}
elt.setAttributeNS(CHART_NS,"dsIdx",ds.getDataSource().getDataSetIndex(ds));
elt.setAttributeNS(CHART_NS,"ptIdx",_9.getDataIndex(i));
}
}
}
};
SingleScatterRenderer.prototype.createItem=function(){
return new ScatterItem(this);
};
SingleScatterRenderer.prototype.expandSelectionRect=function(_1a){
var _1b=this.getMarkerSize()+1;
_1a.grow(_1b,_1b);
return _1a;
};
SingleScatterRenderer.prototype.drawLegendSymbol=function(_1c,g,x,y,w,h){
this._marker(g,x+w/2,y+h/2,Math.min(this._size,Math.min(w,h)/2),this.getStyle(0));
};
