/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

StackedRendererConfig.prototype=new CompositeRendererConfig();
StackedRendererConfig.prototype._stacked100;
function StackedRendererConfig(_1,_2){
CompositeRendererConfig.call(this,_1);
this._stacked100=_2;
}
StackedRendererConfig.prototype.getDrawRenderers=function(){
if(window.BarChartRenderer&&this.getRenderer() instanceof BarChartRenderer){
return this.getRenderer().getChildren();
}else{
return this.getRenderer().getChildren().clone().reverse();
}
};
StackedRendererConfig.prototype.isStacked100Percent=function(){
return this._stacked100;
};
StackedRendererConfig.prototype.setStacked100Percent=function(_3){
if(_3!=this._stacked100){
this._stacked100=_3;
this.updateVirtualData();
}
};
StackedRendererConfig.prototype.dataSetAdded=function(_4){
this.updateVirtualData();
};
StackedRendererConfig.prototype.dataSetRemoved=function(_5){
this.updateVirtualData();
};
StackedRendererConfig.prototype.updateVirtualData=function(){
var _6=this._renderer.getDataSource().getDataSetCount();
if(_6==0){
return;
}
var _7=this._renderer.getDataSource().getDataSets();
if(this.isStacked100Percent()){
var _8=null;
for(var i=0;i<_6;++i){
_8=new Stacked100DataSet(i,_7,_8);
var _a=this._renderer.getChildForDS(_7[i]);
if(_a instanceof SingleChartRenderer){
_a.setVirtualDataSet(_7[i],_8,true);
}
}
}else{
var _a=this._renderer.getChildForDS(_7[0]);
if(_a instanceof SingleChartRenderer){
_a.setVirtualDataSet(_7[0],null,true);
}
var _8=null;
for(var i=1;i<_6;++i){
_8=new StackedDataSet(_8);
var _b=new Array(i+1);
for(var j=0;j<=i;++j){
_b[j]=_7[j];
}
_8.setDataSets(_b);
_a=this._renderer.getChildForDS(_7[i]);
if(_a instanceof SingleChartRenderer){
_a.setVirtualDataSet(_7[i],_8);
}
}
}
};
StackedRendererConfig.prototype.activate=function(){
this.updateVirtualData();
};
StackedRendererConfig.prototype.desactivate=function(){
var _d=this._renderer.getDataSource().getDataSets();
for(var i=0;i<_d.length;++i){
var _f=this._renderer.getChildForDS(_d[i]);
if(_f instanceof SingleChartRenderer){
_f.setVirtualDataSet(_d[i],null,true);
}
}
};
