/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

SumDataSet.prototype=new VirtualDataSet();
SumDataSet.prototype._data=null;
function SumDataSet(_1,_2){
VirtualDataSet.call(this);
this.addDataSet(_1);
this.addDataSet(_2);
this.updateData();
}
SumDataSet.prototype.getName=function(){
return (this.getDataSetCount()>0?this.getDataSet(this.getDataSetCount()-1).getName():null);
};
SumDataSet.prototype.isXValuesSorted=function(){
return true;
};
SumDataSet.prototype.getUndefValue=function(){
if(this.getDataSetCount()>0){
return this.getDataSet(this.getDataSetCount()-1).getUndefValue();
}else{
return null;
}
};
SumDataSet.prototype.map=function(p){
p.dataSet=this;
p.index=-1;
};
SumDataSet.prototype.unmap=function(p){
p.dataSet=this.getDataSet(this.getDataSetCount()-1);
p.index=(this._data==null)?-1:this._data.getDataIndex(p.index);
};
SumDataSet.prototype.dataSetContentsChanged=function(_5){
if(_5.getType()!=DataSetContentsEvent.BEFORE_DATA_CHANGED&&_5.getType()!=DataSetContentsEvent.DATA_LABEL_CHANGED){
this.updateData();
this.dispatchEvent(new DataSetContentsEvent());
}
};
SumDataSet.prototype.getXData=function(_6){
return this._data.getX(_6);
};
SumDataSet.prototype.getYData=function(_7){
return this._data.getY(_7);
};
SumDataSet.prototype.updateData=function(){
if(this.getDataSetCount()==2){
var _8=this.getDataSet(0);
var _9=this.getDataSet(1);
if(!_8.isXValuesSorted()||!_9.isXValuesSorted()){
this._data=null;
}else{
this._data=this.merge(_8.getData(),_9.getData());
}
}else{
if(getDataSetCount()==1){
this._data=this.getDataSet(0).getData();
}else{
this._data=null;
}
}
this.setLimitsValid(false);
this.updateDataCount();
};
SumDataSet.prototype.merge=function(p1,p2){
var _c=(p1==null)?0:p1.size();
var _d=(p2==null)?0:p2.size();
var i=0;
var j=0;
var res=new DataPoints(this,_c+_d);
while(i<_c&&j<_d){
if(p1.getX(i)==p2.getX(j)){
++i;
res.addValuesAt(p2.getX(j),SumDataSet.computeYValue(p2.getX(j),p2.getY(j),p1,i),j);
++j;
}else{
if(p1.getX(i)<p2.getX(j)){
res.addValuesAt(p1.getX(i),SumDataSet.computeYValue(p1.getX(i),p1.getY(i),p2,j),j-1);
++i;
}else{
res.addValuesAt(p2.getX(j),SumDataSet.computeYValue(p2.getX(j),p2.getY(j),p1,i),j);
++j;
}
}
}
while(i<_c){
res.addValuesAt(p1.getX(i),p1.getY(i),j-1);
++i;
}
while(j<_d){
res.addValuesAt(p2.getX(j),p2.getY(j),j);
++j;
}
return res;
};
SumDataSet.computeYValue=function(x,y,p,i){
return (i>0)?y+p.getY(i-1):y;
};
SumDataSet.prototype.computeDataCount=function(){
return (this._data!=null)?this._data.size():0;
};
