/*
 * Licensed Materials - Property of IBM
 * 5724-Y34, 5724-Y36, 5724-Z55 
 * © Copyright IBM Corporation 1996, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 */

Points.prototype._dataPoints;
Points.prototype._projected=false;
Points.prototype._dataSet;
Points.prototype._projectPoints;
Points.prototype._cloneData;
Points.prototype._renderer;
function Points(_1,_2,_3){
this._renderer=_1;
this._dataPoints=_2;
this._dataSet=_2.getDataSet();
this._cloneData=_3;
}
Points.prototype.getChart=function(){
return this._renderer.getChart();
};
Points.prototype.getDataSet=function(){
return this._dataSet;
};
Points.prototype.project=function(){
if(this._dataPoints!=null){
if(this._cloneData){
this._projectPoints=new DoublePoints();
this._projectPoints.addPoints(this._dataPoints);
this._renderer.toDisplay(this._projectPoints);
}else{
this._renderer.toDisplay(this._dataPoints);
this._projectPoints=this._dataPoints;
}
}
this._projected=true;
};
Points.prototype.addData=function(x,y){
this._dataPoints.addValues(x,y);
};
Points.prototype.addDataArrays=function(x,y,_8){
this._dataPoints.addArrays(x,y,_8);
};
Points.prototype.addDataArraysAt=function(_9,x,y,_c){
this._dataPoints.addArraysAt(_9,x,y,_c);
};
Points.prototype.addDataValues=function(_d,x,y){
this.addDataArraysAt(_d,[x],[y],1);
};
Points.prototype.dispose=function(){
if(this._dataPoints!=null){
this._dataPoints.dispose();
}
if(this._projectPoints!=null&&this._projectPoints!=this._dataPoints){
this._projectPoints.dispose();
}
};
Points.prototype.getDataPoints=function(){
return (this.isProjected()&&!this._cloneData)?null:this._dataPoints;
};
Points.prototype.getProjectedPoints=function(){
return this._projectPoints;
};
Points.prototype.isProjected=function(){
return this._projectPoints!=null;
};
Points.prototype.getIndices=function(){
return this._dataPoints.getIndices();
};
Points.prototype.size=function(){
return (this._dataPoints==null)?0:this._dataPoints.size();
};
Points.prototype.getDataIndex=function(i){
return this._dataPoints.getIndices()[i];
};
Points.prototype.getXCoords=function(){
if(!this.isProjected()){
this.project();
}
return this._projectPoints.getXValues();
};
Points.prototype.getYCoords=function(){
if(!this.isProjected()){
this.project();
}
return this._projectPoints.getYValues();
};
Points.prototype.getXCoord=function(idx){
return this.getXCoords()[idx];
};
Points.prototype.getYCoord=function(idx){
return this.getYCoords()[idx];
};
Points.prototype.getDisplayPoint=function(idx){
return this.getDisplayPointImpl(idx,false,true);
};
Points.prototype.getDisplayPointImpl=function(idx,_15,_16){
var _17=_16?this.getXCoord(idx):0;
var _18=_16?this.getYCoord(idx):0;
var dp=new DisplayPoint(this._renderer,this._dataSet,this.getDataIndex(idx),_17,_18);
if(_15&&this._dataSet.unmap){
this._dataSet.unmap(dp);
}
return dp;
};
Points.prototype.getXData=function(){
if(this.isProjected()){
if(this._cloneData){
return this._dataPoints.getXValues();
}
var _1a=this.getIndices();
var _1b=this.size();
var res=new Array(_1b);
for(var i=0;i<_1b;i++){
res[i]=this._dataSet.getXData(_1a[i]);
}
return res;
}else{
return this._dataPoints.getXValues();
}
};
Points.prototype.getYData=function(){
if(this._projected){
if(this._cloneData){
return this._dataPoints.getYValues();
}
var _1e=this.getIndices();
var _1f=this.size();
var res=new Array(_1f);
for(var i=0;i<_1f;i++){
res[i]=this._dataSet.getYData(_1e[i]);
}
return res;
}else{
return this._dataPoints.getYValues();
}
};
Points.prototype.getXDataAt=function(idx){
return (this.isProjected()&&!this._cloneData)?this._dataSet.getXData(this.getDataIndex(idx)):this._dataPoints.getX(idx);
};
Points.prototype.getYDataAt=function(idx){
return (this.isProjected()&&!this._cloneData)?this._dataSet.getYData(this.getDataIndex(idx)):this._dataPoints.getY(idx);
};
Points.prototype.toString=function(){
if(this._dataPoints!=null){
return this._dataPoints.toString();
}else{
return null;
}
};
